;; @(#) tinycb.el -- (C)irculate (b)uffers easily.

;; @(#) $Id: tinycb.el,v 1.22 1997/05/30 16:28:39 jaalto NotReleased $
;; @(#) $Keywords: extensions $
;; @(#) $KnownCompatibility: 19.28+ XEmacs19.14+ $

;; This file is not part of Emacs.

;;{{{ Id

;; Copyright (C) 1996,97 Jari Aalto
;; Author:       Jari Aalto     <jari.aalto@poboxes.com>
;; Maintainer:   Jari Aalto     <jari.aalto@poboxes.com>
;; Created:      May 20 1996
;;
;; To get information on this program use ident(1) or do M-x ticb-version
;; Look at the code with folding.el, tinyfold.el, tinybm.el

;; LCD Archive Entry:
;; tinycb|Jari Aalto|jari.aalto@poboxes.com|
;; Circulate buffers easily in current window. Back, fwd, skipping unwanted.|
;; 30-May-1997|$Revision: 1.22 $|~/misc/tinycb.el.Z|

;; This program is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 2 of the License, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;; or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
;; for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with GNU Emacs.  If you did not, write to the Free Software Foundation,
;; Inc., 675 Mass Ave., Cambridge, MA 02139, USA.

;;}}}
;;{{{ Install

;; ....................................................... &t-install ...
;;  Add following statement(s) to your ~/.emacs
;;
;;	(require 'tinycb)
;;
;;  or use autoload, your ~/.emacs starts lot faster
;;
;;*   (autoload 'ticb-iswitch-to-buffer               "tinycb.el" nil t)
;;*   (autoload 'ticb-previous-buffer                 "tinycb.el" nil t)
;;*   (autoload 'ticb-next-buffer                     "tinycb.el" nil t)
;;*   (autoload 'ticb-sort-mode-toggle                "tinycb.el" nil t)
;;* _
;;*   ;; If you use Emacs/X, these could be suitable keys.
;;*   ;;
;;*   (global-set-key [?\C-,] 'ticb-previous-buffer)
;;*   (global-set-key [?\C-.] 'ticb-next-buffer)
;;*   (global-set-key [?\A-.] 'ticb-sort-mode-toggle)
;;*   (global-set-key [?\C-<] 'ticb-iswitch-to-buffer)
;;*
;;*   ;; For non-windowed emacs; you want to program your own keys
;;*   ;; Here is the HP Numpad keys used
;;*   ;;
;;*   (global-set-key "\eOq" 'ticb-previous-buffer)  ;; numpad 1
;;*   (global-set-key "\eOr" 'ticb-sort-mode-toggle) ;; numpad 2
;;*   (global-set-key "\eOs" 'ticb-next-buffer)      ;; numpad 3
;;*
;;
;;   If you have any questions, use this function
;;
;;      M-x ticb-submit-bug-report


;;}}}
;;{{{ Documentation

;; ..................................................... &t-commentary ...
;;; Commentary:
;;
;;  Preface, May 1996
;;
;;	With this small package you can switch to next or previous buffer
;;	in a current window. If you only have small amount of buffers
;;	circulating the buffer-list may be the fastest way to select a
;;	working buffer. In the other hand, if you have more than 20 working
;;	buffers, I'd recommend that you use exellent substring buffer
;;	switching utility instead.
;;
;;	    iswitch-buffer.el <stephene@cogs.susx.ac.uk>
;;	    http://www.cogs.susx.ac.uk/users/stephene/emacs
;;
;;	And one bonus more; if you have X and want to have hotlist
;;	of your most accessed buffers available, use following package.
;;	Then you can select RMAIL; GNUS; VM; *scratch* buffers instantly.
;;	It is part of the tiny tools distribution.
;;
;;	     tinyhotlist.el -- Hotlist of buffers in X, easy add, easy remove
;;
;;  Description
;;
;;	If you don't want default bindings, clear the installation with
;;	following. This must be prior the 'require command.
;;
;;	    (setq ticb-:load-hook nil)
;;
;;	To circulate buffers forward/backward easily, this file
;;	installs following keybindings to windowed envinronment.
;;	For non-winkdowed emacs (in tty) the default bindings
;;	are for HP numeric keypad keys 1 2 3.
;;
;;	    C-,	previous buffer		(Think this as < back)
;;	    C-.	Next buffer		(Think this as > fwd)
;;	    A-. sort order on/off	(Think this as > sorted)
;;
;;	    C-< iswitch mode, select buffer with RET, move with , .
;;	        This mode is special, it shows the buffer name
;;	        ,in echo area while you go backward and forward.
;;
;;	        This is usefull if you have many buffers and just
;;              want to skip 2-5 buffers fast. Eg. if the buffers
;;              are font-lock conrolled, swithing to them with
;;              the C-, and C-, keys would be slow due to fontification
;;              which happens every time you switch over a buffer.
;;
;;	You should also configure ticb-:ignore-regex to your taste.
;;
;;  Thanks
;;
;;	Original idea for this package comes from yic-buffer.el
;;	by choo@cs.yale.edu (young-il choo), 7 Aug 90.

;;}}}
;;{{{ History

;; ........................................................ &t-history ...
;;; Change Log:
;; [jari]   = <jari.aalto@poboxes.com>
;;
;; Mar	30	1997	[jari]		19.28	v1.22		NotReleased
;; - Checkdoc 1.29 clear. Defcustom supported. Changed some boolean varaibles
;;   to have -flag suffix
;;
;; Mar	19	1997	[jari]		19.28	v1.17-1.21	NotReleased
;; - updated keybinding converter call.
;; - Updater character reading for XEmacs20. Internal changes.
;;
;; Mar	4	1997	[jari]		19.28	v1.16		NotReleased
;; - Added non-windowed emacs installation.
;; - corrected some serious bugs that prevented using sort mode.
;; - If there all buffers are filtered; (no buffers to select) then
;;   message is printed.
;;
;; Jan 	15	1997	[jari]		19.28	v1.13-1.15	NotReleased
;; - Added lib m require due to macros.
;; - Updated autoload installation.
;;
;; Sep	25	1996    [jari]		19.28   v1.10-1.12	Released
;; - Rearranged loading of functions. Converted all to autoloads.
;;   Shuld speed up loading this module by 10X.
;; - Changed all '(lambda forms to use (function (lambda
;;
;; Sep	11	1996    [jari]		19.28   v1.9		Released
;; - done@nexus.sorostm.ro (Dan Nicolaescu) suggested showing
;;   the directory when using the iswitch. Added.
;; - Removed extra 'd!!' debug call.
;;
;; Sep	4	1996    [jari]		19.28   v1.7-1.8	Released
;; - done@nexus.sorostm.ro (Dan Nicolaescu) gave an idea to develop
;;   iswitch styled buffer switching. This is more faster, because
;;   the buffers are not shown (and no hooks in buffer are run. Eg.
;;   font-lock)
;;
;; Jun	8	1996    [jari]		19.28   v1.5-1.6	Released
;; - Textual changes, verision variable corrected. Sort mode func.
;;
;; May  17      1996    [jari]          19.28   v1.4		Released
;; - Added moving buffers in sorted order. Rewrote all code.

;;}}}

;;; Code:

;;; ......................................................... &require ...

(require 'tinylibm)
(eval-when-compile (use-dynamic-compilation))

(defgroup-tiny TinyCb ticb-: extensions
  "Circulating buffers in current window.
	With this small package you can switch to next or previous buffer
	in a current window. If you only have small amount of buffers
	circulating the buffer-list may be the fastest way to select a
	working buffer."
  )

;;{{{ setup: -- variables

;;; ....................................................... &v-private ...
;;; Internal variables

(defvar ticb-:buffer-list  nil
  "Global buffer list for `ticb-iswitch-to-buffer'")

;;; ........................................................ &v-public ...
;;; User configurable

(defcustom ticb-:load-hook '(ticb-install-default-bindings)
  "*Hook run when file has been loaded."
    :type 'hook :group 'TinyCb
    )

(defcustom ticb-:ignore-regexp
  (concat
   "^ "                 ;hidden buffers
   "\\|completion\\|summary"
   "\\|buffer list\\|help\\|ispell\\|abbrev"
   "\\|temp\\|tmp\\|vc\\|compile-log\\|occur"
   )
  "*Buffers to ignore when changing to another."
  :type 'string :group 'TinyCb
  )


(defcustom ticb-:sort-flag nil
  "*Non-nil means that buffers are switched in sorted order."
  :type 'boolean :group 'TinyCb
  )


(defcustom ticb-:iswitch-to-buffer-keys  '(?, ?.)
  "*Keys to scroll buffers backward and forward in iswitch mode."
  :type '(list
	  (character :tag "Backward")
	  (character :tag "Forward")
	  )
  :group 'TinyCb
  )


(defcustom ticb-:iswitch-show-directory-flag  t
  "*Non-nil means that directory name is shown in iswitch mode."
  :type 'boolean :group 'TinyCb
  )

;;; ....................................................... &v-version ...

(eval-and-compile
(ti::m-fmacro-version-bug-report
 "tinylisp.el"
 "ticb"
 ticb-:version-id
 "$Id: tinycb.el,v 1.22 1997/05/30 16:28:39 jaalto NotReleased $"
 '(ticb-:version-id
   )))

;;}}}
;;{{{ code: funcs

;;; ########################################################### &Funcs ###

;;; ----------------------------------------------------------------------
;;;
(defun ticb-install-default-bindings ()
  "Define default global keys to circulate buffers."

  (tinyck-maybe-activate 'emacs)
  ;;  This breaks in -nw, so just ignore the errors,
  ;;  user must define his own preference keys.
  ;;
  (safe-do				;X keys
    (global-set-key [?\C-,] 'ticb-previous-buffer)
    (global-set-key [?\C-.] 'ticb-next-buffer)
    (global-set-key [?\A-.] 'ticb-sort-mode-toggle)
    (global-set-key [?\C-<] 'ticb-iswitch-to-buffer)
    )

  (safe-do				;Non-Window keys
    (global-set-key "\eOq" 'ticb-previous-buffer) ;; numpad 1
    (global-set-key "\eOr" 'ticb-sort-mode-toggle);; numpad 2
    (global-set-key "\eOs" 'ticb-next-buffer)     ;; numpad 3
    )

  (tinyck-maybe-activate 'emacs 'dis)
  )



;;; ----------------------------------------------------------------------
;;;
(defun ticb-start-list  (buffer-pointer list)
  "Let BUFFER-POINTER be first and arrange LIST."
  (let* ((start (memq buffer-pointer list))
	 (rev   (reverse list))
	 before
	 ret
         )
    ;; Basic idea is this, say pointer is at B
    ;; list:   A B C D
    ;; start:    B C D
    ;; rev     D C B A
    ;; before      B A  --> take cdr --> A
    ;;
    ;; ret     start + before = B C D A
    ;;

    (if (null start)
	(error "No such elt in list %s" buffer-pointer))

    (setq before (cdr-safe (memq buffer-pointer rev)))
    (setq ret start)

    (if before
	(list-union (reverse start) before))

    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun ticb-buffer-filter (&optional blist)
  "Filter BLIST, which defaults to buffer-list.
References:
  ticb-:ignore-regexp"
  (let* ((list  (or blist (buffer-list)))
	 elt
	 ret
	 )
    (list-loop list elt
      (if (not (string-match ticb-:ignore-regexp
			     (buffer-name elt)))
	  (push elt ret)))
    ret
    ))

;;; ----------------------------------------------------------------------
;;;
(defun ticb-sort-buffer-list-1 (&optional blist reverse)
  "Sort BLIST, which defaults to buffer-list. Optionally REVERSE."
  (let* ((list  (or blist (buffer-list)))
	 )
    (setq
     list
     (if reverse
	 (sort list
	       (function
		(lambda (a b)
		  (string< (buffer-name b) (buffer-name a)))))
       (sort list
	     (function
	      (lambda (a b)
		(string< (buffer-name a) (buffer-name b))
		)))))
    list
    ))


;;; ----------------------------------------------------------------------
;;;
(defun ticb-sort-buffer-list  (&optional reverse blist)
  "Sort buffer list, optionally REVERSE and use BLIST."
  (let* (sorted
	 part
	 list
	 )
    (setq sorted (ticb-sort-buffer-list-1 blist reverse))

    ;;  What is this? Okay, you see, when we sort the buffer list...
    ;;     A B C D E F G
    ;;         ^
    ;;     #############  'sorted' holds all
    ;;           %%%%%%%  'part'   contains only these
    ;;
    ;;  We're currently in C, and next one must be D. But if we're
    ;;  at the end, we're in G, and no buffers follow.
    ;;
    ;;  So, to get past G, we have to make list in following way:
    ;;
    ;;      @@@@@@ =  %%%%%    ############
    ;;      list   =  'part' + 'sorted
    ;;
    ;;  Sure, there is redundancy, since the 'sorted' holds all elements,
    ;;  but since we actually ignore buffers in the moving loop, we need
    ;;  all buffers past G.
    ;;
    (cond
     ((setq part (memq (current-buffer) sorted))
      (setq list (cdr part))
      (setq sorted (append list sorted))
      ))
    sorted
    ))


;;; ----------------------------------------------------------------------
;;;
(defun ticb-buffer-list-next (&optional reverse)
  "Switch to next buffer in list, skipping unwanted ones. Optionally REVERSE.
See variable `ticb-:ignore-regexp'."
  (let* ((re  ticb-:ignore-regexp)
         list buffer go
         )
    (cond
     (ticb-:sort-flag
      (setq list (ticb-sort-buffer-list reverse)))

     (reverse
      (setq list (reverse (buffer-list))))

     (t
      (setq list (buffer-list))
      ))

    (setq list (delq (current-buffer) list))

    (list-loop list buffer
      (if (not (string-match re (buffer-name buffer)))
	  (setq go buffer   list nil)))	;Stop and select it

    (if (null go)
	(message "ticb: No buffers to circulate; see ticb-:ignore-regexp"))

    (if go   (switch-to-buffer go))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun ticb-init-buffer-list  ()
  "Init global variable ticb-:buffer-list."
  (let* ((list  (ticb-buffer-filter))
         )
    (if ticb-:sort-flag
	(setq list (ticb-start-list
		    (current-buffer)
		    (ticb-sort-buffer-list-1 list))))
    (setq ticb-:buffer-list list)
    ))


;;; ----------------------------------------------------------------------
;;;
(defmacro ticb-iswitch-next ()
  "Return next buffer in list."
  (`
   (let* ((first (car ticb-:buffer-list))
	  (rest  (cdr ticb-:buffer-list))
	  (ret   (car rest))
	  )
     (setq list rest)
     (nconcc list first)		;add to the end
     (setq ticb-:buffer-list list)	;update list
     ret
     )))


;;; ----------------------------------------------------------------------
;;;
(defmacro ticb-iswitch-previous ()
  "Return previous buffer in list."
  (`
   (let* ((rev   (reverse ticb-:buffer-list))
	  (last  (car rev))
	  (rest  (reverse (cdr rev)))
	  (ret   last)
	  )
     (setq list rest)
     (push last list)			;add to the end
     (setq ticb-:buffer-list list)	;update list
     ret
     )))


;;}}}
;;{{{ code: interactive


;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun ticb-iswitch-to-buffer  ()
  "Switch to buffer when RETURN/SPACE/TAB pressed.
Show buffer at echo area. ESC to cancel prompt.

Note:
  The startup time of calling this function is high, because it has
  to build a list of choices and possibly filter out unwanted buffers.

References:
  ticb-:iswitch-to-buffer-keys    keys to scroll list of buffers"
  (interactive)
  (let* ((keys	    ticb-:iswitch-to-buffer-keys)
	 (show-dir  ticb-:iswitch-show-directory-flag)
	 (go-list   '(?\C-m ?\t ?\ ?\e ))
	 (key-back  (nth 0 keys))
	 (key-fw    (nth 1 keys))
	 (str	    (buffer-name))
	 (loop      t)
	 list
	 buffer
	 ch
         )
    (ticb-init-buffer-list)


    (while loop
      (setq ch
	    (read-char-safe-until
	     (format
	      "Iswich buffer: %s %s"
	      str
	      (if show-dir
		  ;;  Wham!  I don't like adding all these
		  ;;  dummy "" choices if the command
		  ;;  fails, but I have no other choice...
		  (or
		   (file-name-directory
		    (or (buffer-file-name (get-buffer str)) ""))
		   "")
		"")
	      )))
;;;      (d! str buffer (char= ch key-back) (char= ch key-fw) go-list)

      (cond
       ((and ch (char= ch key-back))
	(setq buffer (ticb-iswitch-previous)))

       ((and ch (char= ch key-fw))
	(setq buffer (ticb-iswitch-next)))

       ((and ch (char-in-list-case ch go-list))
	(setq loop nil)
	))

      (if buffer (setq str (buffer-name buffer)))
      )


    (if (and ch  buffer  (not (char= ?\e ch)))
	(switch-to-buffer buffer))

    ))


;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun ticb-previous-buffer ()
  "Switch to previous buffer in current window."
  (interactive)
  (ticb-buffer-list-next 'reverse))

;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun ticb-next-buffer ()
  "Switch to the other buffer (2nd in list-buffer) in current window."
  (interactive)
  (bury-buffer (current-buffer))
  (ticb-buffer-list-next))

;;; ----------------------------------------------------------------------
;;;
(defun ticb-sort-mode-toggle ()
  "Circulate buffers: sort mode on/off"
  (interactive)
  (setq ticb-:sort-flag (not ticb-:sort-flag))
  (message (concat "ticb: sort mode " (if ticb-:sort-flag "on" "off")))
  )

;;}}}

(provide   'tinycb)
(run-hooks 'ticb-:load-hook)

;;; tinycb.el ends here
