;; @(#) tinyxreg.el -- Restoring points/win cfg stroed in reg. via X-popup

;; @(#) $Id: tinyxreg.el,v 1.25 1997/04/18 16:29:01 jaalto NotReleased $
;; @(#) $Keywords: X, menu, registers $
;; $KnownCompatibility: 19.28+ XEmacs19.14+ $
;; $outlineRegexp: '@+' $
;; $bookMarkRegexp: '[-~+=*#.,'`^]+ &+\\([^ \t]+\\) [-~+=*#.,'`^]+' $
;; $PackageInstallRe: '^[ \t]*;;+[*] ' $

;; This file is not part of Emacs

;;{{{ Id

;; Copyright (C) 1995,96,97 Jari Aalto
;; Author:       Jari Aalto <jari.aalto@poboxes.com>
;; Maintainer:   Jari Aalto <jari.aalto@poboxes.com>
;; Created:      Oct 4 1995
;;
;; To get information on this program use ident(1) or do M-x tixr-version
;; Look at the code with folding.el, tinyfold.el, tinybm.el

;; LCD Archive Entry:
;; tinyxreg|Jari Aalto|jari.aalto@poboxes.com|
;; Stores point/win cfg to X-POPUP LIST while storing it to register|
;; 18-Apr-1997|$Revision: 1.25 $|~/misc/tinyxreg.el.Z|

;; COPYRIGHT NOTICE
;;
;; This program is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 2 of the License, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;; or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
;; for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with GNU Emacs.  If you did not, write to the Free Software Foundation,
;; Inc., 675 Mass Ave., Cambridge, MA 02139, USA.

;;}}}
;;{{{ Install

;; ....................................................... &t-install ...
;; Put this file on your Emacs-Lisp load path, add following into your
;; ~/.emacs startup file. Rip code with tinylib.el / ti::m-pkg-rip-magic
;;
;;* _  (if window-system
;;*	  (require 'tinyxreg))
;;
;; Or use autoload, preferfed, because your emacs starts up faster.
;;
;;* _
;;*   (cond
;;*    (window-system
;;* 	(global-set-key "\C-x/"			'tixr-point-to-register)
;;* 	(autoload 'tixr-jump-to-register	"tinyxreg" t t)
;;* 	(autoload 'tixr-jump-to-register-mouse	"tinyxreg" t t)
;;* 	(autoload 'tixr-point-to-register	"tinyxreg" t t)
;;* 	(autoload 'tixr-point-to-register-mouse	"tinyxreg" t t)
;;* 	(autoload 'tixr-remove-reg		"tinyxreg" t t)
;;* 	(autoload 'tixr-trash			"tinyxreg" t t)
;;* 	))
;;
;; If you don't want default bindings, put this before require or
;; autoload commands.
;;
;;* _
;;* 	(setq tixr-load-hook nil)
;;
;; If you have any questions, comments, use this function
;;
;;      M-x tixr-submit-bug-report



;;}}}
;;{{{ Documentation

;; ..................................................... &t-commentary ...
;;; Commentary:

;; RESERVED prefix FOR FUNCTIONS IN THIS FILE
;; - To avoid collisions to other modules I use "tixr-" in front of
;;   every function & variable. It stands for '(ti)ny (X) popup for
;;   storage (r)egisters
;; - variable names contain letters 'tixr-:', excecpt version/hook/mode vars.

;;  Preface, oct 1995
;;
;;	I saw post in comp.emacs by  <cpg@cs.utexas.edu> Carlos Puchol
;;
;;	    I find that my life would be remarkably eased if only I
;;	    could "jump" to the marks from a menu.
;;
;;	    Please, let me know if i can implement this myself
;;	    through some sort of macro or something.
;;
;;	As a hobby I started quicly sketching what the person should
;;	do.. I dind't plan to write any code. It just happened that I
;;	got interested in the subject and started experimenting with
;;	couple of functions.
;;
;;	As a result I had complete package in hand within an hour or
;;	so, which I also posted to the group. Later on I properly
;;	packaged all the functions here and rewote whole thing.
;;
;;  Overview of features
;;
;;	o   Stores point/win cfg to X-POPUP LIST while storing it to register
;;	o   Use X-popup to pick register associated with the file.
;;
;; Register update note
;;
;;	If you wonder why some of the registers disappear from the popup
;;	while you were sure you just stored some point to them, the reason is
;;	here.
;;
;;	If you kill some buffer, or reload it again with
;;	find-alternate-file that means that the register reference "dies".
;;	That's why the main function tixr-jump-to-register calls a house
;;	keeping function tixr-update to make sure you can't select invalid
;;	registers. So, trust the poup: it tells what registes are
;;	available.



;;}}}
;;{{{ history

;; ........................................................ &t-history ...
;;; Change Log:
;; [jari]   = <jari.aalto@poboxes.com>
;;
;; Apr 14	1997	[jari]		19.28	v1.24-1.25	NotReleased
;; - Libarary call changes. Removed imenu dependency, now works in XEmacs19.14
;;
;; Jan	15	1997	[jari]		19.28	v1.23		NotReleased
;; - text changes
;;
;; Nov	2	1996	[jari]		19.28	v1.22		NotReleased
;; - No more uses ti::q-read-char, which has been vaporized.
;;
;; Nov	1	1996	[jari]		19.28	v1.21		NotReleased
;; - Installation instructions clarified. Now keys are bound when
;;   package loads.
;; - Added lib m require due to macros. Thanks to "kevin (k.) blake"
;;   <kblake@nortel.ca>
;;
;; Oct	21	1996	[jari]		19.28	v1.19		NotReleased
;; - Thanks to Kevin, he said the key C-x\ was not bound to proper function.
;; - Now doesn't load "tinyck" in Emacs, added xemacs-p test.
;; - Added global-set-key to autoload instructions.
;;   tixr-remove-register		:+
;;
;; Oct	18	1996	[jari]		19.28	v1.18		NotReleased
;; - "kevin (k.) blake" <kblake@nortel.ca> told me that read-char-safe
;;   wasn't inluded. That was true and I wonder why neither XEmacs nor
;;   Emacs byte compiler didn't nofify me about the missing function.
;;   It must be a bug in ByteComp, so that it doesn't notice functions
;;   inside interactive tag.
;; - Removed extra libraries, now all are in autoload state.
;;
;; Sep	25	1996	[jari]		19.28	v1.16-1.17	NotReleased
;; - Rearranged loading. Now uses autoloads as much as possible
;;
;; Aug  21	1996	[jari]		19.28	v1.15		NotReleased
;; - Corrected errros reported by XEmacs 19.14 Bytecompiler. However,
;;   this package doesn not work in XEmacs, because it uses imenu to display
;;   popup. Is the imenu.el for XEmacs?
;;
;; Feb	10	1996	[jari]		19.28	v1.13-1.14	NotReleased
;; - lisp-nt.el's lm-verify checked. ByteComp ok. Feedback rewritten.
;;   Removed library funcs and put require tinylib.  Corrected bug
;;   in tixr-event, defmacro --> defun
;;
;; Oct	13	1995	[jari]		19.28	v1.12		Release_5
;; - Made the levent loading safe, it doesn't hang now when it has
;;   condition-case around it.
;; - Corrected some typing errors in text. No actual code changes.
;;
;; Oct	9	1995	[jari]		19.28	v1.11		NotReleased
;; - Still little fine tuning: now it's detected if user uses "yank at
;;   mouse point". If he is, the cursor is positioned to the mouse position
;;   beforefe asking storing it to register.
;; - Now actually displays the register name. There was a bug in, which
;;   wiped messages too early.
;;   message-flash		    :! updated new macro
;;   tixr-msg			    :! now uses sit-for, not sleep-for
;;    tixr-jump-to-register	    :! Added missing 'remove' arg
;;
;; Oct	9	1995	[jari]		19.28	v1.10		NotReleased
;; - If user pressed mouse while register were asked, the code "broke"
;;   because the character returned was "nil". Now there is error message
;;   is non character is given. And another configure variable to force
;;   input.
;;   tixr-:wait-till-char-given	    :+ should we wait the right input ?
;;
;; Oct	9	1995	[jari]		19.28	v1.9b		Release_4
;; - Added 'reading the input' section to explain why you might get
;;   error "non-character input-event".
;;
;; Oct	5	1995	[jari]		19.28	v1.9a		NotReleased
;; - Added 'reading the input' section to explain why you might
;;   get error signalled.
;; - Forget to make sort function user onfigurable, now there is var for it.
;;   tixr-:imenu-sort-func          :+ how popup will be sorted
;;
;; Oct	5	1995	[jari]		19.28	v1.8		NotReleased
;; - Added 'register update note' section, where the house keeping is
;;   explained.
;; - Moved default keys behind a function, it's more easy to put them into
;;   effect. now you just set: (setq tixr-load-hook 'tixr-default-bindings)
;; - A bug in tixr-jump-to-register: the popup list was created _before_
;;   housekeeping took effect. Now it takes precedence and you get only
;;   valid points.
;;
;; Oct	5	1995	[jari]		19.28	v1.7		NotReleased
;; - Added 'byte compile note' section. Also removed the byte compile hacks
;;   that jeopardised using this package.
;; - Added global-unset-key hint to the 'installation' which makes C-z
;;   available for prefix key.
;; - Also added message flashing .. they get wiped
;;   tixr-:msg-time		   :+ new variable to control disp. time
;;   message-flash		   :+ new lib func
;;   tixr-msg			   :+ hadles messaging
;;
;; Oct	5	1995	[jari]		19.28	v1.6		NotReleased
;; - It's 00:30 right now and this package it still evolving...
;;   I decided to take advantage of the 19.28 events features _if_ they
;;   are available. This makes it possible to ignore mouse movement while
;;   reading user input. Now giving register after mouse click is much
;;   easier and you don't get
;;
;;	"(error "Non-character input-event")"
;;
;;   Errors any more if you happened to move mouse while it was expecting
;;   you to give register name via read-char.
;;
;;   use-events			   :+ detect and turn on events
;;   ti::q-read-char		   :+ better read-char
;;   tixr-point-to-register	   :! rewrote the interactve part
;;
;; Oct	4	1995	[jari]		19.28	v1.5		Release_3
;; - More fine tuning. What happens if you kill buffer where is marker ?
;;  of course the marker becomes invalid, so I have to keep up to date...
;;  tixr-update			   :+ kills dead markers before showing
;;  tixr-jump-to-register-mouse	   :! calls tixr-update now
;;
;; Oct	4	1995	[jari]		19.28	v1.4		Release_2
;; - Hmmm, there were some errors that by byte copiler function didn't
;;   notice. Should check that function I trust... Now comiles cleanly.
;;   BOLP ..			   :+ lib macros added
;;   register-live-p		   :+ lib macro missing
;;
;; Oct	4	1995	[jari]		19.28	v1.3		Release_1
;; - Some more final touches. Made description texts user configurable,
;;   so that he doesn't necessary write his own function.
;;   tixr-:buffer-fmt		   :+ name len desc field
;;   tixr-:wcfg-fmt		   :+ window entry desc form
;;   tixr-event			   :+ simulate keyboard
;;   tixr-trash			   :+ to kill the popup list
;;   tixr-point-to-register-mouse  :! rewrote
;;   tixr-point-to-register	   :! interactive rewrote
;;
;; Oct	4	1995	[jari]		19.28	v1.2		NotReleased
;; - Changed all 'my-' prefixes to package prefix 'tixr-'. Total rewrite
;;   Nothing like the one I posted yesterday. This is the _real_ thing.
;;
;; Oct	3	1995	[jari]		19.28	v1.1		Created
;; - Small version posted to gnu.emacs.help.


;;}}}

;;; Code:

;;{{{ setup: require

;;; ......................................................... &require ...

(require 'tinylibm)
(eval-when-compile (use-dynamic-compilation))


;;}}}
;;{{{ setup: private

;;; .......................................................... &v-bind ...

;;; ......................................................... &v-hooks ...

(defvar tixr-:load-hook 'tixr-default-keys
  "Hook that is run when package is loaded.")

;;; ....................................................... &v-private ...


(defvar tixr-:preg  nil
  "Holds point markers.")

(defvar tixr-:wreg  nil
  "Holds window markers.")

;;}}}
;;{{{ setup: user vars

;;; ........................................................ &v-public ...

(defvar tixr-:msg-time 0.5
  "*Time value to display messages in seconds.")

;;  handy if you want to call from non-mouse, eg. pressing key.
;;
(defvar tixr-:x-coord 170
  "*Default menu coordinate.")

(defvar tixr-:y-coord 170
  "*Default menu coordinate.")


(defvar tixr-:description-func  'tixr-description
  "*Function to return popup description string.
Function should accept two arguments: REGISTER and WINDOW-ARG")


(defvar tixr-:title  "Register list"
  "*Popup title.")


;;;
(defvar tixr-:buffer-fmt "%-20s"
  "*This allows you to size the filename length area reserved for
default popup description.

Note:  The entries itself are stored in this form, so changing this
affets only new entries.
")


(defvar tixr-:wcfg-fmt '(concat "\177 Win " bn)
  "*This is the Window config FORM that is evaled when
the description is put into the list. You can use variable BN
to refer current buffer name.

Remember that list will be sorted later, so you may want to have
common beginning for all win cfg registers.
")

;;}}}
;;{{{ setup: version

;;; ....................................................... &v-version ...

(eval-and-compile
(ti::m-fmacro-version-bug-report
 "tinyxreg.el"
 "tixr"
 tixr-:version-id
 "$Id: tinyxreg.el,v 1.25 1997/04/18 16:29:01 jaalto NotReleased $"
 '(tixr-:version-id
   )))


;;}}}

;;; ########################################################### &Funcs ###

;;{{{ misc

;;; ...................................................... &norm-funcs ...

;;; ----------------------------------------------------------------------
;;;
(defun tixr-msg (msg)
  (message-flash tixr-:msg-time 'sit msg))

;;; ----------------------------------------------------------------------
;;;
(defun tixr-event ()
  "Returns fake event"
  (ti::xe-make-fake-event tixr-:x-coord tixr-:y-coord))


;;; ----------------------------------------------------------------------
;;;
(defun tixr-list ()
  "Returns register list, point list + window list."
  (let* ((ptr   tixr-:wreg)
	 (list  (copy-sequence tixr-:preg))
	 elt
	 )
    ;;  concat two lists
    (list-loop ptr elt (push elt list))
    (nreverse list)
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tixr-default-keys ()
  "Installs default key bindings."
  (interactive)

  (tinyck-maybe-activate 'emacs)	;XEmacs compatibility

  ;;  There is no other good use for these
  (global-set-key "\C-x/"           'tixr-point-to-register)
  (global-set-key "\C-x\\"          'tixr-remove-register)

  ;;  The "C-c j" is like C-x j , but showing the popup
  (global-set-key "\C-cj"           'tixr-jump-to-register)


  ;;  C-x is so easy to reach with left hand... and free
  (global-set-key [?\C-x mouse-1]   'tixr-jump-to-register-mouse)
  (global-set-key [?\C-x S-mouse-1] 'tixr-point-to-register-mouse)


  (tinyck-maybe-activate 'emacs 'dis)

  (if (interactive-p)
      (tixr-msg "Register Keys bound ok."))
  )




;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun tixr-remove-reg (char &optional arg)
  "Removes register CHAR from stored window and point lists.
ARG suggests looking in window list.
"
  (interactive "cRemove register: \nP")
  (let* ((ptr (if arg tixr-:wreg  tixr-:preg))
	 elt
         )
    (if (null (setq elt (rassq char ptr)))
	nil
      (if arg
	  (setq tixr-:wreg (delete elt tixr-:wreg))
	(setq tixr-:preg (delete elt tixr-:preg)))
    )))


;;; ----------------------------------------------------------------------
;;;
(defun tixr-update ()
  "Kills all registers from lists that are not alive any more.
Eg. marker dies if you revert the buffer; kill and load it again."
  (let* ((ptr tixr-:preg)
	 elt
	 reg
	 list
	 )
    ;;  We simple copy valid elements to another list
    (list-loop ptr elt
      (setq reg (cdr elt))
      (if (register-live-p reg)
	  (push elt list))
      )

    (setq tixr-:preg list   ptr tixr-:wreg)
    ))

;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun tixr-trash ()
  "Empties both window and point caches."
  (interactive)
  (setq tixr-:preg nil   tixr-:wreg nil)
  (if (interactive-p)
      (tixr-msg "Register lists trashed."))
  )

;;; ----------------------------------------------------------------------
;;;
(defun tixr-kill-reg (char)
  "kills register from all lists."
  (tixr-remove-reg char nil)
  (tixr-remove-reg char 'window)
  )



;;; ----------------------------------------------------------------------
;;;
(defun tixr-add-reg (char arg &optional desc)
  "Stores register CHAR to window or point list.
ARG tells to store to window list.
"
  (let* (
	 (desc (if (stringp desc)
		   desc
		 (char-to-string char)))
	 (data (cons desc char))
         )
    (if arg
	(push data tixr-:wreg)
      (push data tixr-:preg))
    ))

;;}}}
;;{{{ storing

;; ----------------------------------------------------------------------
;;; So that you call this from mouse
;;;
(defun tixr-description (reg-nbr &optional arg)
  "Return description text for popup list"
  (let* ((bn   (file-name-nondirectory (buffer-name)))
	 (cfg  tixr-:wcfg-fmt)
	 )
    (format (concat tixr-:buffer-fmt " %4s %s")

	    (if arg
		;;  the 177 should print nice block
		;;  so that sorting puts cfg entries last
		(eval cfg)
	      bn)

	    (if arg
		""
	      (int-to-string
	       (count-lines (point-min-marker) (BOLP))))

	    (char-to-string reg-nbr)	;arg 2
	    )))

;;; ----------------------------------------------------------------------
;;;
;;;
;;;###autoload
(defun tixr-point-to-register-mouse (event)
  "See tixr-point-to-register."
  (interactive "e")

  ;;
  ;;	- User using "flying" mouse paste mode? See var mouse-yank-at-point
  ;;	- If he is, then move cursor visually to mouse point first.
  (if (null mouse-yank-at-point)
      (mouse-set-point event))

  (call-interactively 'tixr-point-to-register)
  )

;;; ----------------------------------------------------------------------
;;; based on register.el::point-to-register
;;;
;;;###autoload
(defun tixr-point-to-register (char &optional arg)
  "Store current location of point in register REGISTER and to X-popup list.
With prefix ARGUMENT, store current frame configuration. VERBOSE enables
message printing.


Use \\[tixr-point-to-register]  to go to that location or restore the
configuration.
"
  ;; ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ interactive handling ^^^
  (interactive
   (list

    (let (CHAR
	  (msg
	   (cond
	    (current-prefix-arg
	     "Store Window cfg to register: " )
	    (t
	     "Store point to register: ")))
	  )
      (setq CHAR (read-char-safe-until msg))

      ;;  Show where it got stored.
      (tixr-msg (concat msg (char-to-string CHAR)))
      CHAR
      )

    current-prefix-arg
    ))

  ;; ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ the body ^^^
  (let* ((dfunc   tixr-:description-func)
	 desc
         )

    (setq desc				;get the popup description
	  (if (fboundp dfunc)
	      (funcall dfunc char arg)
	    nil))

    (tixr-remove-reg char arg)
    (tixr-add-reg    char arg desc)

    ;;   Now the normal emacs thing
    (set-register
     char
     (if (null arg)
	 (point-marker)
       (current-frame-configuration)
       ))


    ))

;;}}}
;;{{{ jumping

;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun tixr-remove-register ()
  "Remove register from popup list. See tixr-jump-to-register-mouse
for more."
  (interactive)
  (tixr-jump-to-register-mouse nil 'remove))

;;; ----------------------------------------------------------------------
;;; - for calling from keybord
;;;
;;;###autoload
(defun tixr-jump-to-register (&optional remove)
  "See tixr-jump-to-register-mouse."
  (interactive)
  (tixr-jump-to-register-mouse nil remove))


;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun tixr-jump-to-register-mouse (event &optional remove)
  "Displays X-list of registers. Restore register or
optionally REMOVE register from X-list.
"
  (interactive "e\nP")
  (let* (
	 (event                (or event (tixr-event)))	;kbd call
         (title                tixr-:title)
	 (verb		       (interactive-p))
         ref-list
         list
	 data
	 char
         )
    (tixr-update)			;update register list
    (setq ref-list (tixr-list)
	  list     (mapcar 'car ref-list)
	  )
    (cond
     ((null (ti::xe-window-system))
      (message "Sorry, Requires X to use X-popup"))

     ((null list)
      (if verb (message "Sorry, both register lists are empty.")))

     (t
      (setq data (ti::xe-popup  list event nil title))
      (if (null data)
	  (if verb (tixr-msg "Register not selected."))
	(setq char (cdr-safe (assoc data ref-list)))

	(cond
	 (remove
	  ;;  Remove from both lists
	  (tixr-kill-reg char)
	  (cond
	   (verb
	    (tixr-msg
	     (concat " Register ["
		     (char-to-string char) "] removed"))
	    (sleep-for 1)		;too fast otw when you move mouse..
	    )))

	 (t
	  (jump-to-register char nil)
	  ))))
     )))


;;}}}



(provide   'tinyxreg)
(run-hooks 'tixr-:load-hook)

;;; tinyxreg.el ends here
