;; @(#) tinypgp.el -- PGP minor mode, key, user, mail management
;;
;; @(#) $Id: tinypgp.el,v 1.241 1997/07/04 17:09:47 jaalto NotReleased $
;; @(#) $Keywords: extensions $
;;
;; $KnownCompatibility: 19.28+, XEmacs19.14+, XEmacs20+ $
;; $outlineRegexp: '@+' $
;; $bookMarkRegexp: '[-~+=*#.,'`^]+ &+\\([^ \t]+\\) [-~+=*#.,'`^]+' $
;; $PackageInstallRe: '^[ \t]*;;+[*] ' $
;;
;;
;; Todo:
;;
;; verify: find 0xNNNNN keyid from pgp data
;; Penet:  passwords must be stored into hash table and not stored in
;;         readable format.
;;

;; This file is not part of Emacs

;;{{{ Id

;; Copyright (C) 1996,97 Jari Aalto
;; Author:       Jari Aalto <jari.aalto@poboxes.com>
;; Maintainer:   Jari Aalto <jari.aalto@poboxes.com>
;; Created:      6 Jun 1996
;;
;; To get information on this program use ident(1) or do M-x tipgp-version
;; Look at the code with folding.el, tinyfold.el, tinybm.el

;; LCD Archive Entry:
;; tinypgp|Jari Aalto|jari.aalto@poboxes.com|
;; PGP/remail,keymgmt,nym account,minor modes, multi u/pring,base64,auto pgp|
;; 02-Jul-1997|$Revision: 1.241 $|~/misc/tinypgp.el.Z|

;; COPYRIGHT NOTICE
;;
;; This program is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 2 of the License, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;; or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
;; for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with GNU Emacs.  If you did not, write to the Free Software Foundation,
;; Inc., 675 Mass Ave., Cambridge, MA 02139, USA.

;;}}}
;;{{{ Install

;; ....................................................... &t-install ...
;;  Put this file on your Emacs-Lisp load path, add following into your
;;  ~/.emacs startup file. Rip code with tinylib.el/ti::m-pkg-rip-magic
;;
;;* _
;;*     (setq tipgp-:pgp-exe-version "2.6.3ia")  ;; Your PGP executable ver.
;;*     (require 'tinypgp)
;;
;;  or use this; your ~/.emacs loads quicker
;;
;;* _
;;*     (setq tipgp-:pgp-exe-version "2.6.3ia")
;;* 	(autoload 'tipgp-mode		"tinypgp" t t)
;;* 	(autoload 'turn-on-tipgp-mode	"tinypgp" t t)
;;* 	(autoload 'turn-off-tipgp-mode	"tinypgp" t t)
;;* 	(autoload 'tipgp-install	"tinypgp" t t)
;;* _
;;*     (add-hook 'message-mode-hook    'turn-on-tipgp-mode)
;;* 	(add-hook 'mail-mode-hook	'turn-on-tipgp-mode)
;;*	(add-hook 'vm-mode-hook		'turn-on-tipgp-mode)
;;* 	(add-hook 'rmail-mode-hook	'turn-on-tipgp-mode)
;;* 	(add-hook 'gnus-startup-hook	'tipgp-install)
;;
;;  Put your customizations to separate file and add this.
;;
;;*  (setq tipgp-:load-hook '(lambda () (require 'rc-tipgp  "~/.emacs.tipgp")))
;;* _
;;
;;  to automatically sign all your outgoing mail, add this to your .emacs
;;  For more personal signing, see at the end of file
;;  for controlled signing setup.
;;
;;* 	;;  Regular Emacs C-x m mail-mode
;;*     (add-hook 'mail-send-hook 'tipgp-sign-mail-auto-mode-on)
;;* _
;;*     ;;  Additional, 19.30+ message-mode
;;*     (add-hook 'message-send-hook 'tipgp-sign-mail-auto-mode-on)
;;
;;  Suggested mode binding, "m" prefix for all minor mode toggles.
;;  If these are occupied, then choose some other bindings.
;;
;;*	;; note, Mailcrypt's prefix key is C-c / which is also
;;*	;; this package's prefix key unless you use the setq below.
;;*	;;
;;*	;; Personally I like the "-" because it's easier to reach than "/"
;;*	;; in my keyboard.
;;* 	;;
;;*     (setq tipgp-:mode-prefix-key    "\C-c-")
;;* 	(global-set-key "\C-cm-"	'tipgp-mode)
;;* 	(global-set-key "\C-cm'"	'tipgp-key-mode)
;;
;;  See the end of file for additional examples.
;;  If you want to contact maintainer, always use this function
;;
;;      M-x tipgp-submit-bug-report       ,send feedback, bug report

;;}}}
;;{{{ Documentation

;; ..................................................... &t-commentary ...
;;; Commentary:

;; RESERVED prefix FOR FUNCTIONS IN THIS FILE
;; - To avoid collisions to other modules I use "tipgp-" in front of
;;   every function & variable. It stands for '(ti)ny (pgp) tools.
;; - variable names contain letters 'tipgp-:', excecpt version/mode vars.

;; Documentation:
;;
;;  Preface 1996
;;
;;	Please, read these URLs before you use this package. The pages are
;;	updated constantly. Drop me a mail if the manual doesn't cover some
;;	topic or if there are unclear sections.
;;
;;	.ftp://cs.uta.fi/pub/ssjaaa/pgp-xhd.html -- X-Pgp standard.
;;	.ftp://cs.uta.fi/pub/ssjaaa/tipgp.html   -- TinyPgp.el manual
;;	.ftp://cs.uta.fi/pub/ssjaaa/ema-tipgp.ini -- TinyPgp.el init file

;;}}}
;;{{{ history

;; ........................................................ &t-history ...
;;; Change Log:
;; [jari]   = <jari.aalto@poboxes.com>
;; [Dan]    = Dan Rich <drich@cisco.com>
;;
;; Jul	2	1997	[jari]		19.28	v1.1.239-241	    Beta
;; - Corrected newnym functions and fine tuned modeline update. Renamed
;;   many newnym function. Forget to add 'send flag to requests.
;; - Added newnym echo menu and updated keybindings and added prefix key.
;; - new feature: you can setup default newnym server/account.
;; - 1.240 can open nested encrypted envelopes. (needed when you receive
;;   newnym reply blocks.)
;; - 1.241 fixes wrong v- v+ labelling. Also turns off auto-action
;;   if you use remailer-chain.
;;
;; Jun	27	1997	[jari]		19.28	v1.1.236-238	    Beta
;; - Rewrote the whole remailer interface and added many new functins.
;; - Remailer chains are now supported!
;; - Now you can fully control the Remailer chain with C-c / . C
;;   by individually making each layer. Alternatively you can use
;;   predefined chain with C-c / . c
;; - Added newnym Request commands and rewrote the newnym core interface.
;;
;; Jun	27	1997	[jari]		19.28	v1.1.232-235	    Beta
;; - vm-edit-message advice caused infinite loop [Dan]. Put tipgp-mode
;;   variable test there. No; the 1.232 fix didn't work I have to investigate
;;   this later. Now the advice is disabled.
;; - 'One pass' Encrypt and Sign must use one big pubring. Fixed.
;; - In 235 I radically moved code around the file and renamed many function
;;   so that function name tells the category better.
;;
;; Jun	27	1997	[jari]		19.28	v1.1.231	    Beta
;; - Very annoying bug corrected: When I called 'nym account create'
;;   command, the mail buffer's auto-action was always set to defeated
;;   state "!-". It turned out to be serious error in tipgp-hash.
;;   Now it detects property list and not just variable definition.
;; - Fine tuned the auto-action-p function. Key-id conversion function never
;;   used the hash. Corrected.
;; - Fixed lot of small bugs and sliced many function/renamed too.
;; - concetrated improving the newnym type account: now the Newsgroup post
;;   conversion should work: C-c / . n p
;;
;; Jun	26	1997	[jari]		19.28	v1.1.230	    Beta
;; - this is big release  and bumped version number accordigly.
;; - I wrote 'newnym' mode. It is minor mode that
;;   helps you compose Newnym account commands in the mail buffer.
;;   The default prefix key is C-\.
;; - Converted all possible lisp loop calls to use dolist instead. This
;;   may cause trouble if I made mistake somewhere.
;; - Converted r-penet- prefix to 'nymserver-'.
;; - Added 'one pass' encrypt and sign commands; C-c / t. This caused
;;   lot of rewriting in all over the place. The auto action also knows
;;   this feature: if SIGN parameter is symbol and ENCRYPT is set, then
;;   'one pass' auto action is done. This is requirement when you eg.
;;   send messages to Newnym remailer accounts.
;; - Separated the labelling functionality.
;;
;; Jun	25	1997	[jari]		19.28	v1.1.220-222	    Beta
;; - Changed auto-action: Now detects MIME composed mail better (TM)
;;   and disables auto-action if needed. Moved PGP stream info fo 'mt' lib.
;; - Added tipgp-:newnym-cmd-table (not used yet)
;; - Xpgp -- regular signature conversion fixed (move-to-sig function).
;;   Now Xpgp verify works again.
;; - When regular signature was moved to Xpgp; it also mistakenly
;;   converterted all '- -' lines back to '-', which was wrong. Those
;;   lines must be preserved, because they are part of signing process.
;;
;; Jun	25	1997	[jari]		19.28	v1.1.219	    Beta
;; - Massive changes in 'newnym' interface. I rewrote almost everything.
;; - bug in tipgp-pgp-stream-forward-study corrected.
;; - [Dan] reported bug where signing command failed when it tried to
;;   restore the cursor position. (search didn't have 'noerr parameter).
;;
;; Jun	24	1997	[jari]		19.28	v1.1.217-218	    Beta
;; - Corrected tipgp-verify-region, which wrong arguments to
;;   tipgp-exe-do-command-region. [Dan] reported this bug.
;; - Saved window configuration in control-before and restored
;;   for VM in control-after. Now the cursor stays in the same place
;;   wen we return from VM edit mode.
;; - Label interface rewritten: new user variable tipgp-:label-table
;; - Corrected signing function: Now turns off X-pgp signing in non-mail
;;   buffers and If there is already regular signature (stacked sigs
;;   are now possible.
;; - the signing function was total wreck in VM edit buffer. Reordered
;;   code a lot, because the control-before hook was run in wrong buffer.
;;
;; Jun	19	1997	[jari]		19.28	v1.1.214-216	    Beta
;; - Verifying signature in VM buffer is a bit tricky, because VM
;;   edits messages in separate buffer. The points read from original
;;   buffer are not valid any more, so the calculation must be left
;;   as late as possible. Rewrote the verify interface (now reads 0x
;;   keyid too and prints warning if email is ;not found from pgp keyrings)
;; - Added tipgp-install-vm-check which makes sure the X-Pgp-Signed
;;   header is displayed in VM
;; - Separate frame is no longer opened in VM.
;; - Cache save had error: file was always saved due to wrong hash value read.
;;
;; Jun	18	1997	[jari]		19.28	v1.1.212-213	    Beta
;; - Function tipgp-sign-mail fixes: now preserved the point (if possible).
;;   Won't sign empty mail message any more.
;; - Added couple of new PGP exe error messages.
;; - tipgp-sign-data-set is now set only in mail buffer where it makes sense.
;; - vm-edit-message is now adviced so that PGP mode will be on when
;;   called interactively.
;; - The cache is now written only if the cache length has changed.
;; - the cmd-macro sets vm-frame-per-edit locally to nil so that new frame
;;   won't be created when decrypting message.
;; - Load hook is now called after provide statement.
;;
;; Jun	17	1997	[jari]		19.28	v1.1.211	    Beta
;; - Still problems with VM [Dan reported bugs when decrypting]. I found
;;   out that the initial buffer was INBOX; but the EDIT-BUFFER changed
;;   when vm edit mode was opened. Now the mode specific _after_ hook
;;   knows the right buffer, because there is new hash table entry
;;   'buffer-edit that tells the right edit buffer.
;; - VM seems to be working better now. Added more commands to the
;;   Summary mode menu.
;;   tipgp-sendmail-key-not-in-plan	:! more robust now.
;;
;; Jun	16	1997	[jari]		19.28	v1.1.209-210	    Beta
;; - Moved tipgpd macro to the top of file. It was used before declared and
;;   that caused invalid byte compiled file. [Reported by Dan]
;; - Auto action error: if you decrypted message by hand the auto action
;;   would still decrypt message. I used the remailer indication test
;;   in wrong place. Corrected.
;;
;; Jun	11	1997	[jari]		19.28	v1.1.207-208	    Beta
;; - When I added remailer detection to auto-action, it didn't go
;;   right. The auto-action always returned flase while there was
;;   valid auto action pending. Corrected.
;; - New user function tipgp-pgp-stream-forward-study C-c / x i
;;
;; Jun	11      1997	[jari]		19.28	v1.1.204-206	    Beta
;; - If you composed mail (C-x m) and signed message, the X-pgp was never
;;   used, because the remailer flag was set. The local-varaible
;;   definition was wrong. Corrected.
;; - Changed meaning of tipgp-:auto-action-table a bit, not the
;;   SIGN field is ot a flag, but user id. This means that you can
;;   encrypt (according to  TO field) and SIGN with different user.
;;   This is needed by Newnym account create, when you send create request
;;   encrypted with Server's key, but snigned ny your Nym's key.
;;   (auto action triggers when you hit C-c C-c)
;; - Mitakenly tested (eq major-mode vm-edit-mode) when the test should
;;   have been (eq major-mode 'vm-edit-mode). Maybe the edit mode
;;   now closes.
;;
;; Jun	9      1997	[jari]		19.28	v1.1.200-203	    Beta
;; - minor fixes to Nym create command.
;;   tipgp-newnym-config-sendmail-template	:+ user commadn "/ . n c"
;; - The variable tipgp-:user-identity-table content has been changed.
;;   Now program it finds PGP key-id _directly_ from encrypt ascii armor.
;; - modified the VM edit mode closing according to comment from Dan.
;; - Added more debug to auto-action (multi)
;; - "Body changed..resigning" error rcorrected. Changed the library fucntion
;;   that calculates message body len and that fixes the problem.
;;
;; Jun	6	1997	[jari]		19.28	v1.1.199	    Beta
;; - When flipping from X-Pgp to regular signature, the comment field
;;   wasn't copied. Fixed.
;; - The key-id conversion is now cached and should be definitely faster.
;; - If the Encrypt failed (used From address that is not in in pgp
;;   key-id, it wnt into infinite loop altough user gave new search string.
;;   Corrected.
;; - This is MAJOR release.  I started looking at the 'newnym' type
;;   remail servers and the code has been totally rewritten for them
;;   Many new functions added.
;;   tipgp-add-signature-if-signing	:! now adds "--" before signature
;;   tipgp-key-find-by-keyrings		:! now "retry" feature works
;;
;; Jun	6	1997	[jari]		19.28	v1.1.199	    Beta
;; - VM: after decrypt, the edit mode wasn't closed. It seems that when
;;   editing message; the mode is not vm-message-edit-mode? Now
;;   the buffer name is examined instead.
;;
;; Jun	6	1997	[jari]		19.28	v1.1.197-1.198	    Beta
;; - now sign command shows who signed the message (You didn't know before
;;   because the user change was transparent). Signing function also
;;   changes internal variables if needed see tipgp-set-session-parameters.
;; - Added "wesel|squirrel" to email substitution table.
;; - Corrected newnym create command. It should now send right create block.
;;
;; Jun	6	1997	[jari]		19.28	v1.1.196	    Beta
;; - The buffer modief flag "--" "**" was set to "--" too eagerly.
;;   Eg. if you signed mail in GNUS 5 buffer, that would flag to gnus
;;   that there was no message, because buffer was not modified.
;; - The cure is to use new save-buffer-modified FORM from 'm' lib.
;;
;; Jun	5	1997	[jari]		19.28	v1.1.194-1.195	    Beta
;; - Started looking at the remailer interface again.
;; - Removed the "unfinished" status from the FCC encrypt mode, at least
;;   it worked out of the box When I tied with test message. (RMAIL)
;;   VM propably has its own FCC output function whaich I should call
;; - Corrected key adding function: it can now remove indentation
;;   spaces at the from of PGP key
;; - Tried the 'nym' account create command and it seems to work
;;   just fine (but I couldn't find weasel key to really try it yet)
;; - MH has some weird "signature invalid" message when C-c C-c, added debug.
;;
;; Jun	5	1997	[jari]		19.28	v1.1.192-1.193	    Beta
;; - bug reported by Jerzy.Witkowski@ii.uni.wroc.pl
;; - One mysterious bug: If you opened mail C-x m, wrote "1\n\2\3" in
;;   buffer and positioned curson on line 2 and hit C-c / e to encrypt
;;   the message -- only part of the text was included to encryption.
;; - I changed the tipgp-encrypt-mail function so that it does not
;;   define 'beg' position of text, but the command macro does it.
;; - This seemed to correct the situation.
;; - Variable tipgp-:encrypt-interactive-option is now evaluated instead
;;   of being simple string.
;;
;; Jun	3	1997	[jari]		19.28	v1.1.188-1.191	    Beta
;; - Library functions were changes (internal). Corrected some
;;   19.34 byte compiler warnings away. More debug to header generations
;;   functions.
;; - Checkdoc 1.42 clear. 1.189 had installation problem; the auto action
;;   function were missing fom the sendmail hooks.
;; - Added few eval-and-compile around functions that are
;;   used =in defvar, const, custom. Otherwise bytecompiler doesn't
;;   know what to do to defvars. This bug was reportyed by
;;   Rick Flower <flower@ms31.sp.trw.com> using XEmacs 19.15.
;;
;; May	27	1997	[jari]		19.28	v1.1.185-1.187	    Beta
;; - Now the variables are divided into separate groups and the defcustom.el
;;   buffers seems rather nice. Documentation of groups is still missing
;;   and I would like to have indentation when group is opened.
;; - Compilation problems solved. The 'fmacros' can't be in autoload state,
;;   maybe there is an error in autoload Info Page?
;; - Moved code around quite a lot (due to custom. The variables
;;   appear in the order in this file) and made new custom groups.
;;
;; May	27	1997	[jari]		19.28	v1.1.184	    Beta
;; - Checkdoc 1.29 corrections. Converted package to use latest defcustom.el
;; - This is inital defcustom package and the variables are not yet
;;   grouped according to category.
;; - renamed: All variables now have "-table" at the end of symbol.
;;
;; May	25	1997	[jari]		19.28	v1.1.183	    Beta
;; - New user commands "xh", to show which headers will be signed and "mH"
;;   to toggle including header while signing. Modelie now says "X"
;;   for X-Pgp mode, it used to say "H".
;; - When headers were inserted into body, signed and headers removed, there
;;   was left one extra space to the beginning of BODY. That was wrong.
;;
;; May	22	1997	[jari]		19.28	v1.1.180-1.182	    Beta
;; - Now the buffer modified flag is cleared after signings. User can
;;   see himself if he makes changes after signing.
;; - Corrected all mistakes that Checkdoc 1.15 reported in doc string.
;; - checkdoc 1.22 corections. There was VERY serious SignedHeaders
;;   field handling bug in X-Pgp. It didn't insert header "as is"
;;   but converted the FIELD names to lowercase which was wrong.
;;   The headers must be inserted "as is".
;;
;; May	20	1997	[jari]		19.28	v1.1.178-1.179	Beta
;; - Added Access-Type support. Now the URl and Finger addresses to get
;;   the key is looked from X-Pgp header. Lot of new code needed.
;; - The default email discard function let through addresses like
;;   X-Face: >>@YIrj6h( [Notice @ char]. It is now more restrictive.
;; - Keyserver search now offers Id=0xFFFFFFFF string if that can be found.
;;   Previously offered email string.
;; - Added new user variable tipgp-:verify-message-function to change the
;;   verify message.
;; - Corrected bug in RMAIL labelling code and added VM labels.
;;
;; May	20	1997	[jari]		19.28	v1.1.176-1.177	Beta
;; - The TM mime translate hook in mail-send-hook was run before
;;   the auto action. This caused that patches were converted to quoted
;;   printable before encryption. Modified the function that rearranges
;;   vital hooks. Now the MIME function is last.
;; - Added missing summary mode turn on/off functions.
;; - The mime exit hook was also removed from auto-action hook
;; - Removed eval-after-compile forms from minor mode macros and now
;;   I get different error messages.
;;
;; May	19	1997	[jari]		19.28	v1.1.175	Beta
;; - After examining the different signing outputs for US and
;;   International version, I found the reason why the message body
;;   disappeared mystically. The RESULT command called tipgp-get-result
;;   in US version which expected the BEGIN line to anchor ^ and because
;;   the first thing that it found was signature (not the body begin);
;;   the text inserted to buffer was signature. And because X-pgp was
;;   used; the sig was moved to headers ... and empty body!
;; - Removed the achor restriction and tested with Drich's bug report
;;   data from shell buffer and now it seems to find the result.
;;
;; May	19	1997	[jari]		19.28	v1.1.173-1.174	Beta
;; - Changed all non standard boolean tests to use when and unless
;; - Now shown minor-mode-alist in VM summary buffer too. The pgp-sum
;;   mode is now shown as are all other minor modes.
;; - There was still error in x-pgp signing. if buffer had string "123"
;;   the successive verify failed because the text werent' converted into
;;   "123\n" before signing. Now corrected.
;;
;; May	13	1997	[jari]		19.28	v1.1.172	Beta
;; - Corrected tipgp-pubring-elt; which caused timer call error.
;; - Moved email message trim funcltion to mt library, also corrected
;;   the mysterious X-pgp signing error (when verified, it gave
;;   bad signature). There was extar/missing newline when trimming and
;;   recontructing the message.
;; - If http keyserver key fetch fails, it now keeps cursor in the calling
;;   buffer.
;;
;; May	12	1997	[jari]		19.28	v1.1.170-1.172	Beta
;; - corrected tipgp-path function (serious).
;; - Now uses hash to store the password expire time.
;; - There is byteCompiler message
;;   ** the function tipgp-mode is not known to be defined
;;   But I have no clue where it comes from. The function does get
;;   defined at load and compile time. Hm.
;;
;; May	2	1997	[jari]		19.28	v1.1.169	Beta
;; - I have been very busy and haven't looked any of the current XEmacs 20
;;   corrections yet. This release mainly contains renamed functions
;;   and variables and some improvements to doc strings.
;; - renamed user variable tipgp-:pgp-user-info --> tipgp-:xpgp-user-info
;; - I get compiler error, while the function is defined...?(macro def prob?)
;;   ** the function tipgp-mode is not known to be defined
;; - Finally got the minor mode wizard working in the main library.
;; - Fixed many small errors like reading the email addresses from the
;;   headers fro key server/finger call. The guess function was
;;   rewritten.
;; - Moved the email-substitution-add to the end of file due to byte
;;   compilation
;;
;; Mar	23	1997	[jari]		19.28	v1.1.167-1.168	Beta
;; - Rewrote the base64 decrypting. Now if there is base64 block containing
;;   a file, user can save it to disk. This is counterpart to
;;   command C-c / i in the receiving end.
;;
;; Mar	22	1997	[jari]		19.28	v1.1.165-1.166 	Beta
;; - Removed mime exit from Before-hook, because if you do in TM like this
;;   o mark message region as encrypted
;;   o Call mime-exit --> it calls tiny-pgp where before hooks again
;;     tried to call mime exit...
;; - Corrected PGP data type detection.
;;
;; Mar	20	1997	[jari]		19.28	v1.1.164 	Beta
;; - Many serious Penet errors corrected. Now there is FROM-ADDRESS in
;;   the tipgp-:nymserver-account-table which enables you to use
;;   nymserver from several accounts.
;; - New user commadn C-c / x a to show auto-action elt.
;;
;; Mar	20	1997	[jari]		19.28	v1.1.156-1.163 	Beta
;; - XEmacs20 char changes again. Imporved debugging due to strange
;;   VM decryption errors when VM inbox was put in edit state.
;; - Corrected auto-action decrypt call. Rearranged mail-send-hook
;;   installation.
;; - MIME mode corrections: the TM mime exit call was changed and
;;   calls to it were also adjusted.
;; - auto-action corrected so that there is now user defeat hook
;;   that inhibits auto action (modeline process does not call this,
;;   so you still see ! -- performance reason).
;; - Added more hook ordering to the hook-vital function.'
;; - Renamed variables -:pgp-auto-action  is now  -:auto-action
;; - Added quiet PGP error, bad pass phrase does not gring up shell
;;   error buffer any more.
;; - rnamed tipgp-:sign-mail-auto-mode-no-form -->
;;   tipgp-:auto-action-sign-mail-mode-no-form
;; - Signing now calls error if mail buffer is empty.
;; - Rewrote the decypting section and cmd-macro: When decryptis called
;;   turning on Vm edit mode copies the content of message to different
;;   edit buffer. This means that the BEG and END point are not known
;;   when decrypt is called, but only after the edit mode is turned on.
;;   The cmd-macro's statements were rearranged so that the mode-specific
;;   function was called first, then the BEG end point were read (now
;;   possibly in different buffer that when invoking decrypt command.)
;; - Changed tipgp-highlight so that it accepts 'match arguments beg end.
;; - When reading email; the entry was now squeezed. " email", now
;;   corrected.
;;
;; Mar	19	1997	[jari]		19.28	v1.1.155 	Beta
;; - Added vm edit mode invocation in cmd-before hook and closing
;;   in after hook. VM support for decrypting should now be ok.
;;   (this was crucial correction)
;; - Added more hook rearrangements to the timer process. Now the
;;   sign checking hook is last in the sendmail.
;;
;; Mar	18	1997	[jari]		19.28	v1.1.154 	Beta
;; - Added save-match-data around the debug macro. moved goto-char
;;   call to another place in tipgp-highlight function: I'm suspecting
;;   that this invalidated the match-beginning value if function
;;   was called with parameter 'match.
;; - Added new penet function "abuse", user command "A" in penet echo-menu.
;; - Penet: wrote lot of code to handle Penet CC mail sending. Nymserver
;;   Doesn't allow CC or multiple To recipients, so I had to code
;;   Penet-CC handler to the auto-action. Modeline now shows "P" for
;;   penet mail.
;; - encrypt key was not found when encrypting to penet account, because
;;   I had changed the pgp-env macro. Created new function
;;   tipgp-encrypt-mail-find-keyring that forces finding keyring.
;; - Added VM before/after mode specific control for derypt. Now
;;   opens VM edit mode and closes it.
;;
;; Mar	17	1997	[jari]		19.28	v1.1.153 	Beta
;; - Corrected Penet (h)elp function. Now it can send mail to ask
;;   for the help page. Penet echo-menu didn't pass prefix arg.
;; - More XEmacs20 character handling corrections.
;; - Decrypt's interactive part: showed wrong user when asking pass phrase,
;;   now corrected.
;; - Cache save now detects if file underneath has been changed
;;   (maybe by some other emacs instance). The newest cache is now loaded.
;;
;; Mar	13	1997	[jari]		19.28	v1.1.152 	Beta
;; - Added automatic password deletion from buffer before mail is
;;   send. This is needed because user may send mail to maintainer
;;   which has *Backtrace* buffer. He doesn't relize that it will
;;   contains his password.
;; - The right thing would have been to send the bug report by using submit
;;   function. Still user may simply forget/doesn't know that he should use
;;   it. Many times bug reports are sent as ad hoc, so the chance that
;;   password is sent in mail is high. Now the automatic password deletion
;;   makes things more secure and the password information is no more sent
;;   so easily by accident.
;; - Added summary-mode to GNUS summary buffer too.
;;
;; Mar	12	1997	[jari]		19.28	v1.1.150-1.51 	Beta
;; - Solved problem why rmail summary mode doesn't update mode names.
;;   Had to use defadvice.
;; - If the verify fails due to missing key, then we ask if he wants
;;   to fetch the key from keyserver. This function changed a lot.
;; - Rearranged pull-down menus so that they are more clearer.
;; - Now the RMAIL buffer is not left in edit state any more if
;;   there happens error while the buffer was under use. (decrypt)
;;   [Internal note: uses global hash array]
;;
;; Mar	8	1997	[jari]		19.28	v1.1.148-1.149	Beta
;; - Rearranged code a lot in auto-action functions. Now they are
;;   optimized for speed and use hash values better.There was also
;;   promlem in identifying ! or $ auto-action type. Now the
;;   modeline shows correct one.
;;
;; Mar	7	1997	[jari]		19.28	v1.1.146-1.147	Beta
;; - Implemented auto-encrypt feature; when there is multiple addresses
;;   (cc, bcc, To). User variable tipgp-:auto-action-encrypt-regexp.
;; - The modeline now shows "$" for this, and not ! character.
;; - Finally found the reason why the echo area showed mystiquous
;;   '(... ...) list statements. The error was in fact in the prin1str
;;   library function that use eva-expression which echoed the result.
;; - Added new function to ask decrypt pass phrase.
;; - Corrected few minor and annoying bugs (auto-action; region decrypt
;;   command had wrong interactive handling.)
;;
;; Mar	6	1997	[jari]		19.28	v1.1.145	Beta
;; - Added tipgp-install-hooks-vital which keeps vital hooks in
;;   right order.
;; - Added Prefix arg for Summary mode commands. Next action now accepts
;;   argument for decrypt too. Lot of minor correction (var names in
;;   key mode definition)
;; - Corrected tipgp-auto-action-on-p, it now ignores read-only buffers
;;
;; Mar	6	1997	[jari]		19.28	v1.1.144	Beta
;; - Added RMAIL summary and VM summary mode support. Added automatic
;;   pach detection and applying if the buffer had diff after
;;   RMAIL/VM verify/decrypt.
;; - Moved code around a lot, so the diff to 1.143 seems bigger
;;   than the actual changes.
;;
;; Mar	5	1997	[jari]		19.28	v1.1.143	Beta
;; - Corrected auto action function: it didn't recognize x-pgp flag
;;   or keyring elt correctly (nth offset error)
;; - Corrected key extract and remove function. The removing of key
;;   is not quite that simple because PGP may start asking y/N questions
;;   and we can't do much for those. Even batchmode/force does not help.
;; - Corrected the pgp-env settting macro: now if there is multiple
;;   elts in user-list, the last keyring is used. This enables right
;;   encryption to multiple users.
;; - Changed variable's documentation and meaning tipgp-:pubring-table,
;;   The keyring that holds ALL keys must be last.
;; - Removed variable tipgp-:pgp-encrypted-p-regexp and started using
;;   mt library function to detect pgp type when decrypting.
;;
;; Mar	4	1997	[jari]		19.28	v1.1.142	Beta
;; - Removed one variable which referred to "tpubring.pgp" which was never
;;   used. Started using tipgp-unfinished-function to mark functions
;;   that are not yet finished.
;;
;; Mar	1	1997	[jari]		19.28	v1.1.141	Beta
;; - now base64 signing has standardized +comment messages. For small
;;   files included, the byte  count is shown instead of K.
;; - The x-pgp header contruction broke after I changed the format
;;   of tipgp-:xpgp-user-info. Now corrected and working again.
;;
;; Mar	1	1997	[jari]		19.28	v1.1.140	Beta
;; - Changed format of tipgp-:xpgp-user-info. Not is is sting or EVAL-FORM.
;;   This had to be done because, I van't format the entries in the code,
;;   user must format the string. It is also much simpler to use now.
;; - Now the password is read via ti::xe function that is compatible
;;   with both Emacs and XE.
;; - Adjusted cache put function so that only 2 or more long names
;;   are cached.
;; - Correct x-pgp header contruction so that it always start from
;;   the X-pgp-signed field. I got reports that the field had been
;;   included below CC line without "X-pgp-signed"! I believe the
;;   proble was that we left the initial X-pgp-signed line empty.
;; - Corrected signing command so that if tries to find the
;;   KeyId from keyrings (previously it only looked active keyring)
;;
;; [1.70  - 1.139 log deleted, Beta releases    ]
;; [1.1   - 1.69 log deleted, no public release]
;;
;; Jun	6	1996	[jari]		19.28	v1.1		Created

;;}}}

;;; Code:

;;{{{ setup: require

;;; ......................................................... &require ...

(require 'tinylib)
(require 'tinylibmt)

(eval-when-compile
  (require 'advice)
  (use-dynamic-compilation)
  )

(eval-and-compile
  (use-timer)
  (autoload 'rmail-edit-current-message		"rmailedit" t t)
  (autoload 'rmail-cease-edit			"rmailedit" t t)
  (autoload 'rmail-add-label			"rmailkwd")
  (autoload 'rmail-kill-label			"rmailkwd")


  (defvar vm-frame-per-edit t)		;Borrowed from vm-vars.el
  (autoload 'vm-edit-message			"vm-edit" t t)
  (autoload 'vm-edit-message-end		"vm-edit" t t)
  (autoload 'vm-delete-message-labels		"vm-undo" t t)
  (autoload 'vm-add-message-labels		"vm-undo" t t)

  (defvar mail-send-hook nil)
  (defvar mail-mode-hook nil)
  (defvar message-mode-hook nil)

  (autoload 'message-send-and-exit		"message")

  (autoload 'mail-send-and-exit			"sendmail")
  (autoload 'mail-setup				"sendmail")
  (autoload 'mail-do-fcc			"sendmail")
  (autoload 'comint-send-input			"comint")

  (autoload 'adelete				"assoc")

  ;; TM mime available at
  ;; ftp://ftp.jaist.ac.jp:/pub/GNU/elisp/mime/
  ;;
  (defvar   mime/editor-mode-flag nil)
  (autoload 'mime-editor/exit			"tm-edit")
  (autoload 'timi-mail				"tinymail")


  ;;  Only used if featurep 'vm
  ;;
  (autoload 'vm-update-summary-and-mode-line  "vm" t t)
  )

;;; ......................................................... &v-group ...

(defgroup TinyPgp nil
  "Emacs PGP and Remailer interface.

        TinyPgp is intended to be a 2nd generation Emacs PGP interface
        and it will support all major pgp commands from inside
        emacs. Remailing and anonymous account handling in different
        servers will be included."

  :link '(url-link
	  :tag "Keyserver home"
	  "http://geronimo.uit.no/cc/tjenester/PGP/servruit.eng.html"
	  )

  :link '(url-link
	  :tag "Pgp mailing list"
	  "http://pgp.rivertown.net/"
	  )

  :link '(url-link
	  :tag "Norway's keyserver"
	  "http://www.ifi.uio.no/pgp/"
	  )

  :link '(url-link
	  :tag "Remailer Faq (Galactus)"
	  "http://www.stack.urc.tue.nl/~galactus/remailers/"
	  )

  :link '(url-link
	  :tag "PGP faq alt.security.pgp"
	  "ftp://ftp.prairienet.org/pub/providers/pgp/pgpfaq.txt"
	  )

  :link '(url-link
	  :tag "X-Pgp header standard"
	  "ftp://cs.uta.fi/pub/ssjaaa/pgp-xhd.html"
	  )

  :link '(url-link
	  :tag "TinyPgp Manu page"
	  "ftp://cs.uta.fi/pub/ssjaaa/tipgp.html"
	  )

  :prefix "tipgp-:"
  :group 'extensions
  )

;;; .................................................... &v-group-mode ...


(defgroup tipgp-mode-definitions nil
  "Mode names, menu names and prefix key settings."
  :prefix "tipgp-:"
  :group  'TinyPgp
  )

(defgroup tipgp-mode nil
  "Options that directly address basic PGP commands in minor modes."
  :prefix "tipgp-:"
  :group  'TinyPgp
  )

(defgroup tipgp-header nil
  "Options that deal with Email message headers."
  :prefix "tipgp-:"
  :group  'TinyPgp
  )

(defgroup tipgp-file nil
  "Files used when communicating with PGP. You shouldn't rename these.
Do not add any extension to files, because PGP itself may append extension
.asc or .pgp or .bak. change only directory location.

When you load the package first time the directory name is initialized
from `tipgp-:file-directory' or if it is nil a wild guess will be taken
See function documentation `tipgp-path' for details.
"
  :prefix "tipgp-:"
  :group  'TinyPgp
  )

(defgroup tipgp-hook nil
  "Variables where you can put your own functions."
  :prefix "tipgp-:"
  :group  'TinyPgp
  )

(defgroup tipgp-pgp nil
  "Options that relate to PGP executable and shell envinronment."
  :prefix "tipgp-:"
  :group  'TinyPgp
  )

;;; .................................................... &v-group-misc ...

(defgroup tipgp-interface nil
  "Variables to configure connections to outside world (ftp, http, email)"
  :prefix "tipgp-:"
  :group  'TinyPgp
  )

(defgroup tipgp-remail nil
  "Remailer interface settings."
  :prefix "tipgp-:r"
  :group  'TinyPgp
  )


(defgroup tipgp-remail-hook nil
  "Remailer interface hooks."
  :prefix "tipgp-:r"
  :group  'tipgp-remail
  )

(defgroup tipgp-nymserver nil
  "Anonymous service (paid) anon.nymserver.com settings.
Similar to anon.penet.fi, which has been closed permanently."

  :link '(url-link
	  :tag "Nymserver main page"
	  "http://www.nymserver.com"
	  )

  :link '(url-link
	  :tag "Nymserver html doc (a bit old)"
	  "ftp://cs.uta.fi/pub/ssjaaa/nymserv.html"
	  )

  :prefix "tipgp-:r"
  :group  'TinyPgp
  )

(defgroup tipgp-newnym nil
  "Anonymous PGP service newnym type remailers."

  :link '(url-link
	  :tag "Nym help page"
	  "http://www.stack.nl/~galactus/remailers/nym.html"
	  )

  :prefix "tipgp-:r"
  :group  'TinyPgp
  )

;;}}}
;;{{{ setup: predefined functions


(defcustom tipgp-:file-directory nil
  "*Directory where to store temporary files. Must not be public; like /tmp/.
You should store files under your private directory. If this variable
is nil; then `tipgp-path' guesses the right location for you. See function
documentations for more."
    :type 'directory :group 'tipgp-file
    )


;;; ----------------------------------------------------------------------
;;; Define this function becore it is used in variables.
;;;
(eval-and-compile
(defun tipgp-path (file)
  "Construct path for FILE. See also `tipgp-:file-directory'.
Prepend file with path in this order, which one is found first:

    `tipgp-:file-directory'
    PGPPATH
    ~/.pgp/
    ~/

If FILE already has path, do nothing."
  (let* (path
	 )
    (if (string-match "[~/]" (substring file 0 1))
	(expand-file-name file)		;Already has path
      (setq path  (or tipgp-:file-directory
		      (getenv "PGPPATH")
		      (if (file-exists-p "~/.pgp/")
			  "~/.pgp/"
			"~/")
		      ))

      (setq path (ti::s-verify-ends path "/"))

      (if (not (file-exists-p path))
	  (error "Can't find path %s" path))

      (expand-file-name (concat path file))
      )))
)


;;; ----------------------------------------------------------------------
;;;
(eval-and-compile
(defun tipgp-exe-get-version  (&optional ret-type call-shell )
  "Return version number of current pgp.

Input:
  RET-TYPE	How the information is returned.
		If this is nil then return STRING.
		If this is non-nil then return 'us (2.6.2) or
		'international (2.6.3i)

  CALL-SHELL    if nil, then look variable `tipgp-:pgp-exe-version'.
		If there is no variable or it is not string, then
		call shell to find out pgp exe's version number

Return:
  string	See RET-TYPE
  symbol"
  (let (ret
	)
    (if (and (null call-shell)
	     (boundp 'tipgp-:pgp-exe-version)
	     (setq ret (symbol-value 'tipgp-:pgp-exe-version))
	     )
	nil				;ret already set
      (setq ret (ti::mt-pgp-exe-version-number))
      )

    (if ret-type
	(if (string-match "\\.3i" ret)
	    (setq ret 'international)
	  (setq ret 'us)))
    ret
    ))
)
;;}}}
;;{{{ setup: version

;;; ...................................................... &vp-version ...
;;; the version information is needed in the variable definitions later.

(eval-and-compile
(defconst tipgp-:version-id
  "$Id: tinypgp.el,v 1.241 1997/07/04 17:09:47 jaalto NotReleased $"
  "Latest modification time and version number."
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-version-number  ()
  "Return version number as string."
  (strmatget "\\([0-9]+\\.[0-9]+\\)" 1 tipgp-:version-id))
)


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-version (&optional arg)
  "Show version information. ARG instruct to print message in echo area only."
  (interactive "P")
  (ti::m-pkg-version-info "tinypgp.el" arg))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-version-message  ()
  "Display version."
  (interactive)
  (message tipgp-:version-id))

;;}}}
;;{{{ setup: hooks

;; ......................................................... &v-hooks ...

(defcustom tipgp-:load-hook nil
  "*Hook that is run when package is loaded."
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:mode-hook  nil
  "*Hook run when minor mode is turned on."
  :type 'hook
  :group 'tipgp-hook
  )

(defcustom tipgp-:key-mode-hook  nil
  "*Hook run when minor mode is turned on."
  :type 'hook
  :group 'tipgp-hook
  )

(defcustom tipgp-:summary-mode-hook  nil
  "*Hook run when minor mode is turned on."
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:turn-on-hook-list
  '(mail-mode-hook
    rmail-mode-hook
    vm-mode-hook
    message-mode-hook
    gnus-article-mode-hook		; When selecting the article.
    news-reply-mode-hook		; 'f' key reply, GNUS 4 only
    mh-letter-mode-hook
    mh-show-mode-hook
    )
  "*List of hooks where to install pgp mode.
Call `add-hook' only inside `tipgp-:load-hook', because the defvar
installs many default hooks."
  :type 'hook
  :group 'tipgp-hook
  )



(defcustom tipgp-:sig-from-header-hook  nil
  "*Hook run at the end of `tipgp-pgp-move-sig-from-header' function.
If there is no PGP header, hook is not called."
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:sig-to-header-hook  nil
  "*Hook run at the end of `tipgp-signature-move-to-header function' function.
If there is no PGP header, hook is not called."
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:sign-loose-info-hook  nil
  "*Hook run when the `tipgp-sign-loose-info' function has completed."
  :type 'hook
  :group 'tipgp-hook
  )

(defcustom tipgp-:define-keys-hook nil
  "*List of functions to define all keys and menus."
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:key-mode-define-keys-hook nil
  "*List of functions to define all keys and menus."
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:summary-mode-define-keys-hook nil
  "*List of functions to define all keys and menus."
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:newnym-mode-define-keys-hook nil
  "*List of functions to define all keys and menus."
  :type 'hook
  :group 'tipgp-hook
  )


(defvar tipgp-:do-command-region-before-hook nil
  "*Hook run in tmp buffer where containing data for pgp.
The PGP shell command is at this point stored into variable
`tipgp-:last-pgp-exe-command'.

Note:
  If function in this hook returns non-nil, the rest of the functions are
  not called.

Call arguments:
  cmd msg res-str"
  )

(defvar tipgp-:do-command-region-after-hook nil
  "*Hook run in tmp buffer after the PGP shell command has completed.

Note:
  If function in this hook returns non-nil, the rest of the functions are
  not called.

Call arguments:
  cmd msg res-str"
  )


(defvar tipgp-:cmd-macro-before-hook nil
  "Hook which run before the pgp sequence initiates in current buffer.
See function `tipgp-cmd-macro' for arguments.

Note:
  First function that returns non-nil terminates running the
  rest of the functions. User functions must be at the end of hook
  (use add-hook's 3rd parameter)

Call arguments:
  cmd user password msg string")


(defvar tipgp-:cmd-macro-after-hook nil
  "*Hook which run after the pgp sequence has been completed.
See function `tipgp-cmd-macro' for arguments.

Note:
  First function that returns non-nil terminates running the
  rest of the functions. User functions must be at the end of hook
  (use add-hook's 3rd 'append parameter)

Call arguments:
  cmd user password msg string

Call Note:
  if the CMD is 'cancel, then the function in this hook must not
  do any modification, but only restore any state that may have
  been opened in the *before* hook. (Eg. closing rmail-edit-mode).
  The 'cancel indicates that `error' command is about to be called soon.")


(defvar tipgp-:verify-before-hook  nil
  "*Hook run before verify function is called.
Every function in the hook is called with 2 args: region-beg region-end
The function should return non-nil if it doesn't want to allow other
functions in the hook to continue.")


(defcustom tipgp-:verify-after-hook  nil
  "*Hook run when verify function is done.

Note:
  First function that returns non-nil terminates running the
  rest of the functions.

Call arguments:
  region-beg region-end verify-string-ret-val."
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:read-email-after-hook 'tipgp-email-substitution-defult
  "*This hook is called after email address list has been read.
The list is used eg. for decrypting the message to multiple
users.

It may be desireadble to change some email address to something else;
supposes that you're sending encrypted message to foo2@site.com, but
you have key from him only that refers to email foo1@site.com. If you
try to encrypt according to \"To: foo2@site.com\" you get PGP error,
because there is no such key in the active keyring. That's why
you modify list and change the foo2@site.com to foo1@site.com.

Call arguments:
  email-list or string

Function should return:
  list			,original list if no changes.
  modified list"
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:insert-file-sign-base64-hook
  'ti::p-tar-zip-view-maybe-command
  "*Hook to run before the file is inserted to current point.
There is default function to this hook for tar/zip files, which inserts
the file listing into the buffer.

Note:
  If some function return non-nil the rest of the functions are not run.
  The buffer is temporary buffer for inserted data where hook is run,
  point sits at `point-min' and buffer holds the base64 signed file.

Call arguments:
  string : filename"
  :type 'hook
  :group 'tipgp-hook
  )


(defcustom tipgp-:auto-action-before-hook  nil
  "*Hook run before `tipgp-auto-action' processes anything."
  :type 'hook
  :group 'tipgp-hook
  )

(defcustom tipgp-:auto-action-defeat-hook  'tipgp-auto-action-defeat-p
  "*If any the functions return non-nil, the auto action is defeated.
Called from `tipgp-auto-action'. The default function
`tipgp-auto-action-defeat-p' inhibits processing MIME messages."
  :type 'hook
  :group 'tipgp-hook
  )

;;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. others . .


(defvar tipgp-:finger-discard-email-hook 'tipgp-finger-discard-by-regexp
  "*This hook is called before finger spawned to fetch public key.
You should discard any email addresses that refer to your account.

Default function:
  `tipgp-finger-discard-by-regexp'
  --> uses variable `tipgp-:finger-discard-by-regexp'

Function call arguments:
  string or list of strings '(email email ..)

Function should return:
  modified list or string
  nil			    ,do not finger anything.

Example code, which is also the idea of default function:


  (add-hook 'tipgp-:finger-discard-email-hook
            'my-tipgp-finger-discard-email)

  (setq my-:tipgp-me \"me.surname@\\|myOtherAccount@foo\\|3rd@bix.com\")

  (defun my-tipgp-finger-discard-email (string-or-list)
    ;;  Discard addresses that point to me
    ;;
    (require 'tinylibm)
    (let (ret
	  )
      (mapcar
       (function
	(lambda (x)
	  (if (not (string-match my-:tipgp-me x))
	      (push x ret))))
       ;; convert string to list if needed.
       ;;
       (list-make string-or-list))
      ret
      ))")


(defvar tipgp-:find-by-guess-hook nil
  "*Function called to find public key and keyring.

Notes:
  First function that return non-nil terminates calling other
  function in the hook

  PLEASE THINK CAREFULLY WHICH IS THE FIND ORDER, if you
  use your own function; use add-hook's 3rd parameter to
  add your methods last in the hook.

Function call arguments:
  string	,usually email address(key id)

Function should return:
  string	,(filename) keyring where the key is available
  nil")

;;; ...................................................... &v-function ...
;;; These are not in defcustom. Experts user know what to look
;;; for from source code if they need to change these.

(defvar tipgp-:filter-email-function  'tipgp-mail-abbrevs-filter
  "*Function to filter out unwanted mailabbrevs.
When making the completion list of email address out of the
mail-abbrev table, the obarray may contain some _old_, unwanted, or
invalid email addresses. Perhaps you just don't want to have all
email addresses for PGP encryption: that's what this filter
function is for.

Call arguments:
  list	    ,list of email addresses.

Return value:
  list	    ,list of valid email addresses.")


(defvar tipgp-:verify-message-function  nil
  "*Function called to print the verify status.
This function is called with one argument: STRING, when verify status
is displayed. For example; sometimes PGP could display

    Good signature from user \"0f00bc000\".

Which isn't quite enlightling. By supplying your own function you
can check cases like this and convert the message into something
more meaningful.

Example:

    (setq tipgp-:verify-message-function 'my-tipgp-verify-message)

    (defun my-tipgp-verify-message  (str)
      \"Display more meaninfull message\"
      (let* ((pfx \"Good signature from: \")
	     )
	(cond
	 ((string-match \"0f00bc095\" str)
	  (setq str (concat pfx \"Foo Bar\"))
	  ))
	(message str)
	))"
  )


(defvar tipgp-:pgp-encrypted-p-function
  (function
   (lambda ()
     (let (stat)
       ;; this function returns symbol, convert it to string
       (save-excursion
	 (PMIN)
	 (if (setq stat (ti::mt-pgp-data-type))
	     (symbol-name stat))))))
  "*Function to return PGP data type for message.
When you call `tipgp-decrypt-mail' interactively, the
PGP type is asked. However, you can automate the type checking if you
know the type of PGP data.

The default function `ti::mt-pgp-data-type' check the CTB bits
and returns the correct type.

Function arguments:
  none

Function should return:
  string	'pgp', 'base64', 'conventional' or nil")


(defvar tipgp-:pgp-decrypt-arg-function
    'tipgp-decrypt-arg-function
  "*How to Honour variable `tipgp-:decrypt-arg-interpretation'.
The default function `tipgp-decrypt-arg-function' treats writable and read
only buffers differently.")

(defcustom tipgp-:pgp-command-compose-function  nil
  "*Hook to run after pgp executable command has been composed.
If this hook doesn't modify the command, it should return CMD untouched.

function args:
  cmd      ,string

Should retun:
  cmd      ,string"
  :type  'function :group 'tipgp-pgp
  )

;;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  remailer . .

(defcustom tipgp-:r-post-before-hook  nil
  "*Hook run before post is converted into Anon format."
  :type 'hook
  :group 'tipgp-remail-hook
  )

(defcustom tipgp-:r-post-after-hook  nil
  "*Hook run after post is converted into Anon format."
  :type 'hook
  :group 'tipgp-remail-hook
  )

(defcustom tipgp-:nymserver-post-hook  nil
  "*Hook run after `tipgp-nymserver-post' function finishes."
  :type 'hook
  :group 'tipgp-nymserver
  )



;;}}}
;;{{{ setup: mode variables

;;; .......................................................... &v-mode ...


(defvar tipgp-mode nil
  "Minor mode variable.")
(make-variable-buffer-local 'tipgp-mode)

(defvar tipgp-:mode-name nil
  "Minor mode name.
This is not a user variable because the string is modified dynamically.")
(make-variable-buffer-local 'tipgp-:mode-name)

(defcustom tipgp-:mode-menu-name  "TPgp"
  "*Menu name for pgp mode."
  :type 'string
  :group 'tipgp-mode-definitions
  )

(defvar tipgp-:mode-map  nil
  "Minor mode map.")

(defvar tipgp-:mode-menu  nil
  "Menu for mode.")

(defcustom tipgp-:mode-prefix-key "\C-c/"
  "*Key map prefix."
  :type '(string :tag "Key sequence")
  :group 'tipgp-mode-definitions
  )

;;; ................................................ &v-key-management ...


(defvar tipgp-key-mode nil
  "Minor mode variable.")
(make-variable-buffer-local 'tipgp-key-mode)

(defconst tipgp-:key-mode-name nil
  "Minor mode name.
This is not a user variable because the string is modified dynamically.")
(make-variable-buffer-local 'tipgp-:key-mode-name)


(defvar tipgp-:key-mode-map  nil
  "Minor mode map.")

(defvar tipgp-:key-mode-menu  nil
  "Menu for mode.")

(defcustom tipgp-:key-mode-menu-name  "TPk"
  "*Menu name for pgp key mode."
  :type 'string
  :group 'tipgp-mode-definitions
  )

(defcustom tipgp-:key-mode-prefix-key "\C-c'"
  "*Key map prefix."
  :type 'string
  :group 'tipgp-mode-definitions
  )


;;; .................................................. &v-summary-mode ...

(defvar tipgp-summary-mode nil
  "Minor mode variable.")
(make-variable-buffer-local 'tipgp-summary-mode)

(defconst tipgp-:summary-mode-name nil
  "Minor mode name. Changed dynamically.")
(make-variable-buffer-local 'tipgp-:summary-mode-name)

(defvar tipgp-:summary-mode-map  nil
  "Minor mode map. \\[tipgp-:summary-mode-map].")

(defvar tipgp-:summary-mode-menu  nil
  "Menu for mode.")

(defcustom tipgp-:summary-mode-menu-name  "TPsum"
  "*Menu name for mode."
  :type 'string
  :group 'tipgp-mode-definitions
  )

(defcustom tipgp-:summary-mode-prefix-key tipgp-:mode-prefix-key
  "*Key map prefix."
  :type 'string
  :group 'tipgp-mode-definitions
  )


;;; ................................................... &v-newnym-mode ...

(defvar tipgp-newnym-mode nil
  "Minor mode variable.")
(make-variable-buffer-local 'tipgp-newnym-mode)

(defvar tipgp-:newnym-mode-name " Nym"
  "Minor mode name.")
(make-variable-buffer-local 'tipgp-:newnym-mode-name)

(defvar tipgp-:newnym-mode-map  nil
  "Minor mode map. \\[tipgp-:newnym-mode-map].")

(defvar tipgp-:newnym-mode-menu  nil
  "Menu for mode.")

(defcustom tipgp-:newnym-mode-menu-name  "TPnym"
  "*Menu name for mode."
  :type 'string
  :group 'tipgp-mode-definitions
  )

(defcustom tipgp-:newnym-mode-prefix-key "\C-\\"
  "*Key map prefix."
  :type 'string
  :group 'tipgp-mode-definitions
  )


;;; ................................................. &v-mode-remailer ...

;;  In HP the keys "/." are next to each other on the lower right
;;  near RET key
;;
(defcustom tipgp-:mode-prefix-key-remailer "\C-c/."
  "*Key map prefix for remailer commands."
  :type 'string
  :group 'tipgp-mode-definitions
  )

(defcustom tipgp-:mode-prefix-key-newnym "\C-c/.n"
  "*Keymap prefix for newnym type anon server commands.
The default prefix key is C-c / . n; where p refers to (n)ewwnym
account; similar to famous nym.alias.net"
  :type 'string
  :group 'tipgp-mode-definitions
  )


(defcustom tipgp-:mode-prefix-key-nymserver "\C-c/.y"
  "*Keymap prefix for nymserver type anon server commands.
The default prefix key is C-c / . y; where p refers to n(y)mserver
account; similar to ex-anon.penet.fi.

As of writing this,  the only active remailer that resembles 'penet' is
anon.nymserver.com"
  :type 'string
  :group 'tipgp-mode-definitions
  )


;;}}}
;;{{{ setup: user config

;;; ........................................................ &v-config ...
;;; PGP executable settings


;;  This variable is defconst purposively, reset it in tipgp-:load-hook
;;
(defcustom tipgp-:encrypt-interactive-option
  '(format "+comment=\"Processed by Emacs TinyPgp.el %s\""
	   (tipgp-version-number))
  "*Extra encrypt option passed to PGP; use only \"+comment=\\\"\\\"\".
This varaible is EVALUATED; so it can contain lisp FORM."
  :type 'sexp
  :group 'tipgp-pgp
  )

;;; ....................................................... &v-pgp-exe ...


(defcustom tipgp-:pgp-exe
  (or (ti::f-get-load-path "pgp" (delete "." exec-path))
      (error "\
TinyPgp: tipgp-:pgp-exe, Please set absolute path.")
      )
  "*PGP executable. Use absolute path name for greater speed."
  :type 'file
  :group 'tipgp-pgp
  )


(defcustom tipgp-:pgp-exe-version
  ;;  Try to find it out, this slows down loading this package though...
  ;;
  (tipgp-exe-get-version nil 'shell)
  "*String of current pgp version in use. Support only US and International."
  :type '(choice
	  (const "2.6.3")
	  (const "2.6.3i")
	  (const "2.6.3ia")
	  (const "2.6.2")
	  )

;;;  '(string :valid-regexp "^2\\.6"
;;;	     :error "Only PGP 2.6.* is supported.")

  :group 'tipgp-pgp
  )


(defconst tipgp-:pgp-exe-support-table
  '(;; will generate a file with the specified filename, containing <nnn>
    ;; random bytes, to allow other programs to benefit from PGP's
    ;; strong random-number generator.
    ;;
    (random  "+makerandom=")

    ;;  This prints trust parameters
    ;;
    (trust   "-km")

    )
  "Support table of undocumented commands for your PGP binary.
These commands are usually available in 2.6.3, but they just aren't
include in PGP documentation.")



(defcustom tipgp-:pgp-exe-charset "noconv"
  "*See PGP documentation.
You can set this variable only once during the session. If you
change it later, you have to reload tinypgp.el.

Possible choices according to Pgp 2.6.3ia manual
  noconv	,No conversion
  latin1	,ISO 8859-1
  koi8		,Eastern countries eg. Russia
  cp850		,ms-dos users in Europe"

  :type '(choice
	  (const "noconv")
	  (const "latin1")
	  (const "koi8")
	  (const "cp850")
	  )
  :group 'tipgp-pgp
  )


(defcustom tipgp-:pgp-sh-exe
  (or (ti::f-get-load-path "sh" (delete "." exec-path))
      (error "\
TinyPgp: tipgp-:pgp-sh-exe, Please set absolute path.")
      )
  "*Shell executable. Use absolute path name like /bin/sh for greater speed.
This variable must be SHELL that understands following environment
variable setting syntax:

   set VARIABLE=value"
  :type 'file
  :group 'tipgp-pgp
  )


;;; ......................................................... &v-files ...

;;; Please do not add exension to these files!
;;; --> PGP itself adds extension if it needs to create any additional files.
;;;
(defcustom tipgp-:file-source  (tipgp-path "pgp-src")
  "*Source file fed to PGP. Region is written to this file and."
  :type 'file
  :group 'tipgp-file
  )

(defcustom tipgp-:file-output  (tipgp-path "pgp-out")
  "*Output file produced by PGP when it gets `tipgp-:file-source'."
  :type 'file
  :group 'tipgp-file
  )

(defcustom tipgp-:file-password  (tipgp-path "pgp-pwd")
  "*File where to save the password only during calling PGP.
The file is immediately deleted after PGP has finished."
  :type 'file
  :group 'tipgp-file
  )

(defcustom tipgp-:file-user-list  (tipgp-path "pgp-lst")
  "*File where to store user list. (eg. when encrypting)."
  :type 'file
  :group 'tipgp-file
  )


(defcustom tipgp-:file-key-cache  (tipgp-path "tipgp-cache")
  "*File where to store key cache."
  :type 'file
  :group 'tipgp-file
  )


;;; .......................................................... &v-user ...


(defcustom tipgp-:user-primary
    (or (car-safe (ti::mt-email-from-string user-mail-address))
	(error
	 "\
TinyPgp: tipgp-:user-primary, Set user-mail-address to foo@site.com: '%s'"
	 user-mail-address
	 ))
  "*Variable is used when you decrypt mail in buffer.

o  whatever your logical user id may
   be currently, it is changed to this

After decrypt has finished, the previous user identity is restored.
This should provide smooth processing of incoming encrypted messages,
while you may be doing something else."
  :type 'string
  :group 'tipgp-mode
  )


(defcustom tipgp-:user-identity-table  nil
  "*When decrypting, this table is consulted for right active pgp user.

Format:
  '((\"key-hex-id\"  \"key-id\")
    ( k-h-i         k-i)
    )

The encrypted PGP ascii armor is examined and if the found
hex key-id match K-H-I, then switch to k-i (usually mode descriptive
email string) as a current PGP user.

Example:

 (setq tipgp-:user-identity-table
   '(
     ;;  My known public keyid firsname.surname@site.com
     (\"12345670\"  \"firsname.surname\")

     ;;  If I receive pgp message from nymserver, then use my
     ;;  nymserver user id

     (\"12345678\"  \"an12345@anon.nymserver\")
     ))"
  :type '(repeat
	  (list
	   (string :tag "Key-id (8 hex)"
	   (string :tag "Clear text User id")
	   )))
  :group 'tipgp-mode
  )

;;; .......................................................... &v-misc ...



(defcustom tipgp-:register  ?/
  "*Register used to store the contents of PGP output."
  :type 'character
  :group 'tipgp-mode
  )


(defcustom tipgp-:password-protection  t
  "*If this variable is non-nil, use extra caution to protect the password.
Set this to t only if you're in UNIX system where
the processes commands can be seen by running 'ps'. This variable
prohibits using PGP's -z flag and forces using file descriptors
which cannot be snooped so easily.

Set the variable to t only if your PGP understands env variable PGPPASSFD
and that it can use many file descriptors."
  :type 'boolean
  :group 'tipgp-pgp
  )


(defcustom tipgp-:password-keep-time (* 15 60)         ;; 15 minutes default
  "*How many seconds to keep password in memory before forgetting it.
Set to nil, if you want to be asked password every time when you sign
a message."
  :type 'integer
  :group 'tipgp-mode
  )



(defcustom tipgp-:decrypt-arg-interpretation  nil
  "*How to interpret prefix argument to `tipgp-decrypt-mail' (interacive only).
This variable is used _only_ if function is called interactively.
If non-nil, then meaning of the prefix arg passed to function
`tipgp-decrypt-mail' is reversed."
  :type 'boolean
  :group 'tipgp-mode
  )


(defcustom tipgp-:mail-fcc-encrypt-mode nil
  "*Non-nil  save Message in encrypted format.
See \\[tipgp-mail-fcc-encrypt-mode-toggle]"
  :type 'boolean
  :group 'tipgp-mode
  )

(defcustom tipgp-:finger-discard-by-regexp (user-login-name)
  "*When fingering email addresses, discard those that match regexp.
Please look at variable `tipgp-:finger-discard-email-hook' for more."
  :type 'string
  :group 'tipgp-mode
  )

;;; ........................................................ &v-labels ...

(defcustom tipgp-:label-table
  '((v	    ("v+" "v-"))
    (s	    "s")
    (d	    "d")
    (e	    "e")
    (pgp    "pgp")
    )
  "*Labels to attach to messages.
There are two ways to use labels in your mail agent. Here is one style,
where a general label is attached first anf then the short flags. The advantage
of this is that you can summarize a) all 'pgp' labels b) summarize
'pgp' labels _and_ decrypted messages 'd'. See TinyRmail.el That adds
new command to RMAIL to do this kinf of label _and_ operation.

   pgp,v+	PGP message, verified
   pgp,v+,d	PGP message, verified and decrypted
   pgp,v-,d	PGP message, verify failed and decrypted

Or you could leave out the general label out and mark each pgp actions with

  pgp+v
  pgp+v, pgp-d
  pgp-v, pgp-d

Choose your style, but remember that shortest labels are the best.

Format:
 '((v   (OK-VERIFY-LABEL NOK-VERIFY-LABEL)
   (s   SIGN-LABEL)
   (d   DECRYPT-LABEL
   (e   ENCRYPT-LABEL)
   (pgp PGP-GENERAL-LABEL)   << can be empty string or nil
   ))"
  :type '(list
	  (list (const v :tag "verify") (list string string))
	  (list (const s :tag "sign")    string)
	  (list (const d :tag "decrypt") string)
	  (list (const e :tag "encrypt") string)
	  (list (const pgp :tag "pgp")   string)
	  )
  :group 'TinyPgp
  )

;;; ................................................... &v-tables-misc ...

(defcustom tipgp-:pubring-table
  (list
   (list
    "default"

    (let* ((file  (tipgp-path "pubring.pgp"))
	   )
      (if (file-exists-p file)
	  file
	(error "\
TinyPgp: tipgp-:pubring-table, Please configure, cannot find pubring"))
      )

    "-"
    )
   )
  "*Pubrings, their alias names and mode line indicator.

Description:

  Possible pubrings user can select. Make sure your primary
  pubring is first in the list and that the others come
  in order of importance. The last one is least unimportant
  keyring. When searching for key, this is the search order.

To remember:

  Your primary pubring must be first.

  Your merged keyring must be last. When you're encrypting to
  multiple people, pgp needs one big pubring which contains
  all keys for those people that your encrypring the message. When
  program sees that you have multiple CC, BCC or To recipients,
  it automatically sets the active pubring to the last one in this
  list.

Tip:

  Please use some common convention when creating new pubring, eg.
  use name \"pr-\" to denote pubring and add the descriptor acter it.
  pr-elisp.pgp            ;; my pgp keys for my elisp mates
  pr-news.pgp             ;; occasional users from newsgroups
  pr-pgpnews.pgp          ;; the pgp newsgroup people pubring
  ...
  pr-temp.pgp             ;; temporary storage that I may discard any time
  pr-all.pgp              ;; Merged, pubring for all. maybe keyserver ring.

Format:

  '((COMPLETION-STRING PUBRING-FILE MODE-STRING) (COMP PUB-F MODE-S) ..)

  COMPLETION-STRING is 'nice name' for the pubring.

  PUBRING-FILE is the absolute filename where pubring resides.

  MODE-STRING is displayed in the modeline to show which pubring
  you have active. Please choose some non-word character to give
  you enough visible hint which pubring you use currently. Eg.

    -      default
    =      secondary
    *      special, whole keyserver pubring."

  :type '(repeat
	  (list
	   (string :tag "Pubring completion name")
	   (file   :tag "Pubring filename")
	   (string :tag "String, One character modeline indicator")
	   ))
  :group 'tipgp-mode
  )


(defcustom tipgp-:header-sign-table
  '(("@" ("subject" "reply-to" )) ;Always use these
    )
  "*List of headers that should be signed along with the message.

Format:
 '((REGEXP '(HEADER-NAME-STRING HEADER-NAME-STRING ..) [NO-XPGP-MODE])
   (R '(H H ..) [X])
   )

REGEXP	      If matches To-field or Newsgroup-field, the HEADER-LIST is used.
	      You should not sign reply-to field if the destination
	      address changes the field contents. Many times mailing
	      list do this.
HEADER-LIST   If it is empty, no headers are included in signing.
NO-XPGP-MODE  This field is optional. If it is non-nil, then when you
	      do signing, this flag is consulted. If the to-field matches
	      the no X-Pgp signing is done, no matter what the
	      `tipgp-:xpgp-signing-mode' says currently. In some cases
	      you can't send X-pgp signed messages to the destination
	      address.

References:

  `tipgp-:xpgp-signing-mode'"
  :type '(repeat
	  (list
	   (string :tag "Regexp matching To/Newsgroups")
	   (repeat (string :tag "Header field to be signed"))
	   ))
  :group 'tipgp-header
  )




(defcustom tipgp-:keyserver-mail-table
  '(
    ;; US
    ("pgp.mit.edu"	    "pgp-public-keys@pgp.mit.edu")
    ("martigny.ai.mit.edu"  "public-key-server@martigny.ai.mit.edu")
    ("ias.edu"		    "pgp-public-keys@pgp.iastate.edu")
    ("burn.ucsd.edu"	    "pgp-public-keys@burn.ucsd.edu")
    ("gondolin.org"	    "pgp-public-keys@gondolin.org")

    ;;  Europe
    ("uni-hamburg.de"	    "pgp-public-keys@fbihh.informatik.uni-hamburg.de")
    ("ox.ac.uk"		    "pgp-public-keys@pgp.ox.ac.uk")
    ("dsi.unimi.it"	    "pgp-public-keys@dsi.unimi.it")
    ("kub.nl"		    "pgp-public-keys@kub.nl")
    ("upc.es"		    "pgp-public-keys@goliat.upc.es")


    ;;  Rest that I don't know
    ("ext221.sra.co.jp"	    "pgp-public-keys@ext221.sra.co.jp")
    ("sw.oz.au"		    "pgp-public-keys@sw.oz.au")
    ("kiae.su"		    "pgp-public-keys@kiae.su")
    ("srce.hr"		    "pgp-public-keys@srce.hr")
    ("pipex.net"	    "pgp-public-keys@pgp.pipex.net")
    )
  "*List of available Email keyservers.
See PGP faq \"8.2. What public key servers...\" for updated list.
http://www.prairienet.org/~jalicqui/pgpfaq.txt

Format:
 '((COMPLETION-NAME EMAIL-ADDRESS))
   (COMP-N EMAIL-A)
   ..
   )"
  :link '(url-link :tag "PGP faq"
		 "http://www.prairienet.org/~jalicqui/pgpfaq.txt")
  :type '(repeat (list string string))
  :group 'tipgp-interface
  )

;;  Change this defconst in load-hook if you know what you are doing.
;;
(defcustom tipgp-:keyserver-http-table
  '(("www-swiss.ai.mit.edu" "/htbin/pks-extract-key.pl?op=get&search=%s")

    ("geronimo.uit.no"
     "/cgi-bin/pks-extract-key.eng.bal.pl?op=get&search=%s")

    ("pgp.ai.mit.edu"  "/htbin/pks-extract-key.pl?op=get&search=%s")
    )
  "*List of available http keyservers.
Be sure that you put your nearest/fastest keyserver first in the list.
It is offered as default connection.

Format:

  '((KEYSERVER COMMAND)
    (KEYSERVER COMMAND)
    ...
    )"
  :type '(repeat (list string string))
  :group 'tipgp-interface
  )

;;; ................................................... &v-auto-action ...

(defcustom tipgp-:auto-action-encrypt-regexp nil
  "*Bulk encryption regexp to match all members in To, CC, BCC.
This is special auto action variable and it is used only if
there is more than _one_ address where you're sending a message.
Typical situation: You want to send encrypted mail to Cc'd
mwmbers who also have pgp.

The regexp s matched idividually against each member in To, Cc and Bcc
fields. If regexp didn't match for each member, then the auto encryption
is not engaged.

You must know for sure who have pgp and those pople's keys must
be stored in big pubring 'all'. (see `tipgp-:pubring-table')"
  :type '(string :tag "Regexp")
  :group 'tipgp-mode
  )


(defcustom tipgp-:auto-action-sign-mail-mode-no-form  nil
  "*FORM to decide when not to auto-sign.

Form return values:

  nil	Use auto-signing
  t     Ignore auto-signing for this message

Example:

  ;;  Do not sign messages that are sent to my fellow
  ;;  workers at domain 'foo'. Ie. sign messages to the outside
  ;;  world.
  ;;
  (setq tipgp-:auto-action-sign-mail-mode-no-form
    '(not (string-match \"foo\" (or (ti::mt-get-field \"to\") \"\"))))"
  :type 'sexp
  :group 'tipgp-mode
  )


(defcustom tipgp-:auto-action-table  nil
  "*Automatic encrypt and sign control table.
When there is only _one_ email destination (no CC, BCC and one entry in To)

Format:
 '((EVAL-OR-REGEXP  [SIGN-KEY-ID] [ENCRYPT] [XPGP] [KEYRING])
   ..
   )

  EVAL-OR-REGEXP: Regexp means matching on To field contents.
  *Note* To field must have address including @ character otherwise no
  comparision is done.

  If you use EVAL, then you can refer to variable 'to-field' in the
  form that builds up eval. You can also search the buffer for specific
  strings before determining if the actions defined should be
  engaged.

  SIGN-KEY-ID is optional and if it contains key-id, that is used
  to sign the message. If value is SYMBOL instead of string _and_
  the ENCRYPT is et, then the result is 'one pass' encrypt and sign and
  not separate encrypt + sign.

  ENCRYPT is optional and if it non-nil, the message is encrypted according
  to TO field content.

  XPGP is optional and non-nil means signing by using X-Pgp headers;
  if this is nil, then use regular signing.

  KEYRING is optional string and tells which file to use as pubring
  when doing the encryption/signing. It defaults to current keyring in use.

  The following example demonstrates EVAL-use of this variable, there are
  three entries in this list.
  o   If newsgroup field is found from the message and
      it matches to pgp groups, then sign every mail.
  o   if to-field matches person foo@site.com, then the mail
      is encrypted and signed. (in this order)
  o   If message is sent somewhere else than my current domain,
      sign it.

  (setq tipgp-:auto-action-table
    '(
      ;;  elt 1
      ((let ((grp  (ti::mt-get-field \"Newsgroups\"))
	    )
        ((string-match \"pgp\" (or grp \"\"))))
        \"me@foo\")

      ;; elt 2
      (\"foo@site.com\" \"me@foo\" 'enc)

      ;; elt 3
      ((not (string-match \"@mysite.com\" to-field))
       \"me@foo\")
      ))

Note 1:

  If message _already_ contains some Pgp data (signed; encrypted)
  this variable is not used, because it's supposed that the user is
  controlling the layout of PGP message.

Note 2:

  This variable is used only if you send message to _one_
  destination. If any CC or BCC is found from the message or if To:
  field contains comma, then this variable is not used.

Note 3:

  All mode settings are overriden. Toggling modes on/off do not
  affect auto-action command.

Note 4:

  The order of regexp elements is important: first one matched is used
  and the rest of the list is forgotten."

  :type	 '(repeat
	   (list
	    (sexp       :tag "To field regexp")
	    (boolean    :tag "Sign flag")
	    (boolean    :tag "X-pgp flag")
	    (file       :tag "Keyring file used:")
	    ))
  :group 'tipgp-mode
  )



;;}}}
;;{{{ setup: header

;;; ........................................................ &v-header ...

(defcustom tipgp-:xpgp-signing-mode t
  "*Non-nil if X-Pgp signing is used.

References:
  `tipgp-:header-sign-table'   ,this overrides `tipgp-:xpgp-signing-mode'

See \\[tipgp-xpgp-header-mode-toggle]"
  :type 'boolean
  :group 'tipgp-header
  )

(defcustom tipgp-:xpgp-user-info
  '(format "Comment= \"Processed by Emacs TinyPgp.el %s\""
	   (tipgp-version-number)
	   )
  "*Additional information added to X-Pgp header.
Set this variable to STRING-OR-EVAL-FORM that you wish to include
in X-Pgp. The correct keywords are defined in X-Pgp standard.
ftp://cs.uta.fi/pub/ssjaaa/pgp-xhd.html#additional_keywords:_telling_how_to

Notes:

  DO NOT put newline code at the end of string.
  Put 2 spaces before each statement line (except first line).
  Every keyword must end to semicolon!
  Enclose strings in double quotes.

Full Example:

  (setq tipgp-:xpgp-user-info
   '(concat
     \"  Fingerprint=\\\"12 92 9C E4 60 DF 62 CD FC AD 18 47 9A 74 E7 D1\\\";\\n\"
     \"  Length=1024; Id=0x17D57681;\"
     \"  Access-type=Finger; Address=foo@site.com;\\n\"
     (format \"  Comment=\\\"Processed by Emacs TinyPgp.el %s\\\";\"
	    (tipgp-version-number))
     ))

Recommended Example (only essential keywords):

  (setq tipgp-:xpgp-user-info
   '(concat
     \" Id=0x17D57681; Access-type=Finger; Address=foo@site.com;\\n\"
     (format \"  Comment=\\\"Processed by Emacs TinyPgp.el %s\\\";\"
	    (tipgp-version-number))
     ))"
   :type '(sexp :tag "String of Form")
   :group 'tipgp-header
   )

;;}}}
;;{{{ setup: remail private

;;; ....................................................... &vp-remail ...
;;; Private

(defvar tipgp-:r-levien-table nil
  "Updated by program. List of remailers and their properties.")


(defvar tipgp-:r-host-table nil
  "Updated by program. List of accepted remailers and their properties.")


(defvar tipgp-:r-history  nil
  "History.")

;;; #Todo: should be removed and trust Raph's remailer list?
;;;
(defconst tipgp-:r-control-list nil
;;;  '(("replay"   ("ek"))			;does no support this
;;;    ("dustbin"  nil ("post"))		;supports this
;;;    ("haystack" nil ("post"))		;supports this
;;;    )
  "List of remailers and additional property control.")


(defvar tipgp-:r-mode-indication-flag  nil
  "Non-nil means that current message should be treated with caution.
Eg. if you encrypt the message, there will be no extra
PGP 'Comment' keywords included that may reveal your identity.")

(make-variable-buffer-local 'tipgp-:r-mode-indication-flag)
(put 'tipgp-:r-mode-indication-flag 'permanent-local t)

;;}}}
;;{{{ setup: remail user config


;;; ................................................... &v-remail-hook ...

(defcustom tipgp-:r-post-before-hook 'tipgp-r-post-before-default
  "*Things to do before converting message to anonymous format.
Turn off/exit all minor modes that may interfere the process."
  :type 'hook
  :group 'tipgp-remail
  )


(defcustom tipgp-:r-reply-block-basic-hook  nil
  "*Hook that is run after reply block is added."
  :type 'hook
  :group 'tipgp-remail-hook
  )


;;; ........................................................ &v-remail ...
;;; User config


(defcustom tipgp-:r-list-file
  (let ((file "~/.remailer.lst"))
    ;;
    ;;  Suppose we have low quota account; use .gz file if it exists.
    ;;  the regular file is not checked here: it is checked when
    ;;  user uses the remail functions.
    ;;
    (if (file-exists-p (concat file ".gz"))
	(concat file ".gz")
      file))

  "*Remailer list file. See `tipgp-r-update-remailer-list'."
  :type 'file
  :group 'tipgp-remail
  )



(defcustom tipgp-:r-user-mail-address user-mail-address
  "*Email address of your reply block.
This account may be different from your regular email address."
  :type 'string
  :group 'tipgp-remail
  )



(defcustom tipgp-:r-list-finger  "remailer-list@kiwi.cs.berkeley.edu"
  "*Finger address where to get updated remailer list."
  :type 'string
  :group 'tipgp-remail
  )


(defcustom tipgp-:r-post-host  "replay"
  "*Remailer alias through which you want to send you usenet posts.
Variable is not a email address, but the remailer alias name according
to levien remailer list. This variable can contain lisp FORM,
because it is evaled.

Must support properties: POST PGP HASH CUTMARKS."
  :type 'string
  :group 'tipgp-remail
  )

(defcustom tipgp-:r-chain  nil
  "*Remailer chain table. List of remailer.
Only remailers that at least have properties PGP HASH EK are allowed.

Format:

 '((COMPLETION-NAME
    [vector		    or (lisp-form-to-evaluate; must return vector)
     (REMAILER
      latent-time	    this is optional
      encrypt-key	    this is optional
      )
     (REMAILER
      ...
      )
     ]
    )
   ...
   )

Exampes:

  (defconst tipgp-:r-chain
    '((\"1-way\"     [(\"replay\" \"+0:05r\" \"ZepHyR1x\")])
      ;;  Select random path
      (\"hide\"      (progn (shuffle-vector [(\"replay\") (\"dustbin\")])))
      ;;  Use some reliable remailer, but hide identity better
      (\"milkyway\"  [\"replay\" \"replay\" \"replay\"])
      ))"
  :type 'sexp
  :group 'tipgp-remail
  )



(defcustom tipgp-:r-subject-table
  '(" dummy"
    " This is a test"
    " ignore this message"
    " Regarding your previous message"
    " As for the www and html..."
    " Re: about the last subject..."
    " Re: Programming langueges.. "
    )
  "*List of dummy Subject sentences that are used in your Remailer message.
The subject should be such that it doesn't draw your sysadm's attention."
  :type '(repeat (list string))
  :group 'tipgp-remail
  )


(defcustom tipgp-:r-reply-block-table  nil
  "*Correct reply block for each remailer.
Suggested filename could be ~/.r-dustbin for dustbin remailer.
You can place anything after the last -----END PGP MESSAGE-----
because the reply block is only read from `point-min' to this
tag line and rest of the file is ignored.

File format:

    ::
    Request-Remailing-To: remailer@replay.com
    Latent-Time: +0:00

    ::
    Encrypted: PGP

    -----BEGIN PGP MESSAGE-----
    Version: 2.6.3ia

    hIkDPRWysueuweUBA+jLifdDpkCxcUYA
    ...
    -----END PGP MESSAGE-----

    #
    # this is comment
    # this is another comment
    # end of file

Variable format:

'((REMAILER-ALIAS FILE)
  (R F)
  ..
  )"
  :type '(repeat
	  (list
	   (string :tag "Remailer alias")
	   (file   :tag "Reply block File")
	   ))
  :group 'tipgp-remail
  )


(defcustom tipgp-:r-header-keep-list '("Gcc" "Fcc")
  "*In addition to srict RFC headers; keep these headers too.
When you compose anon post, all the unnecessary headers will be
killed so that your identity is not revealed by accident.
This is list f headers that are preserved in addition to RFC headers.
Please do not include colon or spaces.

FormaT:
  '(\"hdr1\" \"hdr2\" ..)"
  :type '(repeat string)
  :group 'tipgp-remail
  )

;;; ........................................................ &v-newnym ...

(defcustom tipgp-:newnym-default-account-name nil
  "*If nil, then ask account name each time.
If string, then this should be the nym account name that you use
with `tipgp-:newnym-default-server'. This will be the default
answer to all newnym account name questions."
  :type 'string
  :group 'tipgp-newnym
  )


(defcustom tipgp-:newnym-default-server nil
  "*If nil, ask newnym server each time.
If string, then this should be the server alias name; like 'weasel'.
This is the default aswer to all server questions."
  :type 'string
  :group 'tipgp-newnym
  )


(defcustom tipgp-:r-newnym-help-file  nil
  "*Remailer 'newnym' help file."
  :type 'file
  :group 'tipgp-newnym
  )


(defconst tipgp-:newnym-cmd-table
  '(("acksend"
     "per-message: automatic acknowledgment of successfully remailed message."
     "Default: -acksend"
     )
    ("signsend"
     "per-message: automatic PGP signing of any outgoing mail."
     "Default: -signsend"
     )
    ("cryptrecv"
     "automatic encryption with your nym's public key."
     "Default: +cryptrecv"
     )
    ("fixedsize"
     "all messages padded to exactly the same size (roughly 10K)"
     "Default: -fixedsize"
     )
    ("disable"
     "4 Megabytes per day disables account, notified if this happens."
     "Default: -disable. Re-enable account with -disable."
     )
    ("fingerkey"
     "Allow people to finger <yournym@weasel.owl.de> for you PGP key."
     "Default: -fingerkey"
     )
    ("name"
     "\
Describe text of nym >> From: YOUR-NAME-DESC-HERE <yournym@weasel.owl.de>"
     "Default: name=\"\". Example: name=\"Your Alias Name\""
     )
    ("create"
     "\
Create fails if a nym exists. Use Create? for updating nym. (sign message)."
     "Example: create/create?"
     )
    ("delete"
     "Deletes your alias and wipes your reply block. Acknowledged."
     "<no other options>"
     )
    ("nobcc"
     "\
Counce bcc, only  To, Cc, Resent-To, or Resent-Cc accepted. (SPAM protect)"
     "Default: -nobcc"
     )
    ))
  "Newnym command table.
Format:
 '((COMMAND DESC cmd-example-or-defauilt-value)
   (COMMAND DESC cmd-example-or-defauilt-value)
   ..
   )"

;;; ....................................................... &vp-remail ...
;;; Private variables.


(defvar tipgp-:r-reply-block-cache  nil
  "Reply block cache.

Format:
 '((BUFFER PGP-BEG PGP-END)
   (B P-B P-E)
   )")

;;}}}
;;{{{ setup: Nymserver

;;; ....................................................... &nymserver ...


(defcustom tipgp-:nymserver-request-encrypt  nil
  "*To send every command to 'nymserver' account in encrypted format.
NOTE: You must have inserted the Server's PGP key into the keyring."
  :type 'boolean
  :group 'tipgp-nymserver
  )


;;;  Currently this is not user variable
;;;  There is only one nymserver type remailer currently active.
;;;
(defconst tipgp-:nymserver-table
  '(("nymserver"
     tipgp-nymserver-create-1 "request@anon.nymserver.com"
     "anon@anon.nymserver.com"
     3
     ))
  "Table of 'nymserver' type services.
Format:

  '((SERVER-ALIAS-STRING
     ACCOUNT-CREATE-FUNCTION
     ACCOUNT-CREATE-EMAIL-ADDRESS
     SERVER-EMAIL-POST-TO
     NEWSGROUP-POST-COUNT-LIMIT
     )
    (S A A S N )
    ..
    )"
  )

;;;  When you receive account creation confirmation; update
;;;  this variable immediately.
;;;
(defcustom tipgp-:nymserver-account-table nil
  "*Your nymserver account information table.

'((SERVER-ALIAS-STRING
   ACCOUNT-EMAIL
   ACCOUNT-PASSWORD
   [ACCOUNT-NICKNAME-STRING | nil ]
   [FROM-ADDRESS	    | nil ]
   [HELP-FILE		    | nil ]
   ))


You get the slots ACCOUNT-EMAIL, ACCOUNT-PASSWORD when you order an
account from the server. The ACCOUNT-NICKNAME-STRING can be nil,
because nymserver also controls your Nickname. This overrides
the server's value.

FROM-ADDRESS

    is important. When you orderd acoount from nymserver, it
    allocates only your current address and handles only messages sent from
    that address.

       aa@a.com  --> you ordered anon account here.
       bb@b.com  you have another normal account here
       cc@c.com  you have yet another normal account here

    Suppose you want to post from account bb@b.com as anon. Can't
    do that because nymserver expects you to be only in aa@a.com, in the
    site where you initially ordered the anon account.

    Now, if you set FROM-ADDRESS to aa@a.com, then the From-field is inserted
    into the message pretending that the mail is coming from aa@a.com and
    now you can use your Anon account from different sites.

HELP-FILE

    If the E-mail message that contained the server manual which explains
    all its features. Store the mail to this file;

Example:

 (defconst tipgp-:nymserver-account-table
  '((\"nymserver\"
     \"an1111@anon.nymserver.com\"
     \"qF8asdd\"
     \"\"
     \"my.name@address.com\"
     \"~/txt/nymserver.hlp\"
     )))"
  :type '(list
	  (const "nymserver" :tag "Server")
	  (string :tag "Account email")
	  (string :tag "Account ppassword")

	  ;; optional
	  ;;
	  (string :tag "nickname")
	  (string :tag "From address")
	  (file   :tag "Help file")
	  )
  :group 'tipgp-nymserver
  )

;;}}}

;;{{{ setup: private

;;; ....................................................... &v-private ...

(defvar tipgp-:debug nil
  "If non-nil, then record activity during commands.")

(defvar tipgp-:debug-buffer-size  40000
  "The buffer size after which the debug buffer is emptied.
If you don't see all the information, increase size.")

(defvar tipgp-:key-cache nil
  "Cache: '((key-id, pubring, public-key) (...)).")

(defvar tipgp-:key-cache-last  nil
  "Last accessed 'get element in cache. See function `tipgp-key-cache'.
(ORIGINAL-EMAIL (CACHE-KEY PUBRING ..))")

(defvar tipgp-:return-value  nil
  "Common retun value between functions.
This variable is used as a signal to TinyPgp when it has called
some user function or hook. The usage is explained in
the functions that use it. It will contain properties too.")


(defvar tipgp-:buffer-tmp-shell  "*tipgp-shell-tmp*"
  "Temporary buffer.")


(defvar tipgp-:buffer-tmp-finger  " *tipgp-finger-tmp*"
  "Temporary buffer.")

(defvar tipgp-:buffer-tmp-copy  " *tipgp-copy-tmp*"
  "Temporary buffer.")


(defvar tipgp-:buffer-tmp-http  " *tipgp-http-tmp*"
  "Temporary buffer.")


(defvar tipgp-:buffer-tmp-kring  " *tipgp-kring-tmp*"
  "Temporary buffer.")


(defvar tipgp-:buffer-tmp-show  " *tipgp-show-tmp*"
  "Temporary buffer.")

(defvar tipgp-:buffer-tmp-mail  " *tipgp-mail-tmp*"
  "Temporary mail buffer.")


(defvar tipgp-:buffer-tmp  " *tipgp-tmp*"
  "Temporary buffer.")


(defvar tipgp-:buffer-debug  "*tipgp-debug*"
  "Debug buffer.")

(defvar tipgp-:buffer-newnym "*mail-newnym*"
  "Newnym remailer mail buffer.")


(defvar tipgp-:buffer-comint  "tipgp-comint"
  "Interactive comint buffer to talk with PGP.
This buffer name will automatically have stars over the name.")


(defvar tipgp-:buffer-view  "*tipgp-view*"
  "Interactive comint buffer to talk with PGP.
This buffer name will automatically have stars over the name.")


(defvar tipgp-:original-buffer  nil
  "Original buffer storage. Set in macro `tipgp-run-in-tmp-buffer'.")


(defvar tipgp-:pgp-email-list nil
  "List of email addresses in ~/.emailrc.")

(defvar tipgp-:pgp-email-abbrev-list  nil
  "List of abbrevs and their expansions: '((\"abb\" . \"expa\") ..).")


(defvar tipgp-:pgp-email-list-completions nil
  "Email assoc menu for completion. '((\"a@b.com\" . 1) ..)
This variable is initalized to the contents of your
~/.mailrc file.")


(defvar tipgp-:sign-data  nil
  "Stored sign information for current message.
Used for checking message tampering afterwards.

Format:
  number   ,message body length in characters.")
(make-variable-buffer-local 'tipgp-:sign-data)
(put			    'tipgp-:sign-data 'permanent-local t)

;;; ....................................................... &vp-colors ...

(defvar tipgp-:face-mark 'highlight
  "The face for text marking.")

(defvar tipgp-:face-error 'bold
  "The face for pointing out errors.")

;;; ...................................................... &vp-history ...

(defvar tipgp-:history-key-info  nil
  "History of used key info strings.")

(defvar tipgp-:history-email  nil
  "User email history.")

(defvar tipgp-:history-newnym-account  nil
  "Nym account name history.")

(defvar tipgp-:history-r-chain  nil
  "Remailer chain selection history.")


;;; ..................................................... &vp-commands ...

(defconst tipgp-:pgp-command-table
  (let* ((charset (ti::s-sqz (if (var-nil-p tipgp-:pgp-exe-charset)
				 "noconv"
			       tipgp-:pgp-exe-charset
			       )))
	 (common2			;Without batch mode
	  (concat
	   " +nomanual "
	   " +encrypttoself=off "
	   " +verbose=1 "
	   " +showpass=off "		;There is no cmd line arg
	   " +language=en "		;don't use language modules
	   ;; The PGP compress ratio is like 1,6M text --> 600k
	   ;;
	   " +armorlines=0 "		;No separate UU chunks
	   " +charset=" charset
	   " "
	   ))

	 (common
	  (concat
	   common2
	   " +batchmode "
	   " "
	   ))
	 )
    (list
     ;; Encrypt and output ascii ascii
     (list
      'encrypt
      (concat common " #PUBRING -eatf #SOURCE-FILE #MUSER ") ;Multiple users
      )

     (list
      'encrypt-sign
      (concat (concat common " #PUBRING -eatfs #MUSER #PGP-USER #password"))
      )

     (list
      'decrypt
      (concat (concat common " #PUBRING -f #password "))
      )

     (list
      'decrypt-base64
      (concat (concat common " -f  "))
      )

     (list
      'crypt
      (concat (concat common2 " -a -c "))
      )

     (list
      'sign
      (concat (concat common " #PUBRING -satf #USER #password "))
      )

     (list
      'sign-detach
      (concat (concat common " #PUBRING -bsatf #USER #password "))
      )

     (list
      'verify
      (concat (concat common " #PUBRING -f "))
      )

     (list
      'key-get
      (concat (concat common " #PUBRING -kaf "))
      )

     (list
      'key-info
      (concat (concat common " #PUBRING -kvc "))
      )

     (list
      'key-add
      (concat (concat common " #PUBRING -fka "))
      )
     (list
      'key-extract
      (concat (concat common " #PUBRING -fkxa "))
      )
     (list
      'key-delete
      (concat (concat common " +force #PUBRING -kr "))
      )
     (list
      'key-sign-a
      (concat (concat common " +force #PUBRING #USER -ks "))
      )
     (list
      'key-sign-b
      (concat (concat common " +force #PUBRING #USER -krs "))
      )
     (list
      'key-generate
      (concat (concat common2 " #PUBRING -kg "))
      )

     ))
  "PGP command table. Do not touch.")


(defconst tipgp-:pgp-exe-error-regexp
  (concat
   "Bad pass phrase"
   "\\|user ID is required"
   "\\|Unable to get terminal"
   "\\|Transport armor stripping failed"
   "\\|Encryption error"
   "\\|No such file or directory"
   "\\|Cannot find the public key"
   "\\|Output file.*already exists"
   "\\|You do not have the secret key needed to decrypt this file\\."
   "\\|We need to generate.*bits"      ;; Can I handle this in the prg?
   "\\|Key matching userid.*not found in file"
   "\\|Key matching.*not found in file"

;;; Signature validation....
;;;   "\\|Key matching expected Key ID.*not found in file"

   "\\|Keyring extract error\\."
   ;;  When removing keys...
   "\\|Do you also want to remove it from.*[?]"
   )
  "All error messages from PGP executable.
These are case sensitive sentences.")


(defconst tipgp-:pgp-exe-error-regexp-quiet
  (concat
   "Bad pass phrase"
   "\\|Cannot find the public key"
   "\\|Key matching userid.*not found in file"
   "\\|Key matching.*not found in file"
   )
  "List of errors that does not bring up the Shell Error buffer.
The buffer contain the last PGP executable call.
Consider these errors so familiar that you don't have to
examine the shell error message better.")


(defvar tipgp-:error  nil
  "Last error message.")


(defvar tipgp-:last-pgp-exe-command  nil
  "Last command sent to PGP exe.")


;;; .................................................... &vp-pass-hash ...

(defvar tipgp-:hash-password  (make-vector 100 nil)
  "Stored passwords, expired periodically.")

;;  Some variables must be stored locally, but some variables must
;;  be globally visible; becfause on error conditions the
;;  current buffer may have changed and in order to restore
;;  situation, we must do lookup from GLOBAL array, because we don't
;;  know any more what was the starting buffer.
;;
(defvar tipgp-:hash  nil
  "General _local_  hash storage.")
(make-variable-buffer-local 'tipgp-:hash)

(defvar tipgp-:hash-global  nil
  "General _global_ hash storage.")

;;; ......................................................... &vp-misc ...

(defvar tipgp-:header-sign-smf-info  nil
  "The header SMF data that was constructed is stored here.")

(defvar tipgp-:pubring-now  (nth 1 (car tipgp-:pubring-table))
  "Current pubring in use.")

(defvar tipgp-:user-now
  (let* ((em user-mail-address)
	 )
    (cond
     ((not (stringp em))
      (error "\
TinyPgp: tipgp-:user-now, user-mail-address is not str like foo@site.com"))

     ;;  If you have <> in user-mail-address that messes up From
     ;;  field.
     ;;
     ((string-match "<.*@.*>" em)
      (error "\
TinyPgp: tipgp-:user-now, please remove <> from user-mail-address")
      ))
    (car (ti::mt-email-from-string em))
    )
  "Current user.")

(defvar tipgp-:last-network-error  nil
  "Last finger call error text.")

;;}}}

;;; ########################################################### &Funcs ###

;;{{{ Bug report

;;; ........................................................... &debug ...

;;; ----------------------------------------------------------------------
;;;
(defmacro tipgpd (&rest args)
  "Generate debug if debug is on and output ARGS."
  (`
   (when tipgp-:debug
     (let* ( ;; write to package's private buffer.
	    (ti:m-debug-buffer tipgp-:buffer-debug)
	    )
       (save-match-data
	 (d!! (,@ args) "\n")

	 ;;  don't let it grow without limit....
	 ;;
	 (job-buffer ti:m-debug-buffer
	   (if (and (integerp tipgp-:debug-buffer-size)
		    (> (buffer-size) tipgp-:debug-buffer-size))
	       (erase-buffer)))
	 )))))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-debug-toggle  ()
  "Toggle package debug."
  (interactive)
  (var-toggle tipgp-:debug)
  (message "TinyPgp debug is %s" (if tipgp-:debug "on" "off"))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-debug-buffer-clear ()
  "Clear the debug buffer."
  (interactive)
  (use-tmp-buffer tipgp-:buffer-debug 'clear)
  (if (interactive-p) (message "TinyPgp: Debug buffer cleared."))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-password-wipe-buffer (&optional force)
  "Wipe password strings from buffer. This may not succeed if cache is empty.
If FORCE is non-nil ask interactively.
If force is nil, then get the passwords from cache and
if they are not in cache any more this function is no-op.

Normally getting passwords from cache is performed in `mail-send-hook'"
  (interactive (list (interactive-p)))
  (let ((fid  "tipgp-password-wipe-buffer:")
	passwd
	serv-passwd
	)

    (cond
     (force
      (setq passwd (tipgp-password-get-old "\
I need pass phrase to wipe out all references to it: "))

      (setq
       serv-passwd (tipgp-nymserver-password
		     (tipgp-nymserver-ask
		      "Nymserver server you have used: "
		      )))
      )
     (t
      (if (vec-arr-get tipgp-:hash-password tipgp-:user-now) ;; is it there ?
	  (setq passwd (vec-arr-prop
			tipgp-:hash-password tipgp-:user-now 'password)))
      ;;
      ;;  Actually there may be multiple passwords if user has several PGP
      ;;  keys (common, if you use remailers)
      ;;
      ;; #todo: We don't know nymserver password, because it is not in hash

      (mapatoms
       (function
	(lambda (x)
	  (when x
	    ;;  (d! x)
	    )))
       tipgp-:hash-password)
      ))

    ;; finally, scramble any pass pharases, so that they are not sent
    ;; to Maintainer!
    ;;

    (save-line-col nil nil
      (when passwd (PMIN) (replace-string passwd "#PASSWD-WAS-HERE"))
      (when serv-passwd
	(PMIN) (replace-string serv-passwd "#PASSWD-WAS-HERE-ANON"))
      )
    (tipgpd fid "out:" (current-buffer))
    nil					;Clean return value
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-submit-bug-report ()
  "Submit bug report or feedback.
When you call this function it automatically includes all needed
buffers. Please leave the *Backtrace* buffer before you call this function
and it will be copied too.

If this is feedback call, then do not include any extra buffers.
[Answer 'n' when to insert questions]"
  (interactive)
  (let (
	)
    (ti::m-pkg-submit-bug-report
     "tinypgp.el"
     tipgp-:version-id
     '(tipgp-:version-id

       mail-mode-hook
       rmail-mode-hook
       vm-mode-hook
       vm-version
       message-mode-hook
       gnus-article-mode-hook
       gnus-version
       news-reply-mode-hook
       mh-show-mode-hook
       mh-letter-mode-hook
       mh-before-send-letter-hook
       mh-show-hook
       mh-e-version

       tipgp-:load-hook
       tipgp-:mode-hook
       tipgp-:turn-on-hook-list
       tipgp-:sig-from-header-hook
       tipgp-:sig-to-header-hook
       tipgp-:sign-loose-info-hook
       tipgp-:key-mode-define-keys-hook
       tipgp-:do-command-region-before-hook
       tipgp-:do-command-region-after-hook
       tipgp-:cmd-macro-before-hook
       tipgp-:cmd-macro-after-hook
       tipgp-:verify-before-hook
       tipgp-:verify-after-hook
       tipgp-:read-email-after-hook
       tipgp-:find-by-guess-hook
       tipgp-:finger-discard-email-hook
       tipgp-:r-post-before-hook
       tipgp-:r-post-after-hook
       tipgp-:nymserver-post-hook
       tipgp-:r-post-before-hook
       tipgp-:r-reply-block-basic-hook
       tipgp-:define-keys-hook

       tipgp-:pgp-encrypted-p-function
       tipgp-:decrypt-arg-interpretation
       tipgp-:pgp-decrypt-arg-function
       tipgp-:pgp-command-compose-function
       tipgp-mode
       tipgp-:mode-name
;;;       tipgp-:mode-menu-name
;;;       tipgp-:mode-map
       tipgp-:mode-prefix-key
       tipgp-:mode-prefix-key-remailer
       tipgp-:mode-prefix-key-nymserver
       tipgp-key-mode
;;;       tipgp-:key-mode-map
;;;       tipgp-:key-mode-menu
       tipgp-:key-mode-menu-name
       tipgp-:key-mode-prefix-key
       tipgp-:xpgp-user-info
       tipgp-:pgp-exe-charset
       tipgp-:pgp-sh-exe
       tipgp-:pgp-exe
       tipgp-:file-source
       tipgp-:file-output
       tipgp-:file-password
       tipgp-:file-user-list
       tipgp-:file-key-cache
       tipgp-:face-mark
       tipgp-:face-error
       tipgp-:register
       tipgp-:finger-discard-by-regexp
       tipgp-:password-protection
       tipgp-:password-keep-time
       tipgp-:user-primary
       tipgp-:filter-email-function
       tipgp-:auto-action-sign-mail-mode-no-form

;;; Do not send this to maintainer!
;;;       tipgp-:user-identity-table
       tipgp-:header-sign-table
;;;       tipgp-:keyserver-mail-table
       tipgp-:auto-action-table
       tipgp-:pubring-table
       tipgp-:r-levien-table
       tipgp-:r-host-table
       tipgp-:r-history
       tipgp-:r-mode-indication-flag
       tipgp-:r-list-file
       tipgp-:r-user-mail-address
       tipgp-:r-list-finger
       tipgp-:r-newnym-help-file
       tipgp-:r-post-host
       tipgp-:r-chain
       tipgp-:r-reply-block-table
       tipgp-:r-reply-block-cache
       tipgp-:nymserver-request-encrypt
       tipgp-:nymserver-account-table
       tipgp-:debug
       tipgp-:debug-buffer-size
       tipgp-:key-cache
       tipgp-:key-cache-last
       tipgp-:return-value
       tipgp-:buffer-tmp-shell
       tipgp-:buffer-tmp-finger
       tipgp-:buffer-tmp-copy
       tipgp-:buffer-tmp-http
       tipgp-:buffer-tmp-kring
       tipgp-:buffer-tmp-show
       tipgp-:buffer-tmp-mail
       tipgp-:buffer-tmp
       tipgp-:buffer-comint
       tipgp-:buffer-view
       tipgp-:original-buffer
       tipgp-:xpgp-signing-mode
       tipgp-:mail-fcc-encrypt-mode
       tipgp-:history-email
;;;       tipgp-:pgp-email-list
;;;       tipgp-:pgp-email-abbrev-list
;;;       tipgp-:pgp-email-list-completions
       tipgp-:sign-data
       tipgp-:history-key-info
       tipgp-:error
       tipgp-:last-pgp-exe-command
;;;       tipgp-:hash-password
;;;       tipgp-:hash
       tipgp-:header-sign-smf-info
       tipgp-:pubring-now
       tipgp-:user-now
       tipgp-:last-network-error
       tipgp-:nymserver-echo-menu-use-p

       tipgp-:key-mode-name
       tipgp-:encrypt-interactive-option
       tipgp-:pgp-exe-support-table
;;;       tipgp-:keyserver-http-table
       tipgp-:r-control-list
;;;       tipgp-:r-subject-table
       tipgp-:nymserver-table
;;;       tipgp-:pgp-command-table
       tipgp-:pgp-exe-error-regexp
;;;       tipgp-:nymserver-echo-menu
       tipgp-:key-cache

       ))
    (save-excursion
      (end-of-buffer)

      (when (get-buffer "*Backtrace*")
	(insert "\n\n#BACKTRACE BEGIN-------------\n")
	(insert-buffer (get-buffer "*Backtrace*")) (PMAX)
	(insert "\n\n#BACKTRACE END-------------\n")
	)

      (when (and (get-buffer tipgp-:buffer-tmp-shell)
		 (y-or-n-p "Insert PGP shell buffer contents? "))
	(insert "\n\n#SHELL BEGIN-------------\n")
	(insert-buffer (get-buffer tipgp-:buffer-tmp-shell)) (PMAX)
	(insert "\n\#SHELL END-------------\n")
	)


      (cond
       ((or
	 (and
	  (null (get-buffer tipgp-:buffer-debug))
	  (y-or-n-p
	   "No debug buffer: Are you sure maintainer doesn't need it? "))
	 (y-or-n-p "Insert the debug buffer contents too? ")
	 )
	(insert "\n\n#DEBUG BEGIN-------------\n")
	(insert-buffer tipgp-:buffer-debug) (PMAX)
	(insert "\n\#DEBUG END-------------\n")
	))

      (tipgp-password-wipe-buffer 'force)
      )
    (read-char-safe-until
     "[press]Please check that your pass phrase wasn't included...")
    ))

;;}}}
;;{{{ macros: test-p

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-sign-data-same-p ()
  "Compare previous signing info against current buffer content.
If this function returns non-nil, the buffer has been changed and
it should be resigned."
  (eq (ti::mt-message-length) tipgp-:sign-data))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-sign-data-set ()
  "Store sign information."
  (if (ti::mt-mail-p)
      (setq tipgp-:sign-data (ti::mt-message-length))))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-sign-mail-auto-mode-on-p  ()
  "Check if autosign is active."
  (memq 'tipgp-sign-mail-func  mail-send-hook))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-mail-buffer-p  (&optional msg-flag)
  "Check if buffer looks like mail message.
Non-nil MSG-FLAG displaysmessage if test is nil."
  ;;  GNUS 5 uses message-mode
  ;;
  (if (ti::mt-mail-p)
      t
    (if msg-flag
	(message-quick "This PGP action is available only in mail, news"))
    nil
    ))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-hidden-p  ()
  "Check if the PGP BLOCK is hidden.
Return:
  nil
  (point . invisible-property-value)"
  (let* ((point (point-min))		;Before widen
	 (pmax  (+ (point-max) (* 80 6))) ;lookahead about 6 full lines
	 pos
	 prop
	 )
    ;;  first find our property. Then see if it's invisible
    ;;
    (when (and
	   ;;  In RMAIL buffer this widens a lot!
	   (safe-widen
	     (setq pos (text-property-any
			point
			;; Select lookahead or point-max.
			;; In RMAIL the pmax is selected.
			;;
			(min pmax (point-max))
			'owner 'tipgp)))
	   (setq prop (get-text-property pos 'invisible))
	   )
      (cons pos prop)
      )))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-user-find-current  ()
  "Find current user.

If buffer is read-only (supposing RMAIL, VM):

  look at the PGP stream in buffer and consult `tipgp-:user-identity-table'.

If buffer is writable:

  Do nothing special."
  (let ((type   (tipgp-hash 'action 'get 'now))
	key-id
	elt
	)
    (cond
     ((or (not buffer-read-only)
	  tipgp-:r-mode-indication-flag
	  )
      nil
      )
     (t
      (setq type (save-excursion
		   (PMIN)
		   (ti::mt-pgp-stream-forward-and-study)
		   ))
      (when (and (eq (car type) 'enc)
		 (setq key-id (nth 3 type))
		 (inline
		   (setq elt
			 (list-find
			  tipgp-:user-identity-table key-id))
		   ))
	(nth 1 elt)
	)))))

;;}}}
;;{{{ macros: misc

;;; .......................................................... &macros ...
;;; Macros must be defined before used --> top of file

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-email-or-string  (string)
  "Return email address fromt STRING or STRING itself."
  (or (strmatget "[^< \t]+@[^ >\t]+" 0 string)
      string))

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-comint-buffer  ()
  "Return comint buffer name."
  (concat "*" tipgp-:buffer-comint "*"))

;;; ----------------------------------------------------------------------
;;; - This "stringifies" a regexp :-)
;;;
(defsubst tipgp-cnv  (string)
  "Remove possible anchor tag or other RE tags from STRING."
  (ti::s-del-re "[\n\r?$^]+" string))



;;; ----------------------------------------------------------------------
;;;
(defmacro tipgp-do-shell-env (&rest body)
  "Excute BODY in specific shell environment."
  (`
   (let* ((explicit-shell-file-name	tipgp-:pgp-sh-exe)
	  (shell-file-name		tipgp-:pgp-sh-exe)
	  )
     (if (null explicit-shell-file-name);; nop-op Quiet XE ByteCompiler
	 (setq explicit-shell-file-name nil))
     (,@ body)
     )))


;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-save-state-macro 'lisp-indent-function 0)
(defmacro tipgp-save-state-macro (&rest body)
  "Save key values of program and execute BODY."
  (`
   (let ((TIPGP-user  tipgp-:user-now)	;Mixed case: Prevent variable suicide
	 (TIPGP-userp tipgp-:user-primary)
	 (TIPGP-pring tipgp-:pubring-now)
	 (TIPGP-h-s-t tipgp-:header-sign-table)
	 (TIPGP-x-s-m tipgp-:xpgp-signing-mode)
	 )
    (prog1 (progn (,@ body))
      (setq tipgp-:user-now		TIPGP-user
	    tipgp-:user-primary		TIPGP-userp
	    tipgp-:pubring-now		TIPGP-pring
	    tipgp-:header-sign-table	TIPGP-h-s-t
	    tipgp-:xpgp-signing-mode	TIPGP-x-s-m
	    )))))


;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-run-in-tmp-buffer  'lisp-indent-function 1)
(defmacro tipgp-run-in-tmp-buffer  (buffer &rest body)
  "Use BUFFER, which is copy of current buffer, and do BODY.
All text properties in the copy are removed. If BUFFER is nil,
then use internal temporary buffer.

Note:
  The `set-buffer' command leaves pointer to copy buffer.

References:
  `tipgp-:original-buffer' from where the text was copied."
  (`
   (let ((Data-buffeR		(current-buffer))
	 BuffeR
	 )
     (setq BuffeR (or (, buffer) (tipgp-use-tmp-buffer 'copy)))

     (setq tipgp-:original-buffer Data-buffeR)	;save position

     (job-buffer BuffeR
       (erase-buffer)
       (insert-buffer Data-buffeR)
       ;; Because the SIG may be hidden, make it visible
       (ti::t-wipe-properties (point-min) (point-max))
       (,@ body)
       ))))



;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-pubring-set-big  ()
  "Set `tipgp-:pubring-now' to point to big pubring."
  (setq tipgp-:pubring-now
	(nth 1 (car (reverse tipgp-:pubring-table)))))


;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-set-pgp-env-macro 'lisp-indent-function 2)
(defmacro tipgp-set-pgp-env-macro (user-list &optional verb &rest body)
  "Set envinronment. Find correct keyring and switch to it temporarily.
But only if USER-LIST length is 1; if list is longer, use big pubring
that holds all keys. The VERB parameter must also be set. Do BODY.

Error is signalled if we can't find keyring."
  (`
   (tipgp-save-state-macro
     ;;  Let's be a little user friendly and try finding the key
     ;;
     (let ((user   (cond
		    ((stringp (, user-list))
		     (, user-list))

		    ((and (listpp (, user-list))
			  (eq 1 (length (, user-list))))
		     (car (, user-list)))
		    ))
	   kring
	   )
       (when (, verb)

	 (cond
	  (user
	   (if (not (setq kring (tipgp-key-find-by-guess user)))
	       (error "Sorry, can't set keyring '%s'. Fetch key first." user)
	     (tipgpd "tipgp-set-pgp-env-macro" (, user-list) kring )
	     (setq tipgp-:pubring-now kring)
	     ))

	  ((listpp (, user-list))
	   ;;  Multiple users, set pubring to point to BIG RING
	   ;;
	   (tipgpd "tipgp-set-pgp-env-macro: LAST KRING")
	   (tipgp-pubring-set-big)
	   )))
       (tipgpd "tipgp-set-pgp-env-macro: BODY " verb (, user-list)
	       tipgp-:pubring-now)

       (,@ body)
       ))))


;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-user-change-macro  'lisp-indent-function 0)
(defmacro tipgp-user-change-macro  (&rest body)
  "Change pgp user if From field address match `tipgp-:user-identity-table'.
If there is no From field or match this macro does nothing to BODY."
  (`
   (let (UseR
	 )
     (tipgp-save-state-macro
       (if (setq UseR (tipgp-user-find-current))
	   (setq tipgp-:user-now UseR))
       (,@ body)
       ))))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-x-headers-deinstall ()
  "Move X-pgp signature to normal format (if X-pgp exist)."
  (tipgpd "tipgp-x-headers-deinstall")
  (if (ti::mt-pgp-headers-p)
      ;;   Move X-pgp headers to their normal places
      ;;
      (tipgp-signature-from-header)
    ))




;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-pubring-complete (&optional prompt init)
  "Read the pubring name with PROMPT and INIT. Return nil or selected string."
  (let ((ans
	 (completing-read
	  (or prompt "Select pubring: ")
	  (list-to-assoc-menu (mapcar 'car tipgp-:pubring-table))
	  nil 'require-match init
	  ))
	)
    (if (var-nil-p ans)
	nil
      ans
      )))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-name2alias  (str table)
  "Return Nth 0 when NTH 1 STR is given from TABLE."
  (let* (ret
	 )
    (dolist (elt table)
      (when (string= str (nth 1 elt))
	(setq ret elt)
	(return)))
    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-alias2name  (str table)
  "Return Nth 1 when NTH 0 STR is given from TABLE."
  (nth 1 (assoc str table)))



;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-pubring-alias2file  (name)
  "Find real pubring behind completion NAME."
  (if name
      (expand-file-name (nth 1 (assoc name tipgp-:pubring-table)))))



;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-pubring-file2alias  (name)
  "Find alias for real pubring NAME. Return nil if no match."
  (when name
    (setq name (expand-file-name name))
    (car-safe
     (list-find
      tipgp-:pubring-table name
      '(string= arg (expand-file-name (nth 1 (car table))))
      ))))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-pubring-list  ()
  "Return all pubrings known to program."
  (let (list
	)
    (dolist (elt tipgp-:pubring-table)
      (push (expand-file-name (nth 1 elt)) list))
    list
    ))




;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-pubring-change-to-current ()
  "Change to pubring relative to current user.
Calling functionshould possibly save the `tipgp-:pubring-now'."
  (setq tipgp-:pubring-now
	(or (tipgp-key-find-by-cache tipgp-:user-now)
	    tipgp-:pubring-now)))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-user-change-to-primary  ()
  "Change current variable settings to reflect primary user.
The calling function should copy the key values of TinyPgp
before calling this function.

This also changes the pubring.

Reference:
  `tipgp-save-state-macro'"
  (tipgpd "tipgp-user-change-to-primary" tipgp-:user-primary )
  (setq tipgp-:user-now    tipgp-:user-primary)
  (setq tipgp-:pubring-now
	(expand-file-name
	 (if (tipgp-key-find-by-cache
	      tipgp-:user-now)
	     (nth 1 (car tipgp-:pubring-table)))))
  )




;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-randseed-file  ()
  "Return randseed filename."
  (or (getenv "RANDSEED")
      (format "%s/%s"
	      (expand-file-name (or (getenv "PGPPATH") "~/.pgp"))
	      "randseed.bin")
      ))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-finger-email-filter (list)
  "Filter out unwanted entries from email LIST."
  (when list
    (setq  list (tipgp-email-discard-default list))
    (when tipgp-:finger-discard-email-hook
      (setq list (run-hooks-until
		  'tipgp-:finger-discard-email-hook nil list)))
    list
    ))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-email-find-region (beg end)
  "Read all email addressed from BEG END and filter out unwanted ones.
See. `tipgp-:finger-discard-email-hook'."
  (tipgp-finger-email-filter (ti::mt-email-find-region beg end 'no-dupes)))

;;}}}

;;{{{ misc: messages, error; hash; whatever...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-error  (message)
  "Generate error using MESSAGE and show buffer `tipgp-:buffer-tmp-shell'.
If the error is in list `tipgp-:pgp-exe-error-regexp-quiet' then the
shell buffer is not shown."
  (tipgpd "tipgp-error" message )

  (if (not (string-match tipgp-:pgp-exe-error-regexp-quiet message))
      (switch-to-buffer-other-window  tipgp-:buffer-tmp-shell))

  ;;  We must close the EDIT-RMAIL etc. before calling error.
  ;;
  (run-hooks-until 'tipgp-:cmd-macro-after-hook nil 'cancel)
  (tipgp-password-expire-now)
  (error "[PGP exe error] %s" message)
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-unfinished-function  ()
  "Signal error."
  (let* (
         )
    (if  (not (string= (getenv "USER") "jaalto"))
	(error "\
Function you tried to call is not yet operational; it's on todo list."))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-initial-message  ()
  "[This message is displayed until package is labelled alpha].

General

  While reading this message the TinyPgp.el is already fully
  operational. Try turning on `tipgp-mode' with \\[tipgp-mode]

  The latest manual can be found from

	ftp://cs.uta.fi/pub/ssjaaa/tipgp.html

  I regret that you have to read this message, but as long as this package
  is Beta, I have taken measures to inform possible newbies. If you
  know enough emacs lisp, you can suppress this initial, one time only,
  message.  Once the message has been displayed, you can reload TinyPgp
  multiple times and you won't see it again unless you call
  \\[tipgp-initial-message]

RELEASE NOTE FOR 1.236+

  (new) Newnym type account management support is quite good already.
  (new) Remailer chains are now fully supported; but untested.

  VM support should be quite good

Using unofficial X-pgp header signing

  Please read section 'Using PGP headers' from the manual before using
  X-Pgp feature.

  When you have understood the note, configure your mail/news agent
  properly. Set also variable `tipgp-:header-sign-table' to announce your
  finger address and make sure that your X-Pgp keywords are
  correctly placed. (See notes in the variable documentation.)

Errors

  Expect that you get errors from TinyPgp from time to time and to help me
  to catch the source, you must know how to send me good bug reports. Please
  read he manual how you send good bug reports.

  Also be sure to turn on `tipgp-:debug' immediately when you get and
  error. Repeat the task and then hit \\[tipgp-submit-bug-report] which
  will automatically copy the debug information to me.

  The debug buffer *tipgp-debug* adds cumulatively data to it, so make sure
  it is cleared before you start an 'error session'. That way the debug
  info contains straigh transactions between BEGINNING of session and END,
  in this case the ERROR.

  Contact me immediately when you find anything, because I may already have
  new version of this program running and if there is fortunate star on the
  sky, the error may have been noticed and fixed already by me.

  Emacs debug and TinyPgp debug is now ON, and you should install
  fdb.el so that you don't loose your nerves on non-important
  regular Emacs errors.
  ftp://ftp.csd.uu.se/pub/users/andersl/emacs/fdb.el"

  (interactive)
  (let* ((win  (selected-window))
	 )
    (tipgp-version)
    (PMIN) (insert (documentation 'tipgp-initial-message)) (PMIN)
    (select-window win)
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-hash (var-sym mode &optional property value global)
  "Set or get data from obarray.
This function is used for internal data handling for current buffer.

Input:

  VAR-SYM	variable name as symbol
  MODE		'put or 'get and 'def checks if defined
  PROPERTY	property name
  VALUE         value for property
  GLOBAL	Instead of using buffer local hash, use global hash table

References:
  `tipgp-:hash'
  `tipgp-:hash-global'"

  ;; Make sure these two are initialized.
  (unless (vectorp tipgp-:hash)
    (vec-arr-init  tipgp-:hash)
;;;    (tipgpd "HASH INIT" tipgp-:hash)
    )

;;;  (tipgpd "HASH" var-sym mode property tipgp-:hash)

  (or (vectorp tipgp-:hash-global)
      (vec-arr-init  tipgp-:hash-global))

  (let* ((hash (if global tipgp-:hash-global tipgp-:hash))
	 )

    (if (symbolp var-sym)
	(setq var-sym (symbol-name var-sym))
      (error "TinyPgp: Must give a symbol '%s' " var-sym))

    (cond
     ((eq mode 'def)
      (let* ((sym (vec-arr-get hash var-sym))
	     )
	(if (null property)		;Check only if variable exist.
	    (vec-arr-get hash var-sym)
	  (when sym			;Check property list
	    (memq property (symbol-plist sym))
	    ))))

     ((eq mode 'get)
      (if (vec-arr-get  hash var-sym)	;Exist ?
	  (vec-arr-prop hash var-sym property)))

     ((eq mode 'put)
      (vec-arr-get  hash var-sym 'allocate)
      (vec-arr-prop hash var-sym property value 'set)
      )
     (t
      (error "TinyPgp: No such mode '%s' ." mode)
      ))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-update-modeline ()
  "Set correct mode name."
  (let* ((fid   "tipgp-update-modeline:")
	 (str   " pgp")
	 elt
         )
    (if elt (setq elt nil))	;No-op, XE byteComp silencer

    ;;  This makes sense only if mode is on.
    ;;
    (when tipgp-mode
      (tipgpd fid  "BEGIN")


      ;; ................................................ update hooks ...
      ;;  Keep the hooks in proper order, Call function only
      ;;  periodically every 20th time. (it's too heavy operation to
      ;;  run all the time)
      ;;
      (unless (setq elt (tipgp-hash 'vital-hook 'get 'counter nil 'global))
	(setq elt 1)
	(tipgp-hash 'vital-hook 'put 'counter 0 'global)
	)

      (when (zerop (% (inc elt) 20))
	(tipgp-install-hooks-vital)
	(setq elt 1)
	)
      (tipgp-hash 'vital-hook 'put 'counter elt 'global)

      ;; .............................................. update pubring ...
      (setq elt (tipgp-pubring-elt))

      (setq str (concat			;Set pubring indicator
		 str
		 (or (nth 2 elt)
		     (error "\
Internal error tipgp-:pubring-table tipgp-:pubring-now conflict"))))


      ;; ...................................................... remail ...
      (if tipgp-:r-mode-indication-flag
	  (setq str (concat str "r")))

      (when tipgp-:read-email-after-hook
	(if (tipgp-key-id-conversion-check)
	    (setq str (concat str "E"))
	  (setq str (concat str "e"))
	  ))

      ;;  Hmm, Should I call (tipgp-header-sign-active-list)
      ;;  Which tells if this message will have headers?
      ;;
      ;;  Right now I just show the mode.
      ;;
      (if tipgp-:header-sign-table
	  (setq str (concat str "h")))

      (if tipgp-:xpgp-signing-mode
	  (setq str (concat str "x")))

      (if (tipgp-sign-mail-auto-mode-on-p)
	  (setq str (concat str "A")))

      (if tipgp-:mail-fcc-encrypt-mode
	  (setq str (concat str "F")))


;;;      (if (tipgp-nymserver-mail-p)
;;;	  (setq str (concat str "n")))

      (if tipgp-:newnym-default-server
	  (setq str (concat str "N")))


      (cond
       ((tipgp-auto-action-multiple-addresses-p)
	(setq str (concat str "$"))
	(unless (tipgp-hash 'auto-action 'get 'user-mode)
	  (setq str (concat str "-"))))

	((tipgp-auto-action-on-p)
	 (setq str (concat str "!"))
	 (unless (tipgp-hash 'auto-action 'get 'user-mode)
	   (setq str (concat str "-")))
	 ))

      ;;  check if we know this person: is the
      ;;  public key pubring info in cache?
      ;;
      (when (and (null buffer-read-only) ;skip RMAIL
		 (inline (ti::mt-mail-p))
		 (setq elt (car-safe (ti::mt-email-from-string
				      (ti::mt-get-field-1 "to"))))

		 ;;  Call the conversion if it is activated,
		 ;;  save possibly one function call
		 ;;
		 (or (and tipgp-:read-email-after-hook
			  (setq elt (car-safe (tipgp-key-id-conversion elt))))
		     t)
		 (inline (tipgp-key-find-by-cache elt "modeline"))
		 )
	;;  Yes, key is known
	(setq str (concat str "k"))
	)



      (setq tipgp-:mode-name str)
      (ti::xe-modeline-update)
      )

    ;;  These modes may have dynamic mode name later
    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  key mode . .
    (when  tipgp-key-mode
      (setq tipgp-:key-mode-name " pgpK")
      (ti::xe-modeline-update))

    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. summary mode . .
    (when  tipgp-summary-mode
      (setq tipgp-:summary-mode-name " pgp-sum")
      (ti::xe-modeline-update))

    (tipgpd fid  "END")
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-highlight
  (regexp &optional level point face ov-type arg1 arg2 arg3)
  "Mark text forward.
If Emacs does not support highlight, this function does nothing.

Input:

  REGEXP	string to search
		 This can also be symbol with spcial meaning.
		 Additional arguments are passed in other variables.
		 'delet-all      remove all _tipgp_ overlays
		 'wipe-all       delete ALL overlays and faces
		 'match          mark matched text

  LEVEL		which level in string to match, defaults to 0
  POINT		from which point forward, defaults to `point-min'
  FACE          defaults to `tipgp-:face-mark'
  OV-TYPE       overlay type information. Defaults to 'mark
  ARG1          additional arguments to 'match
  ARG2
  ARG3"
  (when (face-supported-p)

    (let* ((fid "tipgp-highlight: ")
	   plist
	   )

      (setq face    (or face  tipgp-:face-mark)
	    level   (or level 0)
	    ov-type (or ov-type 'mark)	;used to be overlay type
	    )

      (setq plist			;property list
	    (list 'owner    'tipgp
		  'type     ov-type
		  'face     face
		  ))

      (tipgpd fid "r" regexp "l" level "point" point face ov-type
	      (current-buffer)
	      )

      (save-excursion
	(cond
	 ((stringp regexp)
	  (goto-char (or point (point-min)))
	  (tima-re-search regexp nil level nil plist))

	 ((eq regexp 'match)
	  (tipgpd fid "level" level arg1 arg2)
	  (tima-match-level level plist arg1 arg2))

	 ((eq regexp 'delete-all)
	  (tima-clear-region-properties (point) (point-max) '(owner tipgp) ))

	 ((eq regexp 'wipe-all)
	  (set-text-properties (point) (point-max) nil))

	 (t
	  (error "TinyPgp: No such action as '%s'" regexp)
	  ))
	))))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-set-session-parameters  (action)
  "Set program flags according to ACTION.
In some cases the program's parameters must be in certain state
before ACTION 'sign 'encrypt 'decrypt 'verify is carried out.

Here is one reason to do so:

  When you sign create command to 'newnym' account: the X-Pgp
  signing must not be used, No headers must be signed.

This function should be inside wrapper macro that saves the previous
state of session. Use `tipgp-save-state-macro'.

Return:
 t	    if state changed
 nil	    nothing done"
  (when (ti::mt-mail-p)
    (let* ((to    (or (ti::mt-get-field-1 "to") ""))
	   ret
	   )
      (cond
       ((string-match "@weasel\\|@squirrel" to)	;Newnym remailers
	(setq tipgp-:header-sign-table nil
	      tipgp-:xpgp-signing-mode nil
	      ret t
	      )
	))
      ret
      )))





;;; ----------------------------------------------------------------------
;;;
(defun tipgp-highlight-wipe ()
  "Wipe all TinyPgp highlighting from buffer."
  (interactive)
  (tipgp-highlight 'delete-all nil (point-min))
  (if (interactive-p)
      (message "TinyPgp: all 'tipgp face and overlay coloring wiped."))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-add-signature-if-signing  (cmd user password msg string)
  "Insert ~/.signature if CMD is 'sign in mail like buffers.

Input:
  CMD
  USER
  PASSWORD
  MSG
  STRING"
  (let* ((file  "~/.signature")
	 )
    ;; Gnus 5 composes messages in message-mode, we don't touch
    ;; that buffer because Gnus 5 can add signature when
    ;; you compose the mail.
    ;;
    (when (and (memq major-mode '(mail-mode news-reply-mode))
	       (eq 'sign cmd)
	       (file-exists-p file)
	       )
      (save-excursion
	(PMAX)
	(insert-file-contents file)
	;;  According to RFC there must be "-- \n" before signature.
	(ti::mt-signature-insert-break)
	)
      nil
      )))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mime-exit  (&rest args)
  "Exit possible mime mode. Ignore ARGS."
  (cond
   ((and (featurep 'tm-edit)		;Is TM loaded to emacs?
	 mime/editor-mode-flag		;is the mode on in buffer?
	 )
    (mime-editor/exit)
    )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-after-pgp-command  (&optional cmd &rest args)
  "Example function: run after you have excuted and some PGP command.
If buffer contains diff (after decrypting) and you have tinydiff.el
loaded, call function `tdi-patch' to apply that diff.

Input:
  CMD	    ,'encrypt 'sign 'verify ...
  ARGS	    ,ignored"
  (if (and (fboundp 'tdi-patch)
	   ;;  We suppose that we're in incoming RMAIL or VM buffer
	   ;;
	   (memq major-mode '(rmail-mode vm-mode))
	   (memq cmd '(verify decrypt))
	   (ti::b-diff-type-p)		;Is there diff
	   )
      (call-interactively 'tdi-patch))
  nil
  )



;;}}}
;;{{{ misc: file control; abbrevs

;;; ........................................................ &pgp-misc ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-show-last-finger-error  ()
  "Show last finger error message in echo area."
  (interactive)
  (if (stringp tipgp-:last-network-error)
      (message tipgp-:last-network-error)
    (message "No Finger error information.")))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-view-register (&optional noerr)
  "View content of register.
Do not signal error if the register `tipgp-:register' is empty and
NOERR is non nil. NOERR is automatically t if function is called
interactively."
  (interactive)
  (let* ((reg   tipgp-:register)
	 (msg   (format "TinyPgp: register '%c' doesn't contain data yet."
			tipgp-:register))
         )
    (if (not (stringp (get-register reg)))
	(if noerr nil
	  (if (interactive-p)
	      (message msg)
	    (error msg)))
      (pop-to-buffer (use-tmp-buffer tipgp-:buffer-view 'clear))
      (insert-register tipgp-:register)
      (PMIN)
      (if (interactive-p)
	  (message-quick (format "Register '%c' content" tipgp-:register)))
      )))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-file-control  (mode &optional arg)
  "Do file operation according to MODE and ARG.
See source code for more information."
  (let* (buffer
	 )
    (tipgpd "file-control in:" mode arg)


    (cond
     ((eq 'all-kill mode)
      (file-delete-safe
       (list
	tipgp-:file-source
	tipgp-:file-output
	tipgp-:file-password
	tipgp-:file-user-list
	)))

     ((eq 'password-write mode)
      (job-buffer (tipgp-use-tmp-buffer)
	(insert arg)
	(file-delete-safe tipgp-:file-password)
	(write-region (point-min) (point-max) tipgp-:file-password)
	(file-mode-protect tipgp-:file-password)
	(erase-buffer)			;Remove passwd info from buffer
	))

     ((eq 'password-kill mode)
      (file-delete-safe tipgp-:file-password))


     ((eq 'source-kill mode)
      (file-delete-safe tipgp-:file-password))


     ((eq 'source-write mode)
      (file-delete-safe
       (list tipgp-:file-source
	     (concat tipgp-:file-source ".asc")))
      (write-region (point) (point-max) tipgp-:file-source)
      (file-mode-protect tipgp-:file-source)
      )

     ((eq 'users-write mode)
      (file-delete-safe tipgp-:file-user-list)
      (setq buffer (tipgp-use-tmp-buffer))
      (unless arg
	(error "No USER LIST"))

      (job-buffer buffer
	(dolist (elt (list-make arg)) (insert (ti::s-sqz elt) "\n"))
	(file-delete-safe tipgp-:file-user-list)
	(write-region (point-min) (point-max) tipgp-:file-user-list)
	(file-mode-protect tipgp-:file-user-list)
	)
      )

     (t
      (error "Unknown mode")))

    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mail-abbrevs-filter  (email-list)
  "Filter invalid entries out form EMAIL-LIST.
Every entry must have .xx or .xxx extension, which referes to country
name or organization form."
  (let* (ret
         )
    (dolist (elt email-list)
      (if (string-match "\\....?$" (car (ti::mt-email-from-string elt)))
	  (push elt ret)))
    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-update-mail-abbrevs  ()
  "Update mail abbrevs.
You need to do this is you have modified ~/.mailrc.
Call mailabbrev.el first to read the file."
  (interactive)
  (let* ((sym 'timi-:mail-aliases-alist)
	 list
	 )
    (tipgpd "update-mail-abbrevs 1:")


    ;;   since the tinymail.el and tinypgp.el use the same
    ;;   abbrevs list, it isn't worth to build 2 separate lists,
    ;;   because creating alist is slow!
    ;;
    ;;   Now we share the same list and the abbrevs are built by
    ;;   tinymail, which we copy here.
    ;;
    (if (and (featurep 'tinymail)
	     (boundp 'timi-:mail-aliases-alist))
	(setq  tipgp-:pgp-email-abbrev-list (symbol-value sym))
      (setq  tipgp-:pgp-email-abbrev-list (ti::m-mail-abbrevs-get-alist))
      )


    (tipgpd "update-mail-abbrevs 2:")
    (setq  tipgp-:pgp-email-list
	   (ti::m-mail-abbrevs-email-list tipgp-:pgp-email-abbrev-list))

    (tipgpd "update-mail-abbrevs 3:")
    ;;	maybe not all are valid in the obarray...
    ;;
    (setq list (funcall tipgp-:filter-email-function
			tipgp-:pgp-email-list))

    (tipgpd "update-mail-abbrevs 4:")
    (setq tipgp-:pgp-email-list-completions
	  (list-to-assoc-menu list))
    nil
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-update-mail-abbrevs-hook  ()
  "Reparse the ~/.mailrc file when it is saved.
This function is installed into `write-file-hooks'."
  (when (string-match "mailrc" (or buffer-file-name "#noName"))
    (message "Updating mail abbrevs for TinyPgp...")
    (tipgpd "update-mail-abbrevs-hook in:")
    (tipgp-update-mail-abbrevs)
    (message "Updating mail abbrevs for TinyPgp...done")
    nil					;Hook return value
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-invisible-region (beg end &optional show)
  "Make BEG END invisible. Optionally SHOW it."
  ;;  We also say that these properties belong to "tipgp"
  ;;
  (let* (buffer-read-only		;allow writing
	 )
    (save-buffer-modified
      (if (null show)
	  (set-text-properties beg end '(invisible t owner tipgp))
	(set-text-properties beg end '(invisible nil owner tipgp)))
      )))


;;}}}
;;{{{ misc: test-p, or or primitives

;;; ........................................................... &tests ...



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-password-time-valid-p ()
  "Return non-nil, if it's not yet time to forget password.
The returned value is number of seconds left."
  (let* (secs-was
	 secs-now
	 diff
	 val
	 )
    (cond
     ((not (integerp tipgp-:password-keep-time))
      nil)
     (t
      (if (null (tipgp-hash 'password-time 'get 'tick nil 'global))
	  (tipgp-hash 'password-time 'put 'tick (current-time) 'global))

      (setq val         (tipgp-hash 'password-time 'get 'tick nil 'global)
	    secs-was	(nth 1  val)
	    secs-now	(nth 1  (current-time))
	    diff	(- secs-now secs-was)
	    diff	(- tipgp-:password-keep-time diff)
	    )
;;;      (d! diff)

      (if (> diff 0)
	  diff)				;How much is left, counts down...
      ))))

;;}}}
;;{{{ misc: email and substitutions

;;; ........................................................... &email ...

(defvar tipgp-:email-substitution-table nil
  "Where this variable is used:

    Change email addresses if needed to get right public key.

    Say, the PGP key-id shows <foo@site.com> as email, but the person also
    has mailing address <foo@x-site.com>. If we receive mail from
    foo@x-site.com, PGP wouldn't find it from the database if we used
    that. Instead we must immediatelly tell 'hey, this person is known as
    <foo@site.com>' which is listed in his key-id field.

How this variable is used:

    List of email substitution. When REGEXP is matces then SUBST is used.
    SUBST is should match unique key entry in your keyrings. Best if
    SUBST is 0xFFFF key id, but many times it more descriptive to use
    alternative email address.

Where this variable is used

    In function `tipgp-email-substitution-defult' which is installed
    to `tipgp-:read-email-after-hook'

Example:

    WE CHANGE THIS VARIABLE WITH FUNCTION `tipgp-email-substitution-add'

    ;;  List of email addresses that are not in the person's pgp-key id
    ;;  Use the right Haand key when left hand matches.
    ;;
    (defconst my-:tipgp-email-substitution-table
      (list
       (cons \"xxx@.*lycaeum\"   \"yyy@lycaeum.org\")
       (cons \"xxx.*jena.de\"    \"zzz.foo@Jena.Thur.De\")

       ;; This one has multiple keys and we want to use one particular.
       ;; The 0xFFFF is unique way to tell which key to use
       ;;
       (cons \"valkyr\"	    \"0xA73B5E6D\")
       )
      \"*My email substitutions that will be added to
    `tipgp-:email-substitution-table'\")

    ;;  Now add my substitutions
    ;;
    (tipgp-email-substitution-add my-:tipgp-email-substitution-table)


Format:
  '((REGEXP  SUBST) (R S) ..)")


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-email-make-choices (email)
  "Make new choices from EMAIL.
If you try to encrypt with EMAIL and it fails; it may be
the case that the email address is not added to user's PGP key-id field.

This function examines EMAIL and constructs some suitable
choices that may match better when doing new lookup.

Return:
  nil
  (\"string\"
   ..
   )"
  (let* (list
	 str
	 s1 s2
         )

    ;;  firstname.surname@site.com --> "Firstname Surname"
    ;;
    (when (string-match "^\\(.*\\)\\.\\(.*\\)@" email)
      (setq s1 (capitalize (read-match 1 email))
	    s2 (capitalize (read-match 2 email)))

      ;;  Because the firsh name may be shortened
      ;;  "Rich" is actually "Richard", we want to add the surname
      ;;  by it self to the list too
      ;;
      (push  (concat s1 " " s2) list)
      (push s2 list)
      )

    ;;   many times the 'server' is local and is not
    ;;   included in the key id
    ;;
    ;;   @server.domain.here.com -->  "domain.here.com"
    ;;
    (if (setq str (strmatget "@[^.]+\\.\\(.*\\..*\\)" 1 email))
	(push str list))

    list
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-email-discard-default  (list)
  "Toss away addresses from LIST that are not finger sites.

In-Reply-To: <199611101605.LAA18736@site.com> from Foo Bar at..
X-Face: >>@YIrj6h"
  (let (ret
	)
    (tipgpd "tipgp-email-discard-default in: " list )

    (when list
      (dolist (elt (list-make list))
      (when (and (not (string-match
			 (concat
			  "\\(19[89][0-9]\\|200[0-9]\\)[0-9][0-9]"
			  "\\|^foo\\|^ba[zr]@\\|@site.com"
			  "\\|[^-_0-9a-zA-Z+]@"
			  )
			 elt))
		   ;;  leave only real email addresses
		   (string-match "@" elt))
	  (push elt ret))
	))
    (tipgpd "tipgp-email-discard-default out: " ret )
    (if ret (nreverse ret))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-email-substitution-add  (cons-list &optional remove)
  "Add CONS-LIST or REMOVE it from list of email substitutions.
The CONS-LIST must be in format:

'((RE . SUBST) (R . S) ..)"

(mapcar
 (function
  (lambda (x)
    (tipgp-email-substitution-add-1 x remove)))
 cons-list
 ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-email-substitution-add-1  (cons-cell &optional remove)
  "Add new CONS-CELL (RE . SUBST) to `tipgp-:email-substitution-table'.
IF REMOVE is non-nil, search for SUBST and delete the entry
from the table.

Return:
  killed entry
  added entry
  nil		;already exist(add) or not exist(remove)"
  (let* (elt
	 ret
         )
    (setq elt (rassoc (cdr cons-cell) tipgp-:email-substitution-table))
    (cond
     (remove
      (when elt
	(setq tipgp-:email-substitution-table
	      (delete elt  tipgp-:email-substitution-table))
	(setq ret elt)
	))

     ((null elt)			;Add new element if not there.
      (setq ret cons-cell)
      (push cons-cell tipgp-:email-substitution-table)
      ))
    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-email-substitution-defult (list)
  "Add LIST of email substitutions.
Refrences:
  `tipgp-:email-substitution-table'
  `tipgp-:read-email-after-hook'."
  (let* (re subst
	 copy
	 )
   (dolist (elt (list-make list))
     (dolist (s-elt tipgp-:email-substitution-table)
       (setq re (car s-elt)  subst (cdr s-elt))
       (when (string-match re elt)
	 ;;  substitute and stop loop
	 ;;
	 (setq elt subst)
	 (return))
       )
     (push elt copy)
     )
   copy
   ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-email-substitution-toggle  (&optional mode)
  "Toggle email substituition.
It is possible that you have coded an email substitution function
and installed it into `tipgp-:read-email-after-hook'.

If there is such a function; it propably converts some email addresses
to some relevant PGP key ids. However sometimes you may want to turn
off this feature completely to be sure that when reading the
email address eg from TO: field, it will also be used when calling
for encryption.

This functions toggles email substitution functions on/off by
clearing/restoring the `tipgp-:read-email-after-hook'

MODE can be
 nil	    toggle
 0 -1	    off
 other	    on"
  (interactive)
  (let* ((sym 'tipgp-:read-email-after-hook)
	 )

    ;; Not recorded; record original value
    ;;
    (if (null (get sym 'original))
	(put sym 'original (symbol-value sym)))

    (cond
     ((or (memq mode '(0 -1))
	  (symbol-value sym))
      (set sym nil)
      (message "Email substitution off."))
     (t
      (set sym (get sym 'original))
      (message "Email substitution restored to original.")
      ))
    (tipgp-update-modeline)
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-id-conversion  (single-or-list)
  "Modify SINGLE-OR-LIST and return possibly modified list.
This function stores the list to hash table and reads the
conversion from there if it exist in symbol 'key-id property
'conversion.

References:
  `tipgp-:read-email-after-hook'"
  (let* ((fid     "tipgp-key-id-conversion: ")
	 ;;  Make hash access key property
	 (prop    (make-symbol
		   (mapconcat
		    'concat
		    (list-make single-or-list)
		    "")))
	 val
	 )


    ;;  Because you use the key-id conversion in the program all the
    ;;  time (called multiple times) and the conversion will
    ;;  always be same, we save the converted list into hash table
    ;;  for later use.
    ;;
    ;;  1. the hash-key is all list strings concatenated
    ;;     together "me@foo.siteyou@bar.site"
    ;;  2. If that hash entry is not found, then we call conversion
    ;;     function and store the result to hash
    ;;  3. Next time the conversion is already available for us
    ;;     from quick cache.
    ;;
    ;;  This should result faster response, becuse calling hook
    ;;  functions is real slow.

    (tipgpd fid prop)

    (cond
     ((tipgp-hash 'key-id-conversion 'def prop)
      (when (setq val (tipgp-hash 'key-id-conversion 'get prop))
	(setq single-or-list val))
      (tipgpd fid "HASH" single-or-list)
      )
     (t
      (dolist (func (list-make tipgp-:read-email-after-hook))
	(setq single-or-list  (funcall func single-or-list)))
      (tipgp-hash 'key-id-conversion 'put prop single-or-list)
      (tipgpd fid "OUT" single-or-list )
      ))
    single-or-list
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-id-conversion-check ()
  "Return non-nil if the the conversion happens on TO field.
To field must contain only one address."
  (let* (elt
         )
    (when (ti::mt-mail-p)
      ;;   Will conversion happen?
      ;;   - To field must have something
      ;;   - there must be only one email
      ;;   - the conversion has changed email.
      (cond
       ((and (not (var-nil-p (setq elt (ti::mt-get-field "To"))))
	     (not (string-match "," elt))
	     (not (string= elt (or (car-safe (tipgp-key-id-conversion elt))
				   "")))
	     )
	(or (car-safe (tipgp-key-id-conversion elt)) "")
	)
       (t
	nil
	)))))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-id-conversion-check-verbose  ()
  "Check if email address conversion is about to happen in To field."
  (interactive)
  (let* ((stat (tipgp-key-id-conversion-check))
         )
    (cond
     ((null (ti::mt-mail-p))
      (message "Email conversion: not a mail buffer, can't read To field."))
     (t
      (cond
       ((null tipgp-:read-email-after-hook)
	(message "You have turned off Email conversion mode. %s"
		 (if stat (format "[cnv: %s" stat))))
       (t
	(if stat
	    (message "Conversion to: %s" stat)
	  (message "No Email conversion trigges")
	  )))))))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-id-find  ()
  "Try to find 'Id' 0x12345678 from current buffer. X-Pgp is searched first."
  (let* ((list (tipgp-xpgp-get-info))
	 elt
	 ret
         )
    (cond
     ((and list				; Id=0xF72ED579;
	   (setq elt (assoc "id" list)))
      (setq ret (nth 1 elt))
      )
     (t					;No other methods yet.
      ))
    ret
    ))


;;}}}

;;{{{ buffer: generate, show

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-use-tmp-buffer (&optional choice arg1 arg2 arg3)
  "Create tmp buffer for TinyPgp.el. CHOICE ARG1 ARG2 ARG3 are internal."
  (let ((fid "tipgp-use-tmp-buffer:")
	mail-setup-hook		;No hooks now (slow) !
	mail-mode-hook
	message-mode-hook
	buffer
	)
    (tipgpd fid choice arg1 arg2 arg3)

    ;;  XE 19.14 ByteComp silencer, this is no-op
    (if mail-setup-hook (setq mail-setup-hook nil))
    (if mail-mode-hook  (setq mail-setup-hook nil))


    (cond
     ((eq choice 'shell)
      (use-tmp-buffer tipgp-:buffer-tmp-shell 'clear))

     ((eq choice 'copy)
      (use-tmp-buffer tipgp-:buffer-tmp-copy  'clear))

     ((eq choice 'finger)
      (use-tmp-buffer tipgp-:buffer-tmp-finger 'clear))

     ((eq choice 'http)
      (use-tmp-buffer tipgp-:buffer-tmp-http 'clear))

     ((eq choice 'kring)
      (use-tmp-buffer tipgp-:buffer-tmp-kring 'clear))

     ((eq choice 'show)
      (use-tmp-buffer tipgp-:buffer-tmp-show 'clear))

     ((eq choice 'mail)
      (kill-buffer-safe tipgp-:buffer-tmp-mail)
      (setq buffer (use-tmp-buffer tipgp-:buffer-tmp-mail 'clear))
      (job-buffer buffer
	(setq tipgp-:hash nil)		;Clear hash array
	(mail-mode)
	;;   to subject in-reply-to cc replybuffer actions
	;;
	(mail-setup arg1 arg2 nil arg3 nil nil)
	)
      (tipgpd fid "MAIL OUT")
      buffer
      )

     ((null choice)
      (use-tmp-buffer tipgp-:buffer-tmp 'clear))
     (t
      (error "TinyPgp: No such mode '%s'" choice)
      ))
    ))




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-show-buffer-general (type)
  "Pop to buffer TYPE."
    (let ((buffer
	   (cond
	    ((eq type 'comint)  (tipgp-comint-buffer))
	    ((eq type 'debug)   tipgp-:buffer-debug)
	    ((eq type 'finger)  tipgp-:buffer-tmp-finger)
	    ((eq type 'http)	tipgp-:buffer-tmp-http)
	    ((eq type 'shell)	tipgp-:buffer-tmp-shell)
	    ((eq type 'tmp)	tipgp-:buffer-tmp)
	    ))
	  )
      (cond
       ((null buffer)
	(error "TinyPgp: Wrong type '%s' " type))

       ((get-buffer buffer)
	(pop-to-buffer buffer))

       (t
	(message "Buffer does not exist: '%s'" buffer)
	))
      ))


(defun tipgp-show-buffer-comint ()
  "Show buffer."
  (interactive) (tipgp-show-buffer-general 'comint))

(defun tipgp-show-buffer-debug ()
  "Show buffer."
  (interactive) (tipgp-show-buffer-general 'debug))

(defun tipgp-show-buffer-finger ()
  "Show buffer."
  (interactive) (tipgp-show-buffer-general 'finger))

(defun tipgp-show-buffer-http ()
  "Show buffer."
  (interactive) (tipgp-show-buffer-general 'http))

(defun tipgp-show-buffer-shell ()
  "Show buffer."
  (interactive) (tipgp-show-buffer-general 'shell))

(defun tipgp-show-buffer-tmp ()
  "Show buffer."
  (interactive) (tipgp-show-buffer-general 'tmp))

;;}}}
;;{{{ pubring: misc

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-pubring-elt  ()
  "Return active pubring ELT."
  (let* ((ring (expand-file-name tipgp-:pubring-now))
	 kring
	 ret
         )
    (dolist (elt tipgp-:pubring-table)
      (setq kring (nth 1 elt))
      (cond
       ((stringp kring)
	;; Second element must be filename string
	(when (string= ring (expand-file-name kring))
	  (setq ret elt)
	  (return)
	  ))
       (t
	(error "Invalid format: tipgp-:pubring-table, please check.")
	)))
    (unless ret
      (error "tipgp-:pubring-table, can't find tipgp-:pubring-now?"))

    ret
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-pubring-ask  (&optional msg)
  "Ask pubring with MSG and offer 'alias' completion.

Return:
  nil
  pubring file"
  (let (ret
	)
    (setq ret
	  (tipgp-pubring-complete
	   (if msg
	       msg
	     (format
	      "Ok to use pubring '%s' [ret=yes]? "
	      (or (tipgp-pubring-file2alias tipgp-:pubring-now)
		  "<unknown>")
	      )
	     )))

    (if (not (var-nil-p ret))
	(setq ret (tipgp-pubring-alias2file ret))
      (setq ret nil))

    (tipgpd "tipgp-pubring-ask out: " ret )
    ret
    ))





;;; ----------------------------------------------------------------------
;;;
(defun tipgp-pubring-in-use-confirm  ()
  "Change pubring if it is not the first entry in `tipgp-:pubring-table'.
Ask confirmation for the change. The calling
function should bound variable `tipgp-:pubring-table' locally,
because it may be changed here.

References:
  `tipgp-save-state-macro'"
  (let ((first  (expand-file-name (nth 1 (car tipgp-:pubring-table))))
	(now    (expand-file-name tipgp-:pubring-now))
	)
    (when (not (string= first now))
      (setq now (tipgp-pubring-ask))
      (when now
	(setq tipgp-:pubring-now now)
	(tipgpd "tipgp-pubring-in-use-confirm out: " tipgp-:pubring-now)
	))
    ))

;;}}}
;;{{{ pubring: interactive

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-pubring-display  ()
  "Show current pubring in use."
  (interactive)
  (message-flash
   2 'sit
   (concat "Current pubring: " tipgp-:pubring-now)))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-pubring-set-current  (alias)
  "Set active pubring using ALIAS and update modeline."
  (interactive (list (tipgp-pubring-complete "Set active pubring to: ")))
  (when alias
    (setq tipgp-:pubring-now
	  (expand-file-name (nth 1 (assoc alias
					  tipgp-:pubring-table))))

    (if (not (file-exists-p tipgp-:pubring-now))
	(error "No pubring file %s" tipgp-:pubring-now))

    (tipgpd "tipgp-pubring-set-current out: " alias tipgp-:pubring-now)
    (tipgp-update-modeline)
    (if (interactive-p)
	(tipgp-pubring-display)
      )))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-pubring-create  (filename)
  "Create new pubring with FILENAME.
Copying current user's public key from primary pubring,
which is first entry in your pubring table, to new pubring.

Signal errror if file exists.

References:
  `tipgp-:user-now'
  `tipgp-:pubring-table'"
  (interactive
   (let ((default-directory
	   (or (getenv "PGPPATH")
	       (if (file-exists-p "~/.pgp/" )
		   "~/.pgp/") "~/"
		   ))
	 )
     (call-interactively
      (function
       (lambda (x)
	 (interactive "FCreating pubring, give filename: ")
	 (list x)
	 )))))
  (tipgpd "tipgp-pubring-create in:" (current-buffer) filename )


  (let (;; (user		    tipgp-:user-now)
	(tipgp-:pubring-now tipgp-:pubring-now)	;Use this locally
	(filename           (expand-file-name filename))
;;	(pass               (tipgp-password-get-old "Pass phrase: "))
	)

    ;;  Note: if you delete a file and call this function again,
    ;;  it still keeps telling it exists. Maybe some old inode
    ;;  information is haunting there...
    ;;
    ;;  Call this once and the other check should succeed.
    ;;
    (file-exists-p filename)


    (if (file-exists-p filename)
	(error "File already exists."))

    (job-buffer (tipgp-use-tmp-buffer)
      (tipgpd "tipgp-pubring-create 2:" (current-buffer) filename )

      ;; #todo Creating pubring requires creating a key: 'test' user ?
      ;;
      ;;
      (tipgp-exe-get-result-re1-macro
	  "Keyring add error"
	(tipgp-error "Can't create fresh pubring, delete possible file."))

      )
    ))


;;}}}
;;{{{ user: general, interactive


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-user-in-use-confirm  (&optional msg)
  "Change user if Primary user is not active ask confirmation with MSG."
  (let (ans
	)
    (setq msg
	  (or
	   msg
	   "Not primary, change user id to [empty = no change]: "))
    (if (and (not (string-match
		   (regexp-quote tipgp-:user-primary) tipgp-:user-now))
	     (not
	      (var-nil-p
	       (setq ans (read-from-minibuffer msg tipgp-:user-now))
	       )))
      (setq tipgp-:user-now ans)
      )))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-user-display ()
  "Show active user."
  (interactive)
  (read-char-safe-until (concat "Current user: " tipgp-:user-now)))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-user-set-current (user)
  "Set active USER."
  (interactive
   (list
    (completing-read
     "Set pgp user to: "
     tipgp-:pgp-email-list-completions
     nil nil nil
     'tipgp-:history-email
     )))

   (if (var-nil-p user)
       (error "Invalid input."))

  (setq tipgp-:user-now user)
  (if (interactive-p) (tipgp-user-display))
  )


;;}}}
;;{{{ key: handling

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-cache  (mode &optional data1 data2 data3)
  "Function to control cacheing of key-id and.
The cache hook tells if the entry should be cached when MODE is 'put

When inserting new keys into cache, every 3rd key triggers saving
the cache to disk.


References:
  `tipgp-:key-cache'
  `tipgp-:key-cache-last'

Input MODE:
  'get  look for data1 from cache and return cache entry or nil
  'put  cache entries data1, data2, data3
  'del  remove named entry from cache. Do nothing if no such entry.

Data arguments:
  DATA1 DATA2 DATA3

Return:
  nil
  cache entry"
  (let ((last		tipgp-:key-cache-last)
	(data1-orig	data1)		;Email may be changed
	(debug          nil)
	(fid            "tipgp-key-cache: ")
	do-it
	ret
	)


    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. fast case . .
    ;; Remember that modeline calls us many times
    ;;
    (cond				;Is the entry in QUICK cache?
     ((and last				;bypass everything if we find it
	   (eq mode 'get)		;many time we call 'get successively
	   (string= (car last) data1))
      (setq ret (nth 1 (nth 1 last)))
      (if debug (tipgpd fid "fast get" data1 ret ))
      )

     (t
      ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . normal case  ..
      (if debug (tipgpd fid "in:"  mode data1))
;;;    (d! "C in: " mode data1 data2)

      (setq data1 (remove-properties data1))
      (if data2
	  (setq data2 (remove-properties data2)))


;;;    (d! "Cache name>>" data1 data2)

      ;; Note: I used elp.el to check if the obarray method
      ;; would be faster, but it seems that at least for single entry
      ;; the list implementation is faster? I was suprised..
      ;;
      (if (not (listp tipgp-:key-cache)) ;make sure this is a list
	  (setq tipgp-:key-cache nil))

      (cond
       ((eq mode 'get)
	(when (setq ret (assoc data1 tipgp-:key-cache))
	  (setq  tipgp-:key-cache-last  (list data1-orig ret)
		 ret			(nth 1 ret))
	  ))

       ((eq mode 'del)
	(if (setq ret (assoc data1 tipgp-:key-cache))
	    (adelete 'tipgp-:key-cache (car ret))))

       (t
	(setq do-it t)

	(if (and do-it
		 ;;  Already there ?
		 (null (assoc data1 tipgp-:key-cache))
		 (< (length  tipgp-:key-cache) 300)) ;Hard limit
	    (push (list data1 data2 data3) tipgp-:key-cache ))

	;;  Save every 3rd new entry
	;;
	(if (eq (% (length tipgp-:key-cache) 3) 0)
	    (tipgp-key-cache-save))
	)))
     )
    (if debug (tipgpd fid "out:" ret))
    ret
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-cache-save  (&optional load)
  "Save or LOAD the key cache file.
If the underlying cache file has recent copy; the SAVE is not
performed, but the newer copy reloaded and evaluated."
  (let* ((fid   "tipgp-key-cache-save:")
	 (file  tipgp-:file-key-cache)
	 (list  tipgp-:key-cache)
	 (len   (length list))
	 (olen  (tipgp-hash 'cache 'get 'len nil 'global))
	 )
    (tipgpd fid file len olen "LOAD" load)
    (job-buffer (find-file-noselect file)
      (cond
       (load
	(if (fboundp 'eval-buffer)	;XE 19.14
	    (sfuncall 'eval-buffer)
	  (sfuncall 'eval-current-buffer)
	  ))

       (t
	;; There may be several emacsen running, and they may have saved the
	;; cache too. Reload the file if it is newer that the buffer
	;; in this emacs (it has been saved by some other emacs)
	;;
	(cond
	 ((file-changed-on-disk-p)
	  (revert-buffer t t)		;No confirmations
	  (if (fboundp 'eval-buffer)	;XE 19.14
	      (sfuncall 'eval-buffer)
	    (sfuncall 'eval-current-buffer)
	    ))
	 ((not (eq len olen))		;Length has changed
	  (tipgp-hash 'cache 'put 'len len 'global)
	  (erase-buffer)
	  (insert ";;\n;;\tEmacs TinyPgp.el: key cache file\n;;\n\n")
	  (insert "(defconst tipgp-:key-cache\n  '(\n")
	  (dolist (elt list) (insert "    " (prin1-to-string elt) "\n"))
	  (insert "    ))\n\n;; End of file\n")
	  (save-buffer)
	  )))
       ))))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-cache-display  (&optional verb)
  "Print contents of cache. VERB."
  (interactive)
  (tipgp-key-cache-save)
  (pop-to-buffer (find-buffer-visiting tipgp-:file-key-cache))
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-cache-remove-entry-last  ()
  "Clear last fast cache entry."
  (interactive)
  (setq tipgp-:key-cache-last nil)
  (if (interactive-p)
      (message "Cleared last cache entry."))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-cache-remove-entry  (string &optional raw-entry)
  "Read email addresses from string and remove it from cacahe.

Input:
  STRING	    ,String ==> email addres is picked from it
  RAW-ENTRY	    ,if nono-nil, then bypass call to
		     `tipgp-:read-email-after-hook' which may change the string"
  (let* ((fid "tipgp-key-cache-remove-entry: ")
	 list
         )
    (tipgpd fid "in:" raw-entry string )

    (cond
     (raw-entry
      (tipgp-key-cache 'del string))

     (t
      (or (setq list (ti::mt-email-from-string string))
	  (setq list (list string)))
      (dolist (elt list)
	;;  Should we change the keyId that is read from field?
	;;
	(when elt
	  (setq elt (car (tipgp-key-id-conversion elt))))
	(tipgp-key-cache 'del elt)
	)))
    (setq tipgp-:key-cache-last nil)	;Clear fast cache too
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-generate
  (key-bit-choice user-id pass-phrase &optional verb)
  "Generate new key. Only default key sizes are supported.

Input:
  KEY-BIT-CHOICE	1,2 or 3
  USER-ID
  PASS-PHRASE
  VERB"
  (interactive
   (let* ((key-list
	   '(("512"   1)
	     ("768"   2)
	     ("1024"  3)
	     ))
	  key
	  user
	  pass
	  ans
	  )

     (setq key (completing-read "Key size: " key-list nil 'match-it "768"))
     (if (null (setq key (tipgp-alias2name key key-list)))
	 (error "No key choice found."))

     (setq user (read-from-minibuffer "User id for your public key: "))
     (if (var-nil-p user)
	 (error "Empty user id."))

     (setq pass (ti::xe-read-password "Pass phrase: "))
     (if (var-nil-p pass)
	 (error "Empty pass phrase"))

     (list key user pass)
     ))


  ;; ... ... ... ... ... ... ... ... ... ... ... ... ... ... ...  body . .

  (if (not (and (memq key-bit-choice '(1 2 3))
		(stringp user-id)
		(stringp pass-phrase)
		))
      (error "Arg error."))

  (let* ((BCMD	(tipgp-exe-get-cmd 'key-generate))
	 (cmd   (tipgp-cmd-compose BCMD user-id pass-phrase))
	 ret
	 )
    (VERB)
    (tipgp-unfinished-function)
    (tipgp-save-state-macro
      (if verb  (tipgp-pubring-in-use-confirm))
      (setq
       ret
       (tipgp-exe-comint-command
	(list cmd
	      (int-to-string key-bit-choice)
	      user-id
	      pass-phrase pass-phrase
	      )
	(point-min) (point-min)
	(if verb "Generating new user-id..." nil)
	nil nil 'no-files
	))
      )
    (if verb
	(message "Generating new user-id...done."))

    ret
    ))

;;}}}

;;{{{ misc: auto-action

;;; ..................................................... &auto-action ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action-on-modeline-p  ()
  "Check if modeline string says that auto action in 'on'."
  (and (stringp tipgp-:mode-name)
       (string-match "!$\\|!k" tipgp-:mode-name)))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action-on-p  ()
  "Check is user has allowed action and if action exists."
  ;;  There is no auto action for read only buffer like RMAIL
  ;;
  (tipgpd "tipgp-auto-action-on-p: "
	  (tipgp-hash 'auto-action 'def 'user-mode)
	  (tipgp-hash 'auto-action 'get 'user-mode)
	  )

  (when (null buffer-read-only)
    (unless (tipgp-hash 'auto-action 'def 'user-mode)
      ;;  Not defined, initialize
      ;;
      (tipgpd "tipgp-auto-action-on-p: SET DEFAULT")
      (tipgp-hash 'auto-action 'put 'user-mode t)
      )
    (tipgp-auto-action-p 'read-hash)
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action-defeat-p  ()
  "Check if auto action should be cancelled."
  (let* (
         )
    ;;  Forget mime multiparts/PGP signed.
    (ti::mt-mime-maybe-p)
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action-verbose  ()
  "Show auto-action entry to user.
If auto action is found it is also available from `tipgp-:register'."
  (interactive)
  (let* (elt
         )
    (tipgpd "tipgp-auto-action-verbose in:")
    (cond
     ((ti::mt-mime-maybe-p)
      (message "Looks like MIME message, no auto action allowed"))
     ((tipgp-auto-action-multiple-addresses 'check)
      (message "encryption to multiple recipients pending."))
     ((setq elt (tipgp-auto-action-p))
      (message "Auto-action triggers: %s" (prin1-to-string elt))
      (set-register tipgp-:register (prin1-to-string elt))
      )
     (t
      (message "There is no auto action that would activate.")
      ))
    (tipgp-update-modeline)
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action-update-modeline ()
  "Do auto action check and update modeline"
  (tipgp-auto-action-p)
  (tipgp-update-modeline)
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action-p (&optional read-hash)
  "Check if auto-action entry is defined for current (email) buffer.
Any MIME message in buffer suppresses auto-action.

References:

  `tipgp-:auto-action-table'

Input:

  READ-HASH	    ,non-nil instructs to read the value
		     from storage, if the TO: addres hasn't changed.
		     This is faster than evaluating the list every time.

Return:
  elt		    ,entry from action table"
  (let (;; (EVAL-OR-STRING  SIGN-FLAG [ENCRYPT-FLAG] [KEYRING])
	(fid	"tipgp-auto-action-p: ")
	(tbl	tipgp-:auto-action-table)
	;;   We don't enable this because timer calls us
	;;   Only when we debug the function
	;;
	(debug  t)
	user-mode
	to-field
	val
	ret
	)
    ;;  This function is called from a timer process to update the
    ;;  modeline, that's why we can't afford to rescan the auto-action
    ;;  list all the time: it takes too much time.
    ;;
    ;;  Instead, we store the found ACTION to hash table and read the
    ;;  hash entry. The drawback is that if user goes and changes
    ;;  the auto action table, we can't tell about it in the modeline.
    ;;
    ;;  Used local hash properties on variable 'auto-action
    ;;	'user-mode	bool	t = ok, nil = defeated by user
    ;;	'to-field	string	to field contents
    ;;	'elt		lisp	stored auto action.

    ;;  If not yet defined, set the auto action to 't'
    ;;  User may defeat the action manually.
    ;;
    (if (tipgp-hash 'auto-action 'def 'user-mode)
	(setq user-mode (tipgp-hash 'auto-action 'get 'user-mode))
      (tipgp-hash 'auto-action 'put 'user-mode t)
      (setq user-mode t))


    ;;  TO FIELD: see what we have in the hash table
    ;;
    (setq val (tipgp-hash 'auto-action 'get 'to-field))

    (when debug
      (tipgpd fid
	      "USER-MODE"	user-mode
	      "mail"		(ti::mt-mail-p)
	      "pgp"		(ti::mt-pgp-p)
	      "MIME"		(ti::mt-mime-maybe-p)
	      "remail"		tipgp-:r-mode-indication-flag
	      "READ HASH"	read-hash
	      "to-field hash"	val
	      "to-field"        (ti::mt-get-field-1 "to")
	      ))

    (when (and (ti::mt-mail-p)
	       (cond
		((ti::mt-mime-maybe-p)
		 ;;  MIME found, defeat auto action immediately.
		 ;;
		 (tipgp-hash 'auto-action 'put 'elt nil) nil)
		(t t))
	       ;;
	       ;;  only if there is no previous PGP,
	       ;;  If there is PGP, let go through is there is
	       ;;  remailer message Eg. newnym account create where
	       ;;  you send you PGP key in buffer.
	       ;;
	       (if (ti::mt-pgp-p)
		   (if tipgp-:r-mode-indication-flag
		       t nil)
		 t)

	       (not (var-nil-p (setq to-field (ti::mt-get-field-1 "to"))))
	       (not (string-match "," to-field)) ;skip multiple addresses
	       )

      ;; .................................................. hash check ...
      (cond
       ((and read-hash
	     val			;previous TO field in HASH ?
	     (string= to-field val)	;compare previous with current TO
	     )
	(setq val   (tipgp-hash 'auto-action 'get 'elt))
	(when debug (tipgpd fid "hash ret"))
	(setq ret val)
	)

       ;; .................................................. raw check ...
       (
	;; Empty field with spaces does not come here
	;; To field has changed, we must calculate new entry
	;; OR the hash-get wasn't set.
	;;
	(tipgp-hash 'auto-action 'put 'to-field to-field)
	(tipgp-hash 'auto-action 'put 'elt nil)
	(when debug (tipgpd fid "evaluate"))

	(dolist (elt tbl)
	  (setq val  (nth 0  elt))
	  (when (or			;Try to match
		 (and (stringp val)
		      (string-match val to-field))
		 (and (symbolp val) (not (bool-p val))
		      (eval val))
		 )
	    (tipgp-hash 'auto-action 'put 'elt elt) ;Save it!
	    (setq ret elt)
	    (return)
	    ))
	)))

    (if debug (tipgpd fid "RET" ret))
    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action  ()
  "Determine right auto action for mail message.
If you have disabled the auto-action control, do nothing.

References:
  `tipgp-:header-sign-table'
  `tipgp-:auto-action-table'
  `tipgp-:auto-action-defeat-hook'"
  (let ((fid            "tipgp-auto-action: ")
	(umode          (tipgp-hash 'auto-action 'get 'user-mode))
	(multi-flag     (tipgp-auto-action-multiple-addresses 'check))
	to-field
	sign-pwd
	sign enc xpgp keyr
	email
	len
	elt
	)

    (tipgpd fid "user-mode" umode "multi-flag" multi-flag)

    (run-hooks 'tipgp-:auto-action-before-hook)

    (cond
     ;; .................................................. user defeat ...
     ((setq elt (run-hooks-until 'tipgp-:auto-action-defeat-hook 'rest))
      (tipgpd fid "Hook defeated" elt)
      nil)

     ;; ................................................. nymserver-cc ...
     ((and (tipgp-nymserver-mail-p)
	   (tipgp-nymserver-send))	;Maybe no multi-CC ?
      (tipgpd fid "Nymserver")
      )

     ;; ..................................................... defeated ...
     ((not umode)			;User has defeated the action
      (tipgpd fid "Umode")
      nil)

     ;; ................................................ multi-encrypt ...
     (multi-flag
      (tipgpd fid "Multi")
      (tipgp-auto-action-multiple-addresses))

     ;; .................................................. auto-action ...
     ((and (not (var-nil-p (setq to-field  (ti::mt-get-field-1 "to"))))
	   ;;  The Addresses must be expanded so that they have @
	   ;;
	   (string-match "@" to-field)
	   ;;
	   ;; Force reading real action. If user has made changes
	   ;; in his rc file; this guarrantees that we see them.
	   ;;
	   (setq elt (tipgp-auto-action-p))
	   ;;  returns a list of email strings
	   ;;
	   (setq email (ti::mt-email-from-string to-field))
	   )
      (tipgpd fid "Action" elt email)
      (setq len  (length elt)
;;;	    frm  (nth 0  elt)
	    sign (nth 1  elt)
	    keyr tipgp-:pubring-now
	    )
      ;;  Should we change the key-id that is read from field?
      ;;
      (setq email (car-safe (tipgp-key-id-conversion email)))

      ;;  optional fields
      ;;
      (setq enc    (if (> len 2) (nth 2 elt))
	    xpgp   (if (> len 3) (nth 3 elt))
	    keyr  (expand-file-name
		   (cond
		    ((> len 4)
		     (nth 4 elt))
		    ((tipgp-key-find-by-keyrings email))
		    (t
		     tipgp-:pubring-now
		     )))
	    )

      ;;  XE byteCompiler 19.14 has bug here, it reports that
      ;;  variable 'xpgp bound but not referenced, allthoug
      ;;  it is used in 'let' stement underneath!
      ;;
      ;;  Silence it with no-op
      ;;
      (if (null xpgp) (setq xpgp nil))

      (tipgpd fid "addr" email "XP" xpgp enc keyr elt)

      (tipgp-save-state-macro
	(let (pass
	      )
	  (if sign   (setq tipgp-:user-now
			   (if (and (not (bool-p sign))
				    (symbolp sign)) ;One pass encrypt/sign
			       (symbol-name sign)
			     sign)))
	  (if keyr   (setq tipgp-:pubring-now keyr))
	  (setq tipgp-:xpgp-signing-mode xpgp)

	  (when enc
	    (when (and (not (bool-p sign)) (symbolp sign))
	      (setq sign-pwd
		    (tipgp-password-get-old
		     (format "[%s] Auto-action sign password: "
			     tipgp-:user-now))))
	    (tipgp-encrypt-mail-find-keyring email sign-pwd)
	    )


	  (when (and sign (stringp sign))
	    (setq pass
		  (tipgp-password-get-old
		   (format
		    "Auto-action, Sign pass phrase %s: "
		    tipgp-:user-now)))
	    ;; The previous function call may have changed the user,
	    ;; keep the pubring also in sync
	    ;;
	    (tipgp-pubring-change-to-current)
	    (tipgp-sign-mail pass sign))
	  ))
      )
     ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . auto-encrypt ..
     ;; If there is no auto action, we check if we have previously
     ;; encrypted to that person.
     ;;
     ((and (null (ti::mt-pgp-p))	;No previsou pgp
	   (not (var-nil-p (setq to-field  (ti::mt-get-field-1 "to"))))
	   (setq elt
		 (tipgp-key-find-by-cache
		  (car-safe (ti::mt-email-from-string to-field))))
	   )
      (tipgpd "tipgp-auto-action : encrypt guess" to-field elt)
      ;;  We actually do nothing here...but the code is ready
      ;;  (tipgp-encrypt-mail email)
      ))

    (tipgpd fid "out:" (current-buffer))

;;;    (d! "AUTO-ACT done" email)
    elt
    ))




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action-multiple-addresses-p  (&optional force)
  "Check multiple address auto-action. Optionally FORCE raw check."
  (and (null (tipgp-nymserver-mail-p))
       (tipgp-auto-action-multiple-addresses 'check force)))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action-multiple-addresses (&optional mode force)
  "Determine if multiple address encryption will be done.

Input:

  MODE	    If 'check, then return nil or t if auto-action
	    is in progress. Any other value starts auto-ecryption
	    if the conditions are met.
  FORCE     Force re-evaluating the buffer check (normally read result
	    from stored value in hash table)

Return:

  non-nil   auto action in progress
  nil

References:
  `tipgp-:auto-action-encrypt-regexp'"
  (let* ((re	tipgp-:auto-action-encrypt-regexp)
	 (fid   "tipgp-auto-action-multiple-addresses: ")
	 (debug nil)			;func is Called by timer...
	 hsize-prev
	 hsize
	 list
	 len
	 missed
	 ret
	 )
    ;;  Because this function is called from timer process, the
    ;;  'check must be very quick in order not to decrease
    ;;  emacs performance
    ;;
    ;;  'many-addr-hsize
    ;;    We count the length of the header area and put that value
    ;;    into property. If the size has changed, we reread
    ;;    the To,CC,BCC headers again and do the checking
    ;;
    ;;    If the headers have not changed, then we don't do time
    ;;    consuming parse, but assume thet 'many-addr-hsize value
    ;;    is valid (No changes compared to last parse)
    ;;
    ;;  'many-addr-stat
    ;;    Holds value t or nil if auto action should be engaged.

    (if debug  (tipgpd fid "in:" mode force (ti::mt-mail-p) ))

    (when (ti::mt-mail-p)		;Only do in mail buffers
      (setq hsize	(ti::mt-header-area-size)
	    hsize-prev	(tipgp-hash 'auto-action 'get 'many-addr-hsize))

      (when debug
	(tipgpd
	 fid "hsize" hsize "prev" hsize-prev
	 (ti::mt-get-all-email-addresses
	  nil tipgp-:pgp-email-abbrev-list)
	 ))

      (if force (setq hsize nil hsize-prev 1)) ;Re-evaluate.

      (cond
       ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .
       ((and (eq hsize hsize-prev)
	     (eq mode  'check))
	;; return the precalculated status
	;;
	(setq ret (tipgp-hash 'auto-action 'get 'many-addr-stat))
	(if debug (tipgpd fid "cond1-hash" ret))
	)

       ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .
       ((eq hsize hsize-prev)		;Not check mode, do action
	(if debug (tipgpd fid "cond2-enc" ret))
	(if (and (tipgp-hash 'auto-action 'get 'many-addr-stat)
		 (not (ti::mt-pgp-p)))	;No previous pgp
	    (tipgp-encrypt-mail-verbose))
	)

       ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  recalculate . .
       ;; *) The size has changed, so update it immediately.
       ;; *) put initial value into the property, because we may not enter
       ;;    the case at all if list is empty
       ;;
       ;; The rest of the 'and' are real tests
       ;;
       ((and (prog1 t
	       (tipgp-hash 'auto-action 'put 'many-addr-hsize hsize)
	       (tipgp-hash 'auto-action 'put 'many-addr-stat nil))
	     (setq list (ti::mt-get-all-email-addresses
			 nil tipgp-:pgp-email-abbrev-list))
	     (> (setq len  (length list)) 1)
	     )
	(if debug  (tipgpd fid "cond3" len list))
;;;	(d! "HZ" hsize (tipgp-hash 'auto-action 'get 'many-addr-hsize))


        ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. do checking ..
	;;  Is there regexp defined in the table ?
	;;
	(when (stringp re)
	  ;;  See if there is hit for all recipinets,
	  ;;  then we want to encrypt this mail.
	  ;;
	  ;;  Other times; this may be just regular CC mail
	  ;;
	  (dolist (elt list)
;;;	    (d! (string-match re elt) elt)
	    (unless (string-match re elt)
	      (tipgpd fid "NOK" re "-->" elt)
	      (setq missed t)
	      (return)
	      ))


	  (if debug  (tipgpd fid "CHECK" missed (ti::mt-pgp-p) re))

	  ;;  *) All in the list matched the PGP users, encrypt this mail.
	  ;;  *) There must not be no PGP already in the buffer!
	  ;;
	  (if (and (null missed) (null (ti::mt-pgp-p)))
	      (tipgp-hash 'auto-action 'put 'many-addr-stat t)
	    (tipgp-hash 'auto-action 'put 'many-addr-stat nil))
	  )
	(setq ret (tipgp-hash 'auto-action 'get 'many-addr-stat))

        ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  return action ..
	(if (and ret (not (eq mode 'check)))
	    (tipgp-encrypt-mail-verbose))

	)))
    (if debug  (tipgpd fid "RET" ret (ti::mt-pgp-p) missed))
    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-auto-action-toggle  (&optional verb)
  "If the auto action is detected for this buffer, toggle it on/off.
Otherwise if no auto action is present, do nothing. VERB."
  (interactive)
  (let* ((act   (tipgp-auto-action-p))
	 val
	 )
    (VERB)
    (if (null act)
	(if verb (message "TinyPgp: no action entry found for this buffer."))
      (setq val (tipgp-hash 'auto-action 'get 'user-mode))

      (tipgp-hash 'auto-action 'put 'user-mode (not val))
      (tipgp-update-modeline)

      (if verb
	  (message (format "TinyPgp auto action: %s"
			   (if (not val) "pending" "defeated"))))
      )))

;;}}}
;;{{{ misc: functions

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-require-final-newline  ()
  "Make sure there is empty line at the end."
  (save-excursion
    (PMAX)
    (if (not (looking-at "^[ \t]*$"))
	(insert "\n"))
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-xpgp-get-info ()
  "Return X-pgp info '((MIME-KEY  DATA) (MIME-K  DATA) ..) or nil.
This function caches the read X-Pgp information so that the parsing
doen't take effect in every call. The cache will be expired if the buffer
size has changed and the new data parsing will be done."
  (let* ((fid	"tipgp-xpgp-get-info:")
	 (size	(- (point-max) (point-min)))
	 field
	 list
	 )
    (cond
     ((and (eq  size  (tipgp-hash 'xpgp-info 'get 'size))
	   (setq list (tipgp-hash 'xpgp-info 'get 'data)))
      (tipgpd fid "cache")
      )
     ((setq field  (ti::mt-get-field "X-Pgp-signed"))
      (setq list   (ti::mt-mime-parse-header field 'downcase))
      (tipgp-hash 'xpgp-info 'put 'size size)
      (tipgp-hash 'xpgp-info 'put 'data list)
      ))
    (tipgpd fid (current-buffer) list)
    list
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-xpgp-key-address  (type &optional message)
  "Return TYPE (Finger or http) URL if can be found from X-Pgp header.
Print optional MESSAGE if there is no such information.

TYPE can be
 'finger
 'http

Return:
 string
 nil"
  (let* ((elt (tipgp-xpgp-get-info))
	 ret
	 )
    (when elt
      (cond
       ((and (eq type 'finger)
	     (setq elt (assoc "address" elt)))
	(setq ret (nth 1 elt)))
       ((and (eq type 'http)
	     (setq elt (assoc "url" elt)))
	(setq ret (nth 1 elt))
	)))
    (if message
	(message message))

    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-header-sign-toggle  (&optional mode)
  "Toggle signing of selected headers `tipgp-:header-sign-table' with MODE.
When the mode if OFF, the `tipgp-:header-sign-table' is ignored."
  (interactive)
  (let* ((sym 'tipgp-:header-sign-table)
	 )
    ;; Not recorded; record original value
    ;;
    (if (null (get sym 'original))
	(put sym 'original (symbol-value sym)))

    (cond
     ((or (memq mode '(0 -1))
	  (symbol-value sym))
      (set sym nil)
      (message "Headers are not signed: tipgp-:header-sign-table is ignored.")
      )
     (t
      (set sym (get sym 'original))
      (message "Header list tipgp-:header-sign-table is used.")
      ))
    (tipgp-update-modeline)
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-header-list-show  ()
  "See what headers will be signed for this message."
  (interactive)
  (tipgp-header-sign-active-list 'display))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-header-sign-active-list  (&optional display)
  "See what headers we should sign. Optionally DISPLAY to user.
Subject is the only safe field to sign when you for example
send a message to some mailing list that may alter all other fields.

References:
  `tipgp-:header-sign-table'"
  (let* ((list   tipgp-:header-sign-table)
	 to
	 elt
         )
    (and list
	 (setq to (or (ti::mt-get-field-1 "To")
		      (ti::mt-get-field-1 "Newsgroups")))
	 (not (var-nil-p to))
	 (setq elt (list-find list to))
	 )
    (when display
      (cond
       ((var-nil-p to)
	(message "Header sign info: Can't find field To or Newsgroups."))
       ((null elt)
	(message "Header sign info: To or Newsgroup header does not trigger."))
       (t
	(message "Header sign info: %s" (list-to-string (nth 1 elt)))
	)))

    elt
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-header-move-to-body  (&optional opt1 opt2)
  "Move headers into body and anonymize them. See source for OPT1 and OPT2."
  (interactive)
  (ti::mt-pgpr-anonymize-headers
   (or opt1 'move-to-body-maybe) opt2 "message" "dummy")
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-header-kill  (&optional add-list)
  "Kill all but the most crucial headers. ADD-LIST is additional
headers to keep."
  (let* ((hlist (list-merge-elements
		 (mapcar
		  (function
		   (lambda (x)
		     (make-symbol
		      (downcase x))))
		  tipgp-:r-header-keep-list)
		 (ti::mt-required-headers)))
	 )
    (ti::mt-kill-non-rfc-fields hlist)))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-header-sign-make-smf  (&optional read-xpgp &optional header-list)
  "Construct header SMF (a stripped message format).
Read header field names and their contents from the message. If some
header does not exist or is empty in message, then that header is ignored.

References:

  `tipgp-:header-sign-table'	    Read from
  `tipgp-:header-sign-smf-info'	    Written to

Input:

  READ-XPGP    ,The headers that were signed are told in X-Pgp.
                If cannot read all headers, signal error.
  HEADER-LIST  ,list of headers names

Return:
  (string (hdr hdr ..))        ,SMF'd header-string and headers included
  nil"
  (interactive)
  (let* ((fid   "tipgp-header-sign-make-smf:")
	 elt
	 (list (or header-list
		   (if (setq elt (tipgp-header-sign-active-list))
		       (nth 1 elt))))
	 hdr-name
	 flag
	 fld
	 hlist
	 str
	 buffer
	 ret
	 )

    (tipgpd fid "in" read-xpgp header-list "list" elt)
    ;;  Clear this global
    ;;
    (setq tipgp-:header-sign-smf-info nil)


    (when read-xpgp
      (setq fld (ti::mt-get-field-1 "X-Pgp-signed"))
      (when (setq fld (strmatget "SignedHeaders=\\([^;]+\\);" 1 fld))
	;;  Remove newlines, because the field may continue
	;;
	(setq fld (subst-char-with-string fld ?\n " "))
	(setq list (ti::s-get-blocks fld "[ ,]+"))
	))

    (when (listpp list)
      (setq buffer (tipgp-use-tmp-buffer))
      ;;  Get the fields
      ;;
      (save-restriction
	(dolist (elt list)

	  (when (setq str (ti::mt-get-field elt nil 'pure))

	    ;;  this code is inside loop, because outside loop
	    ;;  we don't know if we got any headers
	    ;;
	    (unless  flag		;Do only once
	      (setq flag t)		;Remailer type header hash ##
	      (append-to-buffer-string buffer "##\n")
	      )

	    ;;  We want to store the real header name, not the "list"
	    ;;  names that can be "reply-to", where real header name is like
	    ;;
	    ;;  REPLY-to:  .....
	    ;;
	    (setq hdr-name (strmatget "^\\([^:]+\\):" 1 str))
	    (tipgpd fid "READ" elt "NAME" hdr-name str)
	    (nconcc hlist hdr-name)


	    (append-to-buffer-string
	     buffer
	     (format "%s\n" (ti::s-sqz str) ))
	    )))

      (when hlist
	;;   Add final newline after the headers.
	;;
	(append-to-buffer-string buffer "\n")
	(job-buffer buffer
	  (setq ret (buffer-substring (point-min) (point-max)))))
      )

    (tipgpd fid "ret" ret hlist)

    (when ret
      (setq tipgp-:header-sign-smf-info (list ret hlist)))
    ))




;;}}}
;;{{{ timer control

;;; .......................................................... &timers ...

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-timer-process  ()
  "PGP timer process. Expires stored password and update modeline."
  (tipgp-update-modeline)
  (if (not (tipgp-password-time-valid-p))
      (tipgp-password-expire-now)))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-timer-control  (&optional delete verb)
  "Keep the password expiration timer alive. Optionally DELETE it. VERB."
  (interactive "P")
  (let* ((fid   "tipgp-timer-control: ")
	 (key   (ti::xe-timer-elt 'tipgp-timer-process))
         )
    (VERB)
    (tipgpd fid key)
    (cond
     ((and delete key)
      (ti::xe-timer-key-delete key)
      (if verb (message "Pocess deleted."))
      )
     (t
      (cond
       ((null key)                      ;doesn't exist
        (run-at-time "10 sec" 10 'tipgp-timer-process))
       (t                               ;no timer running
        ;;  Delete old and start it again. This is more safer
        ;;  than just checking if entry is in the list.
        ;;
        (ti::xe-timer-key-delete key)
        (run-at-time "10 sec" 10 'tipgp-timer-process)
        ))
      (if verb (message "PGP timer process alive."))
      ))
    ))

;;}}}
;;{{{ password control

;;; ........................................................ &password ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-password-expire-now  (&optional verb)
  "Expire all information about PGP password including used files. VERB."
  (interactive)
  (setq tipgp-:hash-password	(make-vector 100 nil)
	;;  This command also may contains the password, wipe it
	tipgp-:last-pgp-exe-command nil
	)
  (tipgp-hash 'password-time 'put 'tick nil 'global)

  (tipgp-file-control 'all-kill)

  (if (or verb (interactive-p))
      (message "TinyPgp: all pass phrases and files expired."))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-password-get-old  (&optional prompt)
  "Return old pass phrase or ask again with PROMPT if it has expired.
Eg. if last PGP command terminated to error, that has expired the
pass phrases."
  (let* ((fid "tipgp-password-get-old:")
	 pass
         )
    (or prompt
	(setq prompt (format "[%s] Pass phrase:  " tipgp-:user-now)))


    (tipgpd fid "in:" tipgp-:user-now prompt)

    (if (and (vec-arr-get tipgp-:hash-password tipgp-:user-now)
	     (tipgp-password-time-valid-p)
	     (null tipgp-:error)
	     )
	(setq pass (vec-arr-prop
		    tipgp-:hash-password tipgp-:user-now 'password))

      (setq pass (ti::xe-read-password prompt))
      (when tipgp-:password-keep-time
	;;  Create new user to hash table
	;;
	(intern tipgp-:user-now  tipgp-:hash-password)

	;;  Set user's password in the hash
	;;
	(vec-arr-prop tipgp-:hash-password tipgp-:user-now 'password pass)
	(tipgp-hash 'password-time 'put 'tick nil 'global)
	))
    (tipgpd fid "out:" pass)
    pass
    ))

;;}}}

;;{{{ installation funcs



;;; ----------------------------------------------------------------------
;;; We can't initialize the substitution table in defvar, because
;;; it may be possible that some user sats (setq ...) and then these
;;; definitions aren't there any more.
;;;
(defun tipgp-install-default-substitutions  (&optional remove)
  "Add defualt email substitutions or REMOVE."
    (let* ((nymserver-re
	    (concat
	     "\\("
	     (mapconcat
	      'concat
	      '("anon" "finger" "ping" "remove" "help"
		"nick"
		"newpassword" "newalias" "newpgp" "newaddress"
		"vacation" "noarchive" "setnon" "paranoid"
		"pgpencrypt" "pgpsign" "sendmix"
		"abuse"
		)
	      "\\|"
	      )
	     "\\)@anon.nymserver.com"
	     ))

	   (weasel-re "@weasel.owl.de\\|@squirrel.owl.de")
	   )

  (tipgp-email-substitution-add
   (list
    ;; the 2nd entry is found from PGP key id.
    (cons nymserver-re "Nymserver at anon.nymserver.com")


    ;;  You can get the Weasel 'newnym' PGP key from
    ;;     <info@weasel.owl.de>
    ;;     Johannes Kroeger <jkroeger@squirrel.owl.de>
    ;;
    ;;  Squirrel.owl.de and weasel.owl.de offer the following mail services:
    ;;  1.  The Squirrel Remailer, a Mixmaster/Ghio remailer combination:
    ;;
    ;;  The capabilities of the Ghio remailer are: $remailer{"squirrel"} =
    ;;  "<mix@squirrel.owl.de> cpunk mix pgp pgponly hash latent cut ek" The
    ;;  abbrevs are explained in http://www.publius.net/rlist.html
    ;;
    ;;  It accepts only PGP messages encrypted

    (cons weasel-re "config@weasel.owl.de")
    )
   remove
   )
  ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-install-hooks-vital  (&optional remove)
  "Install and keep vital functions in right order. Optionally REMOVE."
  (interactive "P")
  (let* (func
	 list
	 hook
	 )
    ;; .............................................. kring find hooks ...
    (setq list
	  (reverse			;due to add-hooks
	   '(tipgp-key-find-by-cache
	     tipgp-key-find-by-keyrings-verbose
	     tipgp-key-find-by-finger-verbose
	     tipgp-key-find-by-http-url-verbose
	     tipgp-key-find-by-http-keyserver-verbose
	     )))

    (add-hooks 'tipgp-:find-by-guess-hook list 'remove)
    (unless remove (add-hooks 'tipgp-:find-by-guess-hook list))

    ;; ................................................. control hooks ...
    (remove-hook 'tipgp-:cmd-macro-after-hook
		 'tipgp-mode-specific-control-after)
    (unless remove
      (add-hook 'tipgp-:cmd-macro-after-hook
		'tipgp-mode-specific-control-after 'append))

    ;;   Hook chain is this:
    ;;
    ;;     tipgp-password-wipe-buffer
    ;;     tipgp-sign-modify-check
    ;;     tipgp-auto-action
    ;;     --> rest of the user hooks.
    ;;
    ;;   The REST user hooks that do something to buffer
    ;;   should be moved to tipgp-cmd-
    ;;   or to tipgp-:auto-action-before-hook.
    ;;

    (setq hook
	  '(mail-send-hook
	    message-send-hook
	    mh-before-send-letter-hook
	    )
	  func
	  '(tipgp-auto-action
	    tipgp-sign-modify-check
	    tipgp-password-wipe-buffer
	    ))

    (add-hooks hook func 'remove)
    (unless remove (add-hooks hook func)) ;Add the hooks in right order

    ;; ...................................................... external ...
    ;; It is essential that mime translate hooks is after TinyPgp
    ;; or otherwise eg when you send patch:
    ;;
    ;;	o   content is made quoted printble (=3D ...)
    ;;	o   auto action triggers encrypting
    ;;	--> receiving end doesn't get clean patch

    (setq func 'mime-editor/maybe-translate ;TM.el
	  list '(mail-send-hook
		 message-send-hook
		 ))

    (dolist (hook list)
      (when (and (boundp hook)
		 (memq func (symbol-value hook)))
	(remove-hook hook func)
	(add-hook hook func 'append)	;Make sure it is last
	))

    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-install-hooks (&optional remove)
  "Install package hooks. Optionally REMOVE installation.
Can't restore changes to keymaps."
  (interactive "P")
  (let* ((f    (if remove 'remove-hook 'add-hook))
	 )

    (add-hooks tipgp-:turn-on-hook-list 'turn-on-tipgp-mode remove)

    (add-hooks 'tipgp-:define-keys-hook  ;; just to make sure they are there.
	       '(tipgp-mode-define-menu
		 tipgp-mode-define-keys
		 ))


    (add-hooks 'tipgp-:key-mode-define-keys-hook
	       '(tipgp-key-mode-define-menu
		 tipgp-key-mode-define-keys
		 ))

    (add-hooks 'tipgp-:summary-mode-define-keys-hook
	       '(tipgp-summary-mode-define-menu
		 tipgp-summary-mode-define-keys
		 ))


    (add-hooks 'tipgp-:newnym-mode-define-keys-hook
	       '(tipgp-newnym-mode-define-menu
		 tipgp-newnym-mode-define-keys
		 ))


    (add-hooks '(rmail-show-message-hook
		 vm-display-buffer-hook
		 mh-show-hook
		 )
	       'tipgp-hide
	       remove)

    (add-hooks '(;; RMAIL summary is handled elswhere
		 vm-summary-mode-hook
		 gnus-summary-mode-hook
		 mh-show-mode-hook
		 )
	       'turn-on-tipgp-summary-mode
	       remove)

    (funcall f 'gnus-select-article-hook    'tipgp-hide-gnus)  ;; gnus 4


    (funcall f 'tipgp-:cmd-macro-before-hook
	       'tipgp-add-signature-if-signing)

    (tipgp-install-hooks-vital remove)

    ;;  This must be after the mode specific hook has finished.
    ;;
    (funcall f 'tipgp-:cmd-macro-after-hook 'tipgp-after-pgp-command 'append)

    (funcall f 'tipgp-:verify-before-hook
	       'tipgp-mode-specific-control-before)

    (funcall f 'tipgp-:verify-after-hook
	       'tipgp-mode-specific-control-after)

    (funcall f 'write-file-hooks	; ~/.mailrc parsing
	       'tipgp-update-mail-abbrevs-hook)

    (funcall f  'tipgp-:r-reply-block-basic-hook 'tipgp-r-mail-mode-init)

    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-install (&optional remove)
  "Install whole package or REMOVE installation.
This is main installation controller."
  (interactive)

  (tipgp-install-default-substitutions)

  (tipgp-install-hooks	    remove)
  (tipgp-timer-control	    remove)

  (if (null remove)
      (tipgp-key-cache-save 'load))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-install-to-current-emacs ()
  "Examine every emacs buffer and turn on PGP minor mode when needed."
  (interactive)
  (let* (
         )
    (tipgp-install-vm)

    ;; If user loads tinypgp.el, it should immediately install itself to
    ;; appropriate buffers. Otherwise user has to call manually tipgp-mode.
    ;;
    ;; The purpose of this function is solely for convenience only.
    (save-excursion
      (dolist (elt (buffer-list))
	(set-buffer elt)
	(cond
	 ((memq major-mode '(vm-mode
			     rmail-mode
			     mail-mode
			     message-mode
			     gnus-article-mode
			     ))
	  (tipgp-mode 1))

	 ((memq major-mode '(vm-summary-mode
			     rmail-summary-mode
			     gnus-summary-mode
			     ))
	  (tipgp-summary-mode 1)
	  ))
	))
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-install-vm-check  ()
  "Check that VM is configured right."
  (let* ((sym 'vm-visible-headers)
         )
    (when (featurep 'vm)
      ;;  1. User loads TinyPgp and VM is not loaded yet
      ;;     --> this function does nothing
      ;;  2. When user uses commands afterwards in VM, this function
      ;;     is called to chek the situation.
      ;;

      (if (or (tipgp-hash 'vm 'get 'check nil 'global)
	      (list-find			;Don't call this unnecessarily
	       (symbol-value sym)
	       "X-Pgp-Signed:"
	       '(string= (car table) arg)
	       ))
	  (tipgp-hash 'vm 'put 'check 'ok 'global) ;Raise flag
	(message "\
TinyPgp config error: Please add 'X-Pgp-Signed:' to vm-visible-headers")
	(sit-for 3)
	))))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-install-vm  ()
  "Install minor mode indication to VM summary buffer."
  (when (featurep 'vm)
    (let* ((sym     'vm-mode-line-format)
	   (sval    (symbol-value sym))
	   )

      ;;  The modeline format is defined in vm-vars.el::vm-mode-line-format,
      ;;  but it does not have varaible minor-mode-alist. That's why TPsum
      ;;  mode is not shown in summary buffer.
      ;;
      (save-excursion
	(dolist (buffer (buffer-list))
	  (set-buffer buffer)
	  (when (and (eq major-mode 'vm-summary-mode)
		     (not (memq 'minor-mode-alist sval)))
	    ;;  Add this and update modeline
	    (nconcc sval 'minor-mode-alist)
	    (ti::xe-set-mode-line-format sval)
	    (vm-update-summary-and-mode-line)
	    )))
      (tipgp-install-vm-check)
      )))


;;}}}
;;{{{ install: modes, keys

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-install-modes (&optional remove)
  "Install or REMOVE minor modes.
Calling this always removes old mode and does reintall."
  (interactive "P")
  (cond
   (remove
    (ti::k-add-minor-mode 'tipgp-mode     nil nil 'remove)
    (ti::k-add-minor-mode 'tipgp-key-mode nil nil 'remove)
    (ti::k-add-minor-mode 'tipgp-summary-mode nil nil 'remove)
    )
   (t
    (setq tipgp-:mode-map  (make-sparse-keymap)) ;; always refresh
    (run-hooks 'tipgp-:define-keys-hook)
    (ti::k-add-minor-mode 'tipgp-mode nil nil 'remove)
    (ti::k-add-minor-mode 'tipgp-mode 'tipgp-:mode-name  tipgp-:mode-map)

    (setq tipgp-:key-mode-map  (make-sparse-keymap)) ;; always refresh
    (run-hooks 'tipgp-:key-mode-define-keys-hook)
    (ti::k-add-minor-mode 'tipgp-key-mode nil nil 'remove)
    (ti::k-add-minor-mode 'tipgp-key-mode 'tipgp-:key-mode-name
			  tipgp-:key-mode-map)

    (setq tipgp-:summary-mode-map  (make-sparse-keymap)) ;; always refresh
    (run-hooks 'tipgp-:summary-mode-define-keys-hook)
    (ti::k-add-minor-mode 'tipgp-summary-mode nil nil 'remove)
    (ti::k-add-minor-mode 'tipgp-summary-mode 'tipgp-:summary-mode-name
			  tipgp-:summary-mode-map)


    (setq tipgp-:newnym-mode-map  (make-sparse-keymap)) ;; always refresh
    (run-hooks 'tipgp-:newnym-mode-define-keys-hook)
    (ti::k-add-minor-mode 'tipgp-newnym-mode nil nil 'remove)
    (ti::k-add-minor-mode 'tipgp-newnym-mode 'tipgp-:newnym-mode-name
			  tipgp-:newnym-mode-map)

    )))

;;}}}

;;{{{ menu: main

;;; ------------------------------------------------------------ &menu ---
;;;
(defun tipgp-mode-define-menu  ()
  "Define menus."
  (easy-menu-define
   tipgp-:mode-menu
   (if (xemacs-p) nil (list tipgp-:mode-map))
   "TinyPgp menu"
   (list
    tipgp-:mode-menu-name
     ["Next action"		        tipgp-next-action-mail		    t]
     ["Sign"				tipgp-sign-mail			    t]
     ["Sign, base64"			tipgp-sign-mail-base64		    t]
     ["Sign, detached"			tipgp-sign-mail-detached	    t]

     ["Encrypt"				tipgp-encrypt-mail		    t]
     ["Encrypt and sign (one pass)"	tipgp-encrypt-mail-sign		    t]
     ["Decrypt"				tipgp-decrypt-mail		    t]
     ["Verify"				tipgp-verify-mail		    t]
     ["Verify detached signature on file"   tipgp-verify-detached-signature t]
     ["Conventional crypt"		tipgp-crypt-mail		    t]
     ["Insert file signed base64 "	tipgp-sign-base64-insert-file	    t]
     "----"
     (list
      "Region PGP"
      ["Sign"				tipgp-sign-region		    t]
      ["Sign, base64"			tipgp-sign-region-base64	    t]
      ["Sign, detached"			tipgp-sign-region-detached	    t]
      ["Encrypt"			tipgp-encrypt-region		    t]
      ["Encrypt and sign (one pass)"	tipgp-encrypt-region-sign	    t]
      ["Decrypt"			tipgp-decrypt-region		    t]
      ["Verify"				tipgp-verify-mail		    t]
      ["Verify detached signature on file"   tipgp-verify-detached-signature t]
      ["Conventional crypt"		tipgp-crypt-region		    t]
      )
     (list
      "Key handling"
      ["Insert with batch to pubring"	tipgp-key-add-region-batch	    t]
      ["Insert with ask to pubring"	tipgp-key-add-region-interactive    t]
      ["Extract to point"		tipgp-key-extract-to-point	    t]
      ["Generate new key"		tipgp-key-generate		    t]
      ["Remove from keyring"		tipgp-key-delete-region		    t]
      "----"
      ["Info insert matches"		tipgp-key-info-insert		    t]
      ["Info show matches"		tipgp-key-info-at-point-show	    t]
      "----"
      ["Fetch by finger"		tipgp-key-find-by-finger	    t]
      ["Fetch by http [keyserver]"      tipgp-key-find-by-http-guess        t]
      ["Fetch by email keysrv request"	tipgp-key-find-by-email		    t]
      ["Fetch by guess"			tipgp-key-find-by-guess		    t]
      )

     (list
      "Pubring and user control"
      ["Pubring create"			tipgp-pubring-create	    t]
      ["Pubring show"			tipgp-pubring-display	    t]
      ["Pubring change"			tipgp-pubring-set-current   t]
      "----"
      ["User show"			tipgp-user-display	    t]
      ["User change"			tipgp-user-set-current	    t]
      )

     (list
      "Modes and toggles"
      ["Flip X-pgp header/regular pgp"	tipgp-xpgp-header-toggle	    t]
      ["Flip Signature hide/show"	tipgp-hide-show-toggle		    t]
      ["Mode X-pgp on/off"		tipgp-xpgp-header-mode-toggle	    t]
      ["Mode Headers signed on/off"	tipgp-header-sign-toggle	    t]
      ["Mode Auto signing on/off"	tipgp-sign-mail-auto-mode	    t]
      ["Mode FCC encryption on/off"	tipgp-mail-fcc-encrypt-mode-toggle  t]
      ["Mode Auto action on/off"	tipgp-auto-action-toggle	    t]
      ["Mode Email substitution on/off"	tipgp-email-substitution-toggle	    t]
      )

;;;     "----"

     (list
      "Extra commands"
      ["Wash Anonymize headers"             tipgp-header-move-to-body   t]
      ["Wash expire pass phrases/files"     tipgp-password-expire-now   t]
      ["Wash loose signing information"     tipgp-sign-loose-info	t]
      ["Wash wipe TinyPgp highlight"	    tipgp-highlight-wipe	t]
      ["Wash wipe passwords from buffer."   tipgp-password-wipe-buffer  t]
      "----"
      ["Info Describe mode"		    tipgp-mode-describe         t]
      ["Info Display last finger error"     tipgp-show-last-finger-error t]
      ["Info View pgp register"    	    tipgp-view-register		t]
      ["Info Show auto-action entry"        tipgp-auto-action-verbose   t]
      ["Info Show email conversion"  tipgp-key-id-conversion-check-verbose t]
      ["Info Show header signing fields"    tipgp-header-list-show	t]
      ["Info Sudy PGP stream forward." tipgp-pgp-stream-forward-study   t]
      "----"
      ["Send email: .plan has no PGP key"   tipgp-sendmail-key-not-in-plan t]
      ["Send email: keyserver cmd"	    tipgp-keysrv-send-email-command t]
      )
     "----"

     (list
      "Remailer service"
      ["Post as Anon "			tipgp-r-post                t]
      ["Make basic reply block"		tipgp-r-reply-block-basic   t]
      "----"
      ["Initialize remailer support"	tipgp-r-init		    t]
      ["Update remailer list"		tipgp-r-update-remailer-list t]
      ["Contruct remailer reply block"	tipgp-r-reply-block-insert  t]
      ["Encrypt-Remail message once"	tipgp-r-chain-1		    t]
      ["Encyptr-Remail message using chain"  tipgp-r-chain	    t]
      ["Test defined reply blocks"      tipgp-r-reply-block-test    t]
      )

     (list
      "Newnym service"
      ["Show or get account help"	tipgp-newnym-help	    t]
      ["Default account toggle"		tipgp-newnym-default-toggle t]
      ["Post as Anon "			tipgp-newnym-post	    t]
      "----"
      ["Request acksend"		tipgp-newnym-req-acksend    t]
      ["Request cryptrecv"		tipgp-newnym-req-cryptrecv  t]
      ["Request disable"		tipgp-newnym-req-disable    t]
      ["Request fingerkey"		tipgp-newnym-req-fingerkey  t]
      ["Request fixedsize"		tipgp-newnym-req-fixedsize  t]
      ["Request sigsend"		tipgp-newnym-req-sigsend    t]
      "----"
      ["Configuration template" tipgp-newnym-config-sendmail-template t]
      ["Create new account"		tipgp-newnym-create	    t]
      ["Delete account"			tipgp-newnym-delete	    t]
      "----"
      ["Get used account list"		tipgp-newnym-get-used-list  t]
      ["Get server's PGP key"		tipgp-newnym-get-pgp-key    t]
      )

     (list
      "Nymserver service"
      ["Post as anon"			tipgp-nymserver-post	    t]
      ["Finger, account status"		tipgp-nymserver-finger	    t]
      ["Ping, your account status"	tipgp-nymserver-ping	    t]
      ["Help, read file"		tipgp-nymserver-help	    t]
      ["Account create"			tipgp-nymserver-create	    t]
      ["Account remove"			tipgp-nymserver-remove	    t]
      "----"
      ["Change account alias"		tipgp-nymserver-newalias	    t]
      ["Change nickname"		tipgp-nymserver-nickname	    t]
      ["Change .plan"			tipgp-nymserver-newplan	    t]
      ["Change .signature"		tipgp-nymserver-newsig	    t]
      ["Change to new address"		tipgp-nymserver-newaddress    t]
      "----"
      ["flag, paranoid"			tipgp-nymserver-paranoid	    t]
      ["flag, vacation"			tipgp-nymserver-vacation	    t]
      ["flag, no archive"		tipgp-nymserver-noarchive	    t]
      ["flag, anNNN/naNNN"		tipgp-nymserver-setnon	    t]
      "----"
      ["PGP key upload "		tipgp-nymserver-pgp-upload    t]
      ["PGP flag, encrypt"		tipgp-nymserver-pgp-encrypt   t]
      ["PGP flag, sign"			tipgp-nymserver-pgp-sign	    t]
      ["PGP flag, mixmaster"		tipgp-nymserver-pgp-sendmix   t]
      )
     "----"

     (list
      "Cache service"
      ["Remove last entry"		tipgp-key-cache-remove-entry-last  t]
      ["Display"			tipgp-key-cache-display	    t]
      )

     (list
      "Report service"
      ["Show version"			tipgp-version-message	    t]
      ["Submit bug report"		tipgp-submit-bug-report     t]
      "----"
      ["Debug on/off"			tipgp-debug-toggle          t]
      ["Debug buffer clear"		tipgp-debug-buffer-clear    t]
      "----"
      ["Display comint"			tipgp-show-buffer-comint    t]
      ["Display debug"			tipgp-show-buffer-debug	    t]
      ["Display finger"			tipgp-show-buffer-finger    t]
      ["Display http"			tipgp-show-buffer-http	    t]
      ["Display shell"			tipgp-show-buffer-shell	    t]
      ["Display tmp"			tipgp-show-buffer-tmp	    t]

;;; I don't know if average user realizes what this command does...
;;;     ["Generate randseed.bin"  t]
      )

     )))

;;}}}
;;{{{ menu: echo, nymserver

;;; ----------------------------------------------------------------------
;;;
(defcustom tipgp-:newnym-echo-menu-use-p t
  "*Should the 'newnym' commands be accessible from echo-area menu?.
You can set this only once; otherwise you have to reload package."
  :type 'boolean
  :group 'tipgp-nymserver
  )

;; Change this mane in the load-hook is need to.
;;
(defconst tipgp-:newnym-echo-menu
  '(
    (let ((def (if tipgp-:newnym-default-server
		   (format "[%s]" tipgp-:newnym-default-server)
		   "Newnym"))
          )
      (format
       "\
%s p)ost c)fg t)oggle   req: (a)ck e)nab f)fing s)sig si(z)e [hCDK]"
       def
       ))
    (
     (?a  . ( (call-interactively 'tipgp-newnym-req-acksend)))
     (?C  . ( (call-interactively 'tipgp-newnym-create)))
     (?c  . ( (call-interactively 'tipgp-newnym-config-sendmail-template)))
     (?D  . ( (call-interactively 'tipgp-newnym-delete)))
     (?e  . ( (call-interactively 'tipgp-newnym-req-disable)))
     (?f  . ( (call-interactively 'tipgp-newnym-req-fingerkey)))
     (?h  . ( (tipgp-newnym-help-verbose current-prefix-arg)))
     (?K  . ( (call-interactively 'tipgp-newnym-get-pgp-key)))
     (?u  . ( (call-interactively 'tipgp-newnym-get-used-list)))
     (?p  . ( (call-interactively 'tipgp-newnym-post)))
     (?r  . ( (call-interactively 'tipgp-newnym-req-cryptrecv)))
     (?s  . ( (call-interactively 'tipgp-newnym-req-sigsend)))
     (?t  . (t (call-interactively 'tipgp-newnym-default-toggle)))
     (?z  . ( (call-interactively 'tipgp-newnym-req-fixedsize)))
     ))
  "Help for the menuing commands and what the keys do.
ESC to exis menu without choosing. Less used commands are in uppercase.

Basic commands

  h   = Show help file (prefix arg orders help file by mail)
  p   = convert current message to anon (p)ost

Account requests

  All these commands send the minus(-) request, if you want to send plus(+)
  request, then you have to supply prefix argument.

  a   = (a)cksend   disable automatic acknowledgement
  r   = c(r)yptrecv disable encryption to you.
  e   = disable	    re-(e)nable account
  f   = fingerkey   disallow people to get your PGP key.
  z   = fixedsize   do not padd messages to 10K
  s   = sigsend	    disable automatic pgp signing

Account management

  t   = Toggle using default account.
  c   = prepare (c)onfigure template and enter 'Nym' mode.
	You can manage you account in details. See tab key.
  C   = Create account
  D   = Delete account

Other

  u   = Get user account(nym) list
  K   = Get newnym server's PGP key.

")

;;}}}
;;{{{ menu: echo, nymserver

;;; ----------------------------------------------------------------------
;;;
(defcustom tipgp-:nymserver-echo-menu-use-p t
  "*Should the 'nymserver' commands be accessible from echo-area menu?.
You can set this only once; otherwise you have to reload package."
  :type 'boolean
  :group 'tipgp-nymserver
  )

;; Change this mane in the load-hook is need to.
;;
(defconst tipgp-:nymserver-echo-menu
  '(
"Nymserv p)ost f)ing p(i)ng n)ick si(g) p(l)an PGP.uesx req.drtovwa [hACR]"
    (
     (?p  . ( (call-interactively 'tipgp-nymserver-post)))
     (?f  . ( (call-interactively 'tipgp-nymserver-finger)))
     (?i  . ( (call-interactively 'tipgp-nymserver-ping)))

     (?n  . ( (call-interactively 'tipgp-nymserver-nickname)))
     (?v  . ( (call-interactively 'tipgp-nymserver-vacation)))
     (?a  . ( (call-interactively 'tipgp-nymserver-newalias)))

     (?l  . ( (call-interactively 'tipgp-nymserver-newplan)))
     (?g  . ( (call-interactively 'tipgp-nymserver-newsig)))
     (?r  . ( (call-interactively 'tipgp-nymserver-noarchive)))

     (?y  . ( (call-interactively 'tipgp-nymserver-setnon)))
     (?o  . ( (call-interactively 'tipgp-nymserver-paranoid)))
     (?d  . ( (call-interactively 'tipgp-nymserver-newaddress)))
     (?w  . ( (call-interactively 'tipgp-nymserver-newpassword)))

     (?u  . ( (call-interactively 'tipgp-nymserver-pgp-upload)))
     (?e  . ( (call-interactively 'tipgp-nymserver-pgp-encrypt)))
     (?s  . ( (call-interactively 'tipgp-nymserver-pgp-sign)))
     (?x  . ( (call-interactively 'tipgp-nymserver-pgp-sendmix)))

     (?A  . ( (call-interactively 'tipgp-nymserver-abuse)))
     (?C  . ( (call-interactively 'tipgp-nymserver-create)))
     (?R  . ( (call-interactively 'tipgp-nymserver-remove)))
     (?h  . ( (tipgp-nymserver-help-verbose current-prefix-arg)))
     ))
  "Help for the menuing commands and what the keys do:
ESC to exis menu without choosing.

Basic commands

  p   = convert current message to anon (p)ost
  f   = (f)inger account for configuration information.

Common commands

  n   = (n)ickname request
  g   = upload new .(s)ignature file
  l   = upload new .p(l)an file

PGP commands

  u   = (u)pload PGP key to your account
  e   = (e)ncrypt request
  s   = (s)igning request
  x   = mi(x)master request

Requests

  d   = newa(dd)ress request
  r   = noa(r)chive request
  t   = se(t)non request
  o   = paran(o)id request
  v   = (v)acation request
  w   = ne(w)password request
  a   = new(a)lias request. This chnages your anNNN to vanity alias.

Other

  h   = show (h)elp file, With Prefix arg send help request email.
  A   = Send (a)buse mail
  C   = (C)reate new account. This command can be sent only once.
  R   = (R)emove account. This is opposite of create.")

;;}}}
;;{{{ mode: keys



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mode-define-keys-buffer  (p map)
  "Define buffer handling keys. Use P prefix key and assign to MAP."
  ;;  Buffer management in prefix "b"
  ;;
  (define-key map (concat p "bc")  'tipgp-show-buffer-comint)
  (define-key map (concat p "bd")  'tipgp-show-buffer-debug)
  (define-key map (concat p "bf")	'tipgp-show-buffer-finger)
  (define-key map (concat p "bh")  'tipgp-show-buffer-http)
  (define-key map (concat p "bs")	'tipgp-show-buffer-shell)
  (define-key map (concat p "bt")  'tipgp-show-buffer-tmp)



  (define-key map (concat p "b\b")   'tipgp-debug-buffer-clear)
  (define-key map (concat p "b\177") 'tipgp-debug-buffer-clear)
  (define-key map (concat p "b\177") 'tipgp-debug-buffer-clear)
  (define-key map (concat p "b\C-m") 'tipgp-show-buffer-debug)
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mode-define-keys-user  (p map)
  "Define user keys. Use P prefix key and assign to MAP."
  ;;  User commands in "u" map
  ;;
  (define-key map (concat p "us")  'tipgp-user-display)
  (define-key map (concat p "u\t") 'tipgp-user-set-current)

  ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  pubring ..
  ;;  Pubring commands in "p map
  ;;
  (define-key map (concat p "ps")  'tipgp-pubring-display)

  ;;  This is little faster key
  (define-key map (concat p "p\t") 'tipgp-pubring-set-current)
  (define-key map (concat p "pc")  'tipgp-pubring-create)


  ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. debug ..
  ;;  I may disable these in product version....
  ;;  Debug in "d" map.
  ;;
  (define-key map (concat p "xdd")  'tipgp-debug-toggle)
  (define-key map (concat p "xdc")  'tipgp-debug-buffer-clear)
  (define-key map (concat p "xds")  'tipgp-submit-bug-report)
  (define-key map (concat p "xdv")  'tipgp-version-message)
  (define-key map (concat p "x\e")  'tipgp-submit-bug-report)
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mode-define-keys ()
  "Define keys."
  (let* ((map  tipgp-:mode-map)
	 (p    tipgp-:mode-prefix-key)
	 (r    tipgp-:mode-prefix-key-remailer)
	 (y    tipgp-:mode-prefix-key-nymserver)
	 (n    tipgp-:mode-prefix-key-newnym)
	 )
    (tipgp-mode-define-keys-buffer p map)
    (tipgp-mode-define-keys-user   p map)

    (define-key map
      (concat p (str-right p 1))    'tipgp-next-action-mail)

    (define-key map (concat p "?")  'tipgp-mode-describe)

    (define-key map (concat p "a")  'tipgp-header-move-to-body)
    (define-key map (concat p "s")  'tipgp-sign-mail)
    (define-key map (concat p "S")  'tipgp-sign-mail-base64)
    (define-key map (concat p "D")  'tipgp-sign-mail-detached)

    (define-key map (concat p "e")  'tipgp-encrypt-mail)
    (define-key map (concat p "t")  'tipgp-encrypt-mail-sign)
    (define-key map (concat p "d")  'tipgp-decrypt-mail)
    (define-key map (concat p "v")  'tipgp-verify-mail)
    (define-key map (concat p "V")
      'tipgp-verify-detached-signature)

    (define-key map (concat p "c")  'tipgp-crypt-mail)
    (define-key map (concat p "i")  'tipgp-sign-base64-insert-file)

    (define-key map (concat p "h")  'tipgp-xpgp-header-toggle)
    (define-key map (concat p "g")  'tipgp-hide-show-toggle)

    (define-key map (concat p "R")  'tipgp-view-register)
    (define-key map (concat p "F")  'tipgp-key-find-by-finger)
    (define-key map (concat p "G")
      'tipgp-key-find-by-guess)
    (define-key map (concat p "E")  'tipgp-key-find-by-email)
    (define-key map (concat p "K")
      'tipgp-key-find-by-http-guess)

    (define-key map (concat p "\C-m") 'tipgp-key-find-by-guess)

    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. region . .
    ;;  Region commands in prefix "r"
    ;;
    (define-key map (concat p "rs") 'tipgp-sign-region)
    (define-key map (concat p "rS") 'tipgp-sign-region-base64)
    (define-key map (concat p "rD") 'tipgp-sign-region-detached)
    (define-key map (concat p "re") 'tipgp-encrypt-region)
    (define-key map (concat p "rt") 'tipgp-encrypt-region-sign)
    (define-key map (concat p "rd") 'tipgp-decrypt-region)
    (define-key map (concat p "rv") 'tipgp-verify-region)
    (define-key map (concat p "rc") 'tipgp-crypt-region)


    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  key management . .
    ;;  Key management in prefix "k"
    ;;
    (define-key map (concat p "kg") 'tipgp-key-generate)
    ;;  - "ki" is closer to keyboard than default pgp "kv".
    (define-key map (concat p "ki") 'tipgp-key-info-at-point-show)
    (define-key map (concat p "kI") 'tipgp-key-info-insert)
    (define-key map (concat p "kv") 'tipgp-key-info-insert)

    (define-key map (concat p "ka") 'tipgp-key-add-region-batch)
    (define-key map (concat p "kA")
      'tipgp-key-add-region-interactive)
    (define-key map (concat p "kx") 'tipgp-key-extract-to-point)
    (define-key map (concat p "kr") 'tipgp-key-delete-region)
    ;;
    ;;


    ;;  Mode  commands in prefix "m"
    ;;
    (define-key map (concat p "ma") 'tipgp-sign-mail-auto-mode)

    (define-key map (concat p "mf")
      'tipgp-mail-fcc-encrypt-mode-toggle)

    (define-key map (concat p "mh") 'tipgp-xpgp-header-mode-toggle)
    (define-key map (concat p "ma") 'tipgp-auto-action-toggle)

    (define-key map (concat p "me")
      'tipgp-email-substitution-toggle)

    (define-key map (concat p "mH")
      'tipgp-header-sign-toggle)

    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  extra . .
    ;;  Extra commands in prefix "x"
    ;;  - The randseed is so seldom used, so it is commented out
    ;;

    (define-key map (concat p "xa") 'tipgp-auto-action-verbose)
    (define-key map (concat p "xe")
      'tipgp-key-id-conversion-check-verbose)

    (define-key map (concat p "xh") 'tipgp-header-list-show)
    (define-key map (concat p "xi")
      'tipgp-pgp-stream-forward-study)

    (define-key map (concat p "xf") 'tipgp-show-last-finger-error)

    (define-key map (concat p "xk")
      'tipgp-keysrv-send-email-command)

    (define-key map (concat p "xl") 'tipgp-sign-loose-info)

    (define-key map (concat p "xp")
      'tipgp-sendmail-key-not-in-plan)

;;;    (define-key map (concat p "xR")
;;;         'tipgp-exe-comint-randseed)

    (define-key map (concat p "xw") 'tipgp-password-wipe-buffer)
    (define-key map (concat p "xW") 'tipgp-highlight-wipe)

    (define-key map (concat p "xx") 'tipgp-password-expire-now)

    ;;  Cache control commands in "xc" map
    ;;
    (define-key map (concat p "xcr")
      'tipgp-key-cache-remove-entry-last)
    (define-key map (concat p "xcd") 'tipgp-key-cache-display)


    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  remailer . .
    ;;
    (define-key map (concat r "b")  'tipgp-r-reply-block-basic)
    (define-key map (concat r "r")  'tipgp-r-reply-block-insert)
    (define-key map (concat r "i")  'tipgp-r-init)
    (define-key map (concat r "u")  'tipgp-r-update-remailer-list)
    (define-key map (concat r "p")  'tipgp-r-post)
    (define-key map (concat r "t")  'tipgp-r-reply-block-test)
    (define-key map (concat r "C")  'tipgp-r-chain-1)
    (define-key map (concat r "c")  'tipgp-r-chain)

    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. newnym . .
    ;;
    (cond
     (tipgp-:newnym-echo-menu-use-p
      ;;  Using menu to remeber commands is easier if you don't use
      ;;  menu bar at all.
      ;;
      (define-key map n
	(function
	 (lambda (&optional arg)
	   "Newnym menu"
	   (interactive "P")
	   (timu-menu 'tipgp-:newnym-echo-menu arg)))))

     (t
      ;;  Seldom used command in big letter to prevent accidents.
      ;;
      (define-key map (concat n "?") 'tipgp-newnym-help)
      (define-key map (concat n "a") 'tipgp-newnym-req-acksend)
      (define-key map (concat n "C") 'tipgp-newnym-create)
      (define-key map (concat n "c")
	'tipgp-newnym-config-sendmail-template)

      (define-key map (concat n "D") 'tipgp-newnym-delete)
      (define-key map (concat n "e") 'tipgp-newnym-req-disable)
      (define-key map (concat n "f") 'tipgp-newnym-req-fingerkey)
      (define-key map (concat n "K") 'tipgp-newnym-get-pgp-key)
      (define-key map (concat n "u") 'tipgp-newnym-get-used-list)
      (define-key map (concat n "p") 'tipgp-newnym-post)
      (define-key map (concat n "r") 'tipgp-newnym-req-cryptrecv)
      (define-key map (concat n "s") 'tipgp-newnym-req-sigsend)
      (define-key map (concat n "t") 'tipgp-newnym-default-toggle)
      (define-key map (concat n "z") 'tipgp-newnym-req-fixedsize)
      ))

    (cond
     (tipgp-:nymserver-echo-menu-use-p
      ;;  Using menu to remeber commands is easier if you don't use
      ;;  menu bar at all.
      ;;
      (define-key map y
	(function
	 (lambda (&optional arg)
	   "Nymserver menu"
	   (interactive "P")
	   (timu-menu 'tipgp-:nymserver-echo-menu arg)))))

     (t
      ;; Normal keybindings then. No menu in echo area used.
      ;;

      (define-key map (concat y "p") 'tipgp-nymserver-post)
      (define-key map (concat y "f") 'tipgp-nymserver-finger)
      (define-key map (concat y "i") 'tipgp-nymserver-ping)

      (define-key map (concat y "a") 'tipgp-nymserver-newalias)
      (define-key map (concat y "n") 'tipgp-nymserver-nickname)
      (define-key map (concat y "w") 'tipgp-nymserver-newpassword)

      (define-key map (concat y "o") 'tipgp-nymserver-paranoid)
      (define-key map (concat y "v") 'tipgp-nymserver-vacation)
      (define-key map (concat y "d") 'tipgp-nymserver-newaddress)
      (define-key map (concat y "r") 'tipgp-nymserver-noarchive)
      (define-key map (concat y "l") 'tipgp-nymserver-newplan)
      (define-key map (concat y "g") 'tipgp-nymserver-newsig)
      (define-key map (concat y "t") 'tipgp-nymserver-setnon)

      (define-key map (concat y "u") 'tipgp-nymserver-pgp-upload)
      (define-key map (concat y "e") 'tipgp-nymserver-pgp-encrypt)
      (define-key map (concat y "s") 'tipgp-nymserver-pgp-sign)
      (define-key map (concat y "x") 'tipgp-nymserver-pgp-sendmix)

      (define-key map (concat y "C") 'tipgp-nymserver-create)
      (define-key map (concat y "R") 'tipgp-nymserver-pgp-remove)
      (define-key map (concat y "A") 'tipgp-nymserver-abuse)

      (define-key map (concat y "h") 'tipgp-nymserver-help)
      ))
    ))

;;}}}
;;{{{ mode: key mode

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-mode-define-menu  ()
  "Define menus."
  (easy-menu-define
   tipgp-:key-mode-menu (if (xemacs-p) nil tipgp-:key-mode-map)
   "TinyPgp Key management menu"
   (list
    tipgp-:key-mode-menu-name
;;;    ["Mail Sign"			tipgp-sign-mail		    t]
    )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-mode-define-keys ()
  "Define keys."
  (let* ((p    tipgp-:key-mode-prefix-key)
	 (map  tipgp-:key-mode-map)
	 )
    (define-key map (concat p "a") 'tipgp-key-add-region-batch)
    ))

;;}}}
;;{{{ mode: summary mode

;;; --------------------------------------------------------- &summary ---
;;;
(defun tipgp-summary-mode-define-menu  ()
  "Define menus."
  (easy-menu-define
   tipgp-:summary-mode-menu (if (xemacs-p) nil tipgp-:summary-mode-map)
   "TinyPgp Mail Summary management menu"
   (list
    tipgp-:summary-mode-menu-name
    ["Verify"			tipgp-summary-mode-verify	t]
    ["Decrypt"			tipgp-summary-mode-decrypt	t]
    ["Next action"		tipgp-summary-mode-next-action  t]
    ["Describe mode"		tipgp-summary-mode-describe	t]

    "----"
    (list
     "Extra commands"
     ["Wash expire pass phrases/files"	    tipgp-password-expire-now	    t]
     "----"
     ["Info Display last finger error"	    tipgp-show-last-finger-error    t]
     ["Info View pgp register"		    tipgp-view-register		    t]
     "----"
     ["Send email: .plan has no PGP key"    tipgp-sendmail-key-not-in-plan  t]
     ["Send email: keyserver cmd"	    tipgp-keysrv-send-email-command t]
     )

    (list
     "Cache service"
     ["Remove last entry"		tipgp-key-cache-remove-entry-last   t]
     ["Display"				tipgp-key-cache-display		    t]
     )

    (list
     "Report service"
     ["Submit bug report"		tipgp-submit-bug-report     t]
     ["Debug on/off"			tipgp-debug-toggle          t]
     ["Debug buffer clear"		tipgp-debug-buffer-clear    t]
     "----"
     ["Display comint"			tipgp-show-buffer-comint    t]
     ["Display debug"			tipgp-show-buffer-debug	    t]
     ["Display finger"			tipgp-show-buffer-finger    t]
     ["Display http"			tipgp-show-buffer-http	    t]
     ["Display shell"			tipgp-show-buffer-shell	    t]
     ["Display tmp"			tipgp-show-buffer-tmp	    t]
     )
    )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-summary-mode-define-keys ()
  "Define keys."
  (let* ((p    tipgp-:summary-mode-prefix-key)
	 (map  tipgp-:summary-mode-map)
	 )

    (tipgp-mode-define-keys-buffer p map)
    (tipgp-mode-define-keys-user   p map)

    (define-key map
      (concat p (str-right p 1))	'tipgp-summary-mode-next-action)

    (define-key map (concat p "?")	'tipgp-summary-mode-describe)
    (define-key map (concat p "d")	'tipgp-summary-mode-decrypt)
    (define-key map (concat p "v")	'tipgp-summary-mode-verify)
    ))

;;}}}
;;{{{ code: Mode functions

;;; ----------------------------------------------------------------------
;;;
;;;
(ti::m-fmacro-minor-mode
 tipgp-mode				;1
 "PGP minor mode.
Mode description:
\\{tipgp-:mode-map}
"
 tipgp-install-modes			;3
 tipgp-mode				;4
 tipgp-:mode-name

 tipgp-:mode-prefix-key			;5
 tipgp-:mode-menu			;6

  nil					;7
 "TinyPgp"				;8
 tipgp-:mode-hook

 (progn
   (if (null tipgp-:pubring-now)
       (setq tipgp-:pubring-now
	     (expand-file-name (nth 1 (car tipgp-:pubring-table)))))

   (if (not (file-exists-p tipgp-:pubring-now))
       (error "TinyPgp: Can't init mode, pubring not found '%s'"
	      tipgp-:pubring-now))

   (if (not (stringp tipgp-:user-now))
       (error "TinyPgp: Can't init mode, user is not defined '%s'"
	      tipgp-:user-now))
   (tipgpd "tipgp-mode" arg)
   (tipgp-update-modeline)
   ))

(defun turn-on-tipgp-mode  () "Pgp mode on."  (tipgp-mode 1))
(defun turn-off-tipgp-mode () "Pgp mode off." (tipgp-mode 0))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mode-describe ()
  "Describe mode."
  (interactive)
  (describe-function 'tipgp-mode))



;;; .................................................... &pgp-key-mode ...



;;; ----------------------------------------------------------------------
;;;
(ti::m-fmacro-minor-mode
 tipgp-key-mode
 "PGP key handling minor mode. You should extract the the key information
to some buffer first before turning on this mode.
Eg. with \\[tipgp-key-info-at-point-show]

Mode description:
\\{tipgp-:key-mode-map}
"
 tipgp-install-modes
 tipgp-key-mode
 tipgp-:key-mode-name			;5

 tipgp-:key-mode-prefix-key
 tipgp-:key-mode-menu			;7

  nil
 "TinyPgp Key handling"
 tipgp-:key-mode-hook			;10

 (progn
    (if tipgp-key-mode
	(tipgp-update-modeline))
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-mode-describe ()
  "Describe mode."
  (interactive)
  (describe-function 'tipgp-key-mode))


;;; .................................................... &pgp-sum-mode ...


;;; ----------------------------------------------------------------------
;;;
(ti::m-fmacro-minor-mode
 tipgp-summary-mode
 "PGP summary minor mode. This function can only be turned on in VM
RMAIL and GNUS summary buffer.  Any PGP action called there is reflected
on the current message selected.

Mode description:
\\{tipgp-:summary-mode-map}
"
 tipgp-install-modes
 tipgp-summary-mode
 tipgp-:summary-mode-name

 tipgp-:summary-mode-prefix-key
 tipgp-:summary-mode-menu

  nil
 "TinyPgp Mail Summary"
 tipgp-:summary-mode-hook


 (progn
    (when tipgp-summary-mode
      (unless (memq major-mode
		    '(rmail-summary-mode
		      vm-summary-mode
		      gnus-summary-mode
		      mh-show-mode
		      ))
	(setq tipgp-summary-mode nil)
	(error "You can use this mode only in Mail summary buffers."))

      ;; This modeline update is a problem only in RMAIL-summary buffer.
      ;; We cannot use rmail-summary-mode-hook, because turning mode on
      ;; there does no good (summary buffer is not shown yet)
      ;;
      ;; See advised function rmail-new-summary which calls us.
      ;;
      (tipgp-update-modeline)
      ))
 )

(defun turn-on-tipgp-summary-mode  () "Summary mode." (tipgp-summary-mode 1))
(defun turn-off-tipgp-summary-mode () "Summary mode." (tipgp-summary-mode 0))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-summary-mode-describe ()
  "Describe mode."
  (interactive)
  (describe-function 'tipgp-summary-mode))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-summary-mode-verify  (&optional arg)
  "Verify current article with ARG."
  (interactive "P") (tipgp-summary-action 'verify arg 'verb))

(defun tipgp-summary-mode-decrypt  (&optional arg)
  "Decrypt current article with ARG."
  (interactive "P") (tipgp-summary-action 'decrypt arg 'verb))

(defun tipgp-summary-mode-next-action  (&optional arg)
  "Guess next action and pass ARG."
  (interactive "P") (tipgp-summary-action 'next-action arg 'verb))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-summary-action-1  (action func arg verb)
  "See source code for `tipgp-summary-action' for ACTION FUNC ARG VERB."
  (save-excursion
    (pop-to-buffer (current-buffer))
    (cond
     ((eq action 'verify)	(call-interactively func))
     ((eq action 'next-action)	(call-interactively func))
     ((eq action 'decrypt)	(tipgp-decrypt-mail-verbose (quote arg)))
     )))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-summary-action  (action-sym &optional arg verb)
  "Do ACTION-SYM in summary buffer. ARG is passed to called function. VERB."
  (let* ((fid	"tipgp-summary-action: ")
	 (list	'(verify decrypt next-action))
	 str
	 func
	 )
    (if (not (memq action-sym list))
	(error "TinyPgp: Unregognized/Not supported summary action."))

    (setq str (format "tipgp-%s-mail" (symbol-name action-sym)))

    (if (null (setq func (intern-soft str)))
	(error "TinyPgp: Function not found %s" str))

    (tipgpd fid major-mode action-sym func)

    (cond
     ((eq major-mode 'rmail-summary-mode)
      (ti::mt-rmail-macro
	(tipgp-summary-action-1 action-sym func arg verb)))

     ((eq major-mode 'vm-summary-mode)
      (ti::mt-vm-macro
	(tipgp-summary-action-1 action-sym func arg verb)))

     ((eq major-mode 'gnus-summary-mode)
      (ti::mt-gnus-macro
	(tipgp-summary-action-1 action-sym func arg verb)))

     ((eq major-mode 'mh-show-mode)
      (ti::mt-mh-macro
	(tipgp-summary-action-1 action-sym func arg verb)))

     (t
      (error "TinyPgp: I Can't do anything in this major mode."))
     )

    ))

;;}}}

;;{{{ code: defadvice

;;; ....................................................... &defadvice ...

(defadvice rmail-new-summary (after tipgp act)
  "Update modeline.
For some reason thi couldn't be done from 19.28's`rmail-summary-mode-hook'."
  (tipgp-summary-mode))


;;; (ad-unadvise 'vm-edit-message)
;;;
(defadvice vm-edit-message  (after tipgp dis)
  "If Edit is called interactively, call `turn-on-tipgp-mode'
We can't do this in `vm-edit-message-hoo' because the hook function
doesn't know if the function were called interactively or not."
  (if (and (interactive-p)
	   (null tipgp-mode))
      (turn-on-tipgp-mode)))

;;}}}

;;{{{ Special: sending email

;;; ........................................................ &sendmail ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-sendmail-key-not-in-plan  (email)
  "Send small mail to EMAIL and ask him to add his PGP key to ~/.plan.

When you finger someone for his pgp key, consider this before you send
notice to person. (check the content of finger buffer)

o  Finger finds the .plan file and the contents seems valid, there is login
   name and directory information and soon. This would indicate that
   it is ok to send notice toperson.
o  Finger result"
  (interactive
   (let* (ret
	  )
     (and (y-or-n-p
	   ;;  someone may think this harrashement
	   ;;
	   "Are you sure you want to send .plan notice? Think twice..." )
	  (y-or-n-p
	   "You did check the content of the finger results: was it ok otw? ")
	  (setq ret
		(read-from-minibuffer
		 "Mail to: "
		 (safe-do (ti::mt-get-field "to" nil 'nil-mode))
		 )))
     (if (not (string-match "@"))
	 (error "Abort."))
     (list ret)
     ))
  (tipgp-sendmail email 'pk-finger-none)
  (if (interactive-p)
      (message "Email sent to: %s" email))
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-sendmail  (email mode &optional arg1 arg2 arg3)
  "Send email notice to EMAIL address according to MODE and ARG1 ARG2 ARG3."
  (let* (
	 (id
	  (format
	   "\nThis is message from TinyPgp.el %s\n\n"
	   (tipgp-version-number)))

	 (subject	(format
			 " %s, Notification concerning your PGP."
			 email))
	 msg
         )
    (cond
     ((eq mode 'pk-no-full-format)
      (setq msg
	    (format
	     (concat
	      "\tWe fingered address %s to get your public key\n\t"
	      "but it was not presented in full format of pgp -fakx.\n\t"
	      "Would you please insert all test starting from\n\t"
	      "'Key for user ID:' line from the -fakx output. \n\t"
	      "That would offer access to your other information\n\t"
	      "that may be needed. \nt"
	      "\n"
	      "Please note that the -kv format is not the same as -fakx\n"
	      "\n"
	      "\tThank you.\n"
	      )
	      email
	      )))
     ((eq mode 'pk-finger-none)
      (setq msg
	    (format
	     (concat
	      "\tHi!\n\t"
	      "We could finger address %s but there was no PGP \n\t"
	      "Public key available. Would you kindly run \n\t"
              "'pgp -fakx' on you keyId and put all\n\t"
	      "lines after 'Key for user ID:' to you $HOME/.plan file.\n\n\t"
	      "Thank you.  Please excuse this message if you don't have\n"
	      "or use PGP\n"
	      )
	      email
	      )))
     (t
      (error "TinyPgp: Unknown mode")))

    (ti::mt-sendmail-macro email subject 'send
      (insert id msg))

    ))

;;}}}
;;{{{ special: Mode specific actions

;;; ................................................... &mode-specific ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mail-do-fcc-encrypted  (&optional no-primary func &rest args)
  "Save the current buffer in encrypted format to FCC folder.

Input:
  NO-PRIMARY	If non-nil, then we don't change to primary user
		temporarily before we encrypt the message
  FUNC		Is called to do the FCC, if nil, this defauls to
		`mail-do-fcc'
  ARGS          arguments to FUNC"
  (save-excursion
    (tipgp-run-in-tmp-buffer nil
      ;;  Without this the mail is cat'd without line separator
      ;;  to the previous message.
      ;;
      (tipgp-require-final-newline)
      (tipgp-save-state-macro
	(if (null no-primary)
	    (tipgp-user-change-to-primary))

       ;;  Make sure this exist, because the encryption doesn't
       ;;  succeed otherwise. If the value is already in the cache,
       ;;  then this command does nothing.
       ;;
       (tipgp-password-get-old
	(format
	 "[%s] Decrypted FCC, pass phrase: " tipgp-:user-primary))

       (tipgp-encrypt-mail tipgp-:user-primary)
       (pop-to-buffer (current-buffer))

       (if (null func)
	   (mail-do-fcc (ti::mt-hmax))
	 (apply func args))
       ))))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mail-do-fcc  (&optional cmd user password msg string)
  "Do FCC before the message is encrypted and remove FCC field.
You don't want sendmail.el to FCC message which was encrypted
with the other user's public key.

Input:
  CMD
  USER
  PASSWORD
  MSG
  STRING"
  (let (field
	hmax
	)
    ;;#todo VM FCC must be handled differently ?
    ;;#todo Gnus 5 mail fcc ?
    ;;
    (cond
     ((and (memq major-mode '(mail-mode))
	   (setq field (ti::mt-get-field-1 "fcc"))
	   (eq 'encrypt cmd)
	   )
      (cond
       ((null tipgp-:mail-fcc-encrypt-mode)
	(cond
	 ((eq 20 (xemacs-p))		;needs MARKER
	  (save-excursion (ti::mt-hmax 'move)
			  (setq hmax (point-marker)))
	  (mail-do-fcc hmax)
	  (setq hmax nil)		;kill marker
	  )
	 (t				;XE19.14 and Emacs needs POINT
	  (mail-do-fcc (ti::mt-hmax))
	  )))
       (t
	(tipgp-mail-do-fcc-encrypted)
	))

      (tipgp-hash 'fcc 'put 'field field)
      (ti::mt-kill-field "^FCC")
      ))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mode-specific-control-before
  (cmd &optional user password msg string)
  "Turn on possible edit mode while we do some PGP action.
This function is called prior the PGP action takes effect in current
region or buffer. Eg. in RMAIL we have to turn on the edit mode in
order to modify the message content.

Input:

  The content of these function call parameter depends on the
  calling CMD which can be 'sign 'encrypt 'decrypt 'verify.
  You have to look at the source code to see what is apssed in each case.
  CMD OPTIONAL USER PASSWORD MSG STRING

Used hash entrys:

  The buffer pointer is recorded to hash table under property
  'mode-specific and value 'buffer. This is name of the current buffer
  where the original message is.

  When edit mode is turned on, the buffer may now be different and
  the buffer pointer is recorded under property 'mode-specific and value
  'buffer-edit.

References:

  `tipgp-:verify-before-hook'		;; contain this fucntion
  `tipgp-cmd-macro'			;; calls this function
  `tipgp-mode-specific-control-after'   ;; 'the other side of the coin'"
  (interactive)
  (let ((fid "tipgp-mode-specific-control-before: ")
	)
    (tipgp-mail-do-fcc cmd user password msg string)
;;;    (tipgp-mime-exit	    cmd)

    ;;  We have to record the initial buffer, so that the AFTER
    ;;  hook can restore the state in correct buffer. The package
    ;;  may die anywhere in the code and the buffer pointer certainly
    ;;  isn't in the right place.
    ;;
    (tipgp-hash 'mode-specific 'put 'buffer (buffer-name) 'global)
    (tipgp-hash 'vm 'put 'control nil 'global)

    (tipgpd fid major-mode "BUFFER" (current-buffer))

    ;; - For some unknown reason the VM window configurations
    ;;   is mixed when we open edit mode and close it afterwards,
    ;;   we must save window configuration now.
    ;; - We save this every time, but we only use it in VM
    ;;
    (tipgp-hash 'mode-specific 'put 'wcfg
		(current-window-configuration)
		'global)

    (tipgp-hash 'mode-specific 'put 'frame (selected-frame)   'global)
    (tipgp-hash 'mode-specific 'put 'window (selected-window) 'global)
    (tipgp-hash 'vm 'put 'vm-frame-per-edit vm-frame-per-edit 'global)

    (cond
     ((memq major-mode '(rmail-mode))
      (rmail-edit-current-message))

     ((memq major-mode '(vm-mode))
      (inline (tipgp-install-vm-check))

      ;; - VM opens another frame immediately if you
      ;;   put message in edit mode (that happend when you decrypt mail)
      ;; - We don't want it to do that; Set this locally to nil
      ;;
      (setq vm-frame-per-edit nil)
      (vm-edit-message)
      (tipgp-hash 'vm 'put 'control 'edit 'global)
      ))
    (tipgp-hash 'mode-specific 'put 'buffer-edit (buffer-name) 'global)
    (tipgpd fid major-mode "BUFFER-EDIT" (current-buffer))
    nil
    ))




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mode-specific-label (cmd &optional buffer)
  "Add mail-agent labels according to CMD. Work buffer is BUFFER."
  (let* ((fid "tipgp-mode-specific-label")

	 (tbl   tipgp-:label-table)
	 (v+	(nth 0 (nth 1 (assq 'v tbl))))
	 (v-	(nth 1 (nth 1 (assq 'v tbl))))
	 (si	(nth 1 (assq 's tbl)))
	 (en	(nth 1 (assq 'e tbl)))
	 (de	(nth 1 (assq 'd tbl)))
	 (pgp	(nth 1 (assq 'pgp tbl)))
	 stat
         )
    (job-buffer (or buffer (current-buffer))
      (cond
       ;; ...................................................... rmail ...
       ((memq major-mode '(rmail-mode rmail-edit-mode))


	(cond
	 ((eq cmd 'sign)
	  (rmail-kill-label v+)
	  (rmail-kill-label v-)
	  (when (not (var-nil-p pgp)) (rmail-add-label pgp))
	  (when (not (var-nil-p si)) (rmail-add-label si))
	  )

	 ((eq cmd 'decrypt)
	  (rmail-kill-label en)
	  (when (not (var-nil-p pgp)) (rmail-add-label pgp))
	  (rmail-add-label de)

	  ;;  The message may have beeen encrypted and signed (one pass),
	  ;;  force checking verify too.
	  ;;
	  (setq cmd 'verify)
	  )

	 ((eq cmd 'encrypt)
	  (rmail-kill-label de)
	  (when (not (var-nil-p pgp)) (rmail-add-label pgp))
	  (rmail-add-label en)
	  )

	 ((eq cmd 'encrypt-sign)
	  (rmail-kill-label de)
	  (when (not (var-nil-p pgp)) (rmail-add-label pgp))
	  (rmail-add-label en)
	  (rmail-add-label si)
	  ))

	(when (eq cmd 'verify)
	  ;;  This is special, the parameter call order is 'beg end RET'
	  ;;
	  (rmail-add-label "pgp")
	  (setq stat (or (tipgp-exe-get-result-verify-status)  ""))
	  (cond
	   ((string-match "good.*signature" stat)
	    (rmail-kill-label si)
	    (rmail-kill-label v-)
	    (rmail-add-label  v+)
	    )
	   ((string-match "bad.*signature" stat)
	    (rmail-kill-label si)
	    (rmail-kill-label v+)
	    (rmail-add-label  v-)
	    )))

	)

       ;; ......................................................... vm ...
       ((or (memq major-mode '(vm-mode vm-edit-mode))
	    (string-match "edit.*note " (buffer-name))
	    )
	(tipgpd fid "LABELING" cmd (current-buffer))

	(cond
	 ((eq cmd 'sign)
	  (vm-delete-message-labels v+ 1)
	  (vm-delete-message-labels v- 1)
	  (vm-add-message-labels    si 1)
	  (when (not (var-nil-p pgp)) (vm-add-message-labels    pgp 1))
	  )

	 ((eq cmd 'decrypt)
	  (vm-delete-message-labels en 1)
	  (vm-add-message-labels    de 1)
	  (when (not (var-nil-p pgp)) (vm-add-message-labels    pgp 1))
	  (setq cmd 'verify)
	  )

	 ((eq cmd 'encrypt)
	  (vm-delete-message-labels de 1)
	  (vm-add-message-labels    en 1)
	  (when (not (var-nil-p pgp)) (vm-add-message-labels    pgp 1))
	  )

	 ((eq cmd 'encrypt-sign)
	  (vm-delete-message-labels de 1)
	  (vm-add-message-labels    si 1)
	  (vm-add-message-labels    en 1)
	  (when (not (var-nil-p pgp)) (vm-add-message-labels    pgp 1))
	  ))

	(when (eq cmd 'verify)
	  (when (not (var-nil-p pgp)) (vm-add-message-labels pgp 1))
	  (setq stat (or (tipgp-exe-get-result-verify-status)  ""))
	  (cond
	   ((string-match "good.*signature" stat)
	    (vm-delete-message-labels si 1)
	    (vm-delete-message-labels v- 1)
	    (vm-add-message-labels    v+ 1)

	    )
	   ((string-match "bad.*signature" stat)
	    (vm-delete-message-labels si 1)
	    (vm-delete-message-labels v+ 1)
	    (vm-add-message-labels    v- 1)
	    (when (not (var-nil-p pgp)) (vm-add-message-labels    pgp 1))
	    )))

	)))
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mode-specific-control-after
  (cmd &optional user password msg string)
  "See `tipgp-mode-specific-control-before' for CMD USER PASSWORD MSG STRING."
  (interactive)
  (let* ((fid  "tipgp-mode-specific-control-after: ")
	 ;;  We have to set this to nil; otherwise TM goes nuts
	 ;;  when it calls tm-rmail/preview-message
	 ;;  #todo: investigate
	 ;;
	 rmail-show-message-hook
	 (buffer
	  (tipgp-hash 'mode-specific 'get 'buffer nil 'global))
	 (buffer-edit
	  (tipgp-hash 'mode-specific 'get 'buffer-edit nil 'global))

	 restore-cfg
         )

    (if rmail-show-message-hook;;  ByteComp silencer; no-op
	(setq rmail-show-message-hook nil))

    (tipgpd fid cmd user "BUFFER" buffer "B-edit" buffer-edit major-mode
	    msg string (buffer-name))

    ;;  The "before" hook must have been called otherwise, there must be
    ;;  some error somewhere or exist some situation I haven't thought of.
    ;;
    (job-buffer (or buffer-edit
		    (prog1 nil
		      (tipgpd fid "**CONFLICT; no buffer")
		      (read-char-safe-until
		       "\
Internal error in AFTER HOOK; send bug report + debug immediately."))
		    (current-buffer))
      (cond
       ((memq major-mode '(rmail-mode rmail-edit-mode))
        ;; ..................................................... rmail ...

	(if (eq major-mode 'rmail-edit-mode)
	    (rmail-cease-edit))
	(tipgp-mode-specific-label cmd)
	)
       ;; ......................................................... vm ...
       ((or (memq major-mode '(vm-mode vm-edit-mode))
	    ;;  XEmacs 19.14 sources say...
	    ;;
	    ;;  In vm-edit.el :: vm-edit-message
	    ;;  It says (funcall (or vm-edit-message-mode 'text-mode)),
	    ;;  where vm-vars.el:1506:(defvar vm-edit-message-mode 'text-mode
	    ;;
	    ;;  --> VM does editing in text mode? Glup; that makes hard
	    ;;      to detect its edit buffer.
	    ;;
	    (string-match "edit.*note " (buffer-name))
	    )

	(tipgpd fid "VM ENTRY" major-mode (current-buffer) (buffer-name))

	(setq restore-cfg 'vm)		;Yes; we need to restore Win cfg

	(setq
	 vm-frame-per-edit
	 (tipgp-hash 'vm 'put 'vm-frame-per-edit vm-frame-per-edit 'global))

	;;  Only close edit mode if we opened it. If user was inside
	;;  edit buffer, we don't close it here.
	;;
	(when (and (tipgp-hash 'vm 'get 'control  nil 'global)
		   (or (eq major-mode 'vm-edit-mode)
		       (string-match "edit.*note " (buffer-name))))
	  (vm-edit-message-end))
	(tipgp-mode-specific-label cmd)
	)))

    (when restore-cfg
      (let* ((wcfg
	      (tipgp-hash 'mode-specific 'get 'wcfg nil 'global))
	     (frame
	      (tipgp-hash 'mode-specific 'get 'frame nil 'global))
	     (window
	      (tipgp-hash 'mode-specific 'get 'window nil 'global))
	     )
	(set-window-configuration wcfg)
	(select-frame frame)
	(select-window window)
	))

    (tipgp-hash 'mode-specific 'put 'buffer nil) ;Clear this
    nil					;hook's return value
    ))

;;}}}

;;{{{ remail: misc

;;; .......................................................... &remail ...
;;; -r-  refers to remailing
;;; -r-h refers to remailer headers


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-r-subject-cookie ()
  "Return random subject cookie."
  (nth (1- (rand1 (length tipgp-:r-subject-table)))
       tipgp-:r-subject-table))

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-r-elt-email2elt (email)
  "Return remailer entry when EMAIL is known."
  (list-find tipgp-:r-levien-table email
	     '(string= arg (nth 1 (car table)))))

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-r-elt-remailer  (remailer)
  "Return remailer elt when REMAILER is known."
  ;;  We have the alias name, find the real email address
  ;;
  (or (assoc remailer tipgp-:r-host-table)
      (error "No such remailer %s" remailer)))

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-r-type  (alias &optional email)
  "Return post type for remailer. ALIAS and EMAIL are mutually exclusive."
  (cond
   (email
    (ti::mt-pgpr-reply-type	 (nth 2 (tipgp-r-elt-email2elt email))))

   (t
    (ti::mt-pgpr-reply-type	 (nth 2 (assoc alias tipgp-:r-levien-table)))
    )))



;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-r-server-macro 'lisp-indent-function 2)
(defmacro tipgp-r-server-macro (server account &rest body)
  "Find SERVER and do body or signal error.

Input:

  SERVER    remailer server (alias name)
  ACCOUNT   remailer ACCOUNT@some.remailer.net
	    Can also be nil, in that case the `email' is not constructed.
	    (gains little speed)
  BODY	    lisp form to do if server exists.

Defined variables inside BODY

  `info'    Full levien list entry for server
  `email'   Constructed according to ACCOUNT."
  (`
   (let* ((info  (or (assoc (, server) tipgp-:r-levien-table)
		      (error "Server is unknown %s" (, server))))
	  email
	  )
    (if (, account)
	(setq email (tipgp-r-format-email-address (, account) info)))

    ;;  If this varibale is not used, then byteCompiler nags.
    ;;  Fool it to shut up.
    ;;
    (if (null email) (setq email nil))
    (if (null info)  (setq info  nil))

    (,@ body)
    )))




;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-r-post-p (elt)
  "Check if this remailer ELT can be used for posting."
  (or (string-match "cut.* hash.* pgp.* post" (nth 2 elt))
      (error "\
TinyPgp: not enough properties %s '%s'" (nth 0 elt) (nth 2 elt))))



;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-r-init-maybe ()
  "Call initialize function is needed."
  (or (tipgp-hash 'remail 'get 'init nil 'global)
      (tipgp-r-init)))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-init  (&optional force)
  "Initialize remailer support. Set up all necessary variables etc.
If `tipgp-:r-levien-table' is non-nil, then this function does nothing.

FORCE tells to discard old values and build all from scratch.
You usually do this if tou have updated your remailer list.
FORCE is set to t if you call this function interactively."
  (interactive (list 'force))		;inteactive call always forces init
  (let ((file  tipgp-:r-list-file)
	(clist tipgp-:r-control-list)
	val
	)

    ;; ... ... ... ... ... ... ... ... ... ... ... ... ... ... . check ...
    ;;
    (if (not (stringp tipgp-:r-post-host)) ;has default
	(error "TinyPgp: Please set Usenet post remailer tipgp-:r-post-host."))

    (if (not (stringp tipgp-:r-user-mail-address)) ;has default
	(error "TinyPgp: Please set tipgp-:r-user-mail-address"))

    (when (not (and (stringp tipgp-:r-list-file)
		    (file-exists-p tipgp-:r-list-file)
		    ))
	(message "TinyPgp: Hm, no tipgp-:r-list-file; fetching it by finger..")
	(sit-for 1)
	;;  Notice the 'no-nit, it would loop back to us otw.
	(tipgp-r-update-remailer-list 'verb 'no-init)
	)

    ;; It is important that you have new remailer file, print
    ;; warning regularly if the file is old
    ;;
    ;;
    (when (and tipgp-:r-list-file
	       (progn
		 (setq val (tipgp-hash 'remail 'get 'file-warning))
		 (if (not (integerp val))
		     (setq val 0))
		 (inc val)
		 (tipgp-hash 'remail 'put 'file-warning val)
		 (eq 0 (% val 5))	;every 5th call
		 ))
      (tipgp-hash 'remail 'put 'file-warning 0)
      (tipgp-r-file-old-warning)
      )

    ;; ... ... ... ... ... ... ... ... ... ... ... ... ... ... do init ...
    ;;  If this doesn't exist, init all
    ;;
    (when (or force (null tipgp-:r-levien-table))
      (when (or (not (stringp file))
		(not (file-exists-p file)))
	(error
	 (substitute-command-keys
	  (concat
	   "TinyPgp: Please set variable tipgp-:r-list-file and call"
	   "\\[tipgp-r-update-remailer-list]"
	   ))))


      (setq tipgp-:r-levien-table (tipgp-r-get-list "." nil file clist))
      (tipgpd "tipgp-r-init: " tipgp-:r-levien-table)

      (setq tipgp-:r-host-table
	    (tipgp-r-get-list nil tipgp-:r-levien-table))

      (if (null tipgp-:r-host-table)
	  (error
	   "TinyPgp: Can't find good remailers from '%s'. Consult maintainer."
	   tipgp-:r-list-file
	   ))

      (setq tipgp-:r-reply-block-cache nil)	;Build from scratch

      (tipgp-hash 'remail 'put 'init (or force 'done) 'global)
      (if (interactive-p)
	  (message "TinyPgp: Remailer support initalized."))
      )))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-file-old-warning (&optional file)
  "Print warning if Remailer list FILE is too old."
  (interactive)
  (let* (days
         )
    (or file
	(setq file tipgp-:r-list-file)
	(error "No tipgp-:r-list-file set.")
	)
    (setq days (ti::f-days-old file))

    ;;  over 3 weeks old remailer list...too old
    ;;
    (when (> days (* 3 7))
      (save-excursion
	(message
	 (format
	  (concat
	   "'%s' is approx %d days old, which is too much."
	   "Update remailer list.")
	  file days))
	(sit-for 2)
	))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-get-list  (&optional re list file control-list)
  "Get remailer list matching RE.

Input:
  RE	    what properties to grep. The properties are sorted
	    and defaults to \"cpunk.* hash.* pgp\". These features are
	    considered minimum features from remailer.
  LIST	    preparsed list
  FILE	    file from where to read the levien list. LIST must be nil.
  CONTROL-LIST  See `ti::mt-pgpr-parse-levien-list'."
  (let* ((fid  "tipgp-r-get-list:")
	 ret
         )
    (setq re (or re "cpunk.* hash.* pgp"))

    (unless list
      ;;  Read remailer list from file and parse it
      ;;
      (if (or (null file)
	      (not (file-exists-p file))
	      )
	  (error "TinyPgp: Can't read remailer file file '%s'" file))


      (job-buffer (tipgp-use-tmp-buffer)
	(insert-file-contents file)
	(tipgp-r-file-old-warning)

	(PMIN)
	(unless (setq list (ti::mt-pgpr-parse-levien-list
			    nil control-list))
	  (tipgpd fid (buffer-string))
	  (pop-to-buffer (current-buffer))
	  (error "\
TinyPgp: Cannot parse this buffer: not in levien format. %s " file))
	))

    (dolist (elt list)
      (if (string-match re (nth 2 elt))
	  (push elt ret)))

    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-mail-mode-init  ()
  "Turn off all interfering minor modes from remailer mail buffer."
  (let (s
	)
    (setq s 'post-command-hook)
    (make-local-hook s)			;19.30+
    (remove-hook s 'timi-post-command)	;disable tinymail.el

    ;;  What should we remove from this hook ?
    (setq s 'post-command-idle-hook)
    (when (boundp s) (make-local-hook s))

    (setq s 'mime/editor-mode-flag)	;tm.el
    (when (boundp s)  (set s nil))
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-post-before-default  ()
  "Disable/exit known minor modes/features."
  (tipgp-mime-exit)
  (if (featurep 'tinymail)
      (timi-mail 'disable))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-latent-time-random (remailer str)
  "Add 'r' to the time if REMAILER supports it. If STR is nil, do nothing."
  (when (stringp str)
    ;;
    ;; The remailers are not checked yet.
    ;;
    (if (not (char= (aref str (1- (length str))) ?r))
	(setq str (concat str "r")))
    )
  str
  )

;;}}}
;;{{{ remail: reply block

;;; ................................................... &r-reply-block ...

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-reply-block-read  (remailer)
  "Read reply block for the REMAILER.
Don't use this function, use `tipgp-r-reply-block-cache' instead.

Return:
  '(buffer-pointer
    pgp-beg          ,points
    pgp-end
    )"
  (let ((elt (assoc remailer tipgp-:r-reply-block-table))
	file
	buffer
	reg beg end
	)
    (unless elt
      (error
       (format
	(concat
	 "TinyPgp: No Reply block defined for remailer '%s' "
	 "in tipgp-:r-reply-block-table")
	remailer
	)))

    (setq file   (nth 1 elt)
	  buffer (or (find-buffer-visiting file)
		     (if (file-exists-p file)
			 ;;
			 ;;  pure find avoigs calling hooks/modes
			 ;;  when file is loaded.
			 ;;
			 (file-pure-find file)
		       (error "TinyPgp: No reply block file %s" file))))
    (job-buffer buffer
      (PMIN)
      ;;  Make sure it will not be modified.
      ;;
      (setq buffer-read-only t)
;;;	(rename-buffer (concat " " file))

      (unless (setq reg (ti::mt-pgp-block-area 'any))
	(pop-to-buffer buffer)
	(error "Can't find reply block region?"))
      (setq beg (point-min) end (cdr reg))
      )
    (if buffer
	(list buffer beg end))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-reply-block-cache  (mode &optional arg1)
  "Reply block cache management according to MODE and ARG1.

MODE:

  'get     ARG1 = remailer alias; return reply block.
  'put     ARG1 = `tipgp-:r-reply-block-cache' element
  'del     ARG1 = remailer alias"
  (let ((table   tipgp-:r-reply-block-table)
	buffer
	elt old
	)
    (cond
     ((eq mode 'get)
      (or (setq elt (assoc arg1 table))
	  (error "%s not defined in tipgp-:r-reply-block-table '%s'"
		 arg1 mode))

      ;;  Have we read it already?
      (setq buffer (find-buffer-visiting (nth 1 elt)))
      (or (setq elt  (assq buffer tipgp-:r-reply-block-cache))
	  ;;  No, load it from file then
	  ;;
	  (and (setq elt (tipgp-r-reply-block-read arg1))
	       (setq old (assq (car elt) tipgp-:r-reply-block-cache))
	       (setq tipgp-:r-reply-block-cache
		     (delq old tipgp-:r-reply-block-cache)))
	  (push elt tipgp-:r-reply-block-cache)
	  )

      ;;  Remove non-existing buffers -- keep the list up to date
      ;;
      (dolist (elt tipgp-:r-reply-block-cache)
	(if (killed-buffer-p (car elt))
	    (setq tipgp-:r-reply-block-cache
	     (delq elt tipgp-:r-reply-block-cache))))

      elt
      )

     ((eq mode 'del)
      (and (setq elt    (assoc arg1 table))
	   (setq buffer (get-buffer
			 (file-name-nondirectory
			  (nth 1 elt))))
	   (setq elt    (assq buffer tipgp-:r-reply-block-cache))
	   (setq tipgp-:r-reply-block-cache
		 (delq elt tipgp-:r-reply-block-cache)))
      tipgp-:r-reply-block-cache
      )

     ((eq mode 'put)
      (push arg1 tipgp-:r-reply-block-cache)
      arg1
      ))
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-reply-block-insert  (remailer)
  "Insert REMAILER's reply block."
  (interactive (list (tipgp-ask-reply-block-remailer)))
  (let* ((elt (tipgp-r-reply-block-cache 'get remailer))
	 )
    (if (null elt)
	(error "Invalid return value.")
      (insert-buffer-substring (nth 0 elt) (nth 1 elt) (nth 2 elt))
      )))




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-reply-block-header (remailer latent key anon-to)
  "Return reply block headers of remailer.

Input:

  REMAILER  string or symbol or list, The remailer used.
	    If list, then the REMAILER is remailer-elt from
	    `tipgp-:r-levien-table'
  LATENT    latent time specification. This is not be used if
            remailer does not support it.
  KEY	    The conventional crypt password
  ANON-TO   Where to send the reply block (return address)."
  (if (symbolp remailer) (setq remailer (symbol-name remailer)))
  (let* ((properties   (cond
			((listpp remailer)  remailer)
			((tipgp-r-elt-remailer remailer))))
;;;	 (email		(nth 1 properties))
	 (rtype		(ti::mt-pgpr-reply-type	 (nth 2 properties)))
	 ;;  What kind of reply block: With/out latent ?
	 ;;
	 (btype		(nth 2 properties))
         )
    (when latent
      (if (null (string-match "latent" btype))
	  (setq latent nil)		;Not supported
	(setq latent (tipgp-r-latent-time-random remailer latent))))

    (when key
      (if (null (string-match "ek" btype))
	  (setq key nil)))

    ;;  The Reply string type "cpunk, eric..."
    ;;
    (ti::mt-pgpr-block nil rtype anon-to key latent)
    ))

;;}}}
;;{{{ remail: reply-block: interactive

;;; ................................................... &reply-block-i ...
;;;
(defun tipgp-r-reply-block-test (&optional no-confirm)
  "Send every reply block listed in `tipgp-:r-reply-block-table'.
NO-CONFIRM bypasses asking.
If you don't receive mail back, there are two possibilities:
o  remailer is down
o  your reply block was not constructed correctly."
  (interactive "P")
  (let* ((i       0)
	 remailer
	 email
         )
    (dolist (elt tipgp-:r-reply-block-table)
      (setq remailer (nth 0 elt))
      (setq email    (nth 1 (assoc remailer tipgp-:r-levien-table)))

      (when (or no-confirm
		(y-or-n-p (format "Send reply block to %s " remailer)))
	(inc i)
	(ti::mt-sendmail-macro email remailer 'send
	  (insert (ti::mt-pgpr-block 'epgp "cpunk" ) "\n")
	  (tipgp-r-reply-block-insert remailer)
	  ))

      (if (interactive-p)
	  (message "Sent %d reply blocks to remailers." i))

      )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-reply-block-basic
  (remailer-elt &optional latent key anon-to final verb)
  "Contruct most basic reply block.

The created encrypted reply block will contain following

  ::
  Request-Remailing-To: <`tipgp-:r-user-mail-address'>
  Encrypt-Key: <key you gave>
  Latent-Time: <latent time you gave>

Important:

  You must be in empty [mail] buffer. When this function finishes, you
  should _encrypt_ the mail body.

Input:

  REMAILER-ELT      Remailer table entry
  LATENT	    \"+1:00\"
  KEY		    crypt key, no spaces
  ANON-TO	    send-to@some.com
  FINAL             flag, if this is final block, include
                    \"**\" to the end. (See remailer faqs)
                    And kill any extra headers.

  VERB		    Verbose messages.

Interactive call note:

  LATENT can be passed by prefix arg. Each \\[universal-argument] adds 30 minutes, so
  3 times \\[universal-argument] is same as +1:30.
  Numeric argument gives straigh hours, so M - x 2 means +2:00. Latent time
  is not always supported by selected remailer and it is ignored if remailer
  can't use it.

  ANON-TO  is `tipgp-:r-user-mail-address'.

  FINAL is always set to t"
  (interactive
   (progn

     (unless (ti::mt-body-empty-p)
       (if (y-or-n-p "Fresh buffer needed, empty this buffer? ")
	   (progn
	     (ti::mt-text-start 'move) (delete-region (point) (point-max)))
	 (error "Buffer must be emptied first")))

     (list-merge-elements
      (tipgp-ask-remail-args)
      tipgp-:r-user-mail-address
      t
      )))
  ;; ... ... ... ... ... ... ... ... ... ... ... ... . interactive end . .
  (let* (
	 )
    (tipgp-r-init-maybe)
    (VERB)
    (unless (ti::mt-body-empty-p)
      (error "Buffer must be emptied first"))

    (tipgp-r-chain-1 remailer-elt latent key anon-to final)

    (if tipgp-:r-reply-block-basic-hook
	(run-hooks 'tipgp-:r-reply-block-basic-hook))

;;;    (if verb
;;;	(message "If you encrypt this, you should leave '**' outside."))

    nil
    ))


;;}}}
;;{{{ remail: interactive

;;; ................................................... &r-interactive ...

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-chain-1 (remailer-elt &optional latent key anon-to final)
  "Encrypt mail to next remailer.
Input:

  REMAILER-ELT	    remailer elt from `tipgp-:r-levien-table'
  ANON-TO	    send-to@somewhere.com
  LATENT	    latent time eg. 0:00r  (not used if...)
  KEY		    Encrypt key (not used if remailer does not support it)
  FINAL             flag, prefix arg, if this is final block, include
                    \"**\" to the end. (See remailer faqs)

Return:
  email		    remailer address"
  (interactive
   (list-merge-elements
    (tipgp-ask-remail-args)
    (read-from-minibuffer
     "Anon to: "
     (ti::mt-get-field "To")
     )))
  (tipgp-r-init-maybe)
  (let* (tipgp-:xpgp-signing-mode	;Do not use X-Pgp
	 (properties    remailer-elt)
	 (email         (nth 1 properties))

	 ;;  The Reply string type "cpunk, eric..."
	 ;;
	 (rtype		(ti::mt-pgpr-reply-type	 (nth 2 properties)))

	 (mail		(ti::mt-mail-p))
	 str
;;;	 str2
	 )
    (or tipgp-:r-mode-indication-flag
	(setq tipgp-:r-mode-indication-flag 'basic-1))

    (if (and key (string-match "[ \t\n]" key))
	(error "Key may not contains spaces '%s'" key))


    ;; ........................................... destination address ...
    ;;
    (ti::mt-text-start 'move)

    (setq str (tipgp-r-reply-block-header remailer-elt latent key anon-to))

    (insert str "\n")
    (tipgp-encrypt-mail email)
    ;; ................................................ remail address ...
    ;;
    (ti::mt-text-start 'move)
    ;;  The outer block encrypt key is disabled for now because
    ;;  it causes double encryptinn. When you receive the mail,
    ;;  then you have to decrypt it twice...not convenient.
    ;;
    ;;  The Reply Blocks EK should be enough. User can add the
    ;;  extra Field if he wants it.
    ;;

    (setq str (ti::mt-pgpr-block nil rtype email nil latent))
    (insert str "\n")

    ;; ... ... ... ... ... ... ... ... ... ... ... ... ... ... . final ...
    (when final
      (ti::mt-pgpr-close)

      (when mail
	(ti::mt-kill-field "^To" (concat "  " email) )

	;;  sysadm in your site propably isn't interested in subjects
	;;  like this one. We don't want to draw his attention
	;;
	(ti::mt-kill-field "^Subject" (tipgp-r-subject-cookie))
	(ti::mt-kill-field "^Fcc")
	(ti::mt-kill-field "^Gcc")	;GNUS 5
	(ti::mt-kill-field "^Reply-to")
	)
      )

    email
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-chain  (chain &optional verb)
  "Decrypt current message according to remailer CHAIN.
Important, before you call this function:
1. You have called \\[tipgp-r-post] or \\[tipgp-newnym-post] to convert
   the message into remail post format first.
2. You must have encrypted the message.

Only after these, the additonal chain layers are feasible."
  (interactive
   (progn
     (or tipgp-:r-chain
	 (error "tipgp-:r-chain is empty"))
     (list
      (completing-read
       "Select remailer chain: "
       tipgp-:r-chain nil 'match nil 'tipgp-:history-r-chain)
      )))
  (let* (to
	 list elt
	 remailer
	 remailer-elt
	 latent key anon-to
	 final
         )
    (VERB)
    (or (setq chain (assoc chain tipgp-:r-chain))
	(error "No such choice in tipgp-:r-chain"))

    (setq chain (nth 1 chain)   list chain)

    (unless (or (vectorp chain)
		(vectorp (setq list (eval chain))))
      (error "%s evaluated to %s, which is not vector." chain list))

    (or (setq list (append list nil))	;Convert to list :-)
	(error "Vector list was empty?"))

    ;;  I can't do automatic encryption, because I have no of
    ;;  knowing if user had called C-c / . p to convert the message
    ;;  to post format. It would be disaster to encrypt non-post message
    ;;
    (or (ti::mt-pgp-encrypted-p)
	(error "The message must have been encrypted to mail2news gateway."))

    (list-loop list elt			;Can't use dolist beacause tests FINAL
      (setq remailer (nth 0 elt)
	    latent   (nth 1 elt)
	    key      (nth 2 elt)
	    remailer-elt  (tipgp-r-elt-remailer remailer)
	    final    (null (cdr list))	;No more remailers
	    anon-to  (ti::mt-get-field "to")
	    )
      (or (var-nil-p to)
	  (error "To address is empty, can't use Anon-to"))

      (tipgp-r-chain-1 remailer-elt latent key anon-to final)
      )

    ;;  Let's do fast check and turn off auto-action
    (when (and verb (tipgp-auto-action-on-modeline-p))
       (tipgp-hash 'auto-action 'put 'user-mode nil))

    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-update-remailer-list  (&optional verb no-auto-init)
  "Finger remailer list maintainer and get updated list.
VERB allows verbose messages. NO-AUTO-INIT suppresses call to
`tipgp-r-init' after file update."
  (interactive)
  (let ((file   tipgp-:r-list-file)
	(email  tipgp-:r-list-finger)
	(buffer (tipgp-use-tmp-buffer))
	ret
	)
    (VERB)

    (setq ret (ti::p-finger email nil nil buffer verb))
    (cond
     ((not (bufferp ret))
      (setq tipgp-:last-network-error ret)
      (error "Finger Failed: %s" ret)
      )
     (t
      (file-delete-safe file)
      (job-buffer ret (write-region (point-min) (point-max) file))
      (if verb (message "Remailer list '%s' updated." file))
      (call-interactively 'tipgp-r-init)
      ))
    ))




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-post  (&optional type)
  "Anonymize message. See TYPE from `tipgp-r-post-usenet'."
  (interactive)
  (let* (
         )
    (or type
	(setq type 'remail))
    (tipgp-r-init-maybe)
    (run-hooks 'tipgp-:r-post-before-hook)
    (if (ti::mt-news-buffer-p)
	(tipgp-r-post-usenet type)
      (call-interactively 'tipgp-r-post-regular))
    (run-hooks 'tipgp-:r-post-after-hook)
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-post-regular
  (remailer &optional insert-reply-block remailer-elt)
  "Normal mail to: send as anonymous post. Bulk mail is not permitted.
This means that any BCC or FCC field generates error.

The Prefix arg inserts to the message a reply block, so that person
can answer to the mail if he sends the message back to remailer.

Notes:

  `post-command-hook' and possible `post-command-idle-hook' are
  bound locally to current buffer and set to nil,
  so that nothing special happens when you compose and send this mail.

Input:

  REMAILER		remailer alias name
  INSERT-REPLY-BLOCK	prefix arg, if non-nil, insert remailer reply block
  REMAILER-ELT		the remailer entry from table `tipgp-:r-host-table'"
  (interactive
   (let (remailer
	 remailer-elt
	 )
     (setq remailer (tipgp-ask-remailer))
     (setq remailer-elt (tipgp-r-elt-remailer remailer))
     (list remailer current-prefix-arg remailer-elt)
     ))


  (let* (tipgp-:xpgp-signing-mode	;Do not use X-Pgp
	 (var-list    '(post-command-hook
			post-command-idle-hook
			))
	 (hlist       (delete 'newsgroups (ti::mt-required-headers)))
	 (hlist       (push  'to hlist))
	 (to          (ti::mt-get-field "TO" nil 'nil-mode))

	 (reply-msg   "To reply to this message, send it to some remailer.")
	 (properties   (or remailer-elt
			   (assoc remailer tipgp-:r-levien-table)
			   (error "No remailer '%s'" remailer)
			   ))
	 (email         (nth 1 properties))

	 ;;  The Reply string type "cpunk, eric..."
	 ;;
	 (rtype		(ti::mt-pgpr-reply-type	 (nth 2 properties)))

	 hash-headers
	 header-block
	 message
	 point
	 str
         )


    (if (or (ti::mt-get-field-1 "CC")
	    (ti::mt-get-field-1 "BCC"))
	(error "Sorry, bulk CC or BCC mail is not permitted."))

    (if (null to)
	(error "No TO field filled."))

    (tipgp-r-init-maybe)
    (setq str (ti::mt-pgpr-block nil rtype to))

    ;; ... ... ... ... ... ... ... ... ... ... ... ... ... . headers . .
    ;;  Get rid of headers that may reveal your identity
    ;;

    (ti::mt-kill-non-rfc-fields hlist)

    (if (setq hash-headers (tipgp-header-move-to-body 'move-to-body 'no-ins))
	(setq header-block (mapconcat 'concat hash-headers ""))
      (setq header-block ""))


    ;; ... ... ... ... ... ... ... ... ... ... ... ... . doing message ...
    ;;
    (ti::mt-kill-field "to" email)
    (setq point   (ti::mt-text-start))
    (setq message (buffer-substring point (point-max)))
    (delete-region point (point-max))



    (PMAX)
    (insert
     str
     "Cutmarks: --\n\n"
     "##\n" header-block "\n"
     )

    (when insert-reply-block
      (tipgp-r-reply-block-insert remailer))

    (when (and insert-reply-block reply-msg)
      (insert reply-msg "\n" ))
    (insert message "\n--\n")

    ;;  Make sure there is nothing that interferes sending.
    ;;  make them first local; then set them to nil
    ;;
    (dolist (sym var-list)
      (when (boundp sym)
	(make-local-hook sym)
	(set sym nil)
	))

    ))


;;; ----------------------------------------------------------------------
;;;
;;;
(defun tipgp-r-post-usenet-body-convert
    (groups email &optional rb rtype rblk)
  "Convert body text into Remail post.
Supposes that you have already reformatted the buffer.

Input:

  GROUPS    list of newsgroups where to post.
  EMAIL	    the mail2news gateway email address
  RB	    if string, insert reply block of remailer given.
  RTYPE     Remailer reply type, eg. 'cpunk'
  RBLK	    Header block
"
  (interactive)
  (let* ((reply-msg   "To reply to this message, send it to some remailer.")
	 point message block
	 str
	 )

    ;; ... ... ... ... ... ... ... ... ... ... ... ...  doing blocks . .
    ;;
    (setq point   (ti::mt-text-start)
	  message (buffer-substring point (point-max)))
    (delete-region point (point-max))

    (dolist (grp groups)
      (setq str   (ti::mt-pgpr-block nil rtype grp)
	    block (concat str "\n##\n" rblk  "\n"))
      (PMAX)
      (insert block)

      (when rb
	(tipgp-r-reply-block-insert rb)
	(insert "**\n")
	(insert reply-msg "\n" )
	)

      (insert message "\n--\n")
      )))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-r-post-usenet  (type &optional rb)
  "Usenet message: Convert current message into anonymous remailer post.
Call error if buffer is not a newsgroup post.

Input:

  TYPE  type of conversion: 'newnym or 'remail
  RB	Insert reply block of remailer RB, so that user can aswer to you
	directly by using this replay block.

Return:
 '(remailer-email-addr  (newsgroup newsgroup ..))

References:
 `tipgp-:r-post-host'"
  (let* (post-command-hook
	 mail-setup-hook
	 mail-mode-hook
	 message-mode-hook

	 hash-headers
	 header-block
	 group-fld
	 group-list
	 phost				;posting host
	 phost-elt
	 phost-prop
	 phost-email
	 rtype
	 sym
	 )
    (setq tipgp-:r-mode-indication-flag 'post)

    ;;  Why these if statemnts? Because the byteCompiler sees that
    ;;  I have introduced hooks in let*, but I never use them!
    ;;  This fools bytecompiler to believe they are used and it
    ;;  doesn't give any warnings any more
    ;;
    (if post-command-hook   (setq post-command-hook nil)) ;ByteComp silencer
    (if mail-setup-hook	    (setq mail-setup-hook nil))
    (if mail-mode-hook	    (setq mail-mode-hook nil))

    ;;  This does exist between 19.30 - 19.33; but then it was made obsolete
    ;;  This trick gives clean byteCompilation and no warnings
    ;;
    (setq sym 'post-command-idle-hook)
    (when (fboundp sym)
      (make-local-hook sym)
      (set sym  nil))

    (setq group-fld   (ti::mt-get-field-1 "Newsgroups"))

    (when (and t			;Enabled now
	       (var-nil-p group-fld))
      (error "TinyPgp: No newsgroups? Buffer must contain a news message."))

    (run-hooks 'tipgp-:r-post-before-hook)

    ;; ... ... ... ... ... ... ... ... ... ... ... ... ... variables . .
    ;;  Read needed variables
    ;;
    (if (or (null (setq phost     (eval tipgp-:r-post-host)))
	    (null (setq phost-elt (assoc phost tipgp-:r-levien-table))))
	  (error "err: tipgp-:r-post-host '%s' %s" tipgp-:r-post-host phost))

      (tipgp-r-post-p phost-elt)	;Calls error is not capable enough
      (setq phost-email (nth 1 phost-elt)
	    phost-prop  (nth 2 phost-elt)
	    rtype       (ti::mt-pgpr-reply-type phost-prop)
	    )

      ;; ... ... ... ... ... ... ... ... ... ... ... ... ... . headers . .
      ;;  Get rid of headers that may reveal your identity
      ;;  Don't kill in-reply to because it is used in newsgroup postings.
      ;;
      (tipgp-header-kill)

      ;;  Save all headers because they are inserted into body
      ;;
      (if (setq hash-headers (tipgp-header-move-to-body 'move-to-body 'no-ins))
	  (setq header-block (mapconcat 'concat hash-headers ""))
	(setq header-block ""))

      ;;  The remaier doesn't need this field
      ;;
      (ti::mt-kill-field "in-reply-to")
      (ti::mt-kill-field "newsgroups")

      (if (string-match "," group-fld)
	  (setq group-list (ti::s-get-blocks group-fld "[,\t\n ]+"))
	(setq group-list (list group-fld)))

      ;; ... ... ... ... ... ... ... ... ... ... ... ...  doing blocks . .
      ;;
;;;      (setq point   (ti::mt-text-start)
;;;	    message (buffer-substring point (point-max)))
;;;      (delete-region point (point-max))

      (cond
       ((eq type 'newnym)
	)
       ((eq type 'remail)
	(tipgp-r-post-usenet-body-convert
	 group-list phost rb rtype header-block)
	))


      (PMIN) (insert "To: " phost-email "\n") ;Set destination

      (mail-mode)			;This is not a news message any more.
      (unless tipgp-mode (tipgp-mode 1))

      (list phost-email group-list)
      ))


;;}}}

;;{{{ newnym: misc

;;; ........................................................ &r-newnym ...

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-newnym-read-word  ()
  "Read newnym configuration command word."
  (let* (word)
    (save-excursion
      (when (char= (char-syntax (following-char)) ?\ ) ;Sitting on whitespace
	(backward-char 1))
      (when (setq word (ti::b-read-space-word))
	(strmatget "[^-+=]+" 0 word)
	))))

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-newnym-list (&optional mode force)
  "Return ELTS for all 'newnym'.
Normally once the list has been generated; it is stored to hash.

Input:

  MODE	    nil    = return full configuration list
	    'alias = return alias name list
  FORCE	    reread Levien table content and update hash.

References:
  `tipgp-:r-levien-table'"
  (let* ((list  (tipgp-hash 'remail 'get 'newnym))
	 )
    (tipgp-r-init-maybe)
    (when (or force (null list))
      (or tipgp-:r-levien-table
	  (error "TinyPgp: Levien list is nil."))

      (setq list (tipgp-r-get-list "newnym" tipgp-:r-levien-table))
      (tipgp-hash 'remail 'put 'newnym list)
      (tipgp-hash 'remail 'put 'newnym-alias (mapcar 'car list))
      )

    (cond				;No other choices yet
     ((eq mode 'alias)
      (setq list (tipgp-hash 'remail 'get 'newnym-alias))
      ))
    list
    ))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-r-format-email-address (account remailer-entry)
  "Return address that has ACCOUNT@site.com derived from REMAILER-ENTRY.
The remailer-entry is one of the entries in `tipgp-:r-levien-table'"

  (let* ((email (nth 1 remailer-entry))
	 )
    (if (null (string-match "^[^@]+" email))
	(error "Internal error. Call \\[tipgp-r-init] or maintainer."))
    ;;	Set address to "help@..."
    ;;
    (kill-match 0 account email)
    ))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-newnym-ask-server  (&optional prompt)
  "Ask newnym server name with completion and PROMPT."
  (or tipgp-:newnym-default-server
      (completing-read
       (or "Newnym account domain: " prompt)
       (list-to-assoc-menu (tipgp-newnym-list 'alias))
       nil 'match
       )))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-newnym-ask-account  ()
  "Ask newnym Account name."
  (let* (nym
	 )
    (setq
     nym
     (or tipgp-:newnym-default-account-name
	 (if (var-nil-p
	      (read-from-minibuffer
	       "Nym account login name: "
	       nil nil nil
		'tipgp-:history-newnym-account
		)))
	 (error "Empty not accepted.")))
    nym
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-ask-srv-acc (&optional confirm-msg)
  "Return '(server account)"
  (let* (srv
	 acc
	 )
    (if confirm-msg
	(or (y-or-n-p confirm-msg)
	    (error "Abort")))

    (setq srv (tipgp-newnym-ask-server))
    (setq acc (tipgp-newnym-ask-account))
    (list srv acc)
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-ask-srv-acc-arg (&optional confirm-msg)
  "Return '(server account prefix-arg)."
  (if confirm-msg
      (or (y-or-n-p confirm-msg)
	  (error "Abort")))
  (list
   (tipgp-newnym-ask-server)
   (tipgp-newnym-ask-account)
   ))

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-r-sendmail-create-buffer (name &optional subject)
  "Create mail buffer. The old buffer is killed.
Input:
  NAME     buffre name. Kill eny existing buffer with NAME without query.
  SUBJECT  Message subject."
  (kill-buffer-safe name)
  (job-buffer (tipgp-use-tmp-buffer 'mail "NONE" (or subject ""))
    (rename-buffer name)
    (buffer-enable-undo)
    (setq tipgp-:r-mode-indication-flag 'newnym)
    (tipgpd "tipgp-r-sendmail-create-buffer" name (current-buffer))
    (current-buffer)
    ))


;;; ----------------------------------------------------------------------
;;;
(eval-and-compile
(defun tipgp-newnym-sendmail-fmacro-1 (func doc account subject msg)
  "Use `tipgp-newnym-sendmail-fmacro' instead.
See FUNC DOC ACCOUNT SUBJECT MSG there."
  (let* ((sym (intern (symbol-name (` (, func)))))
         )
    (`
     (defun (, sym)  (alias &optional verb)
       (, doc)
       (interactive (list (tipgp-newnym-ask-server)))
       (VERB)
       (tipgp-r-server-macro alias (, account)
	 (ti::mt-sendmail-macro email (, subject) 'send (insert "empty"))
	 (if verb
	     (message "'%s' request sent to %s, wait for answer."
		      (, msg) email))
	 )))))
)

;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-newnym-sendmail-fmacro 'lisp-indent-function 0)
(defmacro tipgp-newnym-sendmail-fmacro (func doc account subject msg)
  "Create interactive function that sends mail to remailer.
Input:

  FUNC		Created fucntion name
  DOC		Function's doc string
  ACCOUNT	the account name where to send email request
  SUBJECT	Subject for email
  MSG		Notification message to interactive user eg. 'create'."
  (` (, (tipgp-newnym-sendmail-fmacro-1
	 func doc account subject msg ))))


;;}}}
;;{{{ newnym: keys; menus

;;; ................................................... &newnym-mode ...

(defun tipgp-newnym-mode-define-menu  ()
  "Define menus."
  (easy-menu-define
   tipgp-:newnym-mode-menu (if (xemacs-p) nil tipgp-:newnym-mode-map)
   "TinyPgp Newnym management menu"
   (list
    tipgp-:newnym-mode-menu-name
    ["Nym-Commands: Electric tab"   tipgp-newnym-electric-tab	    t]
    ["Nym-Commands: Go to."	    tipgp-newnym-nym-commands	    t]
    ["Reply-Block:  Add"            tipgp-newnym-reply-block	    t]
    ["Reply-Block:  Kill"	    tipgp-newnym-reply-block-kill   t]
    ["Public-key:   Add"	    tipgp-newnym-public-key	    t]
    ["Public-key:   Kill"	    tipgp-newnym-public-key-kill    t]
    "----"
    )))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-mode-define-keys ()
  "Define keys."
  (let* ((p    tipgp-:newnym-mode-prefix-key)
	 (map  tipgp-:newnym-mode-map)
	 )
    (define-key map "\t"		'tipgp-newnym-electric-tab)
    (define-key map (concat p "\t")	'tipgp-newnym-nym-commands)
    (define-key map (concat p "p")	'tipgp-newnym-public-key)
    (define-key map (concat p "P")	'tipgp-newnym-public-key-kill)
    (define-key map (concat p "r")	'tipgp-newnym-reply-block)
    (define-key map (concat p "R")	'tipgp-newnym-reply-block-kill)
    (define-key map (concat p "?")	'tipgp-newnym-mode-describe)
    ))

;;}}}
;;{{{ newnym: Mode functions

;;; ----------------------------------------------------------------------
;;;
;;;
(ti::m-fmacro-minor-mode
 tipgp-newnym-mode			;1
 "Newnym account management help mode.
You turn this mode on in mail buffer and it helps you to
compose message to nym account. The most interesting command propably
is `tipgp-newnym-electric-tab'; which works as follows

  If cursor is anywhere else that at the line Nym-Commands:, then the
  original tab function is called.

Nym-Commands: create +acksend +fin  +
|	      |	    |		  |  |
|	      |	    |	          |  complete all commands
|	      |	    |		  complete command 'fin'
|             |     Show default setting or example (previous word)
|	      |     *
|	      Show command help and advance to '*'.
If the cursor is over word Nym-Commands:, then advance forward to first
command word.

In hooks you should use functions

  `turn-on-tipgp-newnym-mode'
  `turn-off-tipgp-newnym-mode'

Mode description:
\\{tipgp-:newnym-mode-map}
"
 tipgp-install-modes			;3
 tipgp-newnym-mode			;4
 tipgp-:newnym-mode-name

 tipgp-:newnym-mode-prefix-key		;5
 tipgp-:newnym-mode-menu		;6

  nil					;7
 "Newnym acocunt handling"		;8
 tipgp-:newnym-mode-hook		;

 (progn
   (tipgp-update-modeline)
   ))

(defun turn-on-tipgp-newnym-mode  ()
  "Newnym mode on."
  (tipgp-newnym-mode 1))

(defun turn-off-tipgp-newnym-mode ()
  "Newnym mode off."
  (tipgp-newnym-mode 0))


;;; ..................................................... &newnym-misc ...


;;; .............................................. &newnym-interactive ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-mode-describe ()
  "Describe mode."
  (interactive)
  (describe-function 'tipgp-newnym-mode))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-electric-tab  ()
  "Compose newnym commands if cursor is on field Nym-Commands.
Otherwise call original mode's tab key. See description of this command
from `tipgp-newnym-mode'."
  (interactive)
  (let* ((tbl tipgp-:newnym-cmd-table)
	 elt
	 word
         )
    (cond
     ((null
       (save-excursion (beginning-of-line) (looking-at "Nym-Commands:")))
      ;;  Turn mode off and call original tab key.
      ;;
      (let* (tipgp-newnym-mode)
	(call-interactively (key-binding "\t")))
      )
     (t
      (setq word (tipgp-newnym-read-word))

      (cond
       ;; ................................................... beg line ...
       ((and (not (var-nil-p word))
	     ;;   the "-" terminates word; because it is [+-] option,
	     ;;   that's why we have to test separate words.
	     (member word '("Nym" "Commands:")))
	(skip-chars-forward "^ \t\n")
	(skip-chars-forward " \t")
	)
       ;; ............................................... complete all ...
       ((and (var-nil-p word)		;User wrote [+-] and wants to complete
	     (char-in-list-case (preceding-char) '(?+ ?-)))
	(setq word (completing-read "Insert Command: " tbl))
	(if (not (var-nil-p word))
	    (insert word))
	)

       ;; ............................................... example show ...
       ((and (not (var-nil-p word))
	     (setq elt (assoc word tbl)) ;Full match
	     ;; after word that is full match; on whitespace
	     (char-in-list-case (following-char) '(?\ ?\t ?\n))
	     )
	(message (nth 2 elt))
	)


       ;; ........................................... full match; help ...
       ((and (not (var-nil-p word))
	     (setq elt (assoc word tbl))) ;Full match
	(message (nth 1 elt))
	(skip-chars-forward "^ \t\n")
	)

       ;; ........................................... partial complete ...
       ((and (not (var-nil-p word))		;Partial
	     (setq elt (all-completions word tbl)))
	(cond
	 ((eq 1 (length elt))		;one match
	  (skip-chars-forward "^ \t\n")
	  (delete-backward-char (length word))
	  (insert (car elt))
	  )
	 (t				;many completions
	  (message (list-to-string elt))
	  )))

       ;; .............................................. nothing works ...
       (t
	;; User is sitting on whitespace and nothing is nearby
	;; "Nym-Commands:  "
	(message "Write [+-] before options. Complete with TAB.")
	))
      ))))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-nym-commands  ()
  "Goto Nym-Commands: forward or add that field if it does not exist."
  (interactive)
  (let* ((fld	"Nym-Commands: ")
	 (point (if (re-search-forward fld nil t)
		    (match-end 0)
		  (save-excursion		;Wrap
		    (PMIN)
		    (if (re-search-forward fld nil t)
			(match-end 0)))))
         )
    (if point
	(goto-char point)
      ;; No such field; add one. Put after From field.
      ;;
      ;; Config:
      ;; From:
      ;; Nym-Commands:
      ;;
      ;;
      (ti::mt-text-start 'move)
      (cond
       ((re-search-forward "From:")	(forward-line 1))
       ((re-search-forward "Config:")	(forward-line 1))
       )
      (insert fld "\n")
      (backward-char 1)
      )
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-public-key-kill  ()
  "Kill Public-Key field"
  (interactive)
  (tipgp-newnym-public-key nil 'kill))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-public-key  (key-id &optional kill)
  "Insert Public-Key field and PGP key block to the end.
If there already exist Public-Key tag, then insert pgp key block after it
by possibly deleting old pgp key block.

Input:
  KEY-ID    key-id matching public key
  KILL	    if non-nil prefix arg, kill the public key block"
  (interactive
   (let* ((default (save-excursion
		     (ti::mt-text-start 'move)
		     ;;  find the From command field and suggest
		     ;;  inserting pgp key-id amtching it
		     ;;
		     (ti::mt-get-field "From" 'any)
		     ))
	  )
     (unless current-prefix-arg		;Don't ask if arg given
       (setq
	ret
	(read-from-minibuffer "Insert pgp key matching key-id: "
			      (if (not (var-nil-p default))
				  (ti::s-sqz default))))
       (if (var-nil-p ret) (error "Empty not accepted."))
       )

     (list ret current-prefix-arg)
     ))
  (let* ((fld "Public-Key:")
	 stat
	 )
    (save-with-marker
      (ti::mt-text-start 'move)
      (setq stat (re-search-forward fld nil t))

      (cond
       ((and kill stat)
	(ti::b-kill-line))

       ((null kill)
	(if stat
	    (forward-line 1)
	  (PMAX)
	  (insert fld "\n")
	  )))

      (ti::mt-pgp-block-area-kill-forward 'pkey 'move)

      (when (null kill) (tipgp-key-extract-to-point key-id 'raw))
      )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-reply-block-kill  (&optional insert remailer)
  "Kill Reply-Block or INSERT (or replace with) matching REMAILER."
  (interactive)
  (let* ((fld "Reply-Block:")
	 stat
	 )
    (save-with-marker
      (ti::mt-text-start 'move)
      (setq stat (re-search-forward fld nil t))

      (cond
       ((and insert (null stat))
	(PMAX)
	(insert fld "\n")
	)
       ((and insert
	     stat
	     (save-excursion		;Previous reply block?
	       (forward-line 1)		;Peek next line
	       (looking-at "::\n")
	       ))
	(forward-line 1)
	(delete-region (point) (point-max))
	)
       ((and (null insert) stat)
	(ti::b-kill-line)
	(if (looking-at "::\n")
	    (delete-region (point) (point-max)))
	))

      (when insert
	(tipgp-r-reply-block-insert  remailer)))
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-reply-block  (remailer &optional verb)
  "Insert Reply-Block field and REMAILER block to the end.
If there already exist Reply-Block tag, then insert block after it
by possibly deleting old block.

Input:
  REMAILER  The reply block must have been created beforehand and
	    it must be included in `tipgp-:r-reply-block-table'
  VERB	    Verbose messages."
  (interactive (list (tipgp-ask-reply-block-remailer)))
  (VERB)
  (tipgp-newnym-reply-block-kill 'insert remailer)
  (if verb (message "Tinypgp: '%s' reply block inserted" remailer))
  )

;;}}}
;;{{{ newnym: misc, interactive(delete; create; toggle)

;;; ............................................ &r-newnym-interactive ...




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-default-toggle (&optional arg verb)
  "Toggle setting and resetting default newnym account.
Set and restore variables
  `tipgp-:newnym-default-server'
  `tipgp-:newnym-default-account-name'

ARG behaves like mode arg.
  nil  toggle
  0    set values to nil
  1    restore values.
  9    Force re-reading values now. You have to call this if you chnage the
       contents of the values during session manually."
  (interactive "P")
  (let* ((srv 'tipgp-:newnym-default-server)
	 (acc 'tipgp-:newnym-default-account-name)
	 (force (eq arg 9))
	 msg
	 )
    (VERB)
    ;; Not recorded; record original value
    ;;
    (when (or force (null (get srv 'original)))
      (put srv 'original (symbol-value srv)))

    (when (or force (null (get acc 'original)))
      (put acc 'original (symbol-value acc)))

    (cond
     ((memq arg '(9))
      (setq msg (format "Default newnym parameters updated: %s %s"
			(symbol-value srv) (symbol-value acc)))
      )

     ((memq arg '(0 -1))
      (set srv nil)
      (set acc nil)
      (setq msg (format "Default newnym parameters off."))
      )

     (t
      (cond
       ((symbol-value srv)
	(set srv nil)
	(set acc nil)
	)
       (t
	(set srv (get srv 'original))
	(set acc (get acc 'original))
	))
       (setq msg (format "Default newnym server and account now: %s %s"
			 (or (symbol-value srv) "nil")
			 (or (symbol-value acc) "nil")
			 ))
       ))

    (tipgp-update-modeline)
    (if verb (message msg))
    msg
    ))

;;; ----------------------------------------------------------------------
;;;
(tipgp-newnym-sendmail-fmacro
  tipgp-newnym-get-pgp-key
  "Get PGP key via email from remailer."
  "info" "Send PGP key"  "PGP key get"
  )

(tipgp-newnym-sendmail-fmacro
  tipgp-newnym-get-used-list
  "Get list of used 'newnym' account names."
  "list" "Send used account list" "Used"
  )




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-help-verbose  (&optional arg)
  "Call `tipgp-nymserver-help' as interactive would with ARG."
  (let* ((a (tipgp-newnym-help-i-args arg))
         )
    (tipgp-newnym-help (nth 0 a) (nth 1 a))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-help-i-args (&optional arg)
  "Ask arrgs for `tipgp-newnym-help'. ARG is prefix arg."
  (let* ((list   (tipgp-newnym-list))
	 )
    (when (or (not (stringp tipgp-:r-newnym-help-file))
	      (null (file-exists-p tipgp-:r-newnym-help-file))
	      current-prefix-arg
	      )
      (if (null list)
	  (error "No 'newnym' type remailers in `tipgp-:r-levien-table'."))

      (list
       'mail-req
       (tipgp-newnym-ask-server "Send help request to newnym: ")
       ))))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-help (&optional mail-req nym-alias-name verb)
  "Print newnym remailer help or send the help request via mail.

Input:
  MAIL-REQ	    send mail request [current-prefix-arg]
  NYM-ALIAS-NAME    from where to ask the help file.
  VERB		    verbose messages"
  (interactive (tipgp-newnym-help-i-args current-prefix-arg))
  (let* ((file  tipgp-:r-newnym-help-file)
	 (elt   (if nym-alias-name
		    (assoc nym-alias-name tipgp-:r-levien-table)))
	 email
         )
    (VERB)
    (cond
     (mail-req
      (if (null elt)
	  (error "Cannot find ELT for '%s'" nym-alias-name))

      ;; Set address to "help@..."
      (setq email (nth 1 elt))
      (if (null (string-match "^[^@]+" email))
	  (error "Internal error. Call \\[tipgp-r-init]"))
      (setq email (kill-match 0 "help" email))

      (ti::mt-sendmail-macro email "help" 'send (insert "help\n"))
      (if verb
	  (message
	   "Email request sent to '%s'.%s"
	   email
	   (if file ""
	     "Update tipgp-:r-newnym-help-file when you get answer."
	     )))
      )

     ((and file
	   (file-exists-p file))
      (pop-to-buffer (find-file-noselect file)))

     (t
      (error "Don't know what to do. %s %s " mail-req nym-alias-name)
      ))

    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-config-insert
    (server nym-name &optional command pgp-key remailer)
  "Insert Config request to mail buffer. Mail body is supposed to be empty.

Input:

  SERVER	newnym server alias name, like 'weasel'
  NYM-NAME	account name i the newnym server
  COMMAND	commands to send
  PGP-KEY	PGP key block.
		if 'string' insert as is
		if buffer pointer, insert buffer contents
		if symbol; call pgp to find key from keyrings matching symbol.

  REMAILER	Reply block
		if 'string', then insert as is
                if buffer pointer, then insert buffer content.
		if symbol, it must be remailer alias name to use for
		reply block. The remailer reply block is then
		inserted from file pointed by `tipgp-:r-reply-block-table'."
  (interactive
   (list
    (tipgp-newnym-ask-server)
    (read-from-minibuffer "Nym account name: ")
    ))
  (let* ((fid   "tipgp-newnym-config-insert:")
	 list
         )

    (tipgpd fid "in:" server nym-name  command pgp-key remailer)
    ;; ... ... ... ... ... ... ... ... ... ... ... ... compose request ...
    (tipgp-r-server-macro server "config"

      (ti::mt-kill-field "^To:" email)
      (ti::mt-text-start 'move)

      (insert
       "Config:\n"
       "From: " (or nym-name "") "\n"
       "Nym-Commands: "  (or command "") "\n"
       )

      (when pgp-key
	(insert "Public-Key:\n")
	(cond
	 ((bufferp pgp-key) (insert-buffer pgp-key))
	 ((stringp pgp-key) (insert pgp-key))

	 ((symbolp pgp-key)
	  (tipgp-key-extract-to-point (symbol-name pgp-key) 'raw)
	  ;; check that PGP public key definition contains <> email
	  ;; to this host.
	  ;;
	  (job-buffer tipgp-:buffer-tmp-shell
	    (setq list (ti::mt-email-find-region))
	    (when (or (null list)
		      (not (string-match
			    (ti::s-del-re ".*@" email 0)
			    ;;  Take first email from key-id
			    (or (car list)
				(progn
				  (pop-to-buffer (current-buffer))
				  (error "\
Tinypgp: no email found from pgp key?"
					 ))))))
	      (pop-to-buffer (current-buffer))
	      (error "PGP user ID '%s' does not refer to domain '%s'"
		     pgp-key email)
	      )))

	 ((error "Oops, wrong argument...")
	  )))

      (when remailer
	(insert "Reply-Block:\n")
	(cond
	 ((bufferp remailer) (insert-buffer remailer))
	 ((stringp remailer) (insert remailer))
	 ((symbolp remailer)
	  (tipgp-r-reply-block-insert (symbol-name remailer)))
	 ((error "Oops, wrong argument..."))
	 )
	(insert "\n**\n")

	(PMAX)
	)

      )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-config-sendmail-template  (server account &optional verb)
  "Create mail buffer and inset newnym' configuration template.
Input:

  SERVER    newnym server
  ACCOUNT   login account
  VERB	    verbose, show buffer. Interactive call sets this.

Return:
  buffer pointer"
  (interactive
   (list
    (tipgp-newnym-ask-server)
    (tipgp-newnym-ask-account)
    ))
  (let* (buffer
	 )
    (VERB)
    (job-buffer (setq buffer
		      (tipgp-r-sendmail-create-buffer
		       tipgp-:buffer-newnym
		       "Config request"
		       ))
      (tipgp-newnym-config-insert server account)
      (turn-on-tipgp-mode)
      (turn-on-tipgp-newnym-mode)
      (tipgp-newnym-nym-commands)
      )
    (when verb (switch-to-buffer buffer))
    buffer
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgpg-newnym-account-request
  (server account cmd &optional pgp-key remailer send)
  "Set up all necessary things to send command to newnym server account.
Input:
  SERVER    newnym server alias
  ACCOUNT   newnym account name
  CMD	    Nym-Comands's field content

  PGP-KEY   If t, then inser pgp-key matching ACCOUNT

	    It symbol but not t, Email address string which
	    matches the key-id from PGP key -- that key is sent to newnym.

  REMAILER  Use this remailer's reply block. You must have created this
            beforehand with `tipgp-r-reply-block-basic' and stored
            it to file pointed by `tipgp-:r-reply-block-table'.
  SEND	    if non-nil, encrypt and send the message.

Return:
  mail buffer pointer if SEND is nil"
  (let* ((fid   "tipgpg-newnym-account-request: ")
	 buffer pass
         )
    (tipgpd fid "ARGS" server account)
    ;; ... ... ... ... ... ... ... ... ... ... ... ... ... mail buffer ...
    (tipgp-r-server-macro server account
      (ti::mt-sendmail-pure-env-macro
	(job-buffer (setq buffer (tipgp-r-sendmail-create-buffer
				  tipgp-:buffer-newnym
				  "Account request"
				  ))

	    (tipgpd fid server account email info)
	    (if (eq t pgp-key)
		(setq pgp-key (make-symbol email)))

	    (tipgp-newnym-config-insert server account cmd pgp-key remailer)

	    (if (null send)
		buffer
	      (make-local-variable 'tipgp-:auto-action-table)
	      (setq tipgp-:auto-action-table nil)
	      (ti::mt-sendmail-reset-send-hooks)

	      (pop-to-buffer (current-buffer))
	      (when
		  (save-excursion
		    (y-or-n-p (format "[Beta code] confirm request" cmd))
		    )
		(tipgp-save-state-macro
		  (setq tipgp-:user-now email
			pass   (tipgp-password-get-old))
		  (tipgp-encrypt-mail (ti::s-sqz (ti::mt-get-field "to"))
				      nil pass)
		  )
		(mail-send-and-exit nil)
		))

	    )))))






;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-delete  (server account &optional verb)
  "Send to newbyn SERVER a ACCOUNT delete request. VERB."
  (interactive
   (tipgp-newnym-ask-srv-acc "Are you sure you want to send DELETE request? "))
  (VERB)
  (pop-to-buffer
   (tipgpg-newnym-account-request server account "delete" nil nil)
   )
  (if verb (message "Newnym Delete request sent.")))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-create-i-args  ()
  "Ask arguments to `tipgp-newnym-create'."
  (let* (desc
	 remailer
	 srv-account
         )
    (tipgp-r-init-maybe)
    (message "You should check free Nym login names first...ok?")
    (sit-for 2)

    (setq srv-account (tipgp-newnym-ask-srv-acc))

    (if (var-nil-p (setq desc (read-from-minibuffer
			       "Describe Nym login name: ")))
	(error "Empty not accepted."))

    (setq remailer (tipgp-ask-reply-block-remailer))

    (list (nth 0 srv-account) (nth 1 srv-account) desc remailer)
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-create  (server account desc remailer &optional verb)
  "Send to newbyn SERVER a ACCOUNT delete request.

Note:

  Before you call this function, make sure you have created new key
  with 'pgp -kg' and that its key-id line contain email address
  <yournym@remail.domain.com>

Input:

  SERVER    The newnym server (alias) name
  ACCOUNT   account name in newnym
  REMAILER  remailer's reply block to submit to newnym server.
  VERB	    Verbose messages. Shows the buffer and turns on
	    `tipgp-mode' and `tipgp-newnym-mode`."
  (interactive
   (progn
     (or
      (y-or-n-p
       "\
Do have created the ncessary PGP keys for newnym account? (see manual)")
      ;; Umph; again some impatient user selected this choice without readin
      ;; the newnym documentation....
      (error "Please read the newnym remailer manual first.")
      )
     (tipgp-newnym-create-i-args)
     ))
  (tipgp-r-init-maybe)
  (let* (
	 )
    (VERB)
    ;; ... ... ... ... ... ... ... ... ... ... ... ... ... mail buffer ...
    (job-buffer (tipgpg-newnym-account-request
		server account
		(format "create +acksend +fingerkey name=\"%s\"" desc)
		t
		(make-symbol remailer)
		)

      (when verb
	(turn-on-tipgp-mode)
        (switch-to-buffer (current-buffer)) ;Now visible to user
	(ti::mt-text-start 'move)

	(turn-on-tipgp-newnym-mode)
	(tipgp-mime-exit)

	(read-char-safe-until
	 (substitute-command-keys
	  (concat
	   "Check all; do 'One pass' Encrypt-Sign with NymKey: "
	   "\\[tipgp-encrypt-mail-sign] [press to continue]"
	   )))
	))
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-post  (&optional server account verb)
  "Convert current message into Nym post.
The message can newgroup post or regular email."
  (interactive
   (list
    (tipgp-newnym-ask-server)
    (tipgp-newnym-ask-account)
    ))
  (let* ((subj	    (ti::mt-get-field-1 "Subject"))
	 (news	    (ti::mt-news-buffer-p))
	 (hdr-blk   "")
	 hash-headers to
	 hdr
	 ret
         )
    (VERB)

    (tipgp-r-server-macro server "send"
      (cond
       (news
	(setq ret (tipgp-r-post-usenet 'newnym))
	(ti::mt-kill-field "To")
	(ti::mt-kill-field "Subject")
	;;  Rest of the headers without "To" field.
	;;
	(setq hdr (buffer-substring (point-min) (ti::mt-hmax)))

	;;  Now send to newnym server
	;;
	(PMIN)
	(insert "To: " email "\n"
		"Subject: messge\n")

	(ti::mt-text-start 'move)
	(insert "From: " account "\n"
	        "subject: " subj "\n")

	(insert hdr)
	(insert "Newsgroups: " (list-to-string (nth 1 ret)) "\n")
	(ti::mt-kill-field-in-body '("fcc" "gcc"))
	)
       (t
	(setq to (ti::mt-get-field-1 "to"))
	(tipgp-header-kill)
	;;  Save all headers because they are inserted into body
	;;
	(if (setq hash-headers
		  (tipgp-header-move-to-body 'move-to-body 'no-ins))
	    (setq hdr-blk      (mapconcat 'concat hash-headers "")))
	(ti::mt-kill-field "To" email)
	(PMIN) (insert "To: " email "\n")

	(ti::mt-text-start 'move)
	(insert "From: " account "\n"
	        "To: " to "\n"
	        hdr-blk
	        )
	)))
    (when verb
      (unless tipgp-newnym-mode (turn-on-tipgp-newnym-mode))
      ;; (tipgp-auto-action-update-modeline)
      (message
       (substitute-command-keys
	(concat
	"Nym-Commands can be set per message basis, press "
	"\\[tipgp-newnym-nym-commands] and "
	"\\[tipgp-newnym-electric-tab]"
	))))
    ))


;;}}}
;;{{{ newnym: interactive requests


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-req-acksend (server account &optional plus verb)
  "Send to newbyn SERVER a ACCOUNT -acksend or PLUS request. VERB."
  (interactive (tipgp-newnym-ask-srv-acc-arg))
  (VERB)
  (tipgpg-newnym-account-request
   server account  (if plus "+acksend" "-acksend") nil nil 'send)
  (if verb (message "Newnym Acksend request sent.")))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-req-sigsend (server account &optional plus verb)
  "Send to newbyn SERVER a ACCOUNT -sigsend or PLUS request. VERB."
  (interactive (tipgp-newnym-ask-srv-acc-arg))
  (VERB)
  (tipgpg-newnym-account-request
   server account  (if plus "+sigsend" "-sigsend") nil nil 'send)
  (if verb (message "Newnym Sigsend request sent.")))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-req-cryptrecv (server account &optional plus verb)
  "Send to newbyn SERVER a ACCOUNT -cryptrecv or PLUS request. VERB."
  (interactive (tipgp-newnym-ask-srv-acc-arg))
  (VERB)
  (tipgpg-newnym-account-request
   server account  (if plus "+cryptrecv" "-cryptrecv") nil nil 'send)
  (if verb (message "Newnym Cryptrecv request sent.")))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-req-fixedsize (server account &optional plus verb)
  "Send to newbyn SERVER a ACCOUNT -fixedsize or PLUS request. VERB."
  (interactive (tipgp-newnym-ask-srv-acc-arg))
  (VERB)
  (tipgpg-newnym-account-request
   server account  (if plus "+fixedsize" "-fixedsize") nil nil 'send)
  (if verb (message "Newnym Fixedsize request sent.")))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-req-disable (server account &optional plus verb)
  "Send to newbyn SERVER a ACCOUNT -disable or PLUS request. VERB."
  (interactive (tipgp-newnym-ask-srv-acc-arg))
  (VERB)
  (tipgpg-newnym-account-request
   server account  (if plus "+disable" "-disable") nil nil 'send)
  (if verb (message "Newnym Disable request sent.")))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-newnym-req-fingerkey (server account &optional plus verb)
  "Send to newbyn SERVER a ACCOUNT -fingerkey or PLUS request. VERB."
  (interactive (tipgp-newnym-ask-srv-acc-arg))
  (VERB)
  (tipgpg-newnym-account-request
   server account  (if plus "+fingerkey" "-fingerkey") nil nil 'send)
  (if verb (message "Newnym Fingerkey request sent.")))

;;}}}

;;{{{ Nymserver: misc

;;; .................................................. &nymserver-misc ...
;;; anon.nymserver.com successor of anon.penet.fi


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-mail-p  (&optional alias)
  "Check if there is Anon X-headers in the buffers. ALIAS."
  (setq alias (car (car tipgp-:nymserver-table)))
  (and
   (re-search-check "^X-Anon-Password\\|^X-Anon-To")
   (re-search-check (format "^To:.*%s" alias))
   ))

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-nymserver-service-elt  (alias)
  "Return service entries or call error is no such ALIAS."
  (or (assoc alias tipgp-:nymserver-table)
      (error "No server alias '%s'" alias)))

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-nymserver-mailto  (alias)
  "Return address where user can send mail so that it gets anynymized. ALIAS."
  (or (nth 3 (assoc alias tipgp-:nymserver-table))
      (error "No post email address")))

;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-nymserver-address  (string alias)
  "Return nymserver email address prepended with STRING as account name. ALIAS.

Return:
  STRING@NYMSERVER-ADDRESS"
  (concat
   string
   (strmatget
    "\\(@.*\\)" 1
    (nth 2 (assoc alias tipgp-:nymserver-table)))))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-ask  (&optional msg)
  "Ask server alias name with MSG."
  (if nil				;disabled now
      (completing-read
       (or msg "Use pent server: ")
       (list-to-assoc-menu (mapcar 'car tipgp-:nymserver-table))
       nil 'match
       )
    ;; 97-02-13 Jari aalto
    ;; - We don't support other nymserver accounts currently
    ;;
    (car (car tipgp-:nymserver-table))
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-password (alias)
  "Return password or nil for ALIAS."
  (let* ((elt	   (assoc alias tipgp-:nymserver-account-table))
	 (pass     (nth 2 elt))
	 )
    pass
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-sendmail (action alias &optional verb arg1 arg2)
  "Send ACTION mail to nymserver ALIAS.
Mail will be encrypted if `tipgp-:nymserver-request-encrypt' is non-nil.
See variables documentation for more detailed usage.

Input:
  ACTION ALIAS VERB ARG1 ARG2

Note:
  following variables are bound to nil to prevent any interference when
  sending mail commands.

  `mail-archive-file-name'
  `mail-default-headers'
  `mail-mode-hook'
  `mail-setup-hook'"
  (let* ((elt	    (assoc alias tipgp-:nymserver-account-table))
	 (account   (or (nth 1 elt)
			(error "No account")))
	 (pass      (or (nth 2 elt)
			(error "No account password")))
	 (my-from   (nth 4 elt))

	 (fld1	    "X-Anon-Password: ")
	 (fld2	    "X-Anon-Subject: ")
	 (encrypt   tipgp-:nymserver-request-encrypt)

	 ;; Make sure email substitution mode is on when we send
	 ;; mail to anon server. User may have forgotten it off
	 ;;
	 (tipgp-:read-email-after-hook
	  (or (get 'tipgp-:read-email-after-hook 'original)
	      ;; if the above fails, that means that the 'original
	      ;; property is not used yet and not available.
	      ;;
	      tipgp-:read-email-after-hook
	      ))

	 (email	    (tipgp-nymserver-address (symbol-name action) alias))
	 (enc-key   (car (tipgp-key-id-conversion email)))
	 subject
	 buffer
	 )
    (tipgpd "tipgp-nymserver-sendmail in: " action alias verb arg1 arg2)

    (save-window-excursion
      (cond
       ((memq action '(finger ping remove help abuse))
	(ti::mt-sendmail-macro  email "None" 'send
	  (insert fld2 (or arg1 "No subject data") "\n")

	  ;; This field will confuse Nymserver server. Remove it
	  ;;
	  (ti::mt-kill-field "Reply-To")
	  (if my-from (ti::mt-add-field "From"  my-from "To"))

	  (if encrypt (tipgp-encrypt-mail-find-keyring enc-key))
;;;	  (pop-to-buffer (current-buffer)) (d! 101)
	  ))

       ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  upload pgp key . .
       ((eq action 'newpgp)
	(unless arg1			;Nor a remove request?
	  (job-buffer (setq buffer (tipgp-use-tmp-buffer 'finger))
	    (erase-buffer)
	    (tipgp-key-extract-to-point account)

	    (PMIN)
	    (if (re-search-forward "matching keys found" nil t)
		(error "'%s' didn't match exactly." arg1))
	    ))

	(ti::mt-sendmail-macro  email "No subject" 'send
	  (if my-from (ti::mt-add-field "From"  my-from "To"))

	  (insert fld1 pass    "\n")

;;;	  (pop-to-buffer (current-buffer)) (d! 10)

	  (if (string= "remove" arg1)
	      (insert fld2 "remove" "\n")
	    (insert-buffer buffer))

	  (if encrypt (tipgp-encrypt-mail-find-keyring enc-key))

	  ))

       ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. plan and sig . .
       ((memq action '(newplan newsig))
	(ti::mt-sendmail-macro  email "No subject" 'send
	  (insert fld1 pass "\n")

	  (ti::mt-kill-field "Reply-To")
	  (if my-from (ti::mt-add-field "From"  my-from "To"))

	  (if (string= "remove" arg1)
	      (insert fld2 "remove" "\n")
	    (insert-file arg1))

	  (if encrypt (tipgp-encrypt-mail-find-keyring enc-key))
	  ))

       ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  flags . .
       ((memq action '(paranoid newalias nick
				newpassword vacation noarchive
				newaddress setnon
				pgpencrypt pgpsign sendmix
				))
	(setq subject (or arg1 "No subject")) ;this is the new alias name
	(ti::mt-sendmail-macro  email "No subject" 'send
	  (insert fld1 pass "\n"
		  fld2 subject "\n")

	  (ti::mt-kill-field "Reply-To")
	  (if my-from (ti::mt-add-field "From"  my-from "To"))


;;;	  (pop-to-buffer (current-buffer)) (d! 10)
	  (if encrypt (tipgp-encrypt-mail-find-keyring enc-key))
;;;	  (pop-to-buffer (current-buffer)) (d! 10)
	  ))
       (t
	(error "unknown action '%s'" action)
	))
      (if verb (message "Nymserver: %s request sent."
			(capitalize (symbol-name action))))
      )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-create-1 (email)
  "Send EMAIL to create account."
  (interactive)
  (read-char-safe-until
   "[press] Store received account info into tipgp-:nymserver-account-table.")
  (ti::mt-sendmail-macro email "No subject" 'send)
  )

;;}}}
;;{{{ Nymserver: interactive

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-post (alias &optional verb)
  "Convert message so that it can be posted to through nymserver. ALIAS VERB."
  (interactive
   (list
    (progn
      (or tipgp-:nymserver-account-table
	  (error "No Account info in table tipgp-:nymserver-account-table."))
      (tipgp-nymserver-ask)
      )))

  (let* ((srv    (tipgp-nymserver-service-elt alias))
	 (mailto (or (nth 3 srv)
		     (error "No server mailto address.")))
	 (grp-limit (nth 4 srv))


	 (elt	(or (assoc alias tipgp-:nymserver-account-table)
		    (error "Unknown server %s" alias)))
;;;	 (email (or (nth 1 elt)
;;;		    (error "No account email")))

	 (pass	(or (nth 2 elt)
		    (error "No account password")))
	 (name	    (nth 3 elt))
	 (my-from   (nth 4 elt))

	 (fld1	    "X-Anon-Password: ")
	 (fld2	    "X-Anon-To: ")
	 (fld3	    "X-Anon-Name: ")
	 (fld4	    "X-Anon-Subject: ")
;;;	 (fld-ref   "X-Anon-references: ") references
	 to subject
	 hlist
	 grp
         )
    (VERB)

    (unless (ti::mt-mail-p)     (error "This is not email buffer."))

    (setq to	    (ti::mt-get-field-1 "to")
	  subject   (ti::mt-get-field-1 "subject")
	  hlist     (delete 'newsgroups (ti::mt-required-headers))
	  )

    (when   (var-nil-p subject) (error "No subject. Aborted"))

    (save-with-marker
      (ti::mt-text-start 'move)
      (if (looking-at "X-Anon")
	  (if verb
	      (message "Already in anon post format."))

	(cond
	 ((not (var-nil-p to))		;regular email message

	  ;;  tinymail.el / we have to add 2 spaces to the beginning of field
	  ;;  so that CC tracking goes off.
	  ;;
	  (ti::mt-kill-field "to" (concat "  " mailto))
	  (if my-from (ti::mt-add-field "From"  my-from "To"))

	  (insert fld1 pass "\n"
		  fld2 to   "\n"
		  (if name (concat fld3 name "\n") "")
		  fld4 subject "\n"
		  )
	  (tipgp-update-modeline)
	  )

	 ((not (var-nil-p (setq grp (ti::mt-get-field "newsgroups"))))
	  (if (and grp-limit
		   (> (count-char-in-string ?, grp) grp-limit))
	      (error "Too many newsgroups, only %d allowed" grp-limit))

;;;	  (setq references (ti::mt-get-field "references"))
	  (push 'in-reply-to  hlist )
	  (ti::mt-kill-non-rfc-fields hlist)

	  (ti::mt-add-field "To"  mailto)
	  (if my-from (ti::mt-add-field "From"  my-from  "To"))

	  (ti::mt-text-start 'move)
	  (insert fld1 pass "\n"
		  fld2 grp  "\n"
		  (if name (concat fld3 name "\n") "")
		  fld4 subject "\n"
		  )
	  (tipgp-update-modeline)
	  )

	 (t
	  (if verb
	      (error "Don't know what to do: To or Newsgroup field empty."))
	  ))
	(ti::mt-kill-field "subject" " None")

	;;  Add 'cutmarks' so that all the rest of the text are
	;;  ripped.
	;;
	(PMAX)
	(if (bolp)
	    (insert "--")
	  (insert "\n--"))
	))

    (run-hooks 'tipgp-:nymserver-post-hook)
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-send ()
  "Handle sending mail addressed to Nymserver.
This function is called after C -c C -c to sned the mail.
If there are no multiple recipients, this function does nothing

Return:
  nil
  t"
  (let* ((fid      "tipgp-nymserver-send: ")
	 (email    "anon@anon.nymserver.com")
	 (to	    (ti::mt-get-field-1 "to"))
	 (cc	    (ti::mt-get-field-1 "cc"))
	 (fcc       (ti::mt-get-field-1 "fcc"))
	 (subject   (ti::mt-get-field-1 "subject"))
	 (elist	    (delete
		     email
		     (append
		      (ti::mt-email-from-string to)
		      (if cc (ti::mt-email-from-string cc)))))

	 (enc-key   (car (tipgp-key-id-conversion email)))
	 (encrypt   tipgp-:nymserver-request-encrypt)

	 (len       (length elist))
;;;	 (i         0)
	 (send-flag t)

	 message-body
	 ret
	 )
    ;;  - Nymserver doesn't accept CC or many addresses in To field,
    ;;    it can only have one X-anon-To destination.
    ;;  - What we do here is, that we copy the message and send it
    ;;    individually to each destination
    ;;  - We need confirmation for this
    ;;
    (when (or (> len 1)
	      ;;  If there is CC, then automatically suppose multiple
	      ;;  recipients. The To field is already in X-Anon-To
	      ;;  So this CC makes at least 2 recipients.
	      ;;
	      cc)
      (tipgpd fid subject to cc fcc elist)

      ;;  The X-Anon-To is inside PGP envelope, we can't use this message
      ;;  body to CC it to others.
      ;;
      (if (ti::mt-pgp-encrypted-p 'double-check)
	  (error
	   "You have CC in Nymserver mail. Can't process encrypted message."))

      (if (null
	   (y-or-n-p
	    (format
	     "CC %d: You have multiple anon recipients, are you sure? "
	     len)
	    ))
	  (error "Abort.")
	(setq message-body
	      (buffer-substring (ti::mt-text-start) (point-max)))
	(dolist (elt elist)
	  (ti::mt-sendmail-macro email "None" send-flag
	    (insert message-body)
	    (pop-to-buffer (current-buffer))
	    (PMIN)
	    (re-search-forward "X-Anon-To:\\(.*\\)")
	    (kill-match 1 (concat " " elt))
	    (pop-to-buffer (current-buffer))
;;;	    (inc i) (message "Sending-quick %d/%d %s" i len elt)
	    (if encrypt (tipgp-encrypt-mail-find-keyring enc-key))
	    ))
	(read-char-safe-until
	 "[press]Anon CC copies sent, now sending this mail buffer.")
	(ti::mt-kill-field "cc")
	(if encrypt (tipgp-encrypt-mail-find-keyring enc-key))
	(setq ret t)
	))
    ret
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-create (alias)
  "Send account create request. ALIAS."
  (interactive (list (tipgp-nymserver-ask)))
  (let ((srv (tipgp-nymserver-service-elt alias))
	)
  (if (yes-or-no-p
       "Are you absolutely sure you want to send 'create' request ")
      (funcall (nth 1 srv) (nth 1 srv)))
  ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-remove  (alias)
  "Remove your anonymous account. ALIAS."
  (interactive (list (tipgp-nymserver-ask)))
  (if (yes-or-no-p
       "Are you absolutely sure you want to terminate anonymous account ")
      (tipgp-nymserver-sendmail 'remove alias (interactive-p))
    ))



;;; ----------------------------------------------------------------------
;;; Hm. This function does not have pamaeter 'alias'.
;;; So it's not general purpose for other pener accounts
;;; #todo: Should rethink it sometime.
;;;
(defun tipgp-nymserver-finger  (account)
  "Finger account's email address for its configuration.
If ACCOUNT is in format vanity.an@site or vanity.na@site.com, it is converted
into vanity@site.com before sending finger request."
  (interactive
   (let* ((elt	    (assoc (tipgp-nymserver-ask)
			   tipgp-:nymserver-account-table))
	  (from	    (car-safe
		     (ti::mt-email-from-string
		      (or (ti::mt-get-field-1 "from") ""))))
	  (account  (or (nth 1 elt)
			(error "No account")))
	  (list	    (list-to-assoc-menu (list account)))
	  )
     ;;  If user has reveived mail from anNNN@anon.nymserver.com
     ;;  Then we offer to finger that account too
     ;;
     (when (and from (string-match "an[0-9]@\\|\\.[an][na]@" from))
       (setq list (list-to-assoc-menu (list from account))
	     account from))

     (list
      (completing-read
       "Finger nymserver account: "
       list nil nil
       account
       ))
     ))

  ;;  Use may press <empty> RET in completing-read
  ;;
  (if (not (string-match "@" account))
      (error "Need email address."))

  ;; silent converion to 'an' format
  ;;
  (setq account (ti::mt-nymserver-email-convert account))


  (tipgp-nymserver-sendmail 'finger (tipgp-nymserver-ask) (interactive-p) account)
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-abuse (alias)
  "Send ABUSE request. ALIAS."
  (interactive (list (tipgp-nymserver-ask)))
  (let* ((buffer "*mail-nymserver-abuse*")
	 )
    (kill-buffer-safe buffer)
    (when (y-or-n-p "Nymserver: Are you sure you want to report ABUSE? ")
      (ti::mt-sendmail-macro
	  (tipgp-nymserver-address "abuse" alias)
	  "ABUSE"
	  nil
	(rename-buffer buffer)
	(pop-to-buffer (current-buffer))
	(message "Write message and possibly encrypt it.")
	))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-ping  (alias)
  "Send Ping request. ALIAS.
In order to send ping, you have to be sending
mail FROM AN ACCOUNT WHERE YOU SENT the create command. You can't send ping
from any other location."
  (interactive (list (tipgp-nymserver-ask)))
  (tipgp-nymserver-sendmail 'ping alias (interactive-p))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-paranoid  (alias)
  "Toggle paranoid setting. ALIAS."
  (interactive (list (tipgp-nymserver-ask)))
  (tipgp-nymserver-sendmail 'paranoid alias (interactive-p))
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-vacation  (alias)
  "Toggle vacation setting. ALIAS."
  (interactive (list (tipgp-nymserver-ask)))
  (tipgp-nymserver-sendmail 'vacation alias (interactive-p))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-noarchive  (alias)
  "Toggle USENET achive setting. ALIAS."
  (interactive (list (tipgp-nymserver-ask)))
  (tipgp-nymserver-sendmail 'noarchive alias (interactive-p))
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-setnon  (alias)
  "Toggle anNNN/naNNN mode when you get private mail. ALIAS."
  (interactive (list (tipgp-nymserver-ask)))
  (tipgp-nymserver-sendmail 'setnon alias (interactive-p))
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-newplan  (alias file)
  "ALIAS. Upload plan FILE. If file is 'remove' then remove plan."
  (interactive
   (list
    (tipgp-nymserver-ask)
    (if (y-or-n-p "y = upload .plan, n = remove plan" )
	(call-interactively
	 '(lambda (arg) (interactive "fNymserver plan file: ") arg))
      "remove")
    ))
  (tipgp-nymserver-sendmail 'newplan alias (interactive-p) file)
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-newsig  (alias file)
  "ALIAS. Upload signature FILE. If file is 'remove' then remove signature."
  (interactive
   (list
    (tipgp-nymserver-ask)
    (if (y-or-n-p "y = upload .signature, n = remove plan" )
	(call-interactively
	 '(lambda (arg) (interactive "fNymserver signature file: ") arg))
      "remove")
    ))
  (tipgp-nymserver-sendmail 'newsig alias (interactive-p) file)
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-newaddress  (alias new)
  "ALIAS. Change your mailbox address.
You must be mailing from the NEW ADDRESS currently."
  (interactive
   (list
    (tipgp-nymserver-ask)
    (read-from-minibuffer "[You must be in NEW site now] Your old address: ")
    ))
  (if (var-nil-p new)			;User may have pressed ENTER...
      (error "No address."))

  (tipgp-nymserver-sendmail 'newaddress alias (interactive-p) new)
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-newalias  (alias name)
  "ALIAS NAME. Change you anNNN@ account to NEWALIAS@."
  (interactive
   (list
    (tipgp-nymserver-ask)
    (read-from-minibuffer "newalias request; vanity alias [word]: ")
    ))
  (if (or (< (length name) 3)
	  (> (length name) 15))
      (error "Invalid string size [3-15]; %s has %d characters."
	     name (length name)))
  (tipgp-nymserver-sendmail 'newalias alias (interactive-p) name)
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-nickname  (alias name)
  "ALIAS. Change you nick NAME that appears in anon post From field."
  (interactive
   (list
    (tipgp-nymserver-ask)
    (read-from-minibuffer "Nickname [string or word 'remove']: ")
    ))
  (tipgp-nymserver-sendmail 'nick alias (interactive-p) name)
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-newpassword  (alias password)
  "ALIAS. Change your PASSWORD."
  (interactive
   (list
    (tipgp-nymserver-ask)
    (ti::xe-read-password "New nymserver password: ")
    ))
  (tipgp-nymserver-sendmail 'newpassword alias nil password)
  (read-char-safe-until
   "Update your password _now_ to tipgp-:nymserver-account-table")
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-pgp-upload (alias &optional remove)
  "ALIAS. Upload or REMOVE pgp key. Before you call this commaand note:

o You must have created the PGP public key for your Nymserver account.
o You must have defined the `tipgp-:nymserver-account-table'; the key
  uploaded must have the email address.
o If you change your vanity name, remember to start all over(New key,
  and update table)"
  (interactive
   (list
    (tipgp-nymserver-ask)
    (not (y-or-n-p "Y = upload your PGP key to Anon account [N = remove] "))
    ))
  (tipgp-nymserver-sendmail 'newpgp alias (interactive-p) remove)
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-pgp-encrypt  (alias)
  "Toggle receiving PGP encryped mail. ALIAS.
You have to upload PGP key first with \\[tipgp-nymserver-pgp-upload]"
  (interactive (list (tipgp-nymserver-ask)))
  (tipgp-nymserver-sendmail 'pgpencrypt alias (interactive-p))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-pgp-sign (alias)
  "Turn on/off PGP siging. ALIAS."
  (interactive (list (tipgp-nymserver-ask)))
  (tipgp-nymserver-sendmail 'pgpsign alias (interactive-p))
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-pgp-sendmix (alias)
  "Turn on/off Mixmaster support. ALIAS."
  (interactive (list (tipgp-nymserver-ask)))
  (tipgp-nymserver-sendmail 'sendmix alias (interactive-p))
  )

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-help-i-args (arg)
  "Ask args for `tipgp-nymserver-help' using ARG."
  (list
   (tipgp-nymserver-ask)
   arg
   ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-help-verbose  (&optional arg)
  "Call `tipgp-nymserver-help' as interactive would with ARG."
  (let* ((a (tipgp-nymserver-help-i-args arg))
         )
    (tipgp-nymserver-help (nth 0 a) (nth 1 a))
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-nymserver-help (alias &optional mail-req verb)
  "Print help or send the help request via mail.

Input:
  ALIAS		    ,from where to ask the help file.
  MAIL-REQ	    ,send mail request [current-prefix-arg]
  VERB		    ,verbose messages"
  (interactive  (tipgp-nymserver-help-i-args current-prefix-arg))
  (let* ((elt   (assoc alias tipgp-:nymserver-account-table))
	 (file  (or (nth 5 elt) "_#_#"))
         )
    (VERB)
    (cond
     (mail-req
      (tipgp-nymserver-sendmail 'help alias verb)
      )
     (t
      (cond
       ((file-exists-p file)
	(pop-to-buffer (find-file-noselect file)))

       ((not (file-exists-p file))
	(error "File not exists %s" file))

       (t
	(message-quick "No HELP file defied in tipgp-:nymserver-account-table")
	(message " You get the help file, when you create account.")
	))))
    ))



;;}}}

;;{{{ misc: ask

;;; ........................................................... &r-ask ...

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-ask-reply-block-remailer ()
  "Ask which remailer's reply block to use. Return remailer.
References:
   `tipgp-:r-reply-block-tab.le'"
  (or tipgp-:r-reply-block-table
      (error "tipgp-:r-reply-block-table is empty."))
  (completing-read
   "Select Reply block of remailer: "
   (list-to-assoc-menu (mapcar 'car tipgp-:r-reply-block-table))
   nil 'match
   ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-ask-remailer (&optional msg)
  "Select REMAILER with optional MSG."
  (let* (list
         )
    (tipgp-r-init-maybe)
     (unless (setq list
		   (list-to-assoc-menu (mapcar 'car tipgp-:r-host-table)))
       (error "Internal error, tipgp-:r-host-table is nil."))

     (completing-read
      (or msg "Select remailer: ")
      list
      nil 'match
      nil
      'tipgp-:r-history
      )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-ask-email-keyserver  (&optional msg)
  "Ask which email keyserver to use using MSG."
  (tipgp-alias2name
   (completing-read
    (or msg "Email key server: ")
    (list-to-assoc-menu (mapcar 'car tipgp-:keyserver-mail-table))
    nil 'match-it
    (car (car tipgp-:keyserver-mail-table))
    )
   tipgp-:keyserver-mail-table
   ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-ask-http-keyserver  ()
  "Ask which http keyserver to use. Return keyserver elt."
  (assoc
   (completing-read
    "Key server: "
    (list-to-assoc-menu (mapcar 'car tipgp-:keyserver-http-table))
    nil 'match
    (car (car tipgp-:keyserver-http-table)))
   tipgp-:keyserver-http-table
   ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-ask-remail-args  (&optional msg)
  "Ask remail arguments for REMAILER with crypt key ask MSG.
Return:
 '(remailer-elt latent key)"
   (let (remailer
	 remailer-elt
	 latent
	 key
	 )

     (setq remailer (tipgp-ask-remailer))
     (setq remailer-elt (tipgp-r-elt-remailer remailer))

     (if (string-match "ek" (nth 2 remailer-elt)) ;Supports this ?
	 (if (var-nil-p
	      (setq
	       key (read-from-minibuffer
		    "Use crypt key: ")))
	     (setq key nil)))

     (if (string-match "latent" (nth 2 remailer-elt))
	 (cond
	  ((var-nil-p
	    (setq
	     latent (read-from-minibuffer
		     "Latent time eg. +0:00r [empty = no latent]: ")))
	   (setq latent nil))
	  (t				;Some checkings
	   (setq latent (ti::s-sqz latent))
	   (or (string-match "^\\+[0-9]:[0-9][0-9]r?$" latent)
	       (error "Invalid latent time format '%s'" latent)
	       ))))

     (list remailer-elt  latent key)
     ))


;;}}}
;;{{{ PGP entry i-macros

;;; ........................................................ &i-macros ...
;;; functions that are normally used in (interactive) spec.
;;;

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-i-args-read-email
  (&optional barf-if-not-email-buffer prompt history-sym)
  "Read email addresses from buffer or ask from use with completion.

Input:
 BARF-IF-NOT-EMAIL-BUFFER   as name says
 PROMPT			    display this string
 HISTORY-SYM		    use this history"
   (let* ((fid  "tipgp-i-args-read-email:")
	  to-field
	  ret
	  init
	  tmp
	  )


    (tipgpd fid "in: " barf-if-not-email-buffer prompt)


     (if (and barf-if-not-email-buffer
	      (not (ti::mt-mail-p)))
	 (error "TinyPgp: This is not an mail buffer."))


     (or tipgp-:pgp-email-list-completions	;make sure this exist
	 (tipgp-update-mail-abbrevs))

     (cond
      ((and (string-match "news\\|message\\|mail" (symbol-name  major-mode))
	    (not (var-nil-p
		  (ti::mt-get-field-1 "To")))) ;Just check this

       (setq to-field (ti::mt-get-all-email-addresses
		       nil
		       tipgp-:pgp-email-abbrev-list))

       (tipgpd fid "cond1: to-field" to-field)

       ;;  Slim down "Mr. ABC <abc@com>" --> "abc@com"
       ;;
       (setq to-field
	     (mapcar
	      (function
	       (lambda (x)
		 (ti::s-sqz (remove-properties (tipgp-email-or-string x)))))
	      to-field))

       (setq ret to-field)

       ;;   Confirm only if there is multiple recipients
       ;;   07.03.97 I have disbled the confimation with 'and'.
       ;;
       (if (> (length to-field) 1)
	   (and
	    nil
	    (read-char-safe-until
	     (format "%d email recipients found. Press to continue."
		     (length to-field))))
	 ;;  See if point in on line that has email
	 ;;
	 (when
	     (setq
	      tmp
	      (car-safe (ti::mt-email-from-string
			 (remove-properties (read-full-line)))))
	   (push tmp to-field)
	   (setq tmp
		 (completing-read
		  "You were on email line, use it? [empty=skip]: "
		  (list-to-assoc-menu to-field) nil nil
		  tmp
		  ))

	   (if (not (var-nil-p tmp))
	       (setq ret tmp))
	   ))
       )

      (t
       (setq init
	     (ti::s-sqz
	      (or (ti::mt-get-field "Request-Remailing-To" 'any)
		  (ti::mt-get-field "Anon-To" 'any)
		  tipgp-:user-now)))

       (tipgpd fid "cond t: ")
       (setq
	ret
	(completing-read
	 (or prompt "User: ")
	 tipgp-:pgp-email-list-completions
	 nil nil
	 init
	 (or history-sym
	     'tipgp-:history-email)
	 ))
       (setq ret (tipgp-email-or-string ret))
       (if ret   (setq ret (ti::s-sqz ret)))
       ))


     (tipgpd fid "hook call: " ret)

     (setq ret (tipgp-key-id-conversion ret))

     (tipgpd fid "RET: " ret)

     ret
     ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-i-args-pass-phrase (&optional msg)
  "The MSG defaults to asking signing pass phrase."
  (tipgp-password-get-old
   (format "[%s] %s"
	   (or tipgp-:user-now
	       (error "Internal error: current pgp user unknown."))
	   (or msg
	       "Sign pass phrase: "
	       ))))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-i-args-pass-phrase-decrypt ()
  "See `tipgp-i-args-pass-phrase'."
  (tipgp-i-args-pass-phrase "Decrypt pass phrase: "))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-i-args-reg-email  (&optional prompt barf-not-mail-buffer)
  "Read region + String. PROMPT BARF-NOT-MAIL-BUFFER."
  (i-macro-region-body
    (tipgp-i-args-read-email barf-not-mail-buffer)))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-i-args-reg-password  (&optional prompt)
  "Read region + password using PROMPT."
  (i-macro-region-body
    (tipgp-password-get-old prompt)))





;;}}}
;;{{{ PGP entry command macros, email,exe,comint

;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-cmd-macro-email 'lisp-indent-function 1)
(defmacro tipgp-cmd-macro-email (do-message &rest body)
  "(DO-MESSAGE &REST BODY). Select email body or whole buffer.

You must locally define variable 'beg' 'end' in let statement
before using this macro."
  (`
   (when (or (ti::mt-text-start)
	     (progn
	       ;;  The region is defined beforehand, now.
	       ;;
	       (setq beg (point-min)  end (point-max))
	       (y-or-n-p
		(format "Not a mail buffer, %s whole buffer? "
			(or (, do-message) "operate on")
			))
	       ))
     (,@ body)
     )))


;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-cmd-macro 'lisp-indent-function 3)
(defmacro tipgp-cmd-macro
    (cmd user password &optional msg reg options mode-specific &rest body)
  "Common command macro for all PGP commands.
Macro, used to contruct user command. CMD and USER must be
variables. You must bound 'beg' and 'end' variables before calling this
macro.

Args:

  (cmd user password &optional msg reg options &rest body mode-specific)

Input:

  CMD USER PASSWORD	parameters. CMD is symbol for logical command

  MSG			message shown to user before initiating command

  REG		        non-nil = put results to register instead
                        of replacing the region with pgp output.

  OPTIONS		extra switched that are added to the pgp command.

  NO-MODE-SPECIFIC	Do not run mode specific actions.

  BODY			code to execute when real pgp command is known.
			If there is no body, then execute the command
			that is found from table.

			Body must assign the result of command to
			macro variable 'ReS'

			The default command executed in macro is, where
			Rcmd is the real shell command. However the
			command can still contains macros that start
			like #MACRONAME.

			(tipgp-exe-do-command-region Rcmd beg end msg (, reg))

Hooks:
  `tipgp-before-do-cmd-region-hook'
  `tipgp-after-do-cmd-region-hook'"
  (`
   (let* ((FiD   "tipgp-cmd-macro: ")
	  (Rcmd  (tipgp-exe-get-cmd (, cmd) (, options))) ;Real command
	  (msg  (if (or verb (interactive-p))
		    (, msg)))
	  (enter-buffer (current-buffer))
	  edit-buffer
	  ReS
	  beg-mark
	  end-mark
	  )

     ;;  VM: edit mode changes the current buffer!
     ;;
     (unless (, mode-specific)
       (tipgp-mode-specific-control-before
	(, cmd) (, user) (, password) msg (, reg)))

     (tipgpd FiD "in:" enter-buffer
	     beg end "C" (, cmd) "U" (, user)
	     "P" (, password) msg "register" (, reg)
	     "M-S" (, mode-specific)
	     )


     (setq edit-buffer (current-buffer))
     (tipgpd FiD "EDIT-BUFFER" major-mode edit-buffer)

     ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . setting markers ..
     (cond
      ((eq (, cmd) 'decrypt)
       (setq ReS (save-excursion (PMIN) (ti::mt-pgp-block-area 'msg)))
       (goto-char (or
		   ;;  This checks "encrypted: PGP" tag.
		   (ti::mt-pgp-encrypted-p)
		   ;;  Nope, there was none, use this.
		   ;;
		   (car ReS)
		   ))
       (setq beg-mark (point-marker))
       (goto-char (cdr ReS)) (setq end-mark (point-marker))
       (tipgpd FiD "DECRYPT marks" beg-mark end-mark)
       (setq ReS nil)
       )
      (t
       ;;   If user hasn't set END variable, we suppose
       ;;   rest of the buffer. It is important that END variable
       ;;   gets set here when MAIL message is handled, because
       ;;   only now the message is trimmed and whitespaces
       ;;   removed
       ;;
       (if (null end)
	   (setq end (point-max)))

       (if (null beg)
	   (setq beg (if (ti::mt-mail-p)
			 (ti::mt-text-start)
		       (point-min))))

       ;;  We use markers, because hook is called and it
       ;;  may change the buffer content. The area must still be
       ;;  available for us after changes.
       ;;
       (save-excursion
	 (goto-char beg) (setq beg-mark (point-marker))
	 (goto-char end) (setq end-mark (point-marker))
	 )
       ))
     (tipgpd FiD "BEG END" beg end "MARKER-BEGIN" beg-mark end-mark
	     (current-buffer))
     (tipgpd FiD (buffer-substring beg-mark end-mark))


     ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . user funcall ..
     (if tipgp-:cmd-macro-before-hook
	 (run-hooks-until 'tipgp-:cmd-macro-before-hook nil
			  (, cmd) (, user) (, password) msg (, reg)))


     ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  checking markers ..
     (if (or (null (setq beg (marker-position beg-mark)))
	     (null (setq end (marker-position end-mark)))
	     (eq beg end))		;This is error too.
	 (error "tipgp-:cmd-macro-before-hook modified text too much."))

     (setq beg-mark nil end-mark nil)	;kill the markers



     (if ReS (setq ReS nil))		;NoOp XE ByteComp silencer

     (if (null (, user))
	 (setq (, user) (user-login-name)))

     ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . make command ..
     (setq Rcmd (tipgp-cmd-compose Rcmd (, user) (, password)))

     (tipgpd FiD "vars:" "U" (, user) (current-buffer) beg end "C" Rcmd )

;;;     (d! "Doing COMMAND" beg end (current-buffer))

     ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . DO ACTION ..
     ;;	    Check is BODY is omitted
     ;;
     (if (equal 'nil (quote (, body)))
	 (setq ReS (tipgp-exe-do-command-region
		    Rcmd
		    beg end
		    (tipgp-hash 'mode-specific 'get 'buffer-edit nil 'global)
		    msg
		    (, reg)))
       (,@ body))

     ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  results ..
     (when (, reg)			;Save results
       (set-register tipgp-:register ReS))


     (tipgpd "cmd-macro done. calling mode specific...")

     (if tipgp-:cmd-macro-after-hook
	 (run-hooks-until 'tipgp-:cmd-macro-after-hook nil
			  (, cmd) (, user) (, password) msg (, reg)))



     (tipgpd "cmd-macro out:")
     ReS
     )))



;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-region-cmd-macro-comint 'lisp-indent-function 3)
(defmacro tipgp-region-cmd-macro-comint (cmd user pass msg string &rest body)
  "Macro, used to contruct user command.
(CMD USER PASS MSG STRING &rest BODY)"
  (`
   (let* ((cmd  (tipgp-exe-get-cmd (, cmd)))
	  (msg  (if (or verb (interactive-p))
		    (, msg)))
	  ReS
         )
     (setq cmd (tipgp-cmd-compose cmd (, user) (, pass)))

     (,@ body)

     (setq ReS
	   (tipgp-exe-comint-command cmd beg end msg (, string)))

     (when (, string)			;Save results
       (set-register tipgp-:register ReS)
       )
     ReS
     )))

;;}}}
;;{{{ PGP exe command compose

;;; ................................................. &command-compose ...

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-cmd-compose (cmd user password &optional args)
  "Compose PGP command.a

Input:

  CMD	    string which may contain #TAGS
  USER
  PASSWORD
  ARGS"

  (if tipgp-:pgp-command-compose-function
      (setq cmd (funcall tipgp-:pgp-command-compose-function cmd)))

  (tipgpd "[cmd-compose] in: USER"
	  tipgp-:user-now "PRING" tipgp-:pubring-now )
  (tipgpd "[cmd-compose] in: cmd" cmd "USER" user "PASS" password )


  (if (not (listpp tipgp-:pubring-table)) ;make sure this variable exists
      (setq tipgp-:pubring-now
	    (expand-file-name (nth 1 (car tipgp-:pubring-table)))))

  (if (not (stringp tipgp-:pubring-now))
      (error "TinyPgp: no pubring variable ?"))


  (tipgpd "[cmd-compose] in2: global user, pring"
	  tipgp-:user-now tipgp-:pubring-now )

  (if (not (stringp tipgp-:user-now)) ;;  make sure this variable exists
    (error "TinyPgp: user is unknown."))


  (when (string-match "#PUBRING" cmd)
    (setq cmd (kill-match
	       0
	       (concat "+pubring="
		       (expand-file-name tipgp-:pubring-now)
		       " ")
	       cmd
	       )))

  (when (string-match "#PGP-USER" cmd)
    (setq cmd (kill-match
	       0 (concat "-u \""
			 ;; Always treat this as list
			 (list-to-string (list-make tipgp-:user-now))
			 "\" ")
	       cmd
	       )))

  (when (and user
	     (string-match "#USER" cmd))
    (setq cmd (kill-match
	       0 (concat "-u \""
			 ;; Always treat this as list
			 (list-to-string (list-make user ))
			 "\" ")
	       cmd)))


  (when (string-match "#OUT-FILE" cmd)
    (setq cmd (kill-match
	       0
	       (concat "-o " (expand-file-name tipgp-:file-output) " ")
	       cmd
	       )))

  (when (and user
	     (string-match "#MUSER" cmd))
    (let ((type (save-match-data (tipgp-exe-get-version 'symbol)))
	  )
      (cond
       ((eq type 'international)
	(setq cmd
	      (kill-match
	       0
	       (concat "-@" (expand-file-name tipgp-:file-user-list) " ")
	       cmd)))
       (t				;doesn't know -@ switch
	(setq cmd
	      (kill-match
	       0
	       (format "`cat %s`" (expand-file-name tipgp-:file-user-list))
	       cmd))
	)))
    (tipgp-file-control 'users-write user)
    )

  ;; ........................................................... other ...
  ;; These are called from tipgp-exe-do-command-region when parameters
  ;; are better known.

  (when (and args (string-match "#PIPE" cmd))
    ;; REST ARGS 1 = pipe file
    ;;
    (setq cmd (kill-match
	       0
	       (concat "cat "
		       (expand-file-name
			(or (nth 0 args)
			    tipgp-:file-source
			    ))
		       " | ")
	       cmd
	       )))

  (when (and args (string-match "#SOURCE-FILE" cmd))
    ;; REST ARGS 1 = filename
    ;;
    (setq cmd (kill-match
	       0
	       (concat " "
		       (expand-file-name
			(or (nth 0 args)
			    tipgp-:file-source
			    ))
		       " ")
	       cmd
	       )))


  ;; .......................................................... password ...

  (when (and (not (var-nil-p password))
	     (string-match "#password" cmd))

    (if (or nil				;Enabled now!
	    (null tipgp-:password-protection))
	(setq cmd (kill-match 0 (concat "-z\""  password "\" ") cmd))
      (setq cmd (kill-match 0 nil cmd))
      (tipgp-file-control 'password-write password)

      ;;  PGP gets the password from file desriptor 3. This way
      ;;  'ps' listing doesn't show the password like it does with -z option
      ;;
      (setq cmd (format (concat "PGPPASSFD=3; export PGPPASSFD; "
				"#PIPE %s  3< %s ")
			cmd (expand-file-name tipgp-:file-password)))
      ))



  (tipgpd "[cmd-compose] out: " cmd  tipgp-:pgp-command-compose-function )

  cmd
  )

;;}}}
;;{{{ PGP exe result, general, macros, error

;;; ........................................................ &pgp-core ...


;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-excute-in-tmp 'lisp-indent-function 2)
(defmacro tipgp-excute-in-tmp (beg end &rest body)
  "Copy region BEG END from current buffer and execute BODY.
Uses buffer `tipgp-:buffer-tmp-shell'."
  (`
   (let* ((ob  (current-buffer))
	  (tmp (tipgp-use-tmp-buffer 'shell))
	  )
     (job-buffer tmp
       (insert-buffer-substring ob (, beg) (, end))
       (tipgp-x-headers-deinstall)
       (,@ body)
       )
     )))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-cmd  (cmd &optional options)
  "Return pgp shell command according to logical CMD with appended OPTIONS."
  (let* ((elt (assq cmd tipgp-:pgp-command-table))
	  )
    (if (null elt)
	(error "PGP exe command error: No logical command in table '%s'" cmd)
      (format "%s %s %s " tipgp-:pgp-exe (nth 1 elt) (or options ""))
      )))

;;; ----------------------------------------------------------------------
;;;
(put 'tipgp-exe-get-result-re1-macro 'lisp-indent-function 1)
(defmacro tipgp-exe-get-result-re1-macro (re &rest body)
  "If case-sensitive RE match, execute BODY."
(`
   (job-buffer tipgp-:buffer-tmp-shell
     (let (case-fold-search)		;Case sensitive matching
       (PMIN)
       (when (re-search-forward (, re) nil t)
	 (tipgpd "exe-get-result-re1-macro:" (read-match 0) )
	 (,@ body)
	 )))
   ))



;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-exe-insert-command-log  (&optional point cmd)
  "Insert last command log into POINT[current point] or insert CMD."
  (if point (goto-char point))
  (insert "\n\nTinyPgp.el report, last command and parameters:\n\n"

	  "explicit-shell-file-name\t:"
	  (or explicit-shell-file-name "<>") "\n"

	  "shell-file-name\t\t\t:" (or shell-file-name "<>") "\n"

	  (if cmd
	      (prin1-to-string cmd)
	    (prin1-to-string tipgp-:last-pgp-exe-command))
	  "\n"
	  ))

;;}}}
;;{{{ PGP exe result get,check




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-check-error  (&optional ignore-output-error cmd)
  "Return non-nil, if the PGP output is not valid.

Input:
  IGNORE-OUTPUT-ERROR	,this skips checking the output: --- TAGS
  CMD			,command used

References:
  `tipgp-:error'	    ,stored error message"
  (let (;;  the re-ok does not produce re-block, but it's still valid
	;;  pgp answer, not an error condition.
	(fid		       "tipgp-exe-check-error:" )
	(re-ok                 (concat
				 "Good signature from"
				 "\\|Bad signature from"
				 "\\|Pass phrase +\\(is\\|appears\\) +good"
				 "\\|WARNING: +"
				 ))
	 (re-block		"-----BEGIN.*PGP")
	 (re			tipgp-:pgp-exe-error-regexp)
	 case-fold-search	;; Case is important here !!
         )
    (setq tipgp-:error nil)

    ;;  - See if nuffer DOES not contain opk sign, then GO AND
    ;;    check erroro. Once I have message where
    ;;    "You do not have the secret" was written in message body.
    ;;    and that was not an error condition.
    ;;
    (job-buffer tipgp-:buffer-tmp-shell
      (unless (re-search-check
	       "^Pass phrase is good.  Just a moment[.][.]+"
	       0 '(point-min))
	(tipgp-exe-get-result-re1-macro re
	  (tipgpd fid "MB" (match-beginning 0) "ME" (match-end 0)
		  (current-buffer))
	  (tipgp-highlight 'match 0 nil tipgp-:face-error nil
			   (match-beginning 0)
			   (match-end 0))
	  (setq tipgp-:error (read-full-line))
	  (tipgp-exe-insert-command-log (point-max) cmd)
	  )))


    (unless ignore-output-error
      (job-buffer tipgp-:buffer-tmp-shell
	(when (and (null tipgp-:error)	;Not already set?
		   (not (re-search-check re-ok 0 '(point-min)))
		   (not (re-search-check re-block 0 '(point-min)))
		   )
	  (setq tipgp-:error "Internal error. No output from PGP.")
	  (tipgp-exe-insert-command-log (point-max) cmd)
	  )))

    ;;  If this was encryption and it failed, then remove entry from
    ;;  cache.
    ;;
    (if tipgp-:error  (tipgp-key-cache-remove-entry tipgp-:error))

    (tipgpd "exe-check-error ret: " tipgp-:error )

    tipgp-:error
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result (&optional buffer)
  "Return the result of PGP output from BUFFER or `tipgp-:buffer-tmp-shell'.
Look for markers -----BEGIN PGP, -----END PGP."
  (let* ((re1 "[.]*\\(-----BEGIN.*PGP\\)")
	 (re2 "^-----END.*PGP")
	 beg
	 ret
         )
    (job-buffer (or buffer tipgp-:buffer-tmp-shell)
      (PMIN)
      (when (re-search-forward re1 nil t)
	(setq beg (match-beginning 1))
	(PMAX)
	(when (re-search-backward re2 nil t)
	    (setq ret (buffer-substring beg (EOLPP)))
	    )))
    (tipgpd "exe-get-result ret: " ret )
    ret
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result-decrypt  (&optional buffer)
  "Read BUFFER after decrypting and Signing(international version)."
  (let* (ret
	 )
    ;; Note how international version spits stting "pass phrase",
    ;; and US version doesn't
    ;; +++++++++++++++++++++++++++
    ;;
    ;; International version - not for use in the USA. Does not useRSAREF.
    ;; Current time: 1997/05/19 12:10 GMT
    ;; Pass phrase is good.  Just a moment....-----BEGIN PGP SIGNED
    ;;
    ;;
    ;; Export of this software may be restricted by the U.S. government.
    ;; Current time: 1997/05/16 20:40 GMT
    ;; Pass phrase is good.
    ;; Key for user ID: xxxxk
    ;; 768-bit key, Key ID xxxx
    ;; Also known as:
    ;; Also known as:
    ;; Just a moment....-----BEGIN PGP SIGNED MESSAGE-----
    ;;
    ;; note: When you call command -seatf; encrypt and sign in one pass,
    ;; the output is bit different.
    ;; +++++++++++++++++++++++++++
    ;;
    ;;  International version - not for use in the USA. Does not use RSAREF.
    ;;  Current time: 1997/06/26 20:29 GMT
    ;;
    ;;  Including "/users/jaalto/.pgp/pgp-lst"...
    ;;  Pass phrase is good.  Just a moment....
    ;;  Key for user ID: Jari Aalto <jari.aalto@poboxes.com>
    ;;  512-bit key, key ID 47141D35, created 1996/06/03
    ;;  Also known as: Jari Aalto, Finland <jaalto@tre.tele.nokia.fi>
    ;;  Also known as: Jari Aalto, Finland <ssjaaa@uta.fi>
    ;;  Also known as: Jari Aalto, Finland <jari.aalto@ntc.nokia.com>
    ;;  .-----BEGIN PGP MESSAGE-----
    ;;  Version: 2.6.3ia
    ;;  Comment: Processed by Emacs TinyPgp.el 1.222
    ;;
    ;;  hEwDwLrt1UcUHTUBAgCFBDvkHJ7dEffIGiqyPi2WtdOPwWQ+Duw6/be/7FjJYEUV
    ;;

    (tipgp-exe-get-result-re1-macro	; -seatf
	 "Pass phrase is good.  Just a moment[.]+"
      (when (and (re-search-forward "Key for user ID:" nil t)
		 (re-search-forward (ti::mt-pgp-msg-begin-line) nil t)
		 )
	(setq ret (buffer-substring (match-beginning 0) (point-max)))
	))

    (unless ret
      (tipgp-exe-get-result-re1-macro
	  (concat
	   "Pass phrase is good.  Just a moment[.]+"
	   ;; #todo: warning handling in decrypting
	   ;;
	   "\\|WARNING: Can't find.*can't check signature integrity.*\n"
	   )
	(setq ret (buffer-substring (point) (point-max)))
	))

    (unless ret
      ;;  This is from conventional decrypt
      (tipgp-exe-get-result-re1-macro
	  "Pass phrase appears good\\. \\."
	(setq ret (buffer-substring (point) (point-max)))
	))

    (tipgpd "exe-get-result-decrypt ret: " ret )

    ret
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result-verify-status  (&optional buffer)
  "Return result STRING after verify from BUFFER."
  (tipgp-exe-get-result-re1-macro
      (concat "Good signature from"

	      ;;  This warning is preceeded by lines:
	      ;;  File has signature.  Public key is required to check...
	      ;;  Key matching expected Key ID 1CEB1F55 not found
	      ;;
	      "\\|WARNING: Can't find the right public"
	      "\\|Bad signature from"
	      "\\|Key matching.*not found"
	      )
    (read-full-line)
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result-verify  (&optional buffer)
  "Return result after verifying from BUFFER."
  (let (ret
	beg
	end
	)
    (tipgp-exe-get-result-re1-macro
     (concat "Good signature from"
	     "\\|Bad signature"
     	     ;;  This warning is preceeded by lines:
	     ;;  File has signature.  Public key is required to check...
	     ;;  Key matching expected Key ID 1CEB1F55 not found
	     ;;
	     "\\|WARNING: Can't find the right public"
	     )
     (re-search-forward "Signature made" nil t)
     (forward-line 1)
     (setq beg (point)
	   end (point-max))
     ;; Sometimes PGP says this:
     ;;
     ;; Looking for next packet in '/users/jaalto/junk/pgptemp.$00'...
     ;;
     ;; File has signature.  Public key is required to check signature.
     ;;
     ;; File '/users/jaalto/junk/pgptemp.$01' has signature, but with no text.

     (when (re-search-forward "Looking for next packet in '" nil t)
       (beginning-of-line)
       (setq end (point))
       )

     (setq ret (buffer-substring beg end))
     )
    ret
    (tipgpd "exe-get-result-verify ret: " ret )
    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result-base64 (&optional buffer)
  "Get contents after the 'Signature made 1996/11 ...' from BUFFER."
  (let (ret
	)
    (tipgp-exe-get-result-re1-macro "^Good signature from"
      ;; Good signature from user
      ;; Signature made 1996/11/07
      ;; DATA-HERE
      ;;
      (forward-line 2)
      (setq ret (buffer-substring (point) (point-max)))
      )
    ret
    ))




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result-key-add  (&optional buffer)
  "Return result of key adding from BUFFER."
  (interactive)
  (let (ret
	list
	)
    (cond
     ((tipgp-exe-get-result-re1-macro
	  (concat
	   "^No +keys found\\|.*added.*\\|ERROR: Bkad ASCII armor.*"
	   "\\|.*error\\|No new keys or signatures"
	   )
	(setq ret (read-full-line))
	))
     ((job-buffer tipgp-:buffer-tmp-shell
	(PMIN)
	(setq list (ti::b-grep-lines "new key(s)"))
	)
      (setq ret (format "%d New keys added." (length list)))
      ))

    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result-key-sign  (&optional buffer)
  "Return result of key signing from BUFFER."
  (interactive)
  (let (ret
	)
    (cond
     ((tipgp-exe-get-result-re1-macro
	  (concat
	   "^No +keys found\\|ERROR\\|.*error"
	   "\\|Key is already signed by"
	   )
	(setq ret (read-full-line))
	)
      ))
    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result-key-remove  (&optional buffer)
  "Return result of key remove from BUFFER."
  (let (ret
	)
    (cond
     ((tipgp-exe-get-result-re1-macro
	  (concat
	   ;;  PGP can't remove key if it asks this
	   ;;
	   ;;  Key has more than one user ID.
	   ;;  Do you want to remove the whole key (y/N)? << WAITS HERE
	   ;;
	   "^Key has more than one user ID"
	   "\\|Keyring remove error"
	   )
	(setq ret (read-full-line))
	)
      ))
    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-handle-result  ()
  "Show `tipgp-:buffer-tmp-shell' buffer if error, otherwise return result."
  (let* (error
	 ret
         )
    (setq error (tipgp-exe-check-error))
    (unless error
      (setq ret (or
		 ;;  verifying the message also unpacks
		 ;;  the encrypted message in it if the sig
		 ;;  is good
		 ;;
		 (tipgp-exe-get-result-verify)

		 (tipgp-exe-get-result-decrypt)
		 (tipgp-exe-get-result)
		 )))
    (if (and (null error) (not (var-nil-p ret)))
	ret
      (tipgp-error error)
      )))

;;}}}
;;{{{ PGP exe comint

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result-file-comint ()
  "Read comint result file to `tipgp-:buffer-tmp'.
If there is no result file, do nothing.

Return:
 nil
 buffer pointer	    ,where results are just read."
  (interactive)
  (let* ((file   tipgp-:file-output)
	 buffer
         )
    (when (file-exists-p file)
      (setq buffer (tipgp-use-tmp-buffer))
      (job-buffer buffer
	(insert-file-contents file))
      )
    buffer
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-get-result-comint-error  ()
  "Check if comint command failed."
  (let (ret
	)
    (job-buffer (tipgp-comint-buffer)
      (PMIN)
      (if (re-search-forward
	   ;;  We know what comint commands we use in this package, so we
	   ;;  can predict what errors may happen.
	   ;;
	   (concat
	    "Keygen error"
	    )
	   nil t)
	  (setq ret (read-full-line))
	  ))
    ret
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-comint-finish  (&optional buffer)
  "Finish the COMINT input if the PGP asked for random numbers. Use BUFFER.
\"We need to generate 166 random bits...\""
    (let* ((buffer  (or buffer (tipgp-comint-buffer)))
	 count
         )
    (tipgpd "tipgp-exe-comint-finish in: " buffer )

    (job-buffer buffer
      (PMIN)
      (when (re-search-forward "We need to generate +\\([0-9]+\\)" nil t)
	(setq count (string-to-int (read-match 1)))
	(tipgpd "tipgp-exe-comint-finish count: " count )

	(loop-for 0 (+ 2 count)
	  (insert "a")
	  (comint-send-input)
	  )
	))
;;;    (d! "comint ok")
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-comint-randseed  (bits)
  "Feed BITS to randseed.bin prompt.
You see the message \"We need to generate random bits...\" from PGP
if you need to run this function."
  (interactive)
  (tipgpd "do-comint-randseed in:" bits )
  (let ((elt  (car-safe
	       (cdr-safe
		(assoc 'random tipgp-:pgp-exe-support-table))))
	cmd
	(tmp  (tipgp-use-tmp-buffer))
	)

  (cond
   ((and elt bits)			;only if bits are known
    ;;  We can use undocumented switch and we don't need to launch comint
    ;;
    (setq
     cmd
     (format "%s %s%s %s "
	     tipgp-:pgp-exe
	     elt
	     bits
	     (tipgp-randseed-file)
	     ))
    (tipgpd "tipgp-exe-comint-randseed undocumented:" cmd )
    (shell-execute cmd tmp)
    )

   (t
    (tipgp-file-control 'users-write (user-login-name))
    (tipgp-exe-comint-command
     (list
      (format "echo 1 | %s -eatf -@%s "
	      tipgp-:pgp-exe
	      (expand-file-name tipgp-:file-user-list)
	      ))
     (point-min) (point-min)
     nil nil 'noerr
     )

    ))

  (tipgpd "do-comint-randseed out:")
  ))


;;; ---------------------------------------------------------- &comint ---
;;;
(defun tipgp-exe-comint-command
  (cmd-list beg end &optional msg res-str no-err no-files)
  "Execute interactive PGP command in COMINT buffer.
See `tipgp-exe-do-command-region'. This function is used mainly when input is a
file and output results are put into another file and PGP requires answers
to questions.

Input:

  CMD-LIST	,list of inputs to feed for PGP. The first entry
		 must be a PGP starting command where the destination file
		 switch is also added. The rest are interactive answers
		 to PGP.
  BEG END       ,region to feed
  MSG           ,message to display prior running command list.
  RES-STR	,instead of replacing previous content return result as str.
  NO-ERR        ,signal no error
  NO-FILES      ,if non-nil, then no files are written or read.

Return:

  region end replaced	,point at beg, if res-str = nil
  string		,if res-str = non-nil

References:

  `tipgp-:file-source'
  `tipgp-:file-output'"
  (let* ((buffer    tipgp-:buffer-comint)
	 (from	    tipgp-:file-source)
	 (to	    tipgp-:file-output)
	 (first	    (car cmd-list))
	 err
	 result-buffer
	 ret
         )
    (tipgpd "do-comint-command in: "
	    cmd-list beg end "M" msg res-str no-err )


    (if msg (message msg))
    (setq tipgp-:last-pgp-exe-command cmd-list)
    (file-delete-safe (list from (concat from ".asc")))
    (file-delete-safe (list to   (concat to   ".asc")))


    (cond
     ((null no-files)
      (tipgp-excute-in-tmp beg end	;results in temp buffer
	(file-delete-safe from)
	(write-region (point-min) (point-max) from))

      (setq first (format "%s -o %s %s " first to from))
      (setcar cmd-list first)		;replace
      ))

;;;    (d! (cdr cmd-list))

    (ti::p-comint-run-command
     buffer
     'clear
     '(comint-interrupt-subjob)
     nil
     cmd-list)

    (tipgp-exe-comint-finish)

    ;;  Delete this so that there is no traces...
    (setq err (tipgp-exe-get-result-comint-error))
    (when (and (null no-err)
	       (or err
		   (null (file-exists-p to)))
	       )
      (pop-to-buffer (tipgp-comint-buffer))
      (error "Comint failed, please examine the input sent to PGP."))

    (file-delete-safe from)


    (when (file-exists-p to)
      (setq result-buffer (tipgp-exe-get-result-file-comint))

      (job-buffer result-buffer
	(setq ret (buffer-substring (point-min) (point-max))))

      (unless res-str
	(delete-region beg end)
	(goto-char beg)
	(insert ret)
	(setq ret (point))
	(goto-char beg)
	))

    (tipgpd "do-comint-command out: " ret )

    ret
    ))

;;}}}
;;{{{ PGP exe

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-exe-command-region-fix  (cmd data)
  "If the CMD failed when PGP asked random bits, fix it. DATA is PGP answer."
  (tipgpd "tipgp-exe-command-region-fix in:" data )
  (cond
   ((re-search-check "We need to generate \\([0-9]+\\)"  0
		     '(point-min))
    (message "tinyPgp: Wait, randseed fix needed...")

    ;; generate the random file
    ;;
    (tipgp-exe-comint-randseed (read-match 1))

    (tipgpd "tipgp-exe-command-region-fix done:" data "\n")
    t
    )
   (t
    nil
    )))

;;; ---------------------------------------------------------- &engine ---
;;;
(defun tipgp-exe-do-command-region (cmd beg end o-buffer &optional msg res-str)
  "Execute shell CMD on region BEG END with USER.

Input:

  CMD		full PGP command.
  BEG		region beg to feed to PGP
  END		region end to feed to PGP
  O-BUFFER	buffer where BEG END is
  MSG		message
  RES-STR	instead of replacing previous content return result as str.

Return:

  REGION END REPLACED	point at beg, if res-str = nil
  STRING		if res-str = non-nil

References:

  `tipgp-:pgp-sh-exe'
  `tipgp-:last-pgp-exe-command'
  `tipgp-:file-source'"
  (let* ((fid		"tipgp-exe-do-command-region: ")
	 (loop		t)
	 (final-newline	"\n")
	 ret
	 data
         )

    (tipgp-do-shell-env
     (if msg	(message msg))

     (tipgpd fid "in:" (current-buffer)
	     beg end  "min-max" (point-min) (point-max)
	     "MSG" msg res-str )

     ;; ... ... ... ... ... ... ... ... ... ... ... ... ...  loop start ...
     (while loop			;If we should repeat the task?
       (setq loop nil)
       (tipgpd fid "loop-beg" loop (current-buffer) cmd "\n")

       (tipgp-excute-in-tmp beg end	;results in temp buffer

;;;	 (pop-to-buffer (current-buffer)) (d! "DOING PGP")

	 (setq data (buffer-substring  (point-min) (point-max)))

	 (tipgpd fid "data{" data "}")
	 (PMIN) (tipgp-file-control 'source-write)

;;;	 (d! "data{}")

	 ;;  We Cannot use INPUT file as a parameter to pgp, but we must
	 ;;  feed the file through pipe to pgp. Fix some commands.
	 ;;
	 (cond
	  ((string-match "#PIPE" cmd)
	   (setq cmd (tipgp-cmd-compose cmd nil nil '(nil)))
	   )
	  ((string-match "#SOURCE-FILE" cmd)
	   (setq cmd  (kill-match 0 nil cmd))
	   (setq cmd  (concat "#PIPE" cmd))
	   (setq cmd (tipgp-cmd-compose cmd nil nil '(nil)))
	   )
	  (t
	   (setq cmd (concat "#PIPE" cmd))
	   (setq cmd (tipgp-cmd-compose cmd nil nil '(nil)))
	   ))

	 (tipgpd "tipgp-exe-do-command-region last-cmd:"
		 (current-buffer) cmd )

	 (setq tipgp-:last-pgp-exe-command cmd)

	 (if tipgp-:do-command-region-before-hook
	     (run-hooks-until 'tipgp-:do-command-region-before-hook nil
			      cmd msg res-str))

	 (erase-buffer)
	 (shell-execute cmd (current-buffer))

	 (if tipgp-:do-command-region-after-hook
	     (run-hooks-until 'tipgp-:do-command-region-after-hook nil
			      cmd msg res-str))

	 ;;   sometimes PGP need new randseed file, this generates it
	 ;;   and runs the command again.
	 ;;
	 (when (and t			;enable for now..
		    (tipgp-exe-command-region-fix cmd data))
	   (setq loop t)
	   )

	 (ti::b-u2d-crlf 'dos2Unix 'doReadOnly) ;Remove possible ^M chars
	 ))
     ;; ... ... ... ... ... ... ... ... ... ... ... ... ... .. loop end ...


;;;    (tipgp-exe-insert-command-log)

     (setq ret (tipgp-exe-handle-result))

     ;;	    We don't want to kill these before the results are examined,
     ;;	    because user may want to check the contents if error happend
     ;;
     (tipgp-file-control 'password-kill)	;Remove password file
     (tipgp-file-control 'source-kill)


     ;;  For some reason PGP doen not output final newline
     ;;  after its TAGS. Check this and add it, otherwise replacing
     ;;  the buffer content doesn't go right.
     ;;
     (if (and ret
	      (string= "---" (str-right ret 3)))
	 (setq ret (concat ret final-newline)))
     (cond
      (res-str
       nil				;that's it
       )
      (t
       (ti::b-replace-region-with beg end ret 'keep-cursor-beg)
       ))

     ret
     )))

;;}}}


;;{{{ PGP public key 'find by'

;;; ..................................................... &pgp-key-get ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-finger-discard-by-regexp (string-or-list)
  "Discards some email addresses from STRING-OR-LIST.
See variable `tipgp-:finger-discard-email-hook'"
  (let (ret
	)
    (tipgpd "[tipgp-:finger-discard-email-hook] in:"
	    tipgp-:finger-discard-by-regexp "#" string-or-list )

    (when string-or-list
      (if (not (stringp tipgp-:finger-discard-by-regexp))
	  (setq ret string-or-list)
	(dolist (x (list-make string-or-list))
	  (if (string-match tipgp-:finger-discard-by-regexp x)
	      (tipgpd "[tipgp-:finger-discard-email-hook doing]:" x )
	    (push x ret)
	  ))))
    (nreverse ret)
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-network-spawn (mode &optional arg1 arg2 verb)
  "Get key by fingering EMAIL.
Examine the returned information and ask user help if there is more than
one public key.

Input:

  MODE		'finger
  ARG1 ARG2	,if 'finger then arg1 is email
		,if 'http   then arg1 is host, arg2 is command
  VERB		,Verbose messages.

Return:

 string		,if only one public key
 (string)	,internal finger error string

References:

 `tipgp-:buffer-tmp-shell'     ,results of finger
 `tipgp-:last-network-error'   ,if error happened."
  (let ((fid      "tipgp-key-network-spawn:")
	(buffer   (tipgp-use-tmp-buffer 'finger))
	(email    arg1)			;if command is finger
	stat
	data data2
	len
	ret
	)
    (tipgpd fid "in:" mode arg1 arg2 verb)

    (setq tipgp-:last-network-error nil)

    (cond
     ((eq mode 'finger)
      (setq stat (ti::p-finger email nil nil buffer verb)))
     (t
      (error "Wrong mode '%s' " mode)
      ))


    (cond
     ((stringp stat)
      (setq tipgp-:last-network-error stat)
      (setq ret (list stat)))

     ((bufferp stat)
      (ti::mt-pgp-trim-buffer)		;Remove garbage around keys.

      (or (setq data
		(ti::mt-pgpk-public-get-region  nil nil buffer))
	  (setq data2
		(ti::mt-pgpk-public-get-region  nil nil buffer 'relax))
	  )

      (when data2
	(setq data data2)

	;; I don't think people undertand this mail very well,
	;; they only know how to do -kxa and -kv, not -fkxa
	;;
;;;	(if (y-or-n-p
;;;	     (concat
;;;	      "Public key found, but not in full -fakx format "
;;;	      "Send email notice? "))
;;;	    (tipgp-sendmail email 'pk-no-full-format))

	)

      (setq len (length data))

      (cond
       ((and (eq  1 len)			;only 1 public key found
	     (not
	      (null
	       (setq ret (nth 1 (car data))))) ;P-key block must not me empty
	     )
	ret
	)

       ((null data)
	(read-char-safe-until
	 "finger ok, but no Public key in his ~/.plan file.[press]")
	(setq ret nil)
	)

       (t
	;; #todo
;;;	(d! "FSTAT" stat  (length data))
	(error "Multiple keys not implemented yet.")
	))
      ))

    (tipgpd fid email ret )
    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-finger-guess-email  ()
  "Check Whole buffer for PGP email address.
Return:
  nil			Nothing cound
  email"
  (let* ((set           "[^ \t\n<=\"';:]+")
	 (email-re	(concat "\\(" set "@" set "\\)"))
	 ;;  finger ssjaaa@uta.fi | pgp -fka for pgp key
	 ;;
	 (kaf-re	"[ \t]*|[ \t]*pgp[ \t]+-\\(fka\\|kaf\\|afk\\|fak\\)")
	 email
	 line
	 list
         )
    (save-excursion
      (cond

       ((and
	 buffer-read-only		;Incoming message RMAIL
	 (PMIN)
	 ;; X-Pgp-Signed:
	 ;;     access-type=Finger; Address=foo@site.com;
	 ;;
	 (setq list   (tipgp-xpgp-get-info))
	 (setq email (assoc "address" list))
	 ))

       ((and
	 (PMIN)
	 ;;  If's faster first look for simple regexp, and match
	 ;;  it against complex regexp
	 ;;
	 (re-search-forward kaf-re nil t)
	 (setq line (read-full-line))
	 (string-match (concat email-re kaf-re) line)
	 (setq email (remove-properties (read-match 1 line)))
	 ))

       ((and
	(PMIN)
	(re-search-forward
	 (concat
	  "public.*key.*@\\|@.*public.*key"

	  ;; |Boudewijn Visser|E-mail:visser@ph.tn.tudelft.nl |finger for |
	  ;; |University of Technology                        |PGP-key    |
	  ;;
	  "\\|@.*finger\\|finger.*@"

	  ;;  steve*windsong.demon.co.uk (for which PGP is preferred)
	  ;;
	  "\\|@.*pgp.*prefered\\|pgp.*prefered.*@"
	  )
	 nil t)
	(setq line (read-full-line))
	(string-match email-re line)
	(setq email (remove-properties (read-match 1 line)))
	))
      ))

    (tipgpd "tipgp-key-finger-guess-email out:" email )

    email
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-finger-add  (email &optional no-ask)
  "Ask where to store the public key for EMAIL; optionally NO-ASK.

Return
  non-nil     if added
  nil"
  (let ((finger-buffer	    tipgp-:buffer-tmp-finger)
	ans
	)
    (cond
     (no-ask
      ;;  Put into temporary keyring ... #todo
      (error "Not supported no-ask")
      )
     (email
      (setq ans
	    (tipgp-pubring-alias2file
	     (tipgp-pubring-complete
	      (format
	       "%s: Store the public key to pubring[empty=cancel]: "
	       (or (car-safe (ti::mt-email-from-string email))
		   (str-left email 20)))
	      )))
      (if (var-nil-p ans)
	  (setq ans nil)
	;; #todo, should add the key to keyring.
	;;
	(job-buffer finger-buffer
	  ;;  (tipgp-key-add-region-interactive)
	  (tipgp-key-add-region-batch (point-min) (point-max))
	  )
;;;	(d! "Cacheing finger>>" ans)
	(tipgp-key-cache 'put email ans) ;email, keyring
	)))
    ans
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-finger-verbose (email-list)
  "EMAIL-LIST. See `tipgp-key-find-by-finger'."
  (tipgp-key-find-by-finger email-list nil 'verb))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-finger  (&optional email-list no-ask  verb)
  "Find a PGP key using finger.

The exact references searched are like:

  finger foo@site.com for pgp public key
  finger foo@site.com | pgp -fka
  ...

If finger fails then user is offered a list of all email
addresses and each one selected is fingered.

Input:
  EMAIL-LIST	    ,if this is given, then do not search
		     current buffer for email addresses.
		     All entries that do not contain @ are filtered out.
		     This can be string list or single string
  NO-ASK	    ,store all fingered keys without asking
		     to current keyring.
  VERB		    ,enable verbose messages

Return:
  string    ,pgp publick key block
  nil"
  (interactive)
  (tipgpd "tipgp-key-find-by-finger in:")
  (let* (email
	 stat
	 ans
	 list
	 ret
         )
    (VERB)
    ;; ... ... ... ... ... ... ... ... ... ... ...  exact match search ...
    (if email-list
	(setq list (list-make email-list))

      ;; ... ... ... ... ... ... ... ... ... ... ... .. list not given . .
      (setq email (tipgp-key-finger-guess-email)
	    email (tipgp-email-discard-default list))

      (setq email (tipgp-finger-email-filter email))

      (if (listpp email)
	  (setq email (car email)))

      (when email				;Try adding the exact match
	(setq ret (tipgp-key-network-spawn 'finger email nil verb)))

      (if (stringp ret)
	  (setq ret (tipgp-key-finger-add email))
	(setq list
	      (tipgp-email-find-region
	       (point-min)
	       ;;  For large buffers, look only the start
	       ;;  of buffer. The point-m,in offset is
	       ;;  needed because buffer may be narrowed (RMAIL)
	       ;;
	       (if (> (point-max) (+ (point-min) 1000))
		   (+ (point-min) 1000)
		 (point-max))
	       )))

      )

    (if (and list tipgp-:finger-discard-email-hook)
	(setq list (run-hooks-until
		    'tipgp-:finger-discard-email-hook nil list)))

    (when list
      (setq list (tipgp-email-discard-default list))
      (setq email (car-safe list))
      )

    ;; ... ... ... ... ... ... ... ... ... ... ... ... . loop-finger . .
    (while (and list
		(not (stringp ret))
		(not (var-nil-p email))
		)

	(when (null no-ask)
	  (setq
	   ans
	   (completing-read
	    (format "%sFinger [e(x)it, !, empty=skip]: "
		    (if (> (length list) 1)
			(format "%d: " (length list)) "")
		    )
	    (list-to-assoc-menu list) nil nil email))

	  (cond
	   ((string= "!" ans)
	    (setq no-ask t))

	   ((string= "x" ans)
	    (setq list  nil
		  email nil))

	   ((var-nil-p ans)
	    (setq email nil))

	   (t
	    (setq email ans)
	    )))

        ;; ... ... ... ... ... ... ... ... ... ... ... ... ... results ...

	(when (not (var-nil-p email))
	  (setq stat (tipgp-key-network-spawn 'finger email nil t))

	  (cond
	   ((and (listpp stat)  verb)
	    (message-flash
	     8 'sit
	     (format "[press]Finger internal error: %s" (car stat)))
	    (discard-input)
	    )

	   ((stringp stat)
	    (setq ret stat)
	    (if verb (message-quick "Fingered PGP key found."))
	    ))

	  (setq list (delete email list)) ;Used, remove
	  )

        ;; ................................................ go to next ...
	(unless ret			;not found yet?
	  (if email
	      (setq list (delete email list)))
	  (setq  email (car list)
		 list  (cdr list)))

	)

    (if ret
	(tipgp-key-finger-add email no-ask))

    (tipgpd "tipgp-key-find-by-finger out:" ret )

    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-http-study-buffer  (&optional buffer)
  "Search public key from HTTP keyserver request result BUFFER."
  (let* (
         )
    (tipgpd "tipgp-key-http-study-buffer in: " buffer (current-buffer))

    (job-buffer buffer
      (ti::mt-pgp-trim-buffer)
      )))






;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-http-url-verbose  () ;Called from hook
  "Call `tipgp-key-find-by-http-url' interactively."
  (call-interactively 'tipgp-key-find-by-http-url))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-http-url (url &optional verb)
  "Send http request and try to read key from URL page. VERB.

Interactive call note:

  This function searches only X-Pgp field for possible key location
  pointer in format Access-type=URL; URL=http://me.org/~me/pgp.html"
  (interactive
   (list (tipgp-xpgp-key-address
	  'http
	  "(http) X-Pgp information is not present.")))

  (let* ((fid	    "tipgp-key-find-by-http-url: ")
	 (buffer    (tipgp-use-tmp-buffer 'http))
	 (obuffer   (current-buffer))
	 stat
	 ret
         )
    (VERB)
    (tipgpd fid  "URL" url "VERB" verb)
    (when (stringp url)
      (setq stat (ti::p-http-request url nil nil buffer verb)))

    (cond
     ((and (listpp stat)  verb)
      (message-flash
       8 'sit
       (format "Http internal error: %s" (car stat)))
      (discard-input)
      )

     ((bufferp stat)
      (pop-to-buffer stat) (PMIN)
      (if (setq
	   stat
	   (cond
	    ((ti::mt-pgp-public-key-p (point-min))
	     (if verb
		 (call-interactively 'tipgp-key-add-region-batch)
	       (tipgp-key-add-region-batch (point-min) (point-max))))))
	  ;;
	  ;; See tipgp-key-add-region-batch documentation
	  ;;
	  (setq ret tipgp-:return-value)
	;; Keep cursor in the original buffer
	;;
	(shrink-window-if-larger-than-buffer)
	(pop-to-buffer obuffer)
	(if verb
	    (message "Http request didn't find public key."))
	))
     )					;cond end
    ret
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-http-keyserver-i-args  (&optional string)
  "Ask args for function `tipgp-key-find-by-http-keyserver'.
If STRING is already know then do not ask for it.

Return:
  (srv cmd str)"
  (let* ((fid	    "tipgp-key-find-by-http-keyserver: ")
	 (dummy     (tipgpd fid "in: "))

	 (to-field  (if buffer-read-only	    ;; RMAIL VM
			(ti::mt-get-field-1 "from")
		      (ti::mt-get-field-1 "to")))   ;; mail buffer

	 (eolp      (or (ti::mt-hmax) (point-max)))

	 (elist     (tipgp-email-find-region
		     (point-min)

		     ;;  Search up till character limit 3000
		     (if (> eolp (+ (point-min) 3000))
			 (+ (point-min)3000) eolp)
		     ))
	 (key-id     (tipgp-key-id-find))
	 elt
	 srv
	 cmd
	 )
    (if dummy (setq dummy t))		;No-op, byte-comp silencer.

    (tipgpd fid to-field key-id elist (current-buffer) (point-min) eolp)

    (if to-field
	(setq to-field (car (ti::mt-email-from-string to-field))))

    (if (setq elt (tipgp-ask-http-keyserver))
	(setq srv (nth 0 elt)
	      cmd (nth 1 elt))
      (error "Internal."))		;should not happen


    (if key-id				;Add this to completion list too
	(push key-id elist))

    (or string
	(setq string
	      (completing-read
	       "Search string, no spaces: "
	       (list-to-assoc-menu elist) nil nil
	       (if key-id
		   key-id
		 (remove-properties (or to-field (ti::b-read-space-word))))
	       )))
    (list srv cmd string)
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-http-keyserver-verbose  (string)
  "See `tipgp-key-find-by-http-keyserver'. STRING."
  (let ((a (tipgp-key-find-by-http-keyserver-i-args string))
	)
    (tipgp-key-find-by-http-keyserver (nth 0 a) (nth 1 a) string 'verb)))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-http-keyserver
  (server command string &optional verb)
  "Send http request to keyserver to get a key.

Interactive note:

  All email addresses are read from `point-min' to end of
  current line where your cursor sits. The default search string
  offered is read from the To field but you can delete the prompt
  and enter other found email addresses via Tab completion.

Functional note:

  Please understand that waiting for a HTTP response may be painfully
  slow many times. If you can, prefer the finger and instruct
  poeople to include their publick key information in the
  $HOME/.plan file in full -fkax format.

Input:

  SERVER	www.xx.com
  COMMAND	command to run in server
  STRING	the search string without spaces. If this parameter is nil
		or contains spaces, thi function returns immediately.
  VERB		Verbose messages.

Return:

  keyring	If htttp call succeeded and key was inserted to some keyring
  nil		no keys added or found"
  (interactive (tipgp-key-find-by-http-keyserver-i-args))
  (tipgpd "tipgp-key-find-by-http-keyserver in: " string )

  (unless (var-nil-p string)
    (let* ((cmd      (format (concat "http://%s" command) server string))
	   )
      (VERB)
      (tipgpd "tipgp-key-find-by-http-keyserver cmd: " cmd)
      (tipgp-key-find-by-http-url cmd verb)
      )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-http-guess ()
  "Select X-pgp URL if it exists or suggest keyserver search.
This function is stricly for interactive use."
  (interactive)
  (let* ((url (tipgp-xpgp-key-address 'http))
	 tried
	 ret
         )
    (if (and url
	     (setq tried (y-or-n-p "X-Pgp key url found; obey it ")))
	(setq ret (tipgp-key-find-by-http-url url 'verb)))

    (unless ret
      (if tried
	  (message-quick
	   "No luck, Inform person about possible defective URL"))
      (setq ret (call-interactively 'tipgp-key-find-by-http-keyserver))
      )
    ret
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-email  (email-srv string)
  "Send email to nearest Public key mail service to get the Key.
Notice that this sends _mail_ and doesn't return any values.

This function should not be put into any key find nook, but
called by user with clear intention to find key as last resort.

Input:
  EMAIL-SRV     full string placed in To: field where to send the
		request.
  STRING	what to request from the server normally
		\"FirstName Surname\""
  (interactive
   (let (srv
	 string
	 )
     (setq srv (tipgp-ask-email-keyserver))
     (setq				;ARG 2
      string
      (read-from-minibuffer "Search string [firstname surname]: "))
     (list srv string)
     ))

  ;; ... ... ... ... ... ... ... ... ... ... ... ... .. function start . .
  (let* (cmd
	 )

    (if (or (var-nil-p email-srv)
	    (var-nil-p string)
	    (not (string-match "@" email-srv)))
	(error "Invalid arguments."))

    (setq cmd (format "GET %s" string))

    (ti::mt-sendmail-macro  email-srv cmd 'send
      (insert cmd "\n"))
  ))



;;; ----------------------------------------------------------------------
;;; - We don't make this a macro! It could be installed into hooks...
;;;
(defun tipgp-key-find-by-cache  (string &optional who)
  "Check cache for STRING.

Input:
  STRING   ,string to find
  WHO	    ,who calls this function (for debug purposes)

Return:
  pubring
  nil"
  (tipgpd "tipgp-key-find-by-cache: " string who)
  (if (stringp string)
      (tipgp-key-cache 'get string)))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-key-cache-update  (&optional user)
  "Update cache with current USER/pubring parameters."
  (setq user (or user tipgp-:user-now))

  (tipgpd "tipgp-key-cache-update: " user tipgp-:pubring-now )

  ;;  The USER must at least contain 3 character, it's no use to
  ;;  cache 2 character user, because that may be a bug in program
  ;;
  (if (> (length user) 2)
      (tipgp-key-cache 'put user tipgp-:pubring-now)
    (error "TinyPgp: cache update internal error %s" user))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-keyrings-1 (string-or-list)
  "Search all keyrings and cache.

Input:
  STRING-OR-LIST    string or list of search strings, first one found
		    is used.

Return:
 (string . keyring) STRING is the one in string-or-list that was found
		    first.
 nil"
  (let* ((tipgp-:pubring-now	tipgp-:pubring-now)
	 (fid			"tipgp-key-find-by-keyrings-1:")
	 list
	 kring
	 ret
	 search-string
	 )
    (tipgpd fid "in:" string-or-list)
    (setq string-or-list (list-make string-or-list))

    (list-loop string-or-list search-string	;; Can't use dolist/2 loop
      (setq list (tipgp-pubring-list))

      (tipgp-save-state-macro
	(job-buffer (tipgp-use-tmp-buffer 'shell)
	  (list-loop list kring			;; Can't use dolist/2 loop
	    (if (not (file-exists-p kring))
		(error "\
Check tipgp-:pubring-table/Config error, no keyring '%s'" kring))

	    (setq tipgp-:pubring-now kring) ;Search this

	    (when (tipgp-key-info-insert search-string)
	      ;;  That's it, stop the loop by setting list to nil
	      (setq ret  (cons search-string kring)
		    string-or-list  nil	;Stop loop 1
		    list	    nil	;Stop loop 2
		    )
	      (tipgp-key-cache 'put search-string kring)
	      ))))
      )
    (tipgpd fid "out:" search-string kring ret)
    ret
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-keyrings-verbose (string)
  "See `tipgp-key-find-by-keyrings'. STRING."
  (tipgp-key-find-by-keyrings string 'verb))

(defun tipgp-key-find-by-keyrings (string &optional verb)
  "Try all available keyrings and try to find the public key.
If pubring file searched does not exist, signal error.

Input:

  STRING    ,search string
  VERB      ,if non-nil, then ask for search string if STRING search fails.

Note:

  This function caches the pubring and string information
  The cache is always looked first, before doing any outside search.

Sets global

  `tipgp-:return-value' and property 'find-by-keyrings

  If you call this function with argument VERB
  user can change the search STRING. if the user's string is found
  from the keyrings then the original STRING is changed. The
  property has value nil if STRING is original or
  it has the user's input value if that match was found.

  You need the information if you try to encrypt with key
  xxx@foo.site.com and user changes it to 'doodle'. Then if
  'doodle' is found, you should use that for encryption and not
  the original xxx@foo.site.com

Return:

  string    ,public keyring
  nil"
  (let ((fid  "tipgp-key-find-by-keyrings:")
	(loop t)
	ret
	)

    (tipgpd "tipgp-key-find-by-keyrings in:" string )
    (put 'tipgp-:return-value 'find-by-keyrings nil)

    (while (and loop (null ret))
      (setq loop nil)			;User sets this 't' if retry

      (or (setq ret (tipgp-key-find-by-cache string))
	  (setq ret (tipgp-key-find-by-keyrings-1 string))
	  (and verb
	       (progn
		 (message "\
(To) Hm, Consider using tipgp-email-substitution-add in tipgp rc file...")
		 (sit-for 5)

		 (setq
		  string
		  (completing-read
		   (format
		    "[%s] No keyring, try another string? : "
		    string
		    )
		   (list-to-assoc-menu (tipgp-email-make-choices string))))
		 (if (var-nil-p string)	;RET pressed --> ""
		     nil
		   (setq loop t)
		   (tipgpd fid "RETRY" string)
		   (setq ret (tipgp-key-find-by-keyrings-1 string))
		   ))))
      )

    ;;  tipgp-key-find-by-keyrings-1 return cons cell
    ;;
    (when (listpp ret)
      (put 'tipgp-:return-value 'find-by-keyrings (car ret))
      (setq ret (cdr ret))
      )

;;;    (d! "fbk" (get 'tipgp-:return-value 'find-by-keyrings))
    (tipgpd "tipgp-key-find-by-keyrings out:" string ret )
    ret
    ))




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-find-by-guess (string &optional verb)
  "Try to determine where to get the Public key-id STRING.
For best results, the STRING should be in 0xFFFFF format to
uniquely match single person. Second best choice is full email address.
VERB activates verbose messages.

The order of search depends on the variable:

    `tipgp-:find-by-guess-hook'

Which is list of functions."
  (interactive
   (list
    (ti::s-sqz
     (read-from-minibuffer
      "Search string: "
      (ti::s-sqz (or (ti::mt-get-field "from" nil 'null-mode)
		     (ti::mt-get-field "to" nil 'null-mode)
		     ))

      ))))
  (let* ((fid "tipgp-key-find-by-guess:")
	 ret
	 )
    (VERB)
    (if (var-nil-p string) (error "Invalid arg"))

    ;;  Is there substitution for this ?
    ;;
    (setq ret (car-safe (tipgp-key-id-conversion string)))
    (tipgpd fid "in: STRING" string "key-subst" ret verb)

    (if ret (setq string ret))


    (setq ret (run-hooks-until 'tipgp-:find-by-guess-hook nil string))

    (if ret (tipgp-key-cache 'put string ret))

    (when verb
      (cond
       (ret
	;;  maybe the previous call cached they KEY whose indicator "k"
	;;  is not shown in modeline. Show "k" now
	;;
	(tipgp-update-modeline)
	(message "TinyPgp Guess found: [%s] keyring %s"
		 string
		 (file-name-nondirectory ret)
		 ))
       (t
	(message "TinyPgp Guess failure: (maybe converted) %s" string)
	)))
    ret
    ))

;;}}}
;;{{{ PGP key management

;;; ......................................................... &pgp-key ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-ring-at-point  (&optional alias)
  "See if there is keyring by looking backward.
First empty line terminates search. Eg.

Key ring: '/users/jaalto/.pgp/pubring.pgp', looking for
user ID \"foo@site.com\".
Type Bits/KeyID    Date       User ID
pub  1024/20378F71 1995/08/19 Mr. foo  <foo@site.com>


Input:
 ALIAS   ,flag, return keyring alias name"
  (let (ret
	)
    (save-excursion

      ;;  move away from empty line
      ;;
      (if (looking-at "^[ \t]*$")
	  (forward-line -1))

      (while (and (not (bobp))
		  (not (looking-at "^[ \t]*$"))
		  (null ret)
		  )
	(if (looking-at ".*Key ring:[ \t]+'\\([^']+\\)")
	    (setq ret (read-match 1)))
	(forward-line -1)
	))

    (if alias
	(setq ret (tipgp-pubring-file2alias ret)))

    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defsubst tipgp-key-trust-ask  (&optional id)
  "Ask trust parameter. If user gives empty line, 'undefined' is returned.
ID is user-id."
  (let ((ans
	 (completing-read
	  (format "%s%strust parameter? " (or id "") (if id " " ""))
	  (list-to-assoc-menu
	   '("undefined" "untrusted" "marginal" "complete"))
	  nil 'match-it
	  "undefined"
	  )))
    (if (var-nil-p ans)
	"undefined"
      ans)
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-info-insert-current-user ()
  "Insert current user's key information to point.
The current pubring is set temporarily to first
entry in `tipgp-:pubring-table'."
  (tipgp-save-state-macro
    (setq tipgp-:pubring-now (nth 1 (car tipgp-:pubring-table)))
    (tipgp-key-info-insert tipgp-:user-now 'verb)
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-info-insert  (string &optional verb)
  "Run pgp -kvc to get key information matching the STRING.
Insert the content to current point. VERB allows verbose messges.

References:
  `tipgp-:buffer-tmp-shell'

Return:
  t	    ,something inserted
  nil	    ,error condition"
  (interactive
   (list
    (read-from-minibuffer
     (format "insert key matching [pubring: '%s']: "
	     (or (tipgp-pubring-file2alias tipgp-:pubring-now)
		 "<unknown>")))

     ))

  (barf-if-buffer-read-only)
  (tipgpd "tipgp-key-info-insert in: " string verb )

  (let* ((bcmd	(tipgp-exe-get-cmd 'key-info))           ;;base command
	 (cmd	(tipgp-cmd-compose bcmd nil nil '(nil)))
	 (fid   "tipgp-key-info-insert: ")
	 buffer
	 ret
         )
    (VERB)

    (tipgpd fid "run: " cmd )

    (tipgp-do-shell-env
     (job-buffer (setq buffer (tipgp-use-tmp-buffer 'shell))
       (shell-execute (format "%s '%s'" cmd string) buffer)
;;;       (pop-to-buffer (current-buffer)) (d! "::key" string)
       (PMIN)

       (cond
	((re-search-forward "0 matching keys found\\." nil t)
	 (if verb  (message "0 matching keys found."))
	 )
	(t
	 (setq ret t)
	 ))))

    (if ret
	(insert-buffer buffer))

    (tipgpd fid "out: " ret )

    ret
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-info-at-point-show (string &optional pubring-list)
  "Find match using STRING from current keyring or PUBRING-LIST.
When called interactively, read space-separated-word
under point and find matches from current keyring and
show them in temporary buffer."
  (interactive
    (let (str
	  )
      (setq str
	    (read-from-minibuffer
	     "Display key info matching: "
	     (if (null (setq str (ti::b-read-word "-0-9a-zA-Z@.")))
		 ""
	       ;; If  underlying word is Key-id 12345678, then
	       ;; prepend 0x to it because that is only valid search string
	       ;;
	       (if (and (eq (length str) 8)
			(string-match "^[0-9A-Z]+$" str))
		   (concat "0x" str)
		 (str-left str 35)
		 ))
	     nil nil
	     'tipgp-:history-key-info
	     ))
      (list str (tipgp-pubring-list))
      ))


  (let ((tmp   (tipgp-use-tmp-buffer 'show))
	)
    (if (not (stringp string))
	(error "Arg error")

      (job-buffer tmp
	(tipgp-save-state-macro
	  (dolist (elt pubring-list)
	    (setq tipgp-:pubring-now elt)

	    (insert "\n" elt ":")

	    (beginning-of-line)
	    (if (looking-at "^.*/\\(.*:\\)")
		(tipgp-highlight 'match 1))
	    (end-of-line)  (insert "\n")

	    (tipgp-key-info-insert string)
	    (PMAX)
	    )))
      (pop-to-buffer tmp)
      (PMIN)
      )))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-add-region-batch  (beg end &optional noerr verb)
  "Add all public keys in region to active keyring.
The region is handled by PGP directly. No checkings are done here.

Input:

  BEG END   region
  NOERR	    if nil, then signal error if PGP reports error.
  VERB	    allow verbose messages

Interactive call:

  The region is cecked for public key. If none exist offer using
  whole buffer.

Sets global:
  `tipgp-:return-value'   pubring where the key was inserted

Return:
  string
  nil		,no keys were added"

  (interactive
   (progn
     (ti::xe-activate-region)	;Make sure user sees region
     ;; Check this before going further
     (if (null (ti::mt-pgp-public-key-p (point-min)))
	 (error "No public key area in buffer"))
     (i-macro-region-ask
      "No region selected, use whole buffer for key insert? ")
     ))


  (tipgpd "tipgp-key-add-region-batch in: pring"
	  tipgp-:pubring-now (current-buffer) )

  (let* ((tipgp-:pubring-now tipgp-:pubring-now) ;make local copy
	 (bcmd	    (tipgp-exe-get-cmd 'key-add));;base command
	 (copy	    (tipgp-use-tmp-buffer))
	 (buffer    (tipgp-use-tmp-buffer 'shell))
	 (i	    0)
	 cmd
	 pring
	 ret
	 )
    (VERB)
    (tipgpd "tipgp-key-add-region-batch in:"
	    (current-buffer) beg end bcmd cmd )


    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . verbose part ..
    ;;  Many times there may be old region active and user doesn't
    ;;  realize that,. Do little check first...
    ;;
    (when verb
      (when (and (not (safe-narrow beg end
			(ti::mt-pgp-public-key-p (point-min))
			))
		 (y-or-n-p
		  (concat
		   "Can't find public key block in region.. "
		   "Use full buffer [C-g abort] ")
		  ))
	(setq beg (point-min)  end (point-max))
	)

      (if (setq pring (tipgp-pubring-ask))
	  (setq tipgp-:pubring-now pring))
      )



    ;; Only now can we compose the command: pubring is known or
    ;; set by user.
    ;;
    (setq tipgp-:return-value tipgp-:pubring-now)
    (setq cmd (tipgp-cmd-compose bcmd nil nil '(nil)))

    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. do it ..
    (tipgp-do-shell-env
     (save-window-excursion
       (append-to-buffer copy beg end)
       (append-to-buffer buffer beg end)
       (job-buffer buffer
;;;	 (pop-to-buffer (current-buffer)) (d! 12345)
	 ;;   Remove spaces: "intended PGP key", but only if there is
	 ;;   only one key. Ignore "chop" if there is multiple keys.
	 ;;
	 (PMIN)
	 (while (re-search-forward (ti::mt-pgp-pkey-begin-line) nil t) (inc i))
	 (if (eq 1 i) (ti::mt-pgp-chop-region (point-min) (point-max)))

	 (shell-command-on-region	;This shows the buffer, gawk!
	  (point-min) (point-max) (format "%s " cmd) buffer)
	 )))

    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  results ..
    (setq ret (tipgp-exe-get-result-key-add))
    (when (and verb ret)
      (message "Key add note: %s" ret))

    (when (and (stringp ret)
	       (string-match "error" ret)
	       )
      (if noerr
	  (setq ret nil)
	(tipgp-error "PGP response error.")
	))

    (when (and (stringp ret)
	       (string-match "No keys found" ret))
      (setq ret nil))

    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-add-region-interactive  (beg end)
  "Parse BEG END and ask if key should be added to the active keyring."
  (interactive (i-macro-region-ask))
  (tipgpd "tipgp-key-add-region-interactive in: pring"
	  tipgp-:pubring-now  (current-buffer) beg end )
  (let ((data	(ti::mt-pgpk-public-get-region
		 nil nil tipgp-:buffer-tmp-shell
		 ))
	(verb  (interactive-p))
	id
	pkey
;;;	trust
	)

    (tipgp-unfinished-function)
    (cond
     ((null data)
      (if verb
	  (message
	   "'Key for user ID:' tags not found to signify public key blocks."))
      )
     (t
      (dolist (elt data)
	(setq id (nth 0 elt)   pkey (nth 1 elt))
	(cond
	 ((null pkey)
	  (read-char-safe
	   (format "Public key empty: %s" (or id "<id not known>"))))

	 ((y-or-n-p (format"Add: %s" id))
;;;	  (setq trust (tipgp-key-trust-ask id))
	  (job-buffer (tipgp-use-tmp-buffer)
	    (insert pkey)
	    (tipgp-key-add-region-batch (point-min) (point-max))
	    (error "#todo trust not set.")
	    )))
	)))
    ))


;;; ----------------------------------------------------------------------
;;; Called by TM.el
;;;
(defun tipgp-key-extract-to-point-current-user  ()
  "Extract `tipgp-:user-now' key to current point."
  (tipgp-key-extract-to-point  tipgp-:user-now))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-extract-to-point (string &optional raw noerr)
  "Insert public key matching STRING to current point.

Note:

 If Pgp extracts file to some temporary file, that file will be deleted
 automatically, because the key will be available from emacs buffer.
 This prevents temporary files accumulating in your tmp directory.
 Also the line that containbs sentence

    Key extracted to file '/users/xxx/junk/pgptemp.$07'.

 is removed from the shell output buffer before yanking.

References:

 `tipgp-:buffer-tmp-shell'

Input:

 STRING	    string to search
 RAW        only insert the PGP block
 NOERR	    if non-nil no error is signalled is string is not found,
	    also the output is _not_ inserted to the current point,
	    but returned.

Return:

 string
 nil"
  (interactive
   (list
    (read-from-minibuffer "Insert public key matching: " tipgp-:user-now)
    current-prefix-arg
    ))

  (barf-if-buffer-read-only)
  (tipgpd "tipgp-key-extract-to-point in: pring" tipgp-:pubring-now )
  (let* ((fid   "tipgp-key-extract-to-point:")
	 (bcmd	(tipgp-exe-get-cmd 'key-extract))
	 (out	(tipgp-use-tmp-buffer 'shell))

	 cmd
	 kring
	 ret
         )

    (tipgpd fid "in:" (current-buffer) string noerr )

    (unless (setq kring  (tipgp-key-find-by-keyrings string))
      (error "No PGP key for '%s'" string))

    (tipgpd fid "cmd,out,kring" cmd out kring )

    (tipgp-save-state-macro
      (setq tipgp-:pubring-now kring)
      (setq cmd	(tipgp-cmd-compose bcmd nil nil '(nil)))
      (setq cmd	(format "%s '%s'" cmd string))
      )

    (tipgp-do-shell-env (shell-execute cmd out))

    (job-buffer out
      (PMIN)
      (when (and (null (setq ret (ti::mt-pgp-pkey-read raw 'kill-file)))
		 (null noerr))
	;;  Remove cache entry, maybe user has moved the key
	;;  to another keyring?
	;;
	(tipgp-key-cache-remove-entry string)
	(pop-to-buffer out)
	(error "\
PGP error; Maybe cache has old keyring information? Check cache.")
	  ))

    (when (and ret
	       (null noerr))
      (insert ret))

    (tipgpd fid "out:" ret )

    ret
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-delete-region  (beg end &optional mode plist verb)
  "Remove all keys from keyring that are found from region.
The picked key items are:
o   all email addresses
o   All regular pgp key lines \"pub   512/47141D35 1996/06/03 ...\"

In interactive or verb mode, all removed KeyId's used are marked
with overlays after command completes. Overlays have property '(owner tipgp)

Input:
 BEG END
 MODE	    nil 	= key id 0x based deletion
	    1 or 'email = key id email based deletion
	    2 or 'any	= both methods used.
 PLIST	    list of pubring filenames to touch.
            Interactive call:
	      all public keyring are stepped through;
              permission to use the pubring is asked from user.
            Lisp call:
              If this list oi nil, active pubring is used
 VERB	    Enable verbose asking/message mode.

If VERB is non-nil, error is generated if it happens. if VERB is nil,
then the possible error string is returned."
  (interactive
   (let* ((plist  (list tipgp-:pubring-now))
	  (kring  (or (tipgp-key-ring-at-point 'alias)
		      (tipgp-pubring-file2alias tipgp-:pubring-now)))
	  ans
	  )
     (if (not (ti::xe-mark-active-p))
	 (error "Region not selected."))

     (setq
      ans
      (tipgp-pubring-complete
       (format
	(concat
	 "%sDel keys from all prings or one ring? "
	 "[empty=all] "
	 )
	(cond
	 ((eq 1   current-prefix-arg) "@: ")
	 ((eq 2   current-prefix-arg) "0x@: ")
	 ((eq nil current-prefix-arg) "0x: ")
	 (t
	  (error "No such prefix arg mode")
	  )))
       kring
       ))



     (if (not (var-nil-p ans))
	 (setq plist (list (tipgp-pubring-alias2file ans)))
       (setq plist (tipgp-pubring-list)))

     (list-merge-elements
      (i-macro-region-ask)
      current-prefix-arg
      plist
      )))

  (tipgpd "tipgp-key-delete-region in: " beg end mode plist verb )
  (let* ((buffer-orig   (current-buffer))
	 (BCMD		(tipgp-exe-get-cmd 'key-delete)) ;base command
	 buffer
	 buffer-shell
	 bcmd
	 cmd
	 list1 list2  email-list keyid-list
	 elt elt2
	 err err1 err2
	 permission
         )
    (VERB)
    ;; #todo: use comint to delete keys ?
    ;;
;;;    (error "PGP can't use batch mode...needs new implementation.")

    (tipgpd "tipgp-key-delete-region in: BCMD " BCMD)
    (if (null plist)			;Set defualt value
	(setq plist tipgp-:pubring-now))

    (setq plist (list-make plist))	;make sure it is list

    (if (and verb
	     (not (y-or-n-p
		   "TinyPgp: are you sure about this (region right)? ")))
	(error "Aborted."))

    ;;  We narrow so that highlighting finds right matches
    ;;
    (safe-narrow beg end
      (tipgp-run-in-tmp-buffer nil
	(cond				;Gather key-ids first
	 ((memq mode '(nil 2 any))
	  (setq keyid-list
		(ti::mt-pgpk-id-lines-in-region (point-min) (point-max))))
	 ((memq mode '(1 email))
	  (setq email-list (tipgp-email-find-region (point-min) (point-max))))
	 (t
	  (error "Unknown mode %s" mode)
	  )))

      (and verb (tipgp-highlight 'delete-all))

      (tipgp-do-shell-env
       (tipgp-save-state-macro
	 (setq	buffer		(tipgp-use-tmp-buffer)
		buffer-shell	(tipgp-use-tmp-buffer 'shell))
	 (job-buffer buffer
	   (dolist (pring plist)

	     (setq tipgp-:pubring-now pring)
	     (setq list1 email-list  list2 keyid-list)

	     (when (and verb
			(not (string= "!" (or permission ""))))
	       (setq permission
		     (read-from-minibuffer
		      (format
		       (concat
			"Keyring %s "
			"[ret=ok, !=all, s=skip]: ")
		       (file-name-nondirectory pring)
		       ))))

	     (while (and
		     (member permission '("!" ""))
		     (null err)
		     (or list1 list2))
	       (setq elt nil elt2 nil)
	       (setq bcmd  (tipgp-cmd-compose BCMD nil nil '(nil)))
               ;; ... ... ... ... ... ... ... ... ... ... ... .. email ..
	       (when list1
		 (setq elt (car list1)) (NEXTP list1)
		 (when elt
		   (setq cmd (format "%s '%s'" bcmd elt))
		   (shell-execute cmd buffer-shell)
		   (tipgpd "tipgp-key-delete-region shell: " cmd )
		   ;;
		   ;;  "Key not found in keyring"
		   ;;  But that's no error and we don't report it.
		   ;;
		   (setq err1 (tipgp-exe-check-error 'ignore-output cmd))
		   (when (and verb err1)  (tipgp-error err1))
		   ))

               ;; ... ... ... ... ... ... ... ... ... ... ... ... . 0x ..
	       (when list2
		 (setq elt2 (car list2)) (NEXTP list2)
		 (when (and elt2
			    (setq elt2
				  (strmatget
				   ;;  Get 0xNNNNNN nbr
				   ;;
				   "pub[ \t]+[0-9]+/\\([^ \t]+\\)" 1
				   elt2
				   )))
		   (setq cmd (format "%s '0x%s'" bcmd elt2))
		   (shell-execute cmd buffer-shell)
		   (tipgpd "tipgp-key-delete-region shell: " cmd )
		   (setq err1 (tipgp-exe-check-error 'ignore-output cmd))
		   (when (and verb err2)  (tipgp-error err2))
		   ))

	       (tipgpd "tipgp-key-delete-region do: " pring
		       elt elt2 err1 err2 )


	       ;;  Highlight the line so that user sees it was processed.
	       ;;
	       (if (and verb  (or elt elt2))
		   (job-buffer buffer-orig
		     (if elt  (tipgp-highlight elt))
		     (if elt2 (tipgp-highlight elt2 nil nil 'region))
		     ))

	       ))))
       ))


    (when (and verb (null err))
      (message "Processed keys have been marked with color."))

    (when (and verb
	       (setq err (tipgp-exe-get-result-key-remove buffer-shell)))
      (pop-to-buffer buffer-shell)
      (error "TinyPgp: Key remove problem; remove manually "))



    err
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-sign-1  (your-keyid her-keyid &optional noerr)
  "Sign key-id to current pubring.

Input:
 YOUR-KEYID HER-KEYID NOERR"
  (tipgpd "tipgp-key-sign-1 in: " your-keyid her-keyid noerr )
  (let* ((BCMD		(tipgp-exe-get-cmd 'key-sign)) ;base command
	 (bcmd		(tipgp-cmd-compose BCMD nil nil '(nil)))
	 (buffer-shell	(tipgp-use-tmp-buffer 'shell))
	 stat
	 cmd
	 )
    (tipgp-unfinished-function)
    (setq cmd (format "%s %s" bcmd your-keyid her-keyid))
    (error "#todo") (d! (str-right cmd 50))
    (shell-execute cmd buffer-shell)

    ;; #todo: check results of signing
    ;;
    (if (setq stat (tipgp-exe-get-result-key-sign))
	stat stat)
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-sign-0x-forward  (&optional verb)
  "Sign current 0x key forward. VERB.
The lines must contain valid key info entry extracted from pubring."
  (interactive)
  (let (keyid
	line
	)
    (error "#todo")
    (tipgpd "tipgp-key-sign-0x-forward in:")
    (VERB)

    (when (and (ti::mt-pgp-re-search 'kpub)
	       (setq keyid (read-match 1)))
      (setq line (buffer-substring (match-end 0) (EOLP)))

      (if (or (null verb)
	      (and verb
		   (y-or-n-p
		    (format "Sign key %s , %s: " line keyid ))))
	  (tipgp-save-state-macro
	    (tipgp-user-in-use-confirm
	     (tipgp-key-sign-1 tipgp-:user-now keyid)
	     )))
      )))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-key-mode-set-trust (mode)
  "Set the trust MODE on current key/email in the line or point."
  (interactive "*r")
  (let* (
         )
    (cond
     ((eq mode 'undefined)
      )
     ((eq mode 'untrusted)
      )
     ((eq mode 'marginal)
      )
     ((eq mode 'complete)
      ))

    ))

;;}}}
;;{{{ PGP main code

;;; ............................................................. &pgp ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-signature-user-info  ()
  "Return User's X-Pgp information.

References:
  `tipgp-:xpgp-user-info'

Return:
  nil
  string"
  (let ((ret (if (stringp  tipgp-:xpgp-user-info)
		 tipgp-:xpgp-user-info
	       (eval tipgp-:xpgp-user-info)))
	)
    (if (var-nil-p ret) nil ret)
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-signature-move-to-header  (&optional just-delete no-cnv)
  "Move Normal PGP signature to email headers.
If there is no PGP signature info, do nothing.
Works for read-only buffers too.

You can call this function only after you have composed the
message and attached the normal PGP signature.

Input:
  JUST-DELETE	delete Normal PGP signature: do not move.
  NO-CNV	Do not convert '- -' to '-' when deleting old signature."
  (tipgpd "tipgp-signature-move-to-header in:" just-delete)
  (let* (buffer-read-only
	 (fid           "tipgp-signature-move-to-header:")
	 (hlist         tipgp-:header-sign-smf-info)
	 (psig		"X-Pgp-Signed")

	 data
	 hdr-smf
	 user-info
	 sig-fld

	 sig-list
	 info-list
	 fld str
         )

    (when (and (null just-delete)
	       (setq data		;only if there is PGP
		     (save-excursion
		       (PMIN) (ti::mt-pgp-signature-normal-info))))
      (setq hdr-smf (if hlist
			(concat
			 "SignedHeaders="
			 (mapconcat
			  'concat
			  (nth 1 tipgp-:header-sign-smf-info)
			  ", ")
			 ";"
			 )))

      (tipgpd fid "DATA" data  "HDR-SMF" hdr-smf tipgp-:header-sign-smf-info)
      ;;  moving signature in buffer is not really a modification
      ;;
      (save-buffer-modified
	(save-with-marker
	  (setq info-list (nth 1 data)
		sig-list  (nth 2 data)
		)

;;;	(setq I info-list S sig-list)
;;;	(d! I B E)

	  (tipgpd  fid "INFO-LIST" info-list "SIG-LIST" sig-list)

	  (unless just-delete
	    (setq user-info (tipgp-signature-user-info))

	    (dolist (elt info-list)
	      ;; For each PGP id, we just use that ID as
	      ;; additional header name.
	      ;;
	      (when (string-match "\\(.*\\):[ \t]+\\(.*\\)" elt)
		(setq fld (read-match 1 elt)
		      str (read-match 2 elt))

		(if (string-match "Version\\|Charset" fld)
		    (setq sig-fld (format "%s%s=%s; "
					  (or sig-fld "")
					  fld str)))
		))

	    (setq sig-fld (format "%sSignature=\n" sig-fld))

	    (dolist (elt sig-list)
	      ;; Last one Must have terminating colon
	      ;;
	      (if (null (cdr sig-list))
		  (setq sig-fld (format "%s  \"%s\";\n" sig-fld elt))
		(setq sig-fld (format "%s  \"%s\"\n" sig-fld elt))
		))

	    (tipgpd  fid "SIG-FLD" sig-fld)

	    (setq str
		  (concat (if user-info (concat user-info "\n  " ) " ")
			  (if hdr-smf
			      ;; Fit in the same line?
			      ;;
			      (cond
			       ((< (+ (length hdr-smf) (length sig-fld))
				   ;;  If there is no user info, then
				   ;;  these fields go directly after
				   ;;  X-Pgp-Signed:  (value 60)
				   ;;
				   (if user-info 77 60))
				(concat hdr-smf sig-fld "\n  "))

			       ((< (length hdr-smf) 40)
				(concat hdr-smf " \n  " sig-fld))

			       (t
				(concat "\n  " hdr-smf "\n  " sig-fld)
				))
			    sig-fld
			    )))
	    (ti::mt-add-field psig str)
	    )

	  )))

    ;;  We can do this without knowing if there is PGP sig,
    ;;  The previous statements already got rid of it
    ;;  Remove the traditional signature.
    ;;
    (ti::mt-pgp-signature-remove nil no-cnv)

    (tipgpd fid "out: hooks" tipgp-:sig-to-header-hook)

    (if tipgp-:sig-to-header-hook
	(run-hooks-until 'tipgp-:sig-to-header-hook))
    ))




;;; ----------------------------------------------------------------------
;;; The parameter 'delete' is optional, because
;;; - we may want to convert Headers to INFO block
;;; - do something when the block is there
;;;   remove that blocka.
;;;
;;; And we don't have no Moving back to headers.
;;;
(defun tipgp-signature-from-header  (&optional just-delete)
  "Convert X-Pgp signature to regular PGP signature.

Input:
  JUST-DELETE      do not move but delete header signature info."
  (let* ((fid		"tipgp-signature-from-header:" )
	 (pbase		"X-Pgp-")
	 (sig-b-line    (ti::mt-pgp-re  (ti::mt-pgp-signature-begin-line)))
	 (sig-e-line    (tipgp-cnv (ti::mt-pgp-signed-end-line)))
	 buffer-read-only

	 data
	 hdr-smf
	 sig-list
	 info-list
	 beg end
         )
    (tipgpd fid "in:" "DEL FLAG" just-delete )

    (cond
     (just-delete
      ;;  Old v2.xx x-pgp standard
      ;;
      (setq sig-list '("^X-Pgp-Charset" "^X-Pgp-Version"
		       "^X-Pgp-Signed"  "^X-Pgp-Comment"))
      (dolist (elt sig-list) (ti::mt-kill-field elt))
      (ti::mt-pgp-signature-remove)
      )

     ((setq data (ti::mt-pgp-signature-header-info))
      (tipgpd fid "X-pgp" data)
      (save-with-marker
	(ti::mt-pgp-signature-remove 'add)
	(setq beg	(car (nth 0 data))	;headers are here
	      end	(cdr (nth 0 data))
	      info-list (nth 1 data)
	      sig-list  (nth 2 data))

	(PMIN)
	(when (setq hdr-smf (tipgp-header-sign-make-smf 'xpgp))
	  (ti::mt-text-start 'move)
	  (forward-line 2)
	  (insert (car hdr-smf))
	  )
	(re-search-forward sig-b-line)

	(forward-line 1)
	;; There must be absolutely nothing after it.
	;;
	(delete-region (point) (point-max))

	(unless just-delete
;;;	  (insert sig-b-line "\n")
	  (dolist (elt info-list)
	    (setq elt (ti::s-del-re (concat "^" pbase) elt))
	    (insert elt "\n"))

	  (insert "\n")			;blank line
	  (dolist (elt sig-list) (insert elt "\n"))

	  (insert sig-e-line "\n")

;;;	(d! "DEL" beg end delete)
	  )

	(if (and beg end)
	    (delete-region beg end)
	  ;;  v3.xx has only one heder field
	  (ti::mt-kill-field "^X-Pgp-signed")
	  )

	(run-hooks 'tipgp-:sig-from-header-hook)
	)
      ))
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-signature-move-to-header-maybe  (&optional verb)
  "If current mode is mail or news then move signature to header.
But only if this is not a remailer message.

Input:
  VERB	    Verbose messages.

References:
  `tipgp-:xpgp-signing-mode'
  `tipgp-:header-sign-table'       ,overrides all"
  (tipgpd "tipgp-signature-move-to-header-maybe in:")

  (let* ((fid   "tipgp-signature-move-to-header-maybe:")
	 elt
	 (tipgp-:xpgp-signing-mode ;take local copy
	  tipgp-:xpgp-signing-mode)
	 (allowed  (tipgp-mail-buffer-p 'message))
	 (remail   (or (ti::mt-pgp-remail-p)
		       tipgp-:r-mode-indication-flag
		       ))

  	 (do-it   tipgp-:xpgp-signing-mode)
	 (count   (tipgp-hash 'sign 'get 'sign-remind-counter nil 'global))
	 )
    (tipgpd fid "ALLOWED" allowed "DO" do-it "REMAIL" remail)

    (when (and
	   allowed do-it
	   (null remail)
	   (if (setq elt (tipgp-header-sign-active-list))
	       (null (nth 2 elt))	;if this entry is NIL then proceed
	     t)
	   )

      (tipgp-signature-move-to-header nil 'no-cnv)

      (when verb
	(unless (integerp count)
	  (setq count 0)
	  (tipgp-hash 'sign 'put 'sign-remind-counter 0 'global)
	  )

	(inc count)
	;;
	;;  Display message every 5th time
	;;
	(when (eq 0 (% count 5))
	  (setq count 0)
	  (message-quick
	   (concat
	    "Do not modify buffer, otherwise "
	    "PGP signature must be generated again."))
	  )
	(tipgp-hash 'sign 'put 'sign-remind-counter count 'global)
	)

      )
    (tipgpd fid "out:")
    ))

;;}}}


;;{{{ interactive, guess next action

;;; .................................................... &guess-action ...

;;; ----------------------------------------------------------------------
;;; - If you have used vc.el, then you know why this function ....
;;;
(defun tipgp-next-action-mail  (&optional arg)
  "Try to guess next action. ARG is passed to called function.
If buffer has auto action active or if function cannot guess what
to do, this command does nothing.

In mail buffer,
o  If buffer is read-only, try to decrypt it. We suppose that the
   buffer is used by some mail reader.
o  -- Check if there is only one email in TO field. If the
      user is cached (you have previously encrypted message to him),
      then ask permission to encrypt the message.
   -- Sign the message

In some other buffer:
o  If not signed, sign.
o  If signed, verify.
o  If encrypted, decrypt. (Mail buffers are ignored, because you can't
   decrypt other users encrypted message.)
o  If encrypted and signed, do verify and decrypt.

Prefix argument
o  Is passed to decrypt command"
  (interactive "P")
  (tipgpd "tipgp-next-action-mail in:" arg)
  (let ((auto-action-pending (and (tipgp-auto-action-p)
				  (tipgp-hash 'auto-action 'get 'user-mode)))
	(fid	    "tipgp-next-action-mail: ")
	pring
	to
	)
    (tipgpd fid "auto action :" auto-action-pending )

    (cond
     (auto-action-pending
      (message "TinyPgp.el ...note, auto action is pending."))
     (t
      (cond
       ;; ... ... ... ... ... ... ... ... ... ... ... ... ...  regular ..
       ((not (ti::mt-mail-p))		;Regulat; non-mail buffer
	(tipgpd fid "non-mail buffer start:")

	(cond
	 ((not (ti::mt-pgp-signed-p))
	  (tipgpd fid "regular not pgp-signed:")
	  (tipgp-sign-region (point-min) (point-max)
			     (tipgp-i-args-pass-phrase)))

	 ((and (ti::mt-pgp-encrypted-p)
	       (ti::mt-pgp-signed-p))
	  (tipgpd fid "regular encrypted:")
	  (tipgp-decrypt-region
	   (point-min) (point-max)
	   (tipgp-i-args-pass-phrase-decrypt)
	   ))

	 ((ti::mt-pgp-signed-p)
	  (tipgpd fid "regular signed:")
	  (tipgp-verify-region (point-min) (point-max))

	  ;;  When we virify message there following possible results.
	  ;;  a)  the encrypted message pops up
	  ;;  b)  it was base64 signed -> regular text
	  ;;  c)  only signed --> remains signed.
	  ;;
	  (when (and (not (ti::mt-pgp-signed-p))
		     (ti::mt-pgp-p))
	    ;;  Still pgp ? Maybe we should decrypt it ?
	    (tipgp-decrypt-region
	     (point-min) (point-max)
	     (tipgp-i-args-pass-phrase-decrypt))
	  ))
	 ))

       ;; ... ... ... ... ... ... ... ... ... ... ... ... ... ... mail ..
       ((ti::mt-mail-p)
	(setq to (ti::mt-get-field "to"))

	(tipgpd fid "mail: to" to
		"see pgp? " (ti::mt-pgp-p)
		"multi ,? " (count-char-in-string ?, (or to ""))
		)

	(cond
	 ((and (not buffer-read-only)
		   (not (var-nil-p to))	    ;; Must have TO email
		   (null (ti::mt-pgp-p))    ;; No PGP yet, okay...
		   (eq (count-char-in-string ?, to) 0) ;; only one email?
		   (setq to (car-safe (ti::mt-email-from-string to)))
		   ;;  Have we sent encrypted mail to him?
		   ;;
		   (setq pring (tipgp-key-find-by-cache to))
		   )
	  (tipgpd fid "mail: 1 encrypt")
	  (tipgp-save-state-macro
	    (setq tipgp-:pubring-now pring)
	    (call-interactively 'tipgp-encrypt-mail)
	    ))

	 ((and (ti::mt-pgp-signed-p)
	       (ti::mt-pgp-encrypted-p 'double-check)
	       )
	  (tipgpd fid "mail: verify/decrypt")
	  (call-interactively 'tipgp-verify-mail)
	  (sit-for 1)			;let user see "Good signature..."
	  (tipgp-decrypt-mail-verbose (quote arg))
	  )

	 ((and (null buffer-read-only)
	       (not (ti::mt-pgp-headers-p))
	       (not (ti::mt-pgp-signed-p))
	       )
	  (tipgpd fid "mail: sign")
	  (call-interactively 'tipgp-sign-mail))

	 ((and (ti::mt-pgp-signed-p)
	       (not (ti::mt-pgp-encrypted-p 'message-tag-too))
	       )
	  (tipgpd fid "mail: 3")
	  (call-interactively 'tipgp-verify-mail)
	  ))				;Cond end

        ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..
	;;
	;;  Still pgp ? Maybe we should decrypt it ?
	;;  But what if this is mail that is meant to be sent to
	;;  someone else --> we assume that non-read-only buffer
	;;  is mail to someone else
	;;
	;;  This is looped two times because:
	;;  - Nym account sends use [ENCRYPT [conventional CRYPT]] envelope
	;;  - Loop1 open CRYPT envelope and the second loop checks
	;;    is there was still real encrypted message (by your nym key)
	;;
	;;  but I don't dare...2 envelopes should suffice.
	;;
	(while (and buffer-read-only
		    (not (ti::mt-pgp-signed-p))
		    (ti::mt-pgp-p))
	  (tipgpd fid "mail: still pgp")
	  (tipgp-decrypt-mail-verbose (quote arg))
	  )

	))
      ;; ... ... ... ... ... ... ... ... ... ... ... ... ... mail end ..
      ))
    ))

;;}}}
;;{{{ signing

;;; ......................................................... &signing ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-sign-modify-check  ()
  "Detect if X-pgp signed message is modified.
References:
  `tipgp-:sign-data'"
  (let* ((mail  (ti::mt-mail-p))
	 (xhd   (ti::mt-pgp-headers-p))
	 (valid (tipgp-sign-data-same-p))
	 )

    (when (and mail xhd  (not valid))
      (message-quick "TinyPgp: Body changed, signature invalid; resigning...")
      (tipgp-sign-loose-info)
      (call-interactively 'tipgp-sign-mail)
      )

    (tipgpd "sign-modify-check:"
	    (current-buffer) mail "X" xhd "OK" valid
	    (ti::mt-message-length) tipgp-:sign-data
	    )

    nil					;hook ret val
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-sign-mail-func  ()
  "Sign current buffer. This function is called from hooks.

References:
  `tipgp-:auto-action-sign-mail-mode-no-form'"
  (if (and (not (ti::mt-pgp-signed-p))
	   (if (null tipgp-:auto-action-sign-mail-mode-no-form)
	       t
	     (eval tipgp-:auto-action-sign-mail-mode-no-form)))
      (call-interactively 'tipgp-sign-mail)))


;;; ----------------------------------------------------------------------
;;; the on/off function can be used in hooks
;;;
(defun tipgp-sign-mail-auto-mode-on ()
  "Turn on automatic signing."
  (tipgp-sign-mail-auto-mode 1))

(defun tipgp-sign-mail-auto-mode-off ()
  "Turn off automatic signing."
  (tipgp-sign-mail-auto-mode 0))

;;;###autoload
(defun tipgp-sign-mail-auto-mode (&optional arg)
  "Toggle autosigning mode according to ARG.

Return:
  nil	    autosigning off
  non-nil   autosigning on"
  (interactive)
  (let* ((func		'tipgp-sign-mail-func)
	 (hooks		'(mail-send-hook))
	 remove
         )

    (cond
     ((null arg)
      (if (tipgp-sign-mail-auto-mode-on-p)
	  (setq remove t)))

     ((memq arg '(0 -1))
      (setq remove t)
      ))

    (add-hooks hooks func remove)
    (tipgp-update-modeline)

    (if (interactive-p)
	(message
	 (format
	  "TinyPgp: mail auto signing mode %s"
	  (if remove "off" "on"))))

    remove
    ))


;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun tipgp-sign-loose-info  (&optional verb)
  "Loose signature info.
Input:
  VERB		Verbose messages."
  (interactive)
  (let* (tipgp-:sig-to-header-hook	;must be disabled for now
	 (allow   (tipgp-mail-buffer-p))
	 )
    (VERB)
    (when (and allow
	       (ti::mt-pgp-headers-p))
      (ti::mt-kill-field "X-Pgp-Signed")
      )
    (tipgp-signature-from-header 'just-delete)

    (when (and verb (null allow))
      (message "PGP action maybe partially completed...") (sit-for 2))

    (run-hooks 'tipgp-:sign-loose-info-hook)
    (if verb (message "PGP signing information deleted."))
    t
    ))



;;; ----------------------------------------------------------------------
;;; - parameters BEG and end _must_ be nil
;;;
;;;###autolaod
(defun tipgp-sign-mail  (password &optional user verb noxpgp)
  "Sign message in mail buffer.

Input:

  PASSWORD	sign pass phrase
  USER		key-id
  VERB		allow verbose messages
  NOXPGP	Prohibit X-Pgp

Notes:

  if VERB is non-nil (set in interactive call), the pubring is
  changed if it the information is on the cache."
  (interactive
   (progn
     (tipgp-hash 'action 'put 'now 'sign)
     (tipgp-user-change-macro
       (list
	(tipgp-i-args-pass-phrase)
	(if current-prefix-arg
	    (read-from-minibuffer "Sign User: ")
	  tipgp-:user-now)
	))))
  (barf-if-buffer-read-only)
  (let* ((fid		    "tipgp-sign-mail: ")
	 (tipgp-:pubring-now tipgp-:pubring-now)
	 (signed-p	     (ti::mt-pgp-signed-conventional-p))
	 (signed-xpgp-p	     (ti::mt-pgp-signed-xpgp-p))
	 (signed-multi-p     (ti::mt-pgp-signed-conventional-multi-p))
	 (mail-p             (ti::mt-mail-p))
	 (write-point	     (point))
	 beg
	 write-mark
	 write-line
	 write-col
	 sign-user
	 buffer
	 hdr-smf
	 pring
	 end
	 )
    (VERB)
    (tipgp-hash 'action 'put 'now 'sign)


    (tipgpd fid "signed" signed-p signed-xpgp-p signed-multi-p
	    "mail-p" mail-p
	    "User:" user verb
	    (current-buffer)
	    (buffer-name)
	    )

    (ti::mt-trim-buffer)

    (ti::mt-pgp-header-kill-in-body)

    ;;  Actually; someone else could have signed using X-pgp,
    ;;  and when we sign the message, the Right Thing would be
    ;;  - check if X-pgp is ours --> remove it. If not, then convert
    ;;    it to regular pgp signature.
    ;;  - add out signing (if there is regular signature, then
    ;;    do ot use X-pgp)
    ;;
    (when signed-xpgp-p (tipgp-sign-loose-info))

    (setq beg (if mail-p (ti::mt-text-start) (point-min)))

    (if (or (eq beg (point-max))
	    (and mail-p			;Check only mail buffer
		 (save-excursion
		   (goto-char (or beg (point-min)))
		   ;; there must be text, not just emptly lines
		   ;;
		   (null (re-search-forward "[^ \t\n]" nil t))
		   )))
	(error "Nothing to do, no text found."))

    (tipgp-save-state-macro

      ;; Turn this off if buffer is not mail or if there already is signature
      (when (or (not mail-p)
		signed-p)
	(setq  tipgp-:xpgp-signing-mode nil))

      (when verb
	(if (null (setq pring (tipgp-key-find-by-cache tipgp-:user-now)))
	    (tipgp-pubring-in-use-confirm)
	  (setq tipgp-:pubring-now pring)))

      ;; ... ... ... ... ... ... ... ... ... ... ... ...  tmp buffer ...
      (tipgp-mode-specific-control-before 'sign tipgp-:user-now nil nil nil)

      (tipgp-run-in-tmp-buffer nil
	(tipgp-save-state-macro
	  (tipgp-user-change-macro
	    (tipgp-set-session-parameters 'sign)

	    (goto-char write-point)
	    (setq buffer    (current-buffer)
		  sign-user tipgp-:user-now ;Save this value
		  write-mark (point-marker)
		  write-line (read-full-line)
		  write-col  (current-column)
		  )
	    (tipgp-cmd-macro-email "sign"
	      (when (ti::mt-mail-p)
		(when (setq hdr-smf (tipgp-header-sign-make-smf))
		  (goto-char beg)
		  (insert (car hdr-smf)))
		)

	      (tipgp-cmd-macro 'sign user password "Signing..."
			       nil nil 'no-mode-funcs)

;;;	  (pop-to-buffer (current-buffer))  (d! "::sign ok")
	      (tipgp-signature-move-to-header-maybe verb)
	      (setq write-point (marker-position write-mark)
		    write-mark  nil)	;kill marker
	      ))))

;;;      (tipgp-mode-specific-control-after 'sign tipgp-:user-now nil nil nil)

      ;;  - Copy signed data to original buffer.
      ;;  - restore original write position: this is tricky because the
      ;;    buffer has changed: Search line string and goto column OR
      ;;    got to marker position.
      ;;
      (erase-buffer)
      (insert-buffer buffer)
      (PMIN)
      (if (and (not (var-nil-p write-line)) ; can't search empty line
	       (search-forward write-line nil 'noerr))
	  (move-to-column write-col)
	;;  This doesn't necessarily succeed to preserve position,
	;;  but it's better than nothing.
	;;
	(goto-char write-point))

      (tipgp-sign-data-set);; If this changes, signing is not valid
      (when verb
	(message "Signed with key: %s"  sign-user)
	(sit-for 1))
      t
      )
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-sign-mail-base64  (password &optional register )
  "Uuencode message with pgp using PASSWORD.
Store output to `tipgp-:register' if REGISTER is non-nil.
This function turns off clearsig, so that mail is signed, compressed,
and uuencoded in base64."
  (interactive
   (progn
     (barf-if-buffer-read-only)
     (list
      (tipgp-i-args-pass-phrase "[Base64] Sign pass phrase: ")
      current-prefix-arg
      )))

  (tipgp-hash 'action 'put 'now 'sign)
  (let* ((beg  (or (ti::mt-text-start) (point-min)))
	 (end  (point-max))
         )
    (if (eq beg end)
	(error "TinyPgp: sign mase64, There is no text in message body."))
    (tipgp-sign-region-base64 beg end password register nil (interactive-p))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-sign-base64-insert-file  (file &optional password options)
  "Insert uuencoded FILE into point using PASSWORD and OPTIONS.
This function inserts the given file into point and turns
off clearsig, so that the file is signed, compressed, and uuencoded
in base64.

It is encouraged that insert big files with this function
to the buffer when you're going to send them via email."
  (interactive "*f[base64 sign] Insert file: ")
  (let ((buffer (tipgp-use-tmp-buffer 'finger))	;This is free for us.
	size
	)
    (barf-if-buffer-read-only)
    (tipgp-hash 'action 'put 'now 'sign)
    ;;  Hm. This should be interactive part...
    ;;
    (if (not (stringp password))
	(setq password (tipgp-i-args-pass-phrase)))


    ;; Insert file leaves point before the file, but we need to know
    ;; where it ends...
    ;;
    (job-buffer buffer
      (insert-file-contents file)

      (unless options
	(setq size (/ (buffer-size) 1000)) ;in kilos
	(setq
	 options
	 (format
	  "'+comment= Base64 signed. File: %s uncompresses to approx. %s'"
	  (file-name-nondirectory file)

	  (if (eq 0 size)		;Hm. very small file
	      (format "%dbytex" (buffer-size))
	    (format "%dK" size))

	  )))
      (tipgp-sign-region-base64 (point-min) (point-max) password nil options)
      (PMIN)
      (run-hooks-until tipgp-:insert-file-sign-base64-hook
		       nil file)
      )
    (insert-buffer buffer)
    (clear-buffer buffer) ;; It may be big file, don't leave into emacs
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-sign-region-base64
  (beg end password &optional register options verb )
  "Sign as base64 (uuencode).

Input:

 BEG END PASSWORD
 REGISTER	if non-nil; then store contents to `tipgp-:register'
 OPTIONS	option string passed to pgp.
 VERB		Verbose messages.

This function turns off clearsig, so that region is signed,
compressed, and uuencoded in base64."
  (interactive
   (progn
     (barf-if-buffer-read-only)
     (list
      (region-beginning) (region-end)
      (tipgp-i-args-pass-phrase)
      current-prefix-arg
      )))

  (VERB)
  (barf-if-buffer-read-only)
  (tipgp-hash 'action 'put 'now 'sign)

  (if (null options)
      (setq options
	    (concat
	     "+clearsig=off "
	     "+comment='base64 signed. "
	     "run signature verify to to dearmor to clear text.' "
	     ))
    ;; Add user options to the end
    ;;
    (setq options (concat "+clearsig=off " options)))

  (tipgp-sign-region beg end password verb options nil register )
  (if (and verb register)
      (message "Results in register"))
  )


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-sign-mail-detached  (password)
  "Create detached signature to register `tipgp-:register' using PASSWORD."
  (interactive
   (list
    (tipgp-i-args-pass-phrase)
    ))

  (let* ((beg  (ti::mt-text-start))
	 (end  (point-max))
         )
    (tipgp-hash 'action 'put 'now 'sign)
    (if (eq beg end)
	(error "TinyPgp: sign detached, There is no text in message body."))
    (tipgp-sign-region-detached beg end password (interactive-p))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-sign-region-detached
  (beg end password &optional verb options noerr)
  "Put detached signature to register `tipgp-:register'.

Input:

  BEG END   ,region
  PASSWORD  ;pass phrase
  VERB	    ,verbose messages
  OPTIONS   ,additional option string for PGP
  NOERR	    ;do not call error

Note:
   If verb is non-nil, correct keyring containing the key is
   first set according to `tipgp-:user-now' before signing."
  (interactive
   (progn
     (if (null (ti::xe-mark-active-p))
	 (error "region not active"))
     (list
      (region-beginning)
      (region-end)
      (tipgp-i-args-pass-phrase)
      t
      nil
      )))

  ;;  This is an ugly hack, but the previous SIGN options are replaced
  ;;  with the new ones. User options are added before -bfast.
  ;;
  (VERB)
  (tipgp-hash 'action 'put 'now 'sign)
  (setq options (format "%s %s" (or options "")  "-bfast"))

  (set-register tipgp-:register nil)	;Clear it
  (tipgp-sign-region beg end password verb options nil 'register)
  (if verb
      (message "Detached signature in register '%s'"
	       (char-to-string tipgp-:register)))
  )


;;; ----------------------------------------------------------------------
;;;
;;;###autolaod
(defun tipgp-sign-region
  (beg end password &optional verb options noerr register)
  "Sign region.

Input:

  BEG END	,region
  PASSWORD	,the pass phrase string
  VERB		,verbose messages
  OPTIONS	,string, flags to add to the real pgp command.
  NOERR		,flag -- return nil or t only
  REGISTER      ,flag -- save results to register"
  (interactive
   (progn
     (barf-if-buffer-read-only)
     (if (null (ti::xe-mark-active-p))
	 (error "region not active"))
     (list
      (region-beginning)
      (region-end)
      (tipgp-i-args-pass-phrase)
      t
      nil
      nil
      current-prefix-arg
      )))

  (let ((fid  "tipgp-sign-region:")
	ret
	)
    (barf-if-buffer-read-only)
    (tipgp-hash 'action 'put 'now 'sign)
    (ti::b-trim-blanks beg end)		;EOL whitespace strip

    (tipgpd fid "in:" beg end password verb options)

    (tipgp-save-state-macro
      (tipgp-user-change-macro
	(cond
	 ((null noerr)
	  (tipgp-set-pgp-env-macro tipgp-:user-now 'verb
	    (tipgp-cmd-macro 'sign tipgp-:user-now password "Signing..."
			     register options))
	  (setq ret t))

	 (t
	  (safe-do
	    (tipgp-set-pgp-env-macro tipgp-:user-now 'verb
	      (tipgp-cmd-macro 'sign tipgp-:user-now password "Signing..."
			       register options))
	    (setq ret t)
	    )))
	))

    (when ret
      (tipgp-key-cache-update)
      (tipgp-sign-data-set)
      )

    ret
    ))

;;}}}
;;{{{ interactive, verifying

;;; ....................................................... &verifying ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-verify-maybe-fetch-key  (status-string)
  "If verify fails, asks if we should try to fetch key.

Input:
  STATUS-STRING	    ,the result of verify

Return:
  t		    ,if key fetch tried.
  nil"
  (let* ((fid  "tipgp-verify-maybe-fetch-key:")
	 (tipgp-:find-by-guess-hook
	      ;;  We already tried these methods, there is finger
	      ;;  and http left
	      ;;
	      (delq
	       'tipgp-key-find-by-cache
	       (delq
		'tipgp-key-find-by-keyrings-verbose
		tipgp-:find-by-guess-hook
		)))
	 key-id
	 )
  (when (setq key-id (strmatget "ID \\([^ \t]+\\) not found" 1 status-string))
    ;;
    ;; Key matching expected Key ID C4AF0331 not found in file
    ;; '/home/xxx/.pgp/pubring.pgp'.
    ;;

    (tipgpd fid "status" status-string key-id)

    (when (y-or-n-p
	   (format "Can't verify: fetch key for %s ? "
		   key-id))
      (tipgp-key-find-by-guess key-id)
      t				;Return value
      ))
  ))


;;; ----------------------------------------------------------------------
;;; - parameters BEG and end _must_ be nil
;;;
(defun tipgp-verify-mail  (&optional no-replace verb)
  "Verify message in mail buffer. See `tipgp-verify-region' for more details.
Input:
  NO-REPLACE	flag, store results to `tipgp-:register'
  VERB		flag, display verbose messages"
  (interactive "P")
  (let ((fid   "tipgp-verify-mail:")
	hidden
	stat
	)
    (VERB)
    (tipgp-hash 'action 'put 'now 'verify)
    (tipgpd fid "in:" no-replace verb)

    (when (tipgp-hidden-p)
      (tipgp-hide 'show)
      (setq hidden t)
      )


    (tipgp-verify-region
     nil nil				;it not a good idea to pass region
     no-replace
     verb)

    (setq stat (or (tipgp-exe-get-result-verify-status) ""))
    (when (and (null no-replace)
	       (ti::mt-pgp-headers-p)
	       (not (string-match "bad\\|not found" stat))
	       )
      ;;  We must remove the X-Pgp signed fields, if the status was ok
      ;;
      (tipgp-signature-from-header 'just-delete)
      )

    (if hidden  (tipgp-hide))
    ))




;;; ----------------------------------------------------------------------
;;;
(defun tipgp-verify-region  (beg end &optional no-replace verb)
  "Verify message in region.

If signature is good and there is some PGP message inside it,
say encrypted to you, then message is replaced
with the output of PGP. In short: message is unpacked.

If there is no PGP, this function does nothing.

Input:

  BEG END	region which is feed to PGP. If both are nil, then whole
		buffer is used.

  NO-REPLACE	If non-nil, the result is put into register instead.
		RBEG and REND are replace position beg and end points.
		They default to BEG and END. These arguments are usefull if
		you feed whole buffer to PGP but want the replace tho
		happen only in cerating region.
  VERB		Verbose messages

References:
  `tipgp-:verify-before-hook'
  `tipgp-:verify-after-hook'"
  (interactive "r")
  (tipgpd "tipgp-verify-region in:" no-replace verb)

  (let* ((cmd       (tipgp-exe-get-cmd 'verify))
	 (fid       "tipgp-verify-region: ")
	 (sig-holder (safe-do
		       (or (car-safe
			    (ti::mt-email-from-string
			     (ti::mt-get-field "from")))
			   ;;  Maybe this is mail message that user has
			   ;;  just signed and he want to varify it himself
			   tipgp-:user-now
			   )))
	 (do-it        t)
	 stat
	 region
	 pring
	 msg
	 ret
;;;	 stat
	 info
         )
    (VERB)
    (tipgp-hash 'action 'put 'now 'verify)
    (setq msg       (if verb "Verifying signature..." nil))

    (if (null (ti::mt-pgp-p))
	(if verb (message "No PGP tags found."))

      (run-hooks-until 'tipgp-:verify-before-hook nil 'verify beg end)

      ;;    Because we have our own hooks, we can use the
      ;;    command macro, because if we'd call it see what happens:
      ;;
      ;;    V-B-hook
      ;;      macro (macro-B-hook macro-E-hook)
      ;;    V-E-hook
      ;;
      ;;    The macro-E-hook would eg. cease rmail-edit-mode
      ;;    already. That's why we don't use the macro here at all.
      ;;
      ;;
      (tipgpd fid "verb sig-holder"  verb sig-holder "BEG" beg end )

      (tipgp-save-state-macro
	(when (and verb sig-holder)
	  (if (or (setq pring (tipgp-key-find-by-keyrings
			       (tipgp-key-id-conversion sig-holder)))
		  ;;   Hmmm, User's email weren't found, find HEX key-id
		  ;;   from base64 signature them. This is slower way
		  ;;
		  (and (setq info (ti::mt-pgp-stream-forward-and-study t))
		       (setq sig-holder
			     (concat "0x"
				     (ti::mt-pgp-stream-data-elt
				      info 'key-id)))
		       (setq pring
			     (tipgp-key-find-by-keyrings
			      (tipgp-key-id-conversion sig-holder)))
		       (message "\
Need From addr -- key-id conversion: use `tipgp-email-substitution-add'")
		       (sit-for 5)
		       ))
	      (setq tipgp-:pubring-now pring)
	    (tipgpd fid "--Can't find key-id from keyrings")
	    (if (null
		 (setq
		  do-it
		  (y-or-n-p
		   (format "Can't find %s from keyrings, call pgp anyway?"
			   sig-holder))))
		(setq stat (format "ID %s not found" sig-holder))
	      )))

        ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . action ..
	(when do-it
	  (setq ret (tipgp-exe-do-command-region
		     cmd beg end (current-buffer) msg 'string)))
	)

      ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. result . .

      ;;  Was it encrypted + signed message? The result removes
      ;;  the signature around the region
      ;;
      (cond
       (no-replace
	(if verb
	    (setq ret "Good signature. Results unpacked to register."))
	)
       (t
	(cond
	 ((save-excursion		;Normal PGP signing
	    (ti::mt-hmax 'move)
	    (setq region (ti::mt-pgp-block-area 'signed)))
	  )
	 ((and (ti::mt-pgp-headers-p)	;X-Pgp signed message?
	       (save-excursion
		 (ti::mt-text-start 'move)

		 ;;  Message is not yet verified if this is found
		 ;;
		 (not (re-search-forward "^--+BEGIN.*PGP" nil t))
		 ))
	  (setq region (cons (ti::mt-text-start) (point-max)))
	  )
	 (t
	  (error "\
Cannot find PGP signature. Already verified or signature hidden?")
	  ))

	(tipgpd "REGION" region (current-buffer))
	(ti::b-replace-region-with (car region) (cdr region) ret)
	(setq ret (tipgp-exe-get-result-verify))


;;;	(setq stat (or (tipgp-exe-get-result-verify-status) ""))
	(when (and (null no-replace) (ti::mt-pgp-headers-p))
	  ;;  We must remove the X-Pgp too.
	  ;;
	  (tipgp-signature-from-header 'just-remove-all)
	  )

	))

      (run-hooks-until 'tipgp-:verify-after-hook nil 'verify beg end ret)

      (setq stat (or stat (tipgp-exe-get-result-verify-status) ""))
      (cond
       ((and verb (tipgp-verify-maybe-fetch-key stat))
	nil)				;Nothing more to do
       (verb
	(setq msg (or (tipgp-exe-get-result-verify-status)
		      "<unknown verify status>"))
	(if (fboundp tipgp-:verify-message-function)
	    (funcall tipgp-:verify-message-function msg)
	  (message msg))
	))
      )
    (tipgpd fid "out: " ret "stat" stat)

    ret
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-verify-detached-signature  (file key-id &optional pring verb)
  "Verify file against detached signature in current buffer.

Input:

  FILE
  KEY-ID    If this string has '@' eg.  'mister foo <qf@site.com>'
	    the key-id is automatically shortened to 'qf@site.com'.
  PRING	    If nil; all pubrings are searched to contain key-id and if none
	    found, funtion calls error. The found keyring is used to call
	    pgp with option +pubring
  VERB	    Verbose messages.

Return:
  nbr	    PGP error code
  nil	    verify successfull.


References:
  `tipgp-:buffer-tmp-shell'	pgp response"

  ;;  #todo: find key-id frm ascii armor, then we don't need it func arg list
  ;;
  (interactive "fVerify original pgp file: \nsUsing key id: ")
  (let* (out
	 status
	 email
         )
    (tipgp-hash 'action 'put 'now 'verify)
    (if (and (string-match "@" key-id)
	     (setq email (car-safe (ti::mt-email-from-string key-id))))
	(setq key-id email))


    (VERB)
    (setq file (expand-file-name file))
    ;;  First we have to know in what pubring the key is in, because
    ;;  PGP needs pubring when it checks the key.
    ;;
    (or pring
	(or (tipgp-key-find-by-cache key-id)
	    (tipgp-key-find-by-keyrings key-id))
	(error "Can't find '%s' from any pubring." key-id)
	)

    (setq out    (tipgp-use-tmp-buffer 'shell))

    ;;  call-process-region START END PROGRAM &optional DELETE
    ;;  DESTINATION DISPLAY &rest ARGS
    ;;
    (setq
     status
     (call-process-region (point-min) (point-max) "pgp"
			  (not 'text-delete)
			  out
			  (not 'constant-display)
			  file
			  (format "+pubring=%s" pring)
			  ))

;;;    (pop-to-buffer (current-buffer)) (d!  orig-file pring)
;;;    (pop-to-buffer out)

    (if verb
	(message (or (tipgp-exe-get-result-verify-status)
		     (and (pop-to-buffer out)
			  "<unknown verify results>"))))

    ;;  Convert 0(pgp ok) to nil(lisp ok) return code
    ;;
    (if (eq 0 status) nil status)
    ))

;;}}}
;;{{{ interactive, encrypting

;;; .......................................................... &encypt ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-encrypt-allowed-check  ()
  "In certains situations it is not allowed to encrypt the mail message.
Check those cases and call error."
  (let* (
         )
    (cond
      ((and (tipgp-nymserver-mail-p)
	    (or (string-match "," (or (ti::mt-get-field-1 "To") ""))
		(ti::mt-get-field-1 "CC")))
       (error "\
Impossible to encrypt Nymserver mail to multiple recipients.")
       ))
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-encrypt-by-cache  (string func &rest args)
  "If the STRING is found from cache, encrypt with FUNC and ARGS.

Return:
  t
  nil"
  (tipgpd "tipgp-encrypt-by-cache: " string func args )
  (let* ((pring (tipgp-key-find-by-cache string))
         )
    ;; # todo: not tested
    (when pring
      (tipgp-save-state-macro
	(setq tipgp-:pubring-now pring)
	(apply func args)
	t
	))
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-encrypt-mail-verbose  (&optional arg)
  "Call `tipgp-encrypt-mail' like user would with ARG."
  (eval
   (`
    (tipgp-encrypt-mail
     (,@ (tipgp-encrypt-mail-i-args arg nil 'bquote))))))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-encrypt-mail-find-keyring (single &optional sign-pwd)
  "Find keyring for SINGLE key-id. and encrypt."
  (tipgp-encrypt-mail single nil sign-pwd nil 'verb))



;;; ----------------------------------------------------------------------
;;; - parameters BEG and end _must_ be nil
;;;
;;;###autolaod
(defun tipgp-encrypt-mail-sign
  (single-or-list &optional no-replace sign-pwd options verb noerr)
  "See `tipgp-encrypt-mail'. Raises parameter 'sign'
SINGLE-OR-LIST NO-REPLACE OPTIONS VERB NOERR."
  (interactive (tipgp-encrypt-mail-i-args
		current-prefix-arg
		'pwd
		))
  (VERB)
  (tipgp-encrypt-mail
   single-or-list no-replace sign-pwd options verb noerr))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-encrypt-mail-i-args  (&optional arg pwd bquote)
  "Read args for `tipgp-encrypt-mail'.
Input:
  ARG	     prefix arg
  PWD	     If non-nil, ask password
  BQUOTE     If you call this function in macro which uses ,@ you must
	     set this flag to non-nil"
   (list
    (if bquote
	;;  We need to protect this list or else Backquote
	;;  tries to call first element as a function
	;;
	(quote (tipgp-i-args-read-email nil "Encrypt to: "))
      (tipgp-i-args-read-email nil "Encrypt to: "))
    (or arg current-prefix-arg)
    (if pwd (tipgp-password-get-old
	     (format "[%s] Sign password: " tipgp-:user-now)))
    (if (null tipgp-:r-mode-indication-flag)
	(eval tipgp-:encrypt-interactive-option))
    ))


;;; ----------------------------------------------------------------------
;;; - parameters BEG and end _must_ be nil
;;;
;;;###autolaod
(defun tipgp-encrypt-mail
  (single-or-list &optional no-replace sign-pwd options verb noerr)
  "Encrypt mail buffer.

Input:

  SINGLE-OR-LIST    List of key-ids. Interactive call reads To,CC,BCC.
  NO-REPLACE	    prefix arg, store result to `tipgp-:register'.
  SIGN-PWD	    if non-nil string, sign at the same time as you encrypt.
  OPTIONS	    Additional pgp option string.
  VERB		    If non-nil, verbose messages.
  NOERR		    If non-nil, do not call error.

Function call note:

  [interactive]
  In case the EMAIL address you're sending doesn't have entry in your
  keyring, but you know that person has a PGP public key, then
  please remove the email address prior calling this function and
  it will prompt you a string to match for USER.

  If this function is called interactively, it tries to set right
  pubring by querying cache and other keyrings (user prompted)
  Also the `tipgp-:encrypt-interactive-option' is suppressed if
  `tipgp-:r-mode-indication-flag' is non-nil

  Normally the To field's address is read and used for encryption.
  However, if you are _on_ line that has email address in format
  <foo@site.com> then your are asked if you want to use this email
  instead. You can complete between this and To address.

  [lisp call]
  Be sure to take precaution when passing OPTIONS if the message is
  sent to remailer. Any extra keyword, like 'Comment:'
  may reveal your identity.

  SINGLE-OR-LIST is not processed with `tipgp-key-id-conversion'.
  You should call it manually if you want to respect user's
  substitution definitions.

  [Genenal note]
  If there are multiple recipiens in the To, CC, BCC field the
  last keyring in the `tipgp-:pubring-table' is used when doing the
  encryption.

Input:

  single-or-list    ,list of email addresses or KEY ID's
  no-replace	    ,flag, do not replace area with encryption
  options	    ,string, extra options passed to pgp exe
  verb		    ,flag, allow printing messges."
  (interactive (tipgp-encrypt-mail-i-args current-prefix-arg))
  (let* ((beg-text  (ti::mt-text-start))
	 beg
	 end
	 elt
	 )
    (VERB)
    (tipgp-hash 'action 'put 'now 'encrypt)
    (tipgp-encrypt-allowed-check)

    (put 'tipgp-:return-value 'find-by-keyrings nil) ;reset

    (tipgpd "tipgp-encrypt-mail in: "
	    single-or-list
	    "SIGN" sign-pwd no-replace options
	    verb  beg (point-max) )

    (if (eq beg-text (point-max))
	(error "Nothing to do, no text found."))

    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..  do it . .
    (setq single-or-list (list-make single-or-list))

    (tipgp-cmd-macro-email "Encrypt"
      (tipgp-set-pgp-env-macro single-or-list 'verb

	  ;;  See the tipgp-key-find-by-keyrings function,
	  ;;  the efective encrypt key may have changed
	  ;;
	  (when (setq elt (get 'tipgp-:return-value 'find-by-keyrings))
	    (tipgpd "tipgp-encrypt-mail: KEY CHANGED " elt )
	    (setq single-or-list (list-make elt)))

	  ;;  Beacuse the Encrypt and signing is done
	  ;;  in 'One pass' both keys must be in same pubring.
	  ;;
	  (if sign-pwd
	      (tipgp-pubring-set-big))

	  (tipgp-cmd-macro
	      (if sign-pwd 'encrypt-sign 'encrypt)
	      single-or-list sign-pwd
	    "Encrypting...." no-replace options)

	  ;; If all went ok, then we update cache, use XXX in in pubring YYY
	  ;; All users must be in same pubring otherwise the previous command
	  ;; didn't succeed.
	  ;;
	  (mapcar
	   (function
	    (lambda (x)
	      (tipgp-key-cache 'put x tipgp-:pubring-now)))
	   single-or-list)
	  ))

    ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . results . .
    (when (and (null no-replace)
	       (null buffer-read-only))
      (if (ti::mt-mail-p)
	  (goto-char (ti::mt-text-start)) ;ignore other buffers
	(PMIN))

      ;;  This is recommended, and needed by remailers.
      ;;
      (save-line-col nil nil
	(insert "::\nEncrypted: PGP\n\n"))
      )

    (when verb
      (message
       "%d: Encrypted to %s %s"
       (length single-or-list)
       (list-to-string single-or-list)
       (if (null sign-pwd) ""
	 (format "and signed [%s]" tipgp-:user-now))
       ))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-encrypt-region-i-args  (&optional pwd)
  "Ask arguments for `tipgp-encrypt-region-i-args'"
  (list-merge-elements
   (tipgp-i-args-reg-email "Encrypt to: ")
   current-prefix-arg
   (if pwd (tipgp-password-get-old
	    (format "[%s] Sign password: " tipgp-:user-now)))
   (if (null tipgp-:r-mode-indication-flag)
       (eval tipgp-:encrypt-interactive-option))
   ))

;;; ----------------------------------------------------------------------
;;;
;;;###autolaod
(defun tipgp-encrypt-region-sign
  (beg end user &optional no-replace sign-pwd options verb)
  "Same as `tipgp-encrypt-region' but raises 'sign' parameter."
  (interactive (tipgp-encrypt-region-i-args 'pwd))
  (VERB)
  (tipgp-encrypt-region
   beg end user no-replace sign-pwd options verb))

;;; ----------------------------------------------------------------------
;;;
;;;###autolaod
(defun tipgp-encrypt-region
  (beg end user &optional no-replace sign-pwd options verb)
  "Encrypt region.

Input:

  BEG END	region
  USER		key-id string (possibly email)
  NO-REPLACE	prefix arg, store results to `tipgp-:register'
  SIGN-PWD	if non-nil string, Sign at the same time as you encrypt.
  OPTIONS	Additional option string for PGP.
  VERB	        If non-nil, Verbose messages."
  (interactive (tipgp-encrypt-region-i-args))
  (tipgpd "tipgp-encrypt-region in:"
	  beg end user "replace" no-replace options verb)

  (VERB)
  (tipgp-hash 'action 'put 'now 'encrypt)
  (tipgp-encrypt-allowed-check)

  (tipgp-set-pgp-env-macro user 'verb
    (tipgp-cmd-macro
	(if sign-pwd 'encrypt-sign 'encrypt )
	user sign-pwd
      "Encrypting...." no-replace options
      ))

  ;; If all went ok, then we update cache, use XXX in in pubring YYY
  (tipgp-key-cache-update (car (list-make user)))
  )

;;}}}
;;{{{ interactive, decrypting

;;; .......................................................... &decypt ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-decrypt-signed-base64
  (beg end password user &optional no-replace verb)
  "Decrypt conventinally signed but base64 coded text.

Input:

  BEG END	region
  PASSWORD	Signing pass phrase.
  USER		key-id string (possibly email)
  NO-REPLACE	store results to `tipgp-:register'
  VERB		Verbose messages."
  (let* ((fid  "tipgp-decrypt-signed-base64: ")
	 ret
	 file-out
	 file-write
	 )
    (VERB)
    (tipgp-hash 'action 'put 'now 'decrypt)
    (setq file-out (ti::mt-pgp-comment-file-p beg))

    (tipgpd fid "in:" beg end password user no-replace verb)

    (when file-out
      (setq
       file-write
       (read-file-name
	"Base64 block save contents to file: "
	nil (concat default-directory file-out) nil file-out))
      (cond
       ((var-nil-p file-write)
	(setq file-write nil))

       ((not (file-exists-p (file-name-directory file-write)))
	(error "No such directory %s" file-write))

       ((file-exists-p file-write)
	(if (y-or-n-p "File exists, overwrite?")
	    (delete-file file-write)
	  (error "Abort.")
	  ))
       ))

    (if file-write (setq no-replace t))

    (tipgp-cmd-macro 'decrypt-base64 user password "Decrypting..." no-replace)

    ;; The result of PGP is not delimited by any
    ;; --- TAG, so we cannot request replace now, but read the contents
    ;; by hand first
    ;;
    (job-buffer tipgp-:buffer-tmp-shell
      (setq ret    (tipgp-exe-get-result-base64))
      (unless ret  (tipgp-error "No output from PGP."))
      )

    (cond
     (file-write
      (job-buffer (tipgp-use-tmp-buffer)
	(insert ret)
	(write-region (point-min) (point-max) file-write)
	(erase-buffer)
	)
      (message "Wrote %s" file-write)
      )
     (no-replace
      (set-register tipgp-:register ret))
     (t
      (ti::b-replace-region-with beg end ret)
      ))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-decrypt-arg-function  (arg)
  "See how we should interpret the passed prefix ARG.
If buffer is read-only, then assume, that it may be MAIL buffer
or the like and honor the variable `tipgp-:decrypt-arg-interpretation'

If buffer is not read-only. return ARG as is."
  (if (not buffer-read-only)	;regular buffer
      arg
    ;;
    ;; This may be MAIL buffer, because it is read only,
    ;; see how user want the arg to be intepreted.
    ;;
    (if (null tipgp-:decrypt-arg-interpretation)
	arg
      (if arg				;meaning			;
	  nil 1
	  ))
    ))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-decrypt-mail-verbose  (&optional prefix-arg)
  "Call `tipgp-decrypt-mail' like user would with PREFIX-ARG."
  ;;  Loonks cryptic? Not really, because i-args returns a
  ;;  list and tipgp-decrypt-mail needs individual args,
  ;;  we use eval + backquote to construct command that
  ;;  turns list into individual args before
  ;;  it calls tipgp-decrypt-mail.
  ;;
  ;;  Got it? No? Then you must learn backquote syntax first.
  ;;
  (eval
   (` (tipgp-decrypt-mail
       (,@ (tipgp-decrypt-mail-i-args prefix-arg))))))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-decrypt-mail-i-args (&optional arg)
  "Ask args to function `tipgp-decrypt-mail'.
ARG is `current-prefix-arg' if that is know."
  (let* ((c-point   (ti::mt-pgp-encrypted-p))
	 (tlist     (list-to-assoc-menu '("pgp" "base64" "conventional")))
	 (type      "pgp")
	 pass
	 )
    (if (null (ti::mt-pgp-p))
	(error "Nothing to do. No pgp found."))


    (unless c-point
      ;;  couldn't find "Encrypted: PGP" tag, ask type then
      ;;
      (setq type
	    (and tipgp-:pgp-encrypted-p-function
		 (funcall tipgp-:pgp-encrypted-p-function)))

      ;;  See if the type was set to sensible value. Ask from
      ;;  user if it wasn't
      ;;
      (if (or (not (stringp type))
	      (not (assoc type tlist)))
	  (setq type (completing-read
		      "Decrypt type: " tlist nil 'match "pgp")))
      )

    (cond
     ((string= type "conventional")
      (tipgp-user-change-macro
	(setq pass (ti::xe-read-password
		    "Conventional decrypt password: "))))
     ((string= type "pgp")
      (tipgp-user-change-macro
	;;  Now We are right user to ask the PGP pass phrase
	;;
	(setq pass (tipgp-i-args-pass-phrase-decrypt))
	)))

    (list
     pass
     (funcall tipgp-:pgp-decrypt-arg-function arg)
     type nil c-point
     )
    ))


;;; ----------------------------------------------------------------------
;;;
;;;###autolaod
(defun tipgp-decrypt-mail (password &optional no-replace type verb c-point)
  "Decrypt mail buffer.
The PGP data in the buffer is detected by reading the CTB bits:
see pgpformat.doc in pgp documentation.

Input:

  PASSWORD	,string
  NO-REPLACE    ,flag, prefix arg instructs to show the cotent in
                 separate buffer. See refrerence note too.
  TYPE		,nil or \"pgp\" --> PGP encrypted
	         \"base64\" --> base64 signed and
		 \"conventional\" --> encrypted with conventional key.
  VERB
  C-POINT       never mind this variable

Refrences:

  `tipgp-:pgp-encrypted-p-function'
  `tipgp-:decrypt-arg-interpretation'     for interactive calls
  `tipgp-:pgp-decrypt-arg-function'	  for interactive calls
  `tipgp-:user-identity-table'"

  (interactive (tipgp-decrypt-mail-i-args current-prefix-arg))
  (tipgpd "tipgp-decrypt-mail in:")

  (let* ((region    (save-excursion (PMIN) (ti::mt-pgp-block-area 'msg)))
	 (beg	    (car-safe region))
	 (end	    (cdr-safe region))
	 (buffer    (current-buffer))
	 stat
	 )
    (VERB)
    (tipgp-hash 'action 'put 'now 'decrypt)
    (if (null region)   (error "No PGP encrypt block found."))

    (tipgp-save-state-macro
     (tipgpd "tipgp-decrypt-mail: user" tipgp-:user-now)

     ;; ... ... ... ... ... ... ... ... ... ... ...  normally encrypted ...
     (cond
      ((member type '("conventional" "pgp"))
       (setq beg (or c-point beg))
       (tipgp-user-change-macro
	 (tipgp-cmd-macro-email "Decrypt"
	   (tipgp-decrypt-region beg end password no-replace
				 (or verb (interactive-p)))
	   )))
      ;; ... ... ... ... ... ... ... ... ... ... ... ... ... ... base64  ..
      ((member type '("base64"))
       (when no-replace
	 (setq buffer (tipgp-use-tmp-buffer))
	 (append-to-buffer buffer beg end)
	 )
       (job-buffer buffer
	 ;; There may be several blocks, open them all.
	 ;; This is the first one.
	 ;;
	 (tipgp-decrypt-signed-base64 beg end password nil no-replace)
	 (while (and (setq region
			   (save-excursion
			     (goto-char end)
			     (ti::mt-pgp-block-area 'msg)))
		     (setq beg (car region) end (cdr region))
		     )
	   (tipgp-decrypt-signed-base64 beg end password nil no-replace))
	 ))
      (t
       (error "unkown type '%s'" type)
       )))

    ;;    The message may have been encrypted and signed (one pass).
    ;;    Check it too.
    ;;
    (when (and verb
	       (setq stat (tipgp-exe-get-result-verify-status)))
      (message "[was signed] %s" stat))

    (tipgpd "tipgp-decrypt-mail out: user" tipgp-:user-now)
    ))


;;; ----------------------------------------------------------------------
;;;
;;;###autolaod
(defun tipgp-decrypt-region (beg end password &optional no-replace verb)
  "Decrypt region. Signal error is there is no decrypt message.

Input:

  BEG END	,region
  PASSWORD	,pass phrase
  NO-REPLACE    ,store contents to `tipgp-:register'.
  VERB		;verbose messages"
  (interactive
   (list-merge-elements
    (tipgp-i-args-reg-password)
    (list current-prefix-arg)
    'iact
    ))
  (let* (user				;Must be defined due to macro
	 )
    (tipgp-hash 'action 'put 'now 'decrypt)

    (if (null (save-excursion (PMIN) (ti::mt-pgp-block-area 'msg)))
	(error "No PGP encrypt block found."))

    (tipgpd "tipgp-decrypt-region in:" beg end password no-replace verb)
    (tipgp-cmd-macro 'decrypt user password "Decrypting..." no-replace)

    (if (and no-replace verb
	     (y-or-n-p "View content in temp buffer? "))
	(tipgp-view-register))
    ))

;;}}}
;;{{{ interactive: regular crypting

;;; ............................................................ &cypt ...

;;; ----------------------------------------------------------------------
;;;
;;;###autolaod
(defun tipgp-crypt-mail  (password &optional no-replace verb)
  "Crypt mail buffer.

Input:

  PASSWORD	,pass phrase
  NO-REPLACE    ,store contents to `tipgp-:register'.
  VERB		;verbose messages"
  (interactive "sCrypt password: \nP")
  (let* ((beg  (ti::mt-text-start))
	 (end  (point-max))
	 (verb (or verb (interactive-p)))
	 )
    (tipgp-hash 'action 'put 'now 'crypt)
    (tipgp-crypt-region beg end password no-replace verb)
    ))


;;; ----------------------------------------------------------------------
;;;
;;;###autolaod
(defun tipgp-crypt-region  (beg end password &optional no-replace verb)
  "Crypt region.

Input:

  BEG END	,region
  PASSWORD	,pass phrase
  NO-REPLACE    ,store contents to `tipgp-:register'.
  VERB		;verbose messages"
  (interactive
   (progn
     (barf-if-buffer-read-only)
     (i-macro-region-body
       (read-from-minibuffer "Crypt password: ")
       current-prefix-arg
       )))
  (tipgp-hash 'action 'put 'now 'crypt)
  (tipgp-region-cmd-macro-comint
   'crypt nil password "Regular crypting..." no-replace
   (setq cmd  (list cmd password password))
   ))

;;}}}


;;{{{ interactive, extra, header toggle

;;; ..................................................... &interactive ...



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-mail-fcc-encrypt-mode-toggle  (&optional arg)
  "Toggle automatic FCC encryption mode with ARG."
  (interactive)
  (var-toggle tipgp-:mail-fcc-encrypt-mode arg)
  (if (interactive-p)
      (message
       (concat "TinyPgp: FCC encryption mode: "
	       (if tipgp-:mail-fcc-encrypt-mode
		   "on" "off"))))

  (tipgp-update-modeline)
  tipgp-:mail-fcc-encrypt-mode
  )

;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun tipgp-xpgp-header-mode-toggle  (&optional arg)
  "Toggle X-pgp header mode with ARG.

References
  `tipgp-:header-sign-table'     ,this variable overrides the signing mode."
  (interactive "P")
  (var-toggle tipgp-:xpgp-signing-mode arg)
  (if (interactive-p)
      (message
       (concat "TinyPgp: X-Pgp header mode: "
	       (if tipgp-:xpgp-signing-mode
		   "on" "off"))))

  (tipgp-update-modeline)
  tipgp-:xpgp-signing-mode		;return the changed value
  )


;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun tipgp-xpgp-header-toggle  ()
  "Togle moving signature FROM/TO headers."
  (interactive)
  (cond
   ((null (tipgp-mail-buffer-p 'message)))
   (t

    (save-line-col nil nil		;preserve user's position
      (save-buffer-modified
	(cond
	 ((ti::mt-pgp-headers-p)
	  (tipgp-signature-from-header))

	 ((ti::mt-pgp-normal-p)
	  (tipgp-signature-move-to-header nil 'no-cnv))

	 (t
	  (message-quick "No PGP signature detected...")
	  ))))
    )))



;;; ----------------------------------------------------------------------
;;;
(defun tipgp-hide-gnus (&optional unhide)
  "Hides or UNHIDE pgp signature in GNUS."
  (let* ((buffer (if (boundp 'gnus-article-buffer)
		     ;; Silence byteComp.
		     (symbol-value 'gnus-article-buffer)))
	 )
    (when (stringp buffer)
      (job-buffer buffer
	(tipgp-hide)))
    ))

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-hide  (&optional unhide)
  "Hide PGP signatures, optionally UNHIDE."
  (ti::mt-pgp-signature-normal-do-region
   (tipgp-invisible-region area-beg area-end  unhide)
   t					;return value upon success
   ))


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-show  ()
  "Show PGP signature."
  (tipgp-hide 'show))


;;; ----------------------------------------------------------------------
;;;
;;;###autoload
(defun tipgp-hide-show-toggle ()
  "Togle hiding and showing the PGP signature."
  (interactive)
  (let* (ret
	 )
    (setq ret
	  (if (tipgp-hidden-p)
	      (tipgp-show)
	    (tipgp-hide)))
    (if (and (interactive-p)
	     (null ret))
	(message "No signature found to un/hide"))
    ))

;;}}}
;;{{{ interactive, keyserver submit

;;; ................................................ &keyserver-submit ...


;;; ----------------------------------------------------------------------
;;;
(defun tipgp-keysrv-send-email-command  (email command &optional arg)
  "Send to EMAIL address a keyserver COMMAND with ARG.
The COMMAND is placed in the subject line. If command is 'add' then
the current buffer is sent to keyserver.

See keyserver documentation for more up to date command definitions:

Command                Message body contains
--------------------------------------------------------------------
ADD            Your PGP public key (key to add is body of msg) (-ka)
INDEX          List all PGP keys the server knows about (-kv)
VERBOSE INDEX  List all PGP keys, verbose format (-kvv)
GET            Get the whole public key ring (-kxa *)
GET <userid>   Get just that one key (-kxa <userid>)
MGET <userid>  Get all keys which match <userid>
LAST <n>       Get all keys uploaded during last <n> days
--------------------------------------------------------------------"
  (interactive
   (let* ((obuffer  (current-buffer))
	  arg1
	  arg2
	  arg3
	  elt
	  )
     (setq arg1 (tipgp-ask-email-keyserver))
     (setq arg2 (completing-read
		 "Send command: "
		 (list-to-assoc-menu
		  '("help" "add" "index" "verbose index" "get"
		    "mget" "last"
		    ))))

     (if (setq elt
	       (assoc
		arg2
		'(("get" . "<userid>")
		  ("mget" . "<userid>")
		  ("last" . "<nbr of days>")
		  )))
	 (setq
	  arg3
	  (read-from-minibuffer
	   (format "%s, possible additional parameter %s: " arg2 (cdr elt))
	   )))

     (list arg1 arg2 arg3)
     ))

  ;; .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. . interactive end ..
  (let ((obuffer  (current-buffer))
	insert-flag
	)

    (if (var-nil-p email)    (error "email is invalid."))
    (if (var-nil-p command)  (error "command is invalid."))


    (cond
     ((string= "index" command)
      (if (null (y-or-n-p "\
Really List all PGP keys the server knows about (-kv)? "))
	  (error "Abort.")))

     ((string= "verbose index" command)
      (if (null (y-or-n-p "\
Really  List all PGP keys, verbose format (-kvv) "))
	  (error "Abort.")))

     ((string= "get" command)
      (if (null (y-or-n-p "\
Really Get the whole public key ring (-kxa *) "))
	  (error "Abort.")))

     ((string= "mget" command)
      (if (null (y-or-n-p (format "\
Really Get all keys which match <userid %s> " arg)))
	  (error "Abort.")))


     ((and (string= "add" command)
	   (save-excursion
	     (PMIN)
	     (unless (ti::mt-pgp-public-key-p)
	       (error "I can't send this buffer, no public key found."))
	     t
	     ))
      (setq insert-flag t))


     ((member command '("help" "last"))
      nil)

     (t
      (error "unsupported command %s to %s" command email))

     )

    (ti::mt-sendmail-macro email command 'send
;;;	  (pop-to-buffer (current-buffer)) (d! "__ksrv")
      (if insert-flag
	  (insert-buffer obuffer)))

    ))

;;}}}
;;{{{ interactive: misc

;;; ........................................................... &imisc ...

;;; ----------------------------------------------------------------------
;;;
(defun tipgp-pgp-stream-forward-study  (&optional verb)
  "Find PGP stream and display information from it.
The information is stored to `tipgp-:register'.

Interactive call note:

  If can't find stream forward, then go to point-min and try searching
  again.
"
  (interactive)
  (let* (info
         )
    (VERB)
    (if (setq info (ti::mt-pgp-stream-forward-info 'search 'any))
	(set-register tipgp-:register info)
      (setq info "Can't intepret/find PGP stream."))
    (message info)
    ))

;;}}}


;;{{{ examples

;;; ........................................................ &examples ...
;;; - Rip code with tinylib.el/ti::m-pkg-rip-magic
;;; - Here is how I control PGP message sending: For company mail,
;;;   I don't use PGP, but for outside wordl I use quite often.
;;; - Do not use autosigning if you decide to use this kind of control.

;;* (add-hook 'mail-send-hook   'my-tipgp-ask-if-send-pgp-mail)
;;* _
;;* ;;; ----------------------------------------------------------------------
;;* ;;;
;;* (defun my-tipgp-ask-if-send-pgp-mail  ()
;;*   "See if we should ask to sign the mail with PGP.
;;* - If there is already PGP blocks, do nothing.
;;* - If these are local host email addresses, do not ask PGP signing.
;;* "
;;*   (require 'tinylibmt)
;;*   (let* ((to  (or (ti::mt-get-field "to") ""))
;;* _
;;* 	 ;;  Eclude my local host addresses and Anon posts
;;* 	 ;;
;;* 	 (re  "ntc\\|nokia\\|tne[0-9]\\|[an][na][0-9]")
;;* 	 pgp-ask-no
;;*          )
;;* _
;;*     (setq pgp-ask-no
;;* 	  (or (string-match re to)
;;* 	      ;;    local mail addresses do not have @ --> skip PGP
;;* 	      ;;    There must be string in TO field, eg.
;;* 	      ;;    it doesn't exist in GNUS post...
;;* 	      ;;
;;* 	      (and (not (var-nil-p to))
;;* 		   (not (string-match "@" to)))))
;;* _
;;* ;;;    (d! to pgp-ask-no  (tipgp-normal-p) (ti::mt-pgp-headers-p))
;;* _
;;*     (require 'tinypgp)
;;*     (if (or (ti::mt-pgp-normal-p)	;already has pgp...
;;* 	    (ti::mt-pgp-headers-p)		;X-pgp headers in there...
;;* 	    pgp-ask-no			;Not needed in this post
;;* 	    )
;;* 	nil				;skip PGP asking
;;*       (if (y-or-n-p "PGP send this message? ")
;;* 	  (call-interactively 'tipgp-sign-mail))
;;*       )
;;* _
;;*     ;;  - Well, I just want to have confirmation after C-c C-c
;;*     ;;  - Many times I have changed my mind, or missed something I
;;*     ;;    should have added. At this point there is a short break to
;;*     ;;    have a glimpse on the message I just wrote
;;*     (y-or-n-p "sending msg")
;;*     ))

;;}}}
;;{{{ final install


(setq tipgp-:debug t)
(when (null debug-on-error)
  (setq debug-on-error t))

(tipgp-install)
(tipgp-install-modes)  ;;  Do this every time when package is loaded
(tipgp-install-to-current-emacs)

;;  Until this package is labelled Alpha
;;
(if (not (featurep 'tinypgp))
    (tipgp-initial-message))

(provide   'tinypgp)
(run-hooks 'tipgp-:load-hook)

;;}}}

;;; tinypgp.el ends here
